//--------------------------------------------------------------------------//
// xmtnimage12.cc                                                           //
// Text-related routines                                                    //
// Latest revision: 05-25-1999                                              //
// Copyright (c) 1999 by Thomas J. Nelson                                   //
// All rights reserved.                                                     //
//--------------------------------------------------------------------------//

#include "xmtnimage.h"

extern int         ci;                 // current image
extern Images     *z;
extern Globals     g;
                                       // Position for data on information window
int ypos[20] = { 12,28,44,60,76,92,108,124,140,156,172,188,204,220,236,252,268,284,300};

//--------------------------------------------------------------------------//
// abouttheprogram                                                          //
//--------------------------------------------------------------------------//
void abouttheprogram(void)
{ 
   int k, count;
#ifdef HAVE_MEMINFO
   FILE *fp;
#endif

   if(memorylessthan(16384)){ message(g.nomemory,ERROR); return; }
   char tempstring[FILENAMELENGTH];
   int listcount=-1,selection;
  
   //-------------Put information in list box-------------------------//

   char listtitle[100]="About the program";                  
   char **info;                                    

   //----------Increase this size before adding new items-------------//

   info = new char*[19];

   //-------program name--------------------------//
   listcount++;
   info[listcount] = new char[100];                       
   strcpy(info[listcount],"TN-Image - Copyright(C) Thomas J. Nelson 1999");

   //-------email address for bug reports---------//
   listcount++;
   info[listcount] = new char[100];                       
   strcpy(info[listcount], g.emailaddress);

   //-------operating system...or else Windows----//
   listcount++;
   info[listcount] = new char[100];                       
#ifdef MSDOS
   if(in_windows==0) strcpy(tempstring,"DOS mode");
   if(in_windows==1) strcpy(tempstring,"Windows real or std.mode");
   if(in_windows==2) strcpy(tempstring,"Windows enhanced mode");
#endif
#ifdef LINUX
   strcpy(tempstring,"Linux version");
#endif
#ifdef SOLARIS
   strcpy(tempstring,"Solaris version");
#endif
#ifdef CONVEX
   strcpy(tempstring,"ConvexOS version");
#endif
#ifdef IRIX
   strcpy(tempstring,"Irix version");
#endif
#ifdef UNIX
   if(!strlen(tempstring)) strcpy(tempstring,"UNIX version");
#endif
   strcpy(info[listcount],tempstring);


   //-------version & compilation date-----------//
   listcount++;
   info[listcount] = new char[100];                       
   sprintf(tempstring,"Version %s, compiled on %s ",g.version,__DATE__);
   strcpy(info[listcount],tempstring);

   //-------amount of free memory----------------//
#ifdef MSDOS  
   listcount++;
   info[listcount] = new char[100];                       
   strcpy(tempstring,"Total free memory: "); 
   k = _x32_allcoreleft();                 // Requires Flashtek x32vm dos extender
   k -= imagesize(410,savedialogboxysize,bitsperpixel); // Size of dialog box 
   k -= imagesize(404,112,bitsperpixel);   // Size of message box
   k -= 2000;                              // Safety margin 
   k = max(0,k);
   itoa(k,tempstring2,10);
   strcat(tempstring,tempstring2);
   strcat(tempstring," bytes");
   strcpy(info[listcount],tempstring);

   listcount++;
   info[listcount] = new char[100];                       
   strcpy(tempstring,"Largest memory block: "); 
   k = _x32_coreleft();
   k -= imagesize(410,savedialogboxysize,bitsperpixel); // Size of dialog box 
   k -= imagesize(404,112,bitsperpixel);   // Size of message box
   k -= 2000;                              // Safety margin 
   k = max(0,k);
   itoa(k,tempstring2,10);
   strcat(tempstring,tempstring2);
   strcat(tempstring," bytes");
   strcpy(info[listcount],tempstring);
#endif
#ifdef HAVE_MEMINFO
   fp = fopen("/proc/meminfo","rt");
   if(fp!=NULL)
   {  
    listcount++;
    info[listcount] = new char[100];                       
    strcpy(info[listcount],"Memory usage");

    listcount++;
    info[listcount] = new char[100];                       
    fgets(tempstring, 80, fp);
    remove_terminal_cr(tempstring);
    strcpy(info[listcount],tempstring);

    listcount++;
    info[listcount] = new char[100];                       
    fgets(tempstring, 80, fp);
    remove_terminal_cr(tempstring);
    strcpy(info[listcount],tempstring);

    listcount++;
    info[listcount] = new char[100];                       
    fgets(tempstring, 80, fp);
    remove_terminal_cr(tempstring);
    strcpy(info[listcount],tempstring);

    fclose(fp);
   }
#endif

   //-------screen mode--------------------------//
   listcount++;
   info[listcount] = new char[100]; 
   sprintf(tempstring,"Screen resolution=%d x %d   %d bits/pixel",
         g.xres, g.yres, max(8, g.bitsperpixel)); 
   strcpy(info[listcount],tempstring);
 
   //-------Window resolution--------------------//
   listcount++;
   info[listcount] = new char[100]; 
   sprintf(tempstring,"Window resolution=%d x %d pixels",
         g.main_xsize, g.main_ysize); 
   strcpy(info[listcount],tempstring);

   //-------colormap status----------------------//
   listcount++;
   info[listcount] = new char[100];  
   if(g.want_colormaps) sprintf(tempstring,"Using colormaps");
   else
   {   count = 0;
       for(k=0;k<256;k++) if(g.reserved[k]) count++;
       sprintf(tempstring,"%d colors allocated",count);
   }
   strcpy(info[listcount],tempstring);

   //-------no. of images in memory--------------//
   listcount++;
   info[listcount] = new char[100];                       
   sprintf(tempstring,"%d image(s) present",g.image_count);
   strcpy(info[listcount],tempstring);


   selection=0;
   listinfo l;
   l.title = listtitle;
   l.info  = info;
   l.size  = listcount+1;
   l.itemstoshow = listcount-1;
   l.firstitem   = 1;
   l.wantsort    = 0;
   l.wantsave    = 0;
   l.helptopic   = 34;
   l.allowedit   = 0;
   l.selection   = &selection;
   l.width       = 0;
   l.transient   = 0;
   l.wantfunction = 0;
   l.autoupdate   = 0;
   list(&l);

   for(k=0;k<=listcount;k++) delete[] info[k];              
   delete[] info;
   g.getout=0;
}



//--------------------------------------------------------------------------//
// image_list                                                               //
//--------------------------------------------------------------------------//
void image_list(void)
{ 
   int k;
   if(memorylessthan(16384)){ message(g.nomemory,ERROR); return; }
   int listcount=-1, selection;
  
   char listtitle[128]="Image List";                  
   char **info;                                    
   info = new char*[MAXIMAGES+2];
   listcount = g.image_count + 2;
   for(k=0; k<listcount; k++) {  info[k] = new char[128]; info[k][0] = 0; }
   strcpy(info[0],"_____________________________________________________________________");

   selection=0;
   listinfo l;
   l.title = listtitle;
   l.info  = info;
   l.size  = listcount;
   l.itemstoshow = 6;
   l.firstitem   = 1;
   l.wantsort    = 0;
   l.wantsave    = 0;
   l.helptopic   = 34;
   l.allowedit   = 0;
   l.selection   = &selection;
   l.width       = 0;
   l.transient   = 0;
   l.wantfunction = 1;  // use f1 to perform an action when item is selected
   l.autoupdate   = 1;  // use f2 to update list
   l.f1 = switchto;
   l.f2 = image_list_update;
   list(&l);

   selection = *l.selection;
   if(selection>1) switchto(selection-1);
   for(k=0; k<l.size; k++) delete[] info[k];              
   delete[] info;
   g.getout=0;
}


//--------------------------------------------------------------------------//
// image_list_update                                                        //
//--------------------------------------------------------------------------//
void image_list_update(int listno)
{ 
   int k;
   XmString xms;
   listinfo *l = g.openlist[listno];
   Widget w = l->widget;
   Widget browser = l->browser;
   int wantraise=0;
   char isbackup[8];
   char iscolor[8];
   char tempstring[FILENAMELENGTH];
   for(k=0;k<l->size;k++) delete[] l->info[k];              
   l->size = g.image_count + 2;
   for(k=0;k<l->size; k++) { l->info[k] = new char[256];  l->info[k][0] = 0; }

   XmListDeselectAllItems(w);
   XmListDeleteAllItems(w);  // XmListDeleteItemsPos crashes in solaris
   strcpy(l->info[0], "Image# Frames x pos. y pos. x size ysize  Bpp    Color Backed up  Name ");
   additemtolist(w, browser, l->info[0], BOTTOM, wantraise);
   for(k=0;k<g.image_count;k++)
   {   
         if(z[k].colortype!=GRAY) strcpy(iscolor,"yes"); else strcpy(iscolor,"no ");
         if(z[k].backedup) strcpy(isbackup,"yes"); else strcpy(isbackup,"no ");
         strcpy(tempstring, basefilename(z[k].name));
         tempstring[30]=0;  
         sprintf(l->info[k],"%3d %5d %5d  %5d   %6d %6d   %2d (%2d) %3s   %3s        %s     ",
               k, z[k].frames, z[k].xpos, z[k].ypos, z[k].xsize, z[k].ysize, 
               z[k].originalbpp, z[k].bpp, iscolor, isbackup, tempstring);
         if(k==g.image_count-1) wantraise=1;
         XmListAddItemUnselected(w, xms = XmStringCreateSimple(l->info[k]), 0);
         XmStringFree(xms);      
     }
    XmListSetBottomPos(w, 0);  // Last item is last visible item.
    select_list_item(w, ci+2);
}



//--------------------------------------------------------------------------//
// aboutthefile                                                             //
//--------------------------------------------------------------------------//
void aboutthefile(void)
{ 
   int k=0, compress=0;
   char *filename, *oldfilename;
   char identifier[64];
   char tempstring[256];
   filename = new char[FILENAMELENGTH];
   oldfilename = new char[FILENAMELENGTH];
   strcpy(oldfilename, "Untitled");
   filename[0]=0;
   if(ci>=0)
        strcpy(filename, getfilename(z[ci].name));
   else
        strcpy(filename, getfilename(oldfilename));
   if(!g.getout)
   { if(!access(filename,F_OK))    // access = 0 if file exists  
     {
        k=imagefiletype(filename, identifier, compress);
        if(compress)
             sprintf(tempstring,"Image is a compressed %s file", identifier);
        else
             sprintf(tempstring,"Image is a %s file", identifier);
        switch(k)
        {   case TIF: abouttiffile(filename, compress);break;            
            case PCX: aboutpcxfile(filename);break;
            case IMA: message(tempstring);break;
            case IMM: message("Image is a monochrome IMG file");break;
            case IMG: message("Image is an 8-bit IMG file");break;
            case GIF: aboutgiffile(filename);break;
            case GEM: message("Image is a GEM IMG file");break;
            case JPG: message(tempstring);break;
            case TARGA:message("Image is probably a Targa file");break;
            case PICT: message(tempstring);break;
            case IMDS: message("Image is an IMDS (MVS GEM) file");break;
            case BMP: message("Image is a Windows bitmap (BMP) file");break;
            case XWD: aboutxwdfile(filename);break;
            case FITS: aboutfitsfile(filename);break;
            case PDS:  aboutpdsfile(filename);break;
            case PDS2: aboutpdsfile(filename);break;
            case PBM: message("Image is a PBM monochrome ASCII file");break;
            case PGM: message("Image is a PGM grayscale ASCII file");break; 
            case PPM: message("Image is a PPM color ASCII file");break;
            case PBMRAW: message("Image is a raw PBM monochrome file");break;
            case PGMRAW: message("Image is a raw PGM grayscale file");break;
            case PPMRAW: message("Image is a raw PPM color file");break;
            case CUSTOM: aboutcustomfile(filename, identifier);break;
            default: message("Unknown file type");
        }   
     }else message("Cripes, can't even find the file!");
   }
   delete[] oldfilename;
   delete[] filename;
}                   


//--------------------------------------------------------------------------//
// abouttheimage                                                            //
//--------------------------------------------------------------------------//
void abouttheimage(void)
{ 
   const int MAXITEMS=100;
   int k;

   if(memorylessthan(16384)){ message(g.nomemory,ERROR); return; } 
   if(ci<0){ message("Please select an image"); return; }
  
   //-------------Put information in list box-------------------------//

   int listcount=41;            // Change if you add more items
   char listtitle[100]="About the Image";
   char **info;                                    
   info = new char*[MAXITEMS];  // max. MAXITEMS lines - Change if you add more items
   for(k=0;k<=listcount;k++) info[k] = new char[100];                       
   if(listcount>=MAXITEMS) fprintf(stderr, "Error: too many list items\n");
   about_image_fill(ci,info);   

   listinfo l;
   int crud=0;
   l.title = listtitle;
   l.info  = info;
   l.size  = listcount;
   l.itemstoshow = min(20,listcount+1);
   l.firstitem   = 0;
   l.wantsort    = 0;
   l.wantsave    = 0;
   l.helptopic   = 0;
   l.allowedit   = 0;
   l.selection   = &crud;
   l.width       = 0;
   l.transient   = 0;
   l.wantfunction = 0;
   l.autoupdate   = 1;
   l.f1 = null;               // use f1 to perform an action when item is selected
   l.f2 = about_image_update; // use f2 to update list 
   list(&l);
   for(k=0;k<=listcount;k++) delete[] info[k];              
   delete[] info;
   g.getout=0;
}


//--------------------------------------------------------------------------//
// about_image_update                                                       //
//--------------------------------------------------------------------------//
void about_image_update(int listno)
{ 
   int k;
   XmString *listitems=NULL;
   listitems = new XmString[100];
   listinfo *l = g.openlist[listno];
   char **info = l->info;
   about_image_fill(ci,info);
   for(k=0;k<l->size;k++) 
       listitems[k] = XmStringCreateSimple(info[k]);
   XmListReplaceItemsPosUnselected(l->widget, listitems, l->size, 1);
   for(k=0;k<l->size;k++) XmStringFree(listitems[k]);
   delete[] listitems;
}


//--------------------------------------------------------------------------//
// about_image_fill                                                         //
//--------------------------------------------------------------------------//
void about_image_fill(int ino, char **info)
{
   int f;
   double a=0.0;
   uint zerocolor=0;
   int rr=0,gg=0,bb=0;
   if(ino<0 || ino>=g.image_count || info==NULL) return;
   char tempstring[FILENAMELENGTH];
   sprintf(info[0],"Image no. %d",ino);
   strcpy(tempstring, z[ino].name);   
   tempstring[50]=0;  
   sprintf(info[1],"Title %s",tempstring);
   sprintf(info[2],"X size %d",z[ino].xsize);
   sprintf(info[3],"Y size %d",z[ino].ysize);
   sprintf(info[4],"Frames %d",z[ino].frames);
   sprintf(info[5],"X position %d",z[ino].xpos);
   sprintf(info[6],"Y position %d",z[ino].ypos);
   sprintf(info[7],"Overlap order %d",z[ino].overlap);
   sprintf(info[8],"Current frame %d",z[ino].cf);
   strcpy(info[9],"Backed up: " );  
      if(z[ino].backedup) strcat(info[9],"yes"); 
      else strcat(info[9],"no");
   strcpy(tempstring, basefilename(z[ino].name));
      tempstring[50]=0;  // strncpy doesn't work
      sprintf(info[10],"Filename %s",tempstring);
   sprintf(info[11],"File format %s",z[ino].format_name);
   sprintf(info[12],"Original bits/pixel %d",z[ino].originalbpp);
   sprintf(info[13],"Current bits/pixel %d",z[ino].bpp);
   strcpy(info[14],"Color type: " );  
      if(z[ino].colortype==GRAY)    strcat(info[14],"Grayscale");
      if(z[ino].colortype==INDEXED) strcat(info[14],"Indexed color");
      if(z[ino].colortype==COLOR)   strcat(info[14],"Color");
   sprintf(info[15],"No. of colors %d",z[ino].ncolors);
   strcpy(info[16],"Grayscale map in effect: " );  
      if(z[ino].hitgray) strcat(info[16],"yes");
      else              strcat(info[16],"no");
   strcpy(info[17],"Modified: " );  
      if(z[ino].touched) strcat(info[17],"yes");
      else              strcat(info[17],"no");
   strcpy(info[18],"Separate window: " );  
      if(z[ino].shell) strcat(info[18],"yes");
      else            strcat(info[18],"no");
   strcpy(info[19],"Chromakeyed: " );  
      if(z[ino].chromakey) strcat(info[19],"yes");
      else              strcat(info[19],"no");
   sprintf(info[20],"Opaque range: %d to %d",z[ino].ck_graymin, z[ino].ck_graymax);
   sprintf(info[21],"Red opaque range: %d to %d",z[ino].ck_min.red, z[ino].ck_max.red);
   sprintf(info[22],"Green opaque range: %d to %d", z[ino].ck_min.green, z[ino].ck_max.green);
   sprintf(info[23],"Blue opaque range: %d to %d",z[ino].ck_min.blue, z[ino].ck_max.blue);
   strcpy(info[24],"x Calibration: " );  
      if(z[ino].cal_log[0]==-1) strcat(info[24],"none");
      if(z[ino].cal_log[0]== 0) strcat(info[24],"linear");
      if(z[ino].cal_log[0]== 1) strcat(info[24],"Log");
      if(z[ino].cal_log[0]== 2) strcat(info[24],"Polynomial");
      if(z[ino].cal_log[0]== 3) strcat(info[24],"Distance from center");
   strcpy(info[25],"y Calibration: " );  
      if(z[ino].cal_log[1]==-1) strcat(info[25],"none");
      if(z[ino].cal_log[1]== 0) strcat(info[25],"linear");
      if(z[ino].cal_log[1]== 1) strcat(info[25],"Log");
      if(z[ino].cal_log[1]== 2) strcat(info[25],"Polynomial");
      if(z[ino].cal_log[1]== 3) strcat(info[25],"Distance from center");
   strcpy(info[26],"FFT exists: " );  
      if(z[ino].floatexists) strcat(info[26],"yes");
      else strcat(info[26],"no");
   strcpy(info[27],"FFT state " );  
      f = z[ino].fftstate;
      if(f==0) sprintf(info[27],"FFT state: Untransformed");
      if(f>=1) sprintf(info[27],"FFT state: Forward FFT'd %dx",f);
      if(f<=-1)sprintf(info[27],"FFT state: Reverse FFT'd %dx",f);
   strcpy(info[28],"FFT display " );  
      if(z[ino].fftdisplay==NONE) strcat(info[28],"Original image");
      if(z[ino].fftdisplay==REAL) strcat(info[28],"Real");
      if(z[ino].fftdisplay==IMAG) strcat(info[28],"Imag");
      if(z[ino].fftdisplay==POWR) strcat(info[28],"Power spectrum");
   sprintf(info[29],"FFT value for black  %+e",z[ino].fmin);
   sprintf(info[30],"FFT value for white  %+e",z[ino].fmax);
   strcpy(info[31],"FFT=0 color value: " );  
      a = - z[ino].fmin / z[ino].fmax;
      zerocolor = (uint)(a*g.maxvalue[z[ino].bpp]/(a+1));
      itoa(zerocolor,tempstring,10);
      strcat(info[31],tempstring);
   valuetoRGB(zerocolor,rr,gg,bb,z[ino].bpp);
      sprintf(info[32],"FFT=0 RGB value: r %d g %d b %d",rr,gg,bb);
   sprintf(info[33],"X zoom factor: %g",z[ino].zoomx);
   sprintf(info[34],"Y zoom factor: %g",z[ino].zoomy);
   sprintf(info[35],"Frames/sec: %g",z[ino].fps);
   sprintf(info[36],"Transparency: %d",z[ino].transparency);
   strcpy(info[37],"Wavelet exists: " );  
      if(z[ino].waveletexists) strcat(info[37],"yes");
      else strcat(info[37],"no");
   strcpy(info[38],"Wavelet state " );  
      f = z[ino].waveletstate;
      if(f==0) sprintf(info[38],"Wavelet state: Untransformed");
      if(f>=1) sprintf(info[38],"Wavelet state: Forward Transformed %dx",f);
      if(f<=-1)sprintf(info[38],"Wavelet state: Reverse Transformed %dx",f);
   sprintf(info[39],"Wavelet minimum value %+e",z[ino].wmin);
   sprintf(info[40],"Wavelet maximum value %+e",z[ino].wmax);
   //// Change listcount in abouttheimage() if you add more items here
}


//--------------------------------------------------------------------------//
// test                                                                     //
//--------------------------------------------------------------------------//
void test(void)
{   
#ifdef CONVEX   // No gettimeofday() in ConvexOS
    message("Frame rate testing not available on Convex",ERROR);
#else    
    if(memorylessthan(16384)){  message(g.nomemory,ERROR); return; } 
    char tempstring[200];
    int k;
    const int FRAMES = 10;
    int color=0;
    static int busy=0;
    g.getout=0;
    message("Click to begin testing...\n(ESC to abort)");
    if(busy) return;
    busy=1;

    timeval t;   
    struct timezone tz;    // This requires the word 'struct'

    double t1;
    double t2;
    double tt1,tt2;
    double dt;
    double fps=0.0;
    double bps;
    gettimeofday(&t, &tz);
    t1 = t.tv_sec;
    tt1 = (double)(t.tv_usec)/1000000.0;
    dt = t1 + tt1;
    printstatus(TESTING);
 
    for(k=0;k<FRAMES;k++)
    {   color++;
        if(color>=(int)g.maxcolor) color=0;
        copyimage(0,0,g.main_xsize-1,g.main_ysize-1,0,0,PUT,
            z[0].image_ximage,g.main_window);
    }
    XFlush(g.display);
    XSync(g.display,TRUE);

   printstatus(g.state);
   if(!g.getout)
    {   
        gettimeofday(&t,&tz);  
        t2 = t.tv_sec - t1;
        tt2 = (double)(t.tv_usec)/1000000.0 - tt1;
        dt = t2 + tt2;
        if(dt!=0.0) fps = FRAMES/dt;
        bps = fps * g.main_xsize * g.main_ysize * g.off[g.bitsperpixel];
        sprintf(tempstring,"cpu time %g   %dx%d pixels\n%g frames/sec\n%g bytes/sec",
           dt, g.main_xsize, g.main_ysize, fps, bps); 
    }else strcpy(tempstring,"Aborted");
    copybackground(1, 1, g.main_xsize-1, g.main_ysize-1, -1); 
    selectimage(ci);
    busy=0;
    message(tempstring);
#endif
}


//--------------------------------------------------------------------------//
// printstatus                                                              //
// Prints the cursor size, drawing color & draw status  (items that don't   //
// change frequently). Called when status changes or mouse moves or clicked.//
//--------------------------------------------------------------------------//
void printstatus(int state)
{   printstatus(state, " ");
}
void printstatus(int state, char *message)
{
    static char temp[81];
    static char temp2[81];
    int w,h,fc,bc;
    g.inmenu++;

    ////  Read the pixel value for information_area Widget.
    XtVaGetValues(g.info_area[0], XmNforeground, &fc, XmNbackground, &bc, NULL);         

    ////  Labels for X and Y mouse coordinates
    print("Absolute coord.",8,ypos[0],fc,bc,&g.gc,g.info_window[0],BACKGROUND,HORIZONTAL);
    print("x",8,ypos[1],fc,bc,&g.gc,g.info_window[0],BACKGROUND,HORIZONTAL);
    print("y",8,ypos[2],fc,bc,&g.gc,g.info_window[0],BACKGROUND,HORIZONTAL);
    print("Relative coord.",8,ypos[3],fc,bc,&g.gc,g.info_window[0],BACKGROUND,HORIZONTAL);
    print("x",8,ypos[4],fc,bc,&g.gc,g.info_window[0],BACKGROUND,HORIZONTAL);
    print("y",8,ypos[5],fc,bc,&g.gc,g.info_window[0],BACKGROUND,HORIZONTAL);


        // Cursor/click size
    sprintf(temp2,"Step=%4.4d",g.csize);
    print(temp2,8,ypos[0],fc,bc,&g.gc,g.info_window[3],BACKGROUND,HORIZONTAL);

        // Screen bpp
    sprintf(temp,"Screen bpp %d ",g.bitsperpixel);
    print(temp,8,ypos[2],fc,bc,&g.gc,g.info_window[3],BACKGROUND,HORIZONTAL);

        // Global state
    switch(state)
    {   case MOVEIMAGE:
        case NORMAL:         strcpy(temp,"Normal mode          "); break;
        case MOVE:           strcpy(temp,"Moving region      "); break;
        case COPY:           strcpy(temp,"Copying region     "); break;
        case POSITIONBOX:    strcpy(temp,"Moving a box       "); break;
        case DENSITOMETRY:   strcpy(temp,"Densitometry       "); break;
        case GETBOX:         strcpy(temp,"Select a box       "); break;
        case REDRAW:         strcpy(temp,"Redrawing...       "); break;
        case BUSY:          
               strcpy(temp,"Processing...      "); 
               break;
        case INITIALIZING:   strcpy(temp,"Initializing..         "); break;
        case INMENU:         strcpy(temp,"In menu            "); break;
        case GETNEXTPOINT:   strcpy(temp,"Select corner      "); break;
        case CALCULATING:    strcpy(temp,"Calculating...       "); break;
        case CURVE:          strcpy(temp,"Drawing curve      "); break;
        case SELECT:         strcpy(temp,"Selecting area     "); break;
        case GETPOINT:       strcpy(temp,"Select a point     "); break;
        case GETLINE:        strcpy(temp,"Select a line      "); break;
        case NEWIMAGE:       strcpy(temp,"Creating image     "); break;
        case ERASING:        strcpy(temp,"Erasing image      "); break;
        case DRAWING:     
           switch(g.draw_figure)
           {  case BOX:      strcpy(temp,"Drawing boxes      "); break;
              case SKETCH:   strcpy(temp,"Sketch mode        "); break;
              case LINE:     strcpy(temp,"Drawing lines      "); break;
              case CIRCLE:   strcpy(temp,"Drawing circle     "); break;
              case ARROW:    strcpy(temp,"Drawing arrows     "); break; 
              default:       strcpy(temp,"Drawing mode       "); break; 
           }
           break;
        case READING:        strcpy(temp,"Reading image      "); break;
        case ROTATEPALETTE:  strcpy(temp,"Intro screen       "); break;
        case WAITCHAR:       strcpy(temp,"Press a key...     "); break;
        case FILL:           strcpy(temp,"Fill mode          "); break;
        case PRINTING:       strcpy(temp,"Printing...        "); break;
        case TESTING:        strcpy(temp,"Testing...wait     "); break;
        case MACRO:          strcpy(temp,"Macro Running      "); break;
        case SCANNING:       strcpy(temp,"Acquiring scan     "); break;
        case XTWARNING:      strcpy(temp,"Motif Warning      "); break;
        case SPRAY:          strcpy(temp,"Spraying           "); break; 
        case REDUCE_COLORS:  strcpy(temp,"Reducing colors    "); break;
        case ACQUIRE:        strcpy(temp,"Acquiring image    "); break;
        case MESSAGE:        
        case MESSAGE_INVERTED:        
                             strcpy(temp,message); break;
        case SELECTCURVE:    strcpy(temp,"Selecting areas    "); break;
        default:             strcpy(temp,"Other              "); break; 
    }

    if(state==MESSAGE_INVERTED)    
        print(temp,8,ypos[1],bc,fc,&g.gc,g.info_window[3],BACKGROUND,HORIZONTAL);
    else
        print(temp,8,ypos[1],fc,bc,&g.gc,g.info_window[3],BACKGROUND,HORIZONTAL);
 
    if(g.selectedimage>=0)
       sprintf(temp,"#%d selected          ",ci);
    else
    {  w = abs(g.selected_lrx-g.selected_ulx);
       h = abs(g.selected_lry-g.selected_uly);
       sprintf(temp,"%d x %d area           ",w,h);
       swap(fc,bc);
    }
    print(temp,8,ypos[3],fc,bc,&g.gc,g.info_window[3],BACKGROUND,HORIZONTAL);

    XFlush(g.display);
    g.inmenu--;
}                           


//--------------------------------------------------------------------------//
// printcoordinates - print current coordinates at left.                    //
// Prints items that change frequently.  Set 'exposed' to redraw even if    //
//  mx and my are unchanged.                                                //
//--------------------------------------------------------------------------//
void printcoordinates(uint mx, uint my, int exposed)
{            
    static uint oldpixel=0;      
    static char temp[256];
    static char temp2[256];
    static char temp3[256];
    static char tempx[256];
    static char tempy[256];

    static int oino=-1;
    static uint omx=0,omy=0;
    static char tempstring[2][256];
    static int fc=0, bc=0;
    static int hitcalib=0;

    int bb, bpp, gg, ino, k, oinmenu, rr, x1,y1,x2,y2;
    uint pix;
    double fpixel, xcal, ycal;

    if(exposed){ omx=0; omy=0; oldpixel=0; }
    ////  Read the colors for information_area Widget.
    if(fc==0 && bc==0)
       XtVaGetValues(g.info_area[0], XmNforeground, &fc, XmNbackground, &bc, NULL);         

    oinmenu=g.inmenu;
    g.inmenu=0;   
    ino = whichimage(mx,my,bpp);
    if(ino>=0 && z[ino].is_zoomed)
    {    mx = zoom_x_coordinate(mx, ino);
         my = zoom_y_coordinate(my, ino);
    }
    pix = readpixelonimage(mx,my,bpp,ino);
    g.inmenu=oinmenu;
    g.inmenu++;

               //-------------x coordinate-----------------//
    x1=mx;
    y1=my;
    x2=mx;
    y2=my;
    if(ino>=0 && z[ino].shell)
    {   x1 -= z[ino].xpos;
        y1 -= z[ino].ypos;
    }
    if(ino>=0)
    {   x2 -= z[ino].xpos;
        y2 -= z[ino].ypos;
    }
    if(mx!=omx)
    {   sprintf(tempx,"%d    ",x1);
        print(tempx,24,ypos[1],fc,bc,&g.gc,g.info_window[0],BACKGROUND,HORIZONTAL);
        sprintf(tempx,"%d    ",x2);
        print(tempx,24,ypos[4],fc,bc,&g.gc,g.info_window[0],BACKGROUND,HORIZONTAL);
    }

               //-------------y coordinate-----------------//
    if(my!=omy)
    {   sprintf(tempy,"%d    ",y1);
        print(tempy,24,ypos[2],fc,bc,&g.gc,g.info_window[0], BACKGROUND,HORIZONTAL);
        sprintf(tempy,"%d    ",y2);
        print(tempy,24,ypos[5],fc,bc,&g.gc,g.info_window[0], BACKGROUND,HORIZONTAL);
    }

               //-------------Image no.--------------------//

    ino = g.imageatcursor;
    if(g.image_count>0)
    {   if(ino>0)
        {   bpp = z[ino].bpp;
            sprintf(temp,"Image#%4.4d    ", g.imageatcursor);   
        }
        else if(ino==0) sprintf(temp,"Background     ");   
        else if(ino==-2) sprintf(temp,"Palette        ");   
        print(temp, 8, ypos[0], fc, bc, &g.gc, g.info_window[2], BACKGROUND, HORIZONTAL);
    }else
    {
        print("No Images  ",8,ypos[0],fc,bc, &g.gc, g.info_window[2],
            BACKGROUND,HORIZONTAL);
    }
    if(ino==-2) pix = my; 

                 //-----------total color value--------------//

    oinmenu=g.inmenu;
    g.inmenu=0;
    if(g.maxvalue[bpp]) fpixel = (double)pix/(double)g.maxvalue[bpp];
    else fpixel = pix;
    g.inmenu=oinmenu;
    if(pix!=oldpixel || ino!=oino)
    {
       gcvt(fpixel,g.signif,temp);
       sprintf(temp2,"v=%s             ",temp);
       print(temp2,8,ypos[1],fc,bc, &g.gc, g.info_window[1],BACKGROUND,HORIZONTAL);

       sprintf(temp2,"i=%d             ",pix);
       print(temp2,8,ypos[0],fc,bc, &g.gc, g.info_window[1],BACKGROUND,HORIZONTAL);
         
       ////  rgb value
       ////  In screen modes higher than 8bpp, temporarily switch to the 
       ////  image's palette if it has one (i.e., if image is 8bpp).       
       ////  In 8bpp screen modes, this has already been done.      

       if(ino>=0 && z[ino].colortype==GRAY)
            pix = grayvalue(pix, ino, bpp);
       image_valuetoRGB(pix,rr,gg,bb,bpp,ino);

       sprintf(temp,"r%3.3d g%3.3d b%3.3d ",rr,gg,bb);
       oldpixel = pix;
       print(temp,8,ypos[2],fc, bc, &g.gc, g.info_window[1], BACKGROUND, HORIZONTAL);
       itoa(bpp,temp,10);                 
       
       if(bpp<10)strcat(temp," ");
       strcat(temp," bits/pixel ");
       print(temp, 8, ypos[1], fc, bc, &g.gc, g.info_window[2], BACKGROUND, HORIZONTAL);

       if(ino!=oino)
       {    if(ino>=0) strncpy(temp, basefilename(z[ino].name), 30);
            else strcpy(temp, "     ");
            strcat(temp,"                      ");
            temp[30]=0;
            print(temp,8,ypos[2],fc,bc,&g.gc,g.info_window[2],BACKGROUND,HORIZONTAL);
       }
    }
    
    ////  calibration
    
    if(ino>=0 && z[ino].cal_log[0]!=-1) hitcalib=1;
    if(ino>=0 && hitcalib && (mx!=omx || my!=omy))
    {  if(ino!=oino)
       {  strcpy(tempstring[0], z[ino].cal_title[0]);
          strcpy(tempstring[1], z[ino].cal_title[1]);
          tempstring[0][15]=0; 
          tempstring[1][15]=0; 
          for(k=strlen(tempstring[0]);k<15;k++) strcat(tempstring[0]," "); 
          for(k=strlen(tempstring[1]);k<15;k++) strcat(tempstring[1]," "); 
          print(tempstring[0],8,ypos[6],fc,bc,&g.gc,g.info_window[0],BACKGROUND,HORIZONTAL);
          print(tempstring[1],8,ypos[8],fc,bc,&g.gc,g.info_window[0],BACKGROUND,HORIZONTAL);
       }
       calibratepixel(mx,my,ino,0,xcal,tempstring[0]);
       calibratepixel(mx,my,ino,1,ycal,tempstring[1]);
       tempstring[0][15]=0;
       tempstring[1][15]=0;
       for(k=strlen(tempstring[0]);k<16;k++) strcat(tempstring[0]," ");
       for(k=strlen(tempstring[1]);k<16;k++) strcat(tempstring[1]," ");
       print(tempstring[0],8,ypos[7],fc,bc,&g.gc,g.info_window[0],BACKGROUND,HORIZONTAL); 
       print(tempstring[1],8,ypos[9],fc,bc,&g.gc,g.info_window[0],BACKGROUND,HORIZONTAL); 
    } 
      

    ////  fft value

    if(ino>=0 && z[ino].floatexists)  // ino could be -2 if on palette
    {  
        x1 = mx - z[ino].xpos;
        y1 = my - z[ino].ypos;
        if(x1>=0 && x1<z[ino].xsize && y1>=0 && y1<z[ino].ysize)
        {     sprintf(temp2,"Re %+1.4e", z[ino].fft[y1][x1].real());
              for(k=strlen(temp2);k<12;k++) strcat(temp2," ");
              print(temp2,8,ypos[3],fc,bc,&g.gc,g.info_window[1],BACKGROUND,HORIZONTAL);

              sprintf(temp3,"Im %+1.4e ", z[ino].fft[y1][x1].imag());
              for(k=strlen(temp3);k<12;k++) strcat(temp3," ");
              print(temp3,8,ypos[4],fc,bc,&g.gc,g.info_window[1],BACKGROUND,HORIZONTAL);
        }
    }

    ////  wavelet value

    if(ino>=0 && z[ino].waveletexists)  // ino could be -2 if on palette
    {  
        x1 = mx - z[ino].xpos;
        y1 = my - z[ino].ypos;
        if(x1>=0 && x1<z[ino].xsize && y1>=0 && y1<z[ino].ysize)
        {     print("Wavelet",8,ypos[3],fc,bc,&g.gc,g.info_window[1],BACKGROUND,HORIZONTAL);

              sprintf(temp3,"%+1.4e ", z[ino].wavelet[y1][x1]);
              for(k=strlen(temp3);k<12;k++) strcat(temp3," ");
              print(temp3,8,ypos[4],fc,bc,&g.gc,g.info_window[1],BACKGROUND,HORIZONTAL);
        }
    }


    g.inmenu--;
    oino=ino;
    omx=mx;
    omy=my;
} 


//--------------------------------------------------------------------------//
// pixelmode                                                                //
// change pixel interaction mode                                            //
//--------------------------------------------------------------------------//
void pixelmode(int noofargs, char **arg)
{    int j,k;
     if(memorylessthan(16384)){ message(g.nomemory,ERROR); return; }
     Dialog dialog;
     dialog.needrepeat=0;
     if(noofargs==0)
     {  
         strcpy(dialog.title,"Pixel interaction mode");
         strcpy(dialog.radio[0][0],"Interaction mode");             
         strcpy(dialog.radio[0][1],"Overwrite");
         strcpy(dialog.radio[0][2],"Maximum");
         strcpy(dialog.radio[0][3],"Minimum");
         strcpy(dialog.radio[0][4],"Add");
         strcpy(dialog.radio[0][5],"Subtract new - old");
         strcpy(dialog.radio[0][6],"Subtract old - new");
         strcpy(dialog.radio[0][7],"XOR");
         strcpy(dialog.radio[0][8],"Average");
         strcpy(dialog.radio[0][9],"Superimpose");
         dialog.radioset[0] = g.imode;
         dialog.radiono[0]=10;
         dialog.radiono[1]=0;
         dialog.radiono[2]=0;
         dialog.radiono[3]=0;
         dialog.noofboxes=0;
         dialog.noofradios=1;
         dialog.helptopic=2;
         dialog.keep=0;
         dialog.want_changecicb = 0;
         for(j=0;j<10;j++) for(k=0;k<20;k++) dialog.radiotype[j][k]=RADIO;
         dialog.f1 = null;
         dialog.transient = 1;
         strcpy(dialog.path,".");
         dialogbox(dialog);

         g.imode = dialog.radioset[0];
     }else g.imode=atoi(arg[1]);
}


//--------------------------------------------------------------------------//
// showoptions - list the valid command line options and terminate.         //
//--------------------------------------------------------------------------//
void showoptions(void)
{
    //// Only useful in DOS
}































