//--------------------------------------------------------------------------//
// xmtnimage22.cc                                                           //
// Image file printing                                                      //
// Latest revision: 01-30-1999                                              //
// Copyright (C) 1999 by Thomas J. Nelson                                   //
// All rights reserved.                                                     //
//--------------------------------------------------------------------------//

#include "xmtnimage.h"

extern Globals     g;
extern Images     *z;
extern int         ci;
extern PrinterStruct printer;


//--------------------------------------------------------------------------//
// printimage                                                               //
// print image or selected area of screen. Returns error status.            //
//--------------------------------------------------------------------------//
int printimage(void)
{
  if(memorylessthan(16384)){ message(g.nomemory,ERROR); return(NOMEM); }

  Dialog dialog;
  dialog.needrepeat=0;
  g.getout=0;
  char temp[202];
  int bb, gg, j, k, rr, status=OK;
  create_print_filename(ci, printer.filename);
  
  ////  radios

  if(g.selectedimage==-1) printer.entire=0; else printer.entire=1; 
  strcpy(dialog.title,"Print Image");
  strcpy(dialog.radio[0][0],"Orientation");
  strcpy(dialog.radio[0][1],"Vertical");
  strcpy(dialog.radio[0][2],"Horizontal");
  strcpy(dialog.radio[1][0],"Image");             
  strcpy(dialog.radio[1][1],"Positive");
  strcpy(dialog.radio[1][2],"Negative");
  strcpy(dialog.radio[2][0],"Print what");             
  strcpy(dialog.radio[2][1],"Print entire image");
  strcpy(dialog.radio[2][2],"Print selected area");
  strcpy(dialog.radio[3][0],"Color type");             
  strcpy(dialog.radio[3][1],"Grayscale");
  strcpy(dialog.radio[3][2],"RGB/Indexed color");
  strcpy(dialog.radio[3][3],"CMY color");
  strcpy(dialog.radio[3][4],"CMYK color");
  strcpy(dialog.radio[4][0],"Printer Type");             
  strcpy(dialog.radio[4][1],"PCL");
  strcpy(dialog.radio[4][2],"Postscript");

  if(printer.vertical) dialog.radioset[0]=1;
                  else dialog.radioset[0]=2;
  if(printer.positive) dialog.radioset[1]=1;
                  else dialog.radioset[1]=2;
  if(printer.entire)   dialog.radioset[2]=1;
                  else dialog.radioset[2]=2;
  dialog.radioset[3] = printer.palette;
  if(printer.language==1)dialog.radioset[4]=1;
                    else dialog.radioset[4]=2;

  dialog.radiono[0]=3;
  dialog.radiono[1]=3;
  dialog.radiono[2]=3;
  dialog.radiono[3]=5;
  dialog.radiono[4]=3;

  for(j=0;j<10;j++) for(k=0;k<20;k++) dialog.radiotype[j][k]=RADIO;
 
  ////  Boxes
  
  for(k=0;k<DCOUNT;k++)dialog.boxset[k]=0;
  strcpy(dialog.boxes[0],"Print parameters");
  strcpy(dialog.boxes[1],"Printer command");
  strcpy(dialog.boxes[2],"Printer device");
  strcpy(dialog.boxes[3],"Print to file");
  strcpy(dialog.boxes[4],"No.of copies");
  strcpy(dialog.boxes[5],"Color/Darkness");
  strcpy(dialog.boxes[6],"Horiz. offset (in.)");
  strcpy(dialog.boxes[7],"Vert. offset (in.)");

  strcpy(dialog.boxes[8],"PCL parameters");
  strcpy(dialog.boxes[9],"Printer res.(DPI)");
  strcpy(dialog.boxes[10],"Dither size");
  strcpy(dialog.boxes[11],"Print quality");
  strcpy(dialog.boxes[12],"Media type");
  strcpy(dialog.boxes[13],"Depletion");
  strcpy(dialog.boxes[14],"Printer gray balance");

  strcpy(dialog.boxes[15],"PostScript parameters");
  strcpy(dialog.boxes[16],"Horiz.image size (in.)");
  strcpy(dialog.boxes[17],"Image aspect (V/H)");
  strcpy(dialog.boxes[18],"Horiz.paper size (in.)");
  strcpy(dialog.boxes[19],"Vert. paper size (in.)");
  strcpy(dialog.boxes[20],"Rotation (degrees)");
  strcpy(dialog.boxes[21],"Interpolate");


  dialog.boxtype[0]=LABEL; 
  dialog.boxtype[1]=TOGGLESTRING; 
  dialog.boxtype[2]=TOGGLESTRING;
  dialog.boxtype[3]=TOGGLESTRING;
  dialog.boxtype[4]=STRING;
  dialog.boxtype[5]=MULTICLICKBOX;
  dialog.boxtype[6]=STRING;
  dialog.boxtype[7]=STRING;
  dialog.boxtype[8]=LABEL;
  dialog.boxtype[9]=STRING; 
  dialog.boxtype[10]=NON_EDIT_LIST; 
  dialog.boxtype[11]=NON_EDIT_LIST;
  dialog.boxtype[12]=NON_EDIT_LIST;
  dialog.boxtype[13]=NON_EDIT_LIST;
  dialog.boxtype[14]=TOGGLE; 
  dialog.boxtype[15]=LABEL; 
  dialog.boxtype[16]=STRING; 
  dialog.boxtype[17]=STRING;
  dialog.boxtype[18]=STRING; 
  dialog.boxtype[19]=STRING;
  dialog.boxtype[20]=STRING; 
  dialog.boxtype[21]=TOGGLE;

  for(k=1;k<=3;k++) dialog.boxset[printer.device] = 0;
  dialog.boxset[printer.device] = 1;
  dialog.boxmin[5]=0; dialog.boxmax[5]=256;
  dialog.boxmin[10]=0; // min menu selection
  dialog.boxmax[10]=5; // max no.of menu items to use
  dialog.boxmin[11]=0; // min menu selection
  dialog.boxmax[11]=3; // max no.of menu items to use
  dialog.boxmin[12]=0; // min menu selection
  dialog.boxmax[12]=5; // max no.of menu items to use
  dialog.boxmin[13]=0; // min menu selection
  dialog.boxmax[13]=6; // max no.of menu items to use

  strcpy(dialog.answer[1],printer.command);
  strcpy(dialog.answer[2],printer.devicename);
  strcpy(dialog.answer[3],printer.filename);
  sprintf(dialog.answer[4],"%d",printer.copies);
  printer.intensity = RGBvalue((int)(printer.rfac*128),
                      (int)(printer.gfac*128),(int)(printer.bfac*128),24);
  itoa(printer.intensity,temp,10); strcpy(dialog.answer[5],temp);
  gcvt(printer.hpos,g.signif,temp);strcpy(dialog.answer[6],temp);
  gcvt(printer.vpos,g.signif,temp);strcpy(dialog.answer[7],temp);
  itoa(printer.res,temp,10);       strcpy(dialog.answer[9],temp);

  ////  Dither size menu

  dialog.boxmenutitle[10] = new char[100];
  dialog.boxmenu[10] = new char*[6];
  for(k=0;k<=5;k++) dialog.boxmenu[10][k] = new char[100];
  if(printer.dither==1) dialog.boxmenuselection[10]=0;
  if(printer.dither==2) dialog.boxmenuselection[10]=1;
  if(printer.dither==4) dialog.boxmenuselection[10]=2;
  if(printer.dither==8) dialog.boxmenuselection[10]=3;
  if(printer.dither==16) dialog.boxmenuselection[10]=4;
  strcpy(dialog.boxmenutitle[10],"Dither size");
  strcpy(dialog.boxmenu[10][0],"  1x1 ");
  strcpy(dialog.boxmenu[10][1],"  2x2 ");
  strcpy(dialog.boxmenu[10][2],"  4x4 ");
  strcpy(dialog.boxmenu[10][3],"  8x8 ");
  strcpy(dialog.boxmenu[10][4]," 16x16");

  // print quality menu

  dialog.boxmenutitle[11] = new char[100];
  dialog.boxmenu[11] = new char*[4];
  for(k=0;k<=3;k++) dialog.boxmenu[11][k] = new char[100];
  if(printer.quality==-1)dialog.boxmenuselection[11]=0;
  if(printer.quality== 0)dialog.boxmenuselection[11]=1;
  if(printer.quality== 1)dialog.boxmenuselection[11]=2;
  strcpy(dialog.boxmenutitle[11],"Print Quality");
  strcpy(dialog.boxmenu[11][0]," Draft       ");
  strcpy(dialog.boxmenu[11][1]," Normal      ");
  strcpy(dialog.boxmenu[11][2]," Presentation");

  // Media type menu

  dialog.boxmenutitle[12] = new char[100];
  dialog.boxmenu[12] = new char*[6];
  for(k=0;k<=5;k++) dialog.boxmenu[12][k] = new char[100];
  dialog.boxmenuselection[12]=printer.papertype;
  strcpy(dialog.boxmenutitle[12],"Media type ");
  strcpy(dialog.boxmenu[12][0],"Plain paper      ");
  strcpy(dialog.boxmenu[12][1],"Bond paper       ");
  strcpy(dialog.boxmenu[12][2],"Premier paper    ");
  strcpy(dialog.boxmenu[12][3],"Glossy film      ");
  strcpy(dialog.boxmenu[12][4],"Transparency film");

  // depletion menu

  dialog.boxmenutitle[13] = new char[100];
  dialog.boxmenu[13] = new char*[7];
  for(k=0;k<=6;k++) dialog.boxmenu[13][k] = new char[100];
  dialog.boxmenuselection[13]=printer.depletion;
  strcpy(dialog.boxmenutitle[13],"Depletion ");
  strcpy(dialog.boxmenu[13][0],"Printer default");
  strcpy(dialog.boxmenu[13][1],"Off            ");
  strcpy(dialog.boxmenu[13][2],"25%            ");
  strcpy(dialog.boxmenu[13][3],"50%            ");
  strcpy(dialog.boxmenu[13][4],"25%/gamma corr.");
  strcpy(dialog.boxmenu[13][5],"50%/gamma corr.");

  if(printer.graybalance==1)dialog.boxset[14]=1;
 
  gcvt(printer.hsize,g.signif,temp); strcpy(dialog.answer[16],temp);
  gcvt(printer.ratio,g.signif,temp); strcpy(dialog.answer[17],temp);
  gcvt(printer.paperxsize,g.signif,temp); strcpy(dialog.answer[18],temp);
  gcvt(printer.paperysize,g.signif,temp); strcpy(dialog.answer[19],temp);
  itoa(printer.rotation,temp,10);    strcpy(dialog.answer[20],temp);
  if(printer.interpolate==1)dialog.boxset[21]=1;
 
  dialog.noofradios=5;
  dialog.noofboxes=22;
  dialog.helptopic=4;  
  dialog.bpp = 24;
  dialog.keep=0;
  dialog.want_changecicb = 0;
  dialog.f1 = printcheck;
  dialog.transient = 1;
  strcpy(dialog.path,".");
  g.getout=0;
    
  //////////////////
  dialogbox(dialog);
  //////////////////

  //---radios---//    

  if(dialog.radioset[0]==1)printer.vertical = 1;
                      else printer.vertical = 0;   
  if(dialog.radioset[1]==1)printer.positive = 1;
                      else printer.positive = 0;   
  if(dialog.radioset[2]==1)printer.entire   = 1;
                      else printer.entire   = 0; 
  printer.palette = dialog.radioset[3];
  if(dialog.radioset[4]==1)printer.language = 1;
                      else printer.language = 0; 


  //---boxes---//

  for(k=1;k<=3;k++) if(dialog.boxset[k]) printer.device = k;
  strcpy(printer.command,dialog.answer[1]);
  strcpy(printer.devicename,dialog.answer[2]);
  strcpy(printer.filename,dialog.answer[3]);
  printer.copies = atoi(dialog.answer[4]);
  printer.intensity = atoi(dialog.answer[5]);
  valuetoRGB(printer.intensity,rr,gg,bb,24);

  printer.rfac = (double)rr/128.0;
  printer.gfac = (double)gg/128.0;
  printer.bfac = (double)bb/128.0;
  printer.ifac = (printer.rfac + printer.gfac + printer.bfac)/3;
  printer.hpos = atof(dialog.answer[6]);
  printer.vpos = atof(dialog.answer[7]);
  printer.res = atoi(dialog.answer[9]);

  if(dialog.boxmenuselection[10]==0) printer.dither = 1;
  if(dialog.boxmenuselection[10]==1) printer.dither = 2;
  if(dialog.boxmenuselection[10]==2) printer.dither = 4;
  if(dialog.boxmenuselection[10]==3) printer.dither = 8;
  if(dialog.boxmenuselection[10]==4) printer.dither = 16;

  if(dialog.boxmenuselection[11]==0) printer.quality = -1;
  if(dialog.boxmenuselection[11]==1) printer.quality =  0;
  if(dialog.boxmenuselection[11]==2) printer.quality =  1;

  printer.papertype = dialog.boxmenuselection[12];
  printer.depletion = dialog.boxmenuselection[13];
  if(dialog.boxset[14]) printer.graybalance=1; else printer.graybalance=0;
  printer.hsize = atof(dialog.answer[16]);
  printer.ratio = atof(dialog.answer[17]);
  printer.paperxsize = atof(dialog.answer[18]);
  printer.paperysize = atof(dialog.answer[19]);
  printer.rotation = atoi(dialog.answer[20]);
  if(dialog.boxset[21]) printer.interpolate=1; else printer.interpolate=0;

  //----free memory for submenus----------//

  for(k=0;k<=5;k++) delete[] dialog.boxmenu[10][k];
  delete[] dialog.boxmenu[10];
  delete[] dialog.boxmenutitle[10];

  for(k=0;k<=3;k++) delete[] dialog.boxmenu[11][k];
  delete[] dialog.boxmenu[11];
  delete[] dialog.boxmenutitle[11];
  
  for(k=0;k<=5;k++) delete[] dialog.boxmenu[12][k];
  delete[] dialog.boxmenu[12];
  delete[] dialog.boxmenutitle[12];

  for(k=0;k<=6;k++) delete[] dialog.boxmenu[13][k];
  delete[] dialog.boxmenu[13];
  delete[] dialog.boxmenutitle[13];

  if(!g.getout)
  {    drawselectbox(OFF);
       if(printer.language==1) status = write_pcl_file(printer);
       else status = write_postscript_file(printer);
  }
  g.getout=0;
  g.state=NORMAL;
  return(status);
}


//--------------------------------------------------------------------------//
//  printcheck                                                              //
//--------------------------------------------------------------------------//
void printcheck(dialoginfo *a, int radio, int box, int boxbutton)
{
    int j,k,len;
    if(boxbutton==0 && between(box,1,3))                  // Printer device
    { 
       for(k=1;k<=3;k++) a->boxset[k]=False;
       for(k=1;k<=3;k++) if(k==box) a->boxset[k]=True;  
       for(k=1;k<=3;k++) if(k!=box)
           XmToggleButtonSetState(a->boxwidget[k][0],a->boxset[k],False);
    }
    if(radio==4 ||(radio==0 && box==0))   // PCL/PS parameters
    {
         if(a->radioset[4]==1)            // Switch to PCL
         {    printer.language=PCL;
              create_print_filename(ci, printer.filename);
              if(a->boxwidget[3][1]) 
              {   len = strlen(printer.filename);
                  XtVaSetValues(a->boxwidget[3][1], XmNvalue, printer.filename, 
                         XmNcursorPosition, len,NULL); 
              }
              for(k=0;k<=2;k++) 
              {   for(j=8;j<=14;j++) 
                      if(a->boxwidget[j][k]) XtSetSensitive(a->boxwidget[j][k],True);
                  for(j=15;j<=21;j++) 
                      if(a->boxwidget[j][k]) XtSetSensitive(a->boxwidget[j][k],False);
              }
         }else if(a->radioset[4]==2)      // Switch to Postscript
         {    printer.language=POSTSCRIPT;
              create_print_filename(ci, printer.filename);
              {   len = strlen(printer.filename);
                  XtVaSetValues(a->boxwidget[3][1], XmNvalue, printer.filename, 
                        XmNcursorPosition, len,NULL); 
              }
              for(k=0;k<=2;k++) 
              {   for(j=8;j<=14;j++) 
                      if(a->boxwidget[j][k]) XtSetSensitive(a->boxwidget[j][k],False);
                  for(j=15;j<=21;j++) 
                      if(a->boxwidget[j][k]) XtSetSensitive(a->boxwidget[j][k],True);
              }
         }
    }
}


//--------------------------------------------------------------------------//
//  write_pcl_file                                                          //
//--------------------------------------------------------------------------//
int write_pcl_file(PrinterStruct p)
{
  int status = OK;
  int ncolors=1;
  int b=0, color, oldb;
  int alloc1=0;
  int ink=0;
  double ratio;
  FILE *p_stream;
  char filename[FILENAMELENGTH];
  char tempstring[FILENAMELENGTH];
  
  int bitshift=0,i,ii,j,k,k2,pixbpp,ulx,uly,lrx,lry,shingling=0;

  int want_check=0;

  uchar *buffer_1d;
  int bufx,bufy,bufz=0;
  uchar ***buffer=NULL;               /* Temporary storage of bit map data */
                                      /* for one row of pixels, with up to */
                                      /* 16x16 dithering. One for each ink.*/
                             
  ushort map[256][16];                /* 256 bit maps for each shade of    */
                                      /* gray - assume 16-bit short ints   */
                                      /* so it is maximum of 16x16 dither  */
                                      
                                      /* The bit maps are made by filling  */
                                      /* the box cumulatively 1 pixel at a */
                                      /* time in the order given by the    */
                                      /* fill4, fill8 and fill16 arrays.   */
                                      
  uchar fill2[2][2] = { { 0,1 },
                        { 2,3 }};

  uchar fill4[4][4] = { {  5,11,  7,15 },
                        { 13, 1,  9, 4 },
                        {  8,10,  6,14 },
                        {  0, 3, 12, 2 }};

  uchar fill8[8][8] = { { 32,56,27, 0, 31,53,28,63 },
                        { 40, 1,48,15, 38, 4,45,14 },
                        { 21,52,17,43, 23,49,19,41 },
                        { 60, 9,33, 5, 57,11,34, 8 },

                        { 29,55,25,61, 30,54,26,62 },
                        { 39, 3,47,13, 37, 2,46,16 },
                        { 24,51,20,44, 22,50,18,42 },
                        { 59,12,35, 7, 58,10,36, 6 } };

  uchar fill16[16][16] =\
    { {   5,133, 37,167, 13,143, 53,183,   7,135, 39,169, 15,145, 55,185 }, 
      { 199, 97,227, 81,211,121,  0, 69, 201, 99,229, 83,213,123,253, 71 },
      {  57,187, 21,151, 45,175, 29,139,  59,189, 23,153, 47,177, 31,161 },
      { 243, 73,203,109,239, 85,215,113, 245, 75,205,111,241, 87,217,115 },
      {   9,139, 61,191,  1,129, 33,163,  11,141, 63,193,  3,131, 35,165 },
      { 231,105,235,125,255, 65,195,101, 233,107,237,127,251, 67,197,103 },
      {  41,171, 25,155, 49,179, 17,147,  43,173, 27,157, 51,181, 19,149 },
      { 219, 77,207,117,247, 93,223, 89, 221, 79,209,119,249, 95,235, 91 },

      {   8,136, 40,170, 16,146, 56,186,   6,134, 38,168, 14,144, 54,184 },
      { 202,100,230, 84,214,124,254, 72, 200, 98,228, 82,212,122,252, 70 },
      {  60,190, 24,154, 48,178, 32,162,  58,188, 22,152, 46,176, 30,160 },
      { 246, 76,206,112,242, 88,218,116, 244, 74,204,110,240, 86,216,114 },
      {  12,142, 64,184,  4,132, 36,166,  10,140, 62,192,  2,130, 34,164 },
      { 234,108,238,128,137, 68,198,104, 232,106,236,126,138, 66,196,102 },
      {  44,174, 28,158, 52,182, 20,150,  42,172, 26,156, 50,180, 18,148 },
      { 222, 80,210,120,250, 96,226, 92, 220, 78,208,118,248, 94,224, 90 } };
  

    //------End of declarations-----------//
    //------Set bitmap data---------------// 
  
  g.state=PRINTING;
  printstatus(PRINTING);

 
 if(p.entire && ci>=0 && ci<g.image_count)
 {    ulx = z[ci].xpos;
      uly = z[ci].ypos;
      lrx = z[ci].xpos + z[ci].xsize;
      lry = z[ci].ypos + z[ci].ysize;
  }      
  else
  {   ulx = g.selected_ulx;
      uly = g.selected_uly;
      lrx = g.selected_lrx;
      lry = g.selected_lry;
  }   

   switch(p.dither)            /* Create bitmaps up to 16x16 */
   { 
     case 1: break; 
     case 2:
         for(k=0;k<4;k++)          /* color k */
         for(j=0;j<2;j++)          /* y pixel */
         {  map[k][j] = 0;
            for(i=0;i<2;i++)       /* x pixel */
                if(fill2[i][j]<=k) map[k][j]+=(1<<(1-i));
         }      
         break;
     case 4:
         for(k=0;k<16;k++)         /* color k */
         for(j=0;j<4;j++)          /* y pixel */
         {  map[k][j] = 0;
            for(i=0;i<4;i++)       /* x pixel */
                if(fill4[i][j]<=k) map[k][j]+=(1<<(3-i));
         }      
         break;
      case 8:
         for(k=0;k<64;k++)         /* color k */
         for(j=0;j<8;j++)          /* y pixel */
         {  map[k][j] = 0; 
            for(i=0;i<8;i++)       /* x pixel */
                if(fill8[i][j]<=k) map[k][j]+=(1<<(7-i));
         }   
         break;
      case 16:
         for(k=0;k<256;k++)        /* color k */
         for(j=0;j<16;j++)         /* y pixel */
         {  map[k][j] = 0;
            for(i=0;i<16;i++)      /* x pixel */
                if(fill16[i][j]<=k) map[k][j]+=(1<<(15-i));
         }   
         break;
   }

   //-----------End of initializing data------------//
   //-----------Open printer file-------------------//
  
   if(p.device==1) strcpy(filename, "~temp.print");  // system() to lpr
   if(p.device==2) strcpy(filename, p.devicename);
   if(p.device==3)
   {   strcpy(filename, p.filename);
       if(cant_overwrite_file(filename)) return ABORT;
   }
         
   p_stream = fopen(filename,"wb");
   if(p_stream==NULL) 
   {    error_message(filename, errno);
        if(p.device==1) sprintf(tempstring,"Can't create temporary file \n%s",filename);
        if(p.device==2) sprintf(tempstring,"Unable to access\n%s",p.devicename);
        if(p.device==3) sprintf(tempstring,"Can't open file\n%s",p.filename);
        message(tempstring,ERROR);
        status=ERROR;
        goto endprint;
   }
   sprintf(tempstring,"Printing to\n%s",filename);
   message(tempstring);

#ifdef MSDOS

   if(isatty(fileno(p_stream))) want_check=1;
   if(want_check) if(check_printer()==ABORT) goto endprint;

#endif

   //-----------Send data to printer-----------------//

   fprintf(p_stream,"%cE\n",27);                  /* Esc-E reset           */
   if(p.vertical)      
      fprintf(p_stream,"%c&l0O\n",27);            /* portrait mode         */
   else
      fprintf(p_stream,"%c&l1O\n",27);            /* landscape mode        */ 
   fprintf(p_stream,"%c*rC\n",27);                /* End raster graphics   */  

   fprintf(p_stream,"%c*t%dR\n",27,p.res);        /* set resolution  */
   fprintf(p_stream,"%c&l%dX\n",27,p.copies);     /* no.of copies    */

   if(p.quality==-1) shingling=0;
   if(p.quality== 0) shingling=1;
   if(p.quality== 1) shingling=2;
   if(p.papertype>=3) shingling=min(2,1+shingling);
   if(shingling)
     fprintf(p_stream,"%c*o%dQ",27,shingling);    /* "shingling"        */

   if(p.depletion)
     fprintf(p_stream,"%c*o%dD\n",27,p.depletion);/* "depletion" */

   fprintf(p_stream,"%c&l%dM\n",27,p.papertype);  /* paper type      */
   if(p.quality==-1)
     fprintf(p_stream,"%c*r1Q\n",27);             /* print quality-others */
   else
     fprintf(p_stream,"%c*r2Q\n",27);             /* print quality-others */
   fprintf(p_stream,"%c*o%dM\n",27,p.quality);    /* prnt quality-H/P540 */

   switch(p.palette)
   {  case 1:  ncolors=1;     // Single plane palette
               fprintf(p_stream,"%c*r1U\n",27);
               break; 
      case 2:  ncolors=3;     // RGB
               fprintf(p_stream,"%c*r3U\n",27);
               break;
      case 3:  ncolors=3;     // CMY
               fprintf(p_stream,"%c*r-3U\n",27);
               break; 
      case 4:  ncolors=4;     // KCMY
               fprintf(p_stream,"%c*r-4U\n",27);
               break;
   }
   if(p.graybalance) fprintf(p_stream,"%c*b1B",27);   /* gray balance*/

   print("Printing...", 8, 30, g.main_fcolor, g.main_bcolor, &g.gc, 
        g.info_window[3], BACKGROUND, HORIZONTAL);

                            /* raster y pos.- don't send form feed */
   fprintf(p_stream,"%c*p%dY",27,(int)(p.vpos * p.res)); 

                            /* raster x pos.- don't send form feed */
   fprintf(p_stream,"%c*p%dX",27,(int)(p.hpos*p.res)); 
   fflush(p_stream);


   //--------------------------------------------------------------------//
   // First, calculate b, no.of bytes to send per line for each plane.   //
   //--------------------------------------------------------------------//

   switch(p.dither)
   {    case 1: b=(1+lrx-ulx)/8; break;
        case 2: b=(1+lrx-ulx)/4; break;
        case 4: b=(1+lrx-ulx)/2; break;
        case 8: b=1+lrx-ulx;     break;
        case 16:b=(1+lrx-ulx)*2; break;
   }
   
   //--------------------------------------------------------------------//
   // Warn user that RGB printing will be slow.                          //
   //--------------------------------------------------------------------//

   oldb=b;               
                                  // =(dpi)*(8 inches/page)/(8 bits/byte)
   if(p.palette==2) b=max(b, p.res);  

   ratio = (double)b/(double)oldb;
   if(ratio>1.25 && p.palette==2)
   {  sprintf(tempstring,"RGB printing was selected\nThis may take up to %gx as much time as CMY\n",ratio);
      message(tempstring);
   }   
   if(g.getout){ g.getout=0; return ABORT; }
   
   //--------------------------------------------------------------------//
   // Make buffer big enough for 16 lines of b bytes/line to send.       //
   // Need one of these for each ink.                                    //
   //--------------------------------------------------------------------//

   bufz = 1+ncolors;
   bufy = 2+b;
   bufx = 1+p.dither;
   buffer_1d = (uchar*)malloc(bufx*bufy*bufz*sizeof(uchar));
   buffer = make_3d_alias(buffer_1d,bufx,bufy,bufz);

   if(buffer==NULL)
   {  message(g.nomemory,ERROR);
      return(NOMEM);
   }   
   alloc1 = 1;
  
   if(p.palette==2) 
   {  for(i=0;i<ncolors;i++)
      for(j=0;j<b;j++)
      for(k=0;k<p.dither;k++) buffer[i][j][k]=255;
   }


   //--------------------------------------------------------------------//
   // Start raster graphics                                              //
   // For each row, fill a buffer with bitmap patterns, different        //
   //   for each resolution mode (dither).                               //
   //--------------------------------------------------------------------//

   fprintf(p_stream,"%c*r1A\n",27);                // Start raster graphics
   fflush(p_stream);
   if(want_check) if(check_printer()==ABORT) goto endprint;

   for(j=uly;j<=lry;j++)                           // j is y value     
   { 
      itoa(j,tempstring,10);          
      strcat(tempstring,"  ");         

      print(tempstring, 68, 30, g.main_fcolor, g.main_bcolor, &g.gc, 
            g.info_window[3], BACKGROUND, HORIZONTAL);

      for(ink=0;ink<ncolors;ink++)
      { 
         if(p.dither==1 || p.dither==2 || p.dither==4)
         {                                         // Zero out buffer for 
                                                   // 1-,2- and 4-bit mode
            if(p.dither==2) bitshift=6;                          
            for(i=0;i<=(lrx-ulx);i++)             
            { switch(p.dither)
              { case 1:  buffer[ink][(i>>3)][0]=0; 
                         break;
                case 2:  for(k=0;k<2;k++) 
                            buffer[ink][(i>>2)][k]&=~(3<<bitshift);
                         bitshift -=2;
                         if(bitshift<0) bitshift=6;
                         break;
                case 4:  for(k=0;k<4;k++) 
                          if(((i>>1)<<1)==i)       // If on an even pixel     
                            buffer[ink][(i>>1)][k] &= 0x0f;
                          else                     // Odd pixel
                            buffer[ink][(i>>1)][k] &= 0xf0;
                         break;
              }
            }  
         }      

         if(p.dither==2) bitshift=6;                          
         if(p.dither==1)
         {  for(i=0;i<=(lrx-ulx);i+=8)             // i is x value 
            { 
              for(k=0;k<8;k++)
              { color=readpixelonimage(i+k+ulx,j,pixbpp,ii);        // read  pixel 
                ii = whichimage(i+k+ulx,j,pixbpp);
                color=grayvalue(color,ii,pixbpp);  // Correct for any gray 
                color=ink_color(color,ink, p.palette, pixbpp, p.positive,
                      p.rfac, p.gfac, p.bfac, p.ifac);
                if(!p.positive) color=255-color;        //  Invert color
                if(color>127) buffer[ink][(i>>3)][0] |= (1<<(7-k));
              }              
            }
         }else                                     // Perform dithering
         {  for(i=0;i<=(lrx-ulx);i++)              // i is x value 
            { 
              color=readpixelonimage(i+ulx,j,pixbpp,ii);           // read the pixel 
              color=grayvalue(color,ii,pixbpp);   // Correct for any gray 
              color=ink_color(color, ink, p.palette, pixbpp, p.positive,
                      p.rfac, p.gfac, p.bfac, p.ifac);
              switch(p.dither)
               { case 2:
                   color >>= 6;                    // scale color to 0..3     
                   for(k=0;k<2;k++)                // k is dithering row #
                      buffer[ink][(i>>2)][k] += (map[color][k])<< bitshift;
                   bitshift -=2;
                   if(bitshift<0) bitshift=6;
                   break;
                 case 4:
                   color >>= 4;                    // scale color to 0..15    
                   for(k=0;k<4;k++)                // k is the dither row
                     if(((i>>1)<<1)==i)            // If on an even pixel     
                                                   // fill left 1/2 of byte   
                        buffer[ink][i>>1][k] += map[color][k] << 4; // x 16
                
                     else                          // If on an odd pixel      
                        buffer[ink][i>>1][k] += map[color][k];          
                                                   // fill right 1/2 of byte 
                   break;
                 case 8:
                   color >>= 2;                    // scale color to 0..63    
                   for(k=0;k<8;k++)                // send 1x8 bytes/pixel
                     buffer[ink][i][k] = map[color][k];          
                   break;
                 case 16:
                   for(k=0;k<16;k++)               // send 2x16 bytes/pixel
                   {  buffer[ink][(i<<1)][k]   = map[color][k] >>8; //  256   
                      buffer[ink][(i<<1)+1][k] = map[color][k] & 0x00ff;     
                   }
                   break;
               }       
            }                 
         }
      }
     

    //--------------------------------------------------------------------//
    // Now the filled buffer is sent to the printer.                      //
    // All but the last plane are sent out using ESC*b#V.                 //
    // The last plane is  sent out using ESC*b#W.                         //
    // For B/W printing, there is only 1 plane, which uses ESC*b#W.       //
    //--------------------------------------------------------------------//

      for(k2=0;k2<p.dither;k2++)
      {  for(ink=0;ink<ncolors;ink++)
         {  if(ink<ncolors-1)
               fprintf(p_stream,"%c*b%dV",27,b);     // Expect b bytes
            else      
               fprintf(p_stream,"%c*b%dW",27,b);     // Expect b bytes
            fflush(p_stream);
#ifdef MSDOS
            if(want_check)    // If sending to stdprn
            {  for(k=0;k<b;k++) _bios_printer(0,0,buffer[ink][k][k2]); }
            else
            {  for(k=0;k<b;k++) fprintf(p_stream,"%c",buffer[ink][k][k2]); }
#else
            for(k=0;k<b;k++) fprintf(p_stream,"%c",buffer[ink][k][k2]);

#endif
         } 
         fflush(p_stream);
      }  

      if(want_check) if(check_printer()==ABORT) goto endprint;
      if(keyhit()) if(getcharacter()==27)break;
   }


   //--------------------------------------------------------------------//
   // Reset printer                                                      //
   //--------------------------------------------------------------------//

   fprintf(p_stream,"%c*rC\n",27);                // End raster graphics
   fflush(p_stream);
   fprintf(p_stream,"%c%c\n",27,12);              // Form feed            
   fflush(p_stream);
   fprintf(p_stream,"%cE\n",27);                  // Reset printer        
   fflush(p_stream); 

endprint:
   fclose(p_stream);
   if(p.device==1) 
   {   sprintf(tempstring, "%s %s", p.command, filename);
       status = system(tempstring);  // system() to lpr
       if(status != 0) 
       {    if(errno) error_message(" ", errno);
            else error_message(" ", status);
       }else    // Don't erase their temp file if error
            unlink(filename);
   }
   if(alloc1) free_3d(buffer,bufz);
   g.state=NORMAL;
   return(status);
}


//--------------------------------------------------------------------------//
// ink_color                                                                //
// Returns the value of a given color at specified bpp.                     //
//                                                                          //
// Extracts the color from the supplied pixel value, converts to CMY,       //
//  KCMY, or RGB if necessary, and returns the value for the color being    //
//  processed. This value is the intensity needed for the specified ink#.   //
// The color value is scaled to {0,255}.                                    //
// If p.positive is 0, it inverts the color.                                //
// Also multiplies r,g,b by user-selected print intensity values to         //
//  match the color.                                                        //
//--------------------------------------------------------------------------//
uint ink_color(uint color, int ink, int p_palette, 
     int bpp, int p_positive, double p_rfac, double p_gfac, double p_bfac,
     double p_ifac)
{
   int rr,gg,bb,cc,mm,yy,kk;
   if(p_palette==1)                             // B/W
   {   color = convertpixel(color,bpp,8,1);     // Convert to 8 bpp of black 
       color=(int)(color*p_ifac);               // Mult. by intensity factor
       color=min(color,255);
       if(p_positive) color=255-color;
   } 
   if(p_palette==2)                             // rgb
   {   color = convertpixel(color,bpp,24,1);    // Convert to 8 bpp of r,g,b
       valuetoRGB(color,rr,gg,bb,24);
       if(ink==0) color=(int)(rr*p_rfac);
       if(ink==1) color=(int)(gg*p_gfac);
       if(ink==2) color=(int)(bb*p_bfac);
       color = min(color,255);
       if(!p_positive) color=255-color;
   }else
   if(p_palette==3)                             // cmy
   {   color=convertpixel(color,bpp,24,1);      // Convert to 8 bpp of r,g,b
       valuetoRGB(color,rr,gg,bb,24);
       if(ink==0) color=(int)((255-rr)*p_rfac); // rr is now cyan
       if(ink==1) color=(int)((255-gg)*p_gfac); // gg is now magenta
       if(ink==2) color=(int)((255-bb)*p_bfac); // bb is now yellow
       color = min(color,255);
       if(!p_positive) color=255-color;
   }else
   if(p_palette==4)                             // kcmy
   {   color=convertpixel(color,bpp,24,1);      // Convert to 8 bpp of r,g,b
       valuetoRGB(color,rr,gg,bb,24);
       kk = min(255-rr,min(255-gg,255-bb));
       cc = 255-rr-kk;          // rr is now cyan
       mm = 255-gg-kk;          // gg is now magenta
       yy = 255-bb-kk;          // bb is now yellow
       if(ink==0) color=(int)(kk*p_ifac);
       if(ink==1) color=(int)(cc*p_rfac);
       if(ink==2) color=(int)(mm*p_gfac);
       if(ink==3) color=(int)(yy*p_bfac);
       color = min(color,255);
       if(!p_positive) color=255-color;
   }
   return(color);
}


//--------------------------------------------------------------------------//
// check_printer - MSDOS only                                               //
//--------------------------------------------------------------------------//
int check_printer(void)
{
   // Should only be called if printing to stdprn (== LPT1: ).
   // If output is directed to a network printer, it is not so easy 
   // to get the printer status because bidirectional communication
   // is needed. This only works in DOS/Windows.

   // 'Printer out of paper' is intercepted by DOS to give a critical
   // error. Sometimes "Offline" is also translated by DOS into a 
   // critical "Write error". In these cases, the program goes to
   // criterr_handler instead.

#ifdef MSDOS
   const int OK=0;
   const int ERR=1;

   char temp[20]="y";
   char a,b,status=OK;
   union REGS reg;
   struct SREGS seg;
   
   reg.h.ah = 0x02;
   reg.x.dx = 0;  // 0=LPT1, 1=LPT2, 2=LPT3
   int86(0x17,&reg,&reg);
   a = reg.h.ah;
   b = ~a;

   if(error_occurred)
   {  error_occurred=0; 
      message("Device error!",ERROR);
   }

   if((a & 0x29) || (b & 0x10)) status=ERR;
   if(status==ERR)
   {
      if(a & 0x01) message("Printer timeout!!",ERROR);
      if(a & 0x08) message("Printer I/O error!!!",ERROR);
      if(b & 0x10) message("Printer offline!!!!",ERROR);
      if(a & 0x20) message("Out of paper!!!!!",ERROR); 
   }

   if(temp[0]!='y') return ABORT;
#endif
   return OK;
}



//--------------------------------------------------------------------------//
//  write_postscript_file                                                   //
//--------------------------------------------------------------------------//
int write_postscript_file(PrinterStruct p)
{
  char decode_string[20];
  char filename[FILENAMELENGTH];
  char tempstring[FILENAMELENGTH];
  char tempstring2[128];
  Widget www, scrollbar;
 
  double iratio, vsize;
  int bb, bpp, bitspercomponent=8, cc, color, color_type=0, count, gg, ino, 
     linecount=-1, j, k, kk, lrx, lry, mm, ncolors=1, pixbpp, rr, status=OK, 
     ulx, uly, x, xpixels, y=0, ypixels, yy;

  FILE *fp;
  g.getout=0;

  if(p.entire && ci>=0 && ci<g.image_count)
  {   ulx = z[ci].xpos;
      uly = z[ci].ypos;     
      lrx = z[ci].xpos + z[ci].xsize;
      lry = z[ci].ypos + z[ci].ysize;
      bpp = z[ci].bpp;
      strcpy(tempstring2, "image");
  }else
  {   ulx = g.selected_ulx;
      uly = g.selected_uly;
      lrx = g.selected_lrx;
      lry = g.selected_lry;
      bpp = g.bitsperpixel;
      strcpy(tempstring2, "selected region");
  }   
  if(bpp!=8)
  {  sprintf(tempstring,"Check to ensure %s is\n8 bits/pixel before proceeding.\nSome printers will have problems with\n%d bit PostScript files",tempstring2,bpp);
     message(tempstring,WARNING);
     if(g.getout) {g.getout=0; return ABORT; }
  }
  xpixels = lrx - ulx;
  ypixels = lry - uly;
  iratio = (double)ypixels / (double)xpixels;
  vsize = p.hsize * iratio;

  switch(p.palette)
  {  case 1: color_type =  GRAY; 
             break;   // GrayScale
     case 2: if(bpp==8) color_type=INDEXED; else color_type=COLOR;  // RGB
             break;
     case 3: 
     case 4: color_type = CMYK; break;    // CMY, CMYK
   }
   
   //-----------End of initializing data------------//
   //-----------Open printer file-------------------//

   g.state=PRINTING;
   printstatus(PRINTING);
   drawselectbox(OFF);
   XFlush(g.display); 
 
   if(p.device==1) strcpy(filename, "~temp.print");  // system() to lpr
   if(p.device==2) strcpy(filename, p.devicename);
   if(p.device==3)
   {   strcpy(filename, p.filename);
       if(cant_overwrite_file(filename)) return ABORT;
   } 
   fp = fopen(filename,"wb");
   if(fp==NULL) 
   {    error_message(filename, errno);
        if(p.device==1) sprintf(tempstring,"Can't create temporary file \n%s",filename);
        if(p.device==2) sprintf(tempstring,"Unable to access\n%s",p.devicename);
        if(p.device==3) sprintf(tempstring,"Can't open file\n%s",p.filename);
        message(tempstring,ERROR);
        return ERROR ;
   }
   
   if(p.device==1) sprintf(tempstring,"Printing to\n%s",p.command);
   if(p.device==2) sprintf(tempstring,"Printing to\n%s",p.devicename);
   if(p.device==3) sprintf(tempstring,"Printing to\n%s",filename); 

   progress_bar_open(www, scrollbar);


#ifdef MSDOS
   if(isatty(fileno(fp))) want_check=1;
   if(want_check) if(check_printer()==ABORT) return ABORT;
#endif   // if MSDOS

   //-----------Start of sending file---------------//

   fprintf(fp,"%s!PS-Adobe-2.0 EPSF-2.0\n","%");
   fprintf(fp,"%sTitle: %s\n","%%",p.filename);
   fprintf(fp,"%sCreator: %s version %s\n","%%",g.appname, g.version);
   fprintf(fp,"%sBoundingBox: %d %d %d %d\n","%%", 
       (int)(p.hpos*72.0), 
       (int)((p.paperysize - p.vpos - vsize)*72.0),
       (int)((p.hpos + p.hsize)*72.0), 
       (int)((p.paperysize - p.vpos)*72.0) );
   fprintf(fp,"%sPages: 1\n","%%");
   fprintf(fp,"%sDocumentFonts:\n","%%");
   fprintf(fp,"%sEndComments\n","%%");
   fprintf(fp,"%sEndProlog\n","%%");

   fprintf(fp,"/origstate save def\n");
   fprintf(fp,"\n");

   fprintf(fp,"%sPage: 1 1\n\n","%%");

   //// Send palette if bpp is 8

   switch(color_type)
   {  case INDEXED: 
         fprintf(fp,"[/Indexed /DeviceRGB 255\n<\n"); 

         ////  If palette is an unmodified grayscale palette, send a
         ////  true grayscale map instead of trying to scale 0..63 to
         ////  0..255. This will give better print quality for grayscale
         ////  images.

         if(unmodified_grayscale(g.palette))
         for(k=0;k<256;k+=8)
         {  for(j=0;j<8;j++) 
            fprintf(fp,"%02x%02x%02x ",k+j, k+j, k+j);
            fprintf(fp,"\n");
         }else
         for(k=0;k<256;k+=8)
         {  for(j=0;j<8;j++) 
            fprintf(fp,"%02x%02x%02x ",
                4*(1+g.palette[k+j].red)-1, 
                4*(1+g.palette[k+j].green)-1,
                4*(1+g.palette[k+j].blue)-1 );   
            fprintf(fp,"\n");
         }
         fprintf(fp,"\n>\n] setcolorspace\n\n");
         strcpy(decode_string,"[0 255]");
         bitspercomponent = 8;
         ncolors=1; 
         break; 
      case GRAY:
         ncolors=1;
         bitspercomponent = bpp;
         strcpy(decode_string,"[0 1]");
         fprintf(fp,"[/DeviceGray] setcolorspace\n"); 
         break;
      case COLOR: 
         ncolors=3;
         bitspercomponent = 8;
         strcpy(decode_string,"[0 1 0 1 0 1]");
         fprintf(fp,"[/DeviceRGB] setcolorspace\n"); 
         break;
      case CMYK:   
         ncolors=4;
         bitspercomponent = 8;
         strcpy(decode_string,"[0 1 0 1 0 1 0 1]");
         fprintf(fp,"[/DeviceCMYK] setcolorspace\n"); 
         break;
   }

   fprintf(fp,"\n");
   fprintf(fp,"/pix %d string def\n",xpixels*ncolors);

   //// Distance of upper left corner from lower left of page

   x = (int)(.999+p.hpos*72);
   y = (int)(.999+72.0*(p.paperysize - p.vpos - vsize)); 
   fprintf(fp,"%d %d translate\n", x, y);
   fprintf(fp,"%d rotate\n", p.rotation);
 
   //// Size of image on page

   fprintf(fp,"%f %f scale\n\n", 72.0*p.hsize, 72.0 * vsize * p.ratio);

   //// Image dictionary
  
   fprintf(fp,"<<\n\
      /ImageType 1 \n\
      /Width %d \n\
      /Height %d \n\
      /BitsPerComponent %d \n\
      /Decode %s \n\
      /ImageMatrix [%d 0 0 -%d 0 %d] \n\
      /DataSource { currentfile pix readhexstring pop } \n",
       xpixels, ypixels, bitspercomponent, decode_string, xpixels, ypixels, ypixels);
   fprintf(fp,">>\nimage\n\n");

   //// Send image

   count = 0;
   for(j=uly;j<lry;j++)
   { 
     check_event();             
     progress_bar_update(scrollbar, (j-uly)*100/(lry-uly));
     if(++linecount==10)
     {   sprintf(tempstring,"Printing..%d  ",j);
         printstatus(MESSAGE,tempstring);
         linecount = 0;
     }
     for(k=ulx;k<lrx;k++)
     {  color = readpixelonimage(k,j,pixbpp,ino);  
        switch(color_type)
        { case GRAY:
          case INDEXED:                                  // Gray or Indexed
                if(!p.positive) color=255-color;         // Invert color
                fprintf(fp,"%02x",color); 
                break; 
          case COLOR:                                    // RGB
                color = convertpixel(color,pixbpp,24,1); // Convert to 24 bpp
                valuetoRGB(color,rr,gg,bb,24);           // Extract r,g,b
                rr = (int)(rr * p.rfac);
                gg = (int)(gg * p.gfac);
                bb = (int)(bb * p.bfac);     
                if(!p.positive)                          // Invert color
                {    rr = 255 - rr; 
                     gg = 255 - gg;
                     bb = 255 - bb;
                }
                fprintf(fp,"%02x%02x%02x",rr,gg,bb); 
                break;
          case CMYK:                                     // CMYK
                color = convertpixel(color,pixbpp,24,1); // Convert to 24 bpp
                valuetoRGB(color,rr,gg,bb,24);           // Extract r,g,b
                kk = min(255-rr,min(255-gg,255-bb));
                cc = 255-rr-kk;          // r is now cyan
                mm = 255-gg-kk;          // g is now magenta
                yy = 255-bb-kk;          // b is now yellow
                kk = (int)(kk*p.ifac);
                cc = (int)(cc*p.rfac);
                mm = (int)(mm*p.gfac);
                yy = (int)(yy*p.bfac);
                if(!p.positive) 
                {  kk = 255 - kk;
                   cc = 255 - cc;
                   mm = 255 - mm;
                   yy = 255 - yy;
                }
                fprintf(fp,"%02x%02x%02x%02x ",cc,mm,yy,kk); 
                break;
        }
        count += ncolors;
        if(count>=36){ count=0; fprintf(fp,"\n"); }
     }
   }

   //// Finish

   fprintf(fp,"\n\nshowpage\n");
   fprintf(fp,"origstate restore\n");
   fprintf(fp,"%sTrailer\n","%%");

   //-----------End of sending file-----------------//

  fclose(fp);
  if(p.device==1) 
  {    sprintf(tempstring, "%s %s", p.command, filename);
       status = system(tempstring);  // system() to lpr
       if(status != 0) 
       {    if(errno) error_message(" ", errno);
            else error_message(" ", status);
        }else    // Don't erase their temp file if error
            unlink(filename);
  }
  g.state=NORMAL;
  progress_bar_close(www);
  return status;
}



//--------------------------------------------------------------------------//
//  unmodified_grayscale - test if palette is svgapalette 1.                //
//  If so, caller can safely use a true 0..255 grayscale palette instead of //
//  trying to convert the 6-bit/color palette used in 8 bit screen modes.   //
//--------------------------------------------------------------------------//
int unmodified_grayscale(RGB *p)
{
    int i, answer=1, d;
    for (i=0; i<255; i++)
    {  d = p[i+1].red + p[i+1].green + p[i+1].blue - p[i].red - p[i].green - p[i].blue;
       if(!between(d,0,2)) { answer = 0; break; }
    }
    return answer;
}


//--------------------------------------------------------------------------//
//  error_message                                                           //
//--------------------------------------------------------------------------//
void error_message(char *s, int error)
{ 
    char tempstring[1024];
    switch(error)
    {    case 0: break;
         case E2BIG:  sprintf(tempstring,"Argument list too big"); break;
         case EACCES: sprintf(tempstring,"%s\nPermission denied:\nThe requested access to the \
file\nis not allowed, or one of the\ndirectories in pathname did not\nallow search (execute) \
permission.", s); break;
         case EAGAIN: sprintf(tempstring,"Operation would block, or\nnot enough memory"); break;
         case EBADF:  sprintf(tempstring,"%s\nBad file number",s); break;
         case EEXIST: sprintf(tempstring,"Pathname already exists and O_CREAT and O_EXCL were used."); break;
         case EFAULT: sprintf(tempstring,"%s\nPathname points outside your accessible address space.",s); break;
         case EINVAL: sprintf(tempstring,"Invalid argument"); break;
         case EISDIR: sprintf(tempstring,"%s\nPathname refers to a directory \nand the access requested involved writing.",s);break;
         case ELOOP:  sprintf(tempstring,"%s\nPath contains circular reference",s); break;
         case EMFILE: sprintf(tempstring,"The process already has the\nmaximum number of files open."); break;
         case ENFILE: sprintf(tempstring,"The limit on the total number\n of files open on the system\nhas been reached."); break;
         case ENODEV: sprintf(tempstring,"%s\nNo such device",s); break;
         case ENOMEM: sprintf(tempstring,"Insufficient kernel memory\nwas available."); break;
         case ENOSPC: sprintf(tempstring,"Disk full"); break;
         case ENOTDIR:sprintf(tempstring,"%s\nA component used as a directory in\npathname is not, in fact, a directory.",s); break;
         case ENOEXEC:sprintf(tempstring,"Exec format error"); break;
         case ENAMETOOLONG: sprintf(tempstring,"%s\nFilename too long",s); break;
         case ENOENT: sprintf(tempstring,"%s\nFile not found",s); break;
         case EPERM:  sprintf(tempstring,"Operation not permitted"); break;
         case EROFS:  sprintf(tempstring,"%s\nPathname refers to a file on\na read-only filesystem\nand write access was requested.",s); break;
         case ETXTBSY:sprintf(tempstring,"%s\nPathname refers to an executable image\nwhich is currently being executed\nand write access was requested.",s); break;
         default: strcpy(tempstring,strerror(error));
    }
    message(tempstring,ERROR);
}                 



//--------------------------------------------------------------------------//
// create_print_filename                                                    //
//--------------------------------------------------------------------------//
void create_print_filename(int ino, char *print_filename)
{
    int k,pos=0;
    if(ino<0 || !strlen(z[ino].name)){ strcpy(print_filename, "temp.print"); return; }
    strcpy(print_filename, z[ino].name);
    for(k=0;k<(int)strlen(print_filename);k++) if(print_filename[k]=='.') pos=k;
    if(pos>0) print_filename[pos]=0;
    if(printer.language==POSTSCRIPT) strcat(print_filename, ".ps");
    if(printer.language==PCL) strcat(print_filename, ".prn");
}
