//--------------------------------------------------------------------------//
// xmtnimage23.cc                                                           //
// multiframe images                                                        //
// Latest revision: 03-06-1999                                              //
// Copyright (C) 1999 by Thomas J. Nelson                                   //
// All rights reserved.                                                     //
//--------------------------------------------------------------------------//

#include "xmtnimage.h"

extern Globals     g;
extern Images     *z;
extern int         ci;
int done=0;


//--------------------------------------------------------------------------//
//  movie  delay is in msec                                                //
//--------------------------------------------------------------------------//
void movie(int delay)
{
   if(ci<=0 || z[ci].frames<=1) return;
   done = 0;
   Widget form;
   int moving=1, minval=0, maxval=0, startval=z[ci].cf;
   int *answers;
   char *textlabel;
   textlabel = new char[FILENAMELENGTH];
   strcpy(textlabel, "movie");
   maxval = z[ci].frames-1;
   form = g.main_widget;
   
   answers = new int[10];
   answers[0] = z[ci].cf;
   answers[1] = ci;
   answers[2] = delay;
   answers[3] = moving;
   answers[4] = 0;         // No refresh

   clickboxinfo clickboxdata;
   clickboxdata.f1 = null;
   clickboxdata.f2 = null;
   clickboxdata.f3 = framenext;
   clickboxdata.title = textlabel;
   clickboxdata.answers = answers;
   clickboxdata.startval = startval;
   clickboxdata.minval = minval;
   clickboxdata.maxval = maxval;
   clickboxdata.type = INTARRAY;
   clickboxdata.wantpreview = 0;
   clickboxdata.widget[0] = NULL;
   clickboxdata.form = form;  
   clickboxdata.path = NULL;  
   clickboxdata.k = 0;

   XtAppAddTimeOut(XtWidgetToApplicationContext(form), delay, moviecb, 
       (XtP)&clickboxdata);
   while(!g.getout)
       XtAppProcessEvent (XtWidgetToApplicationContext(g.main_widget), XtIMAll);
   g.getout=0;
   if(delay) z[ci].fps = 1000.0/(double)clickboxdata.answers[2];
   delete[] textlabel;
   delete[] answers;
   done = 1;
}


//--------------------------------------------------------------------------//
//  menu3d                                                                  //
//--------------------------------------------------------------------------//
void menu3d(void)
{  
   if(ci<0) return;
   done=0;
   Widget startbutton, delayslider, slider, xrotslider, yrotslider, zrotslider, form, text, *w;
   XmString xms;
   int k,n, xsize=350, ysize=270, wc=0, rw;
   int *answers;
   int delay;
   if(z[ci].fps) delay = (int)(1000/z[ci].fps); else delay = 1;
   static int moving = 0;
   Arg args[100];
   char *textlabel;
   char tempstring[128];
   textlabel = new char[FILENAMELENGTH];
   clickboxinfo clickboxdata[3];
   char title[100];
   w = new Widget[100];
   int helptopic=0;
   int minval = 0;
   int maxval = 1;
   int startval = z[ci].cf;
   int ino = ci;
   if(ino>=0) maxval = max(1,z[ino].frames-1);
   answers = new int[10];
   answers[0] = z[ci].cf;
   answers[1] = ino;
   answers[2] = delay;
   answers[3] = moving;
   answers[4] = 1;             // No refresh
   answers[5] = z[ci].xangle;  // x angle
   answers[6] = z[ci].yangle;  // y angle
   sprintf(title, "Image # %d Frame controls",ino);
   
   //------- Create a form dialog shell widget -----------------------//

   n=0;
   XtSetArg(args[n], XmNwidth, xsize); n++;
   XtSetArg(args[n], XmNheight, ysize); n++;
   XtSetArg(args[n], XmNtransient, False); n++;
   XtSetArg(args[n], XmNresizable, False); n++;
   XtSetArg(args[n], XmNautoUnmanage, False); n++;
   XtSetArg(args[n], XmNtopAttachment, XmATTACH_WIDGET); n++;
   XtSetArg(args[n], XmNbottomAttachment, XmATTACH_WIDGET); n++;
   XtSetArg(args[n], XmNdialogTitle, xms = XmStringCreateSimple(title));n++;
   ////  Stop Motif from trying to grab another color if none are available.
   if(g.want_colormaps)  
   {    XtSetArg(args[n], XmNbackground, g.main_bcolor); n++;
        XtSetArg(args[n], XmNforeground, g.main_fcolor); n++;
   }
   form = w[wc++] = XmCreateFormDialog(g.main_widget, "Menu3DForm", args, n);
   XmStringFree(xms);
       
   //--------Title for dialog box-------------------------------------//

   w[wc++] = addlabel(form, title, CENTER, 20, 2, 80, 10); 
   itoa(startval, textlabel, 10);

   //--------Slider indicating frame no.------------------------------//

   rw = max(200,xsize-20);
   slider = w[wc++] = add_slider(form,"Frame",rw,7,90,36,48,minval,maxval,startval,1);  
   w[wc++] = addlabel(form, "z", LEFT, 90, 40, 99, 52); 

   //--------Sliders indicating x,y,z rotation------------------------//

   xrotslider = w[wc++] = add_slider(form, "Xrot", rw, 7, 90, 48, 60, 0, 360, 0, 1);  
   sprintf(tempstring, "x%c",XK_degree);
   w[wc++] = addlabel(form, tempstring, LEFT, 90, 52, 99, 64); 

   yrotslider = w[wc++] = add_slider(form, "Yrot", rw, 7, 90, 60, 72, 0, 360, 0, 1);  
   sprintf(tempstring, "y%c",XK_degree);
   w[wc++] = addlabel(form, tempstring, LEFT, 90, 64, 99, 76); 

   zrotslider = w[wc++] = add_slider(form, "Zrot", rw, 7, 90, 72, 84, 0, 360, 0, 1);  
   sprintf(tempstring, "z%c",XK_degree);
   w[wc++] = addlabel(form, tempstring, LEFT, 90, 76, 99, 88); 

   //--------Text area------------------------------------------------//

   n = 0;
   XtSetArg(args[n], XmNcolumns, 40); n++;
   XtSetArg(args[n], XmNrows, 1); n++;
   XtSetArg(args[n], XmNvalue, textlabel); n++;
   XtSetArg(args[n], XmNleftPosition, 5); n++;     // % of width from left
   XtSetArg(args[n], XmNtopPosition, 12); n++;     // % of height from top
   XtSetArg(args[n], XmNbottomPosition, 24); n++;  // % of width from top
   XtSetArg(args[n], XmNrightPosition, 50); n++;   // % of height from left
   XtSetArg(args[n], XmNfractionBase, 100); n++;   // Use percentages
   XtSetArg(args[n], XmNtopAttachment, XmATTACH_POSITION); n++;
   XtSetArg(args[n], XmNleftAttachment, XmATTACH_POSITION); n++;
   XtSetArg(args[n], XmNbottomAttachment, XmATTACH_POSITION); n++;
   XtSetArg(args[n], XmNrightAttachment, XmATTACH_POSITION); n++;
   XtSetArg(args[n], XmNmarginHeight, 1); n++;
   XtSetArg(args[n], XmNmarginWidth, 2); n++;
   ////  Stop Motif from trying to grab another color if none are available.
   if(g.want_colormaps)  
   {    XtSetArg(args[n], XmNbackground, g.main_bcolor); n++;
        XtSetArg(args[n], XmNforeground, g.main_fcolor); n++;
   }
   clickboxdata[0].title = textlabel;
   clickboxdata[0].answers = answers;
   clickboxdata[0].startval = startval;
   clickboxdata[0].minval = minval;
   clickboxdata[0].maxval = maxval;
   clickboxdata[0].type = INTARRAY;
   clickboxdata[0].wantpreview = 0;
   clickboxdata[0].widget[0] = slider;
   clickboxdata[0].form = form;  // set this to -1 for no refresh of dialog
   clickboxdata[0].path = NULL;  
   clickboxdata[0].k = 0;
   clickboxdata[0].f1 = null;
   clickboxdata[0].f2 = null;
   clickboxdata[0].f3 = framenext;
   text = w[wc++] = XmCreateText(form, textlabel, args, n);
   XtAddCallback(text, XmNvalueChangedCallback, (XtCBP)clickboxcb, (XtP)&clickboxdata[0]);
   clickboxdata[0].widget[1] = text;
   XtManageChild(text);
   
   //--------Now add a callback so slider can change text area--------//

   clickboxdata[1].title = textlabel;
   clickboxdata[1].answers = answers;
   clickboxdata[1].startval = startval;
   clickboxdata[1].minval = minval;
   clickboxdata[1].maxval = maxval;
   clickboxdata[1].type = INTARRAY;
   clickboxdata[1].wantpreview = 0;
   clickboxdata[1].widget[0] = text;
   clickboxdata[1].widget[1] = slider;
   clickboxdata[1].form = form;  
   clickboxdata[1].path = NULL;  
   clickboxdata[1].decimalpoints = 0;  
   clickboxdata[1].count = delay;   // time delay
   clickboxdata[1].k = 0;
   clickboxdata[1].f1 = null;
   clickboxdata[1].f2 = null;
   clickboxdata[1].f3 = framenext;
   XtAddCallback(slider, XmNdragCallback, (XtCBP)slidercb, (XtP)&clickboxdata[1]);
   XtAddCallback(slider, XmNvalueChangedCallback, (XtCBP)slidercb, (XtP)&clickboxdata[1]);


   //--------Slider indicating delay----------------------------------//

   delayslider = w[wc++] = add_slider(form,"Delay",rw,7,50,24,36,40,2000,delay,20);  


   clickboxdata[2].title = textlabel;
   clickboxdata[2].answer = delay;
   clickboxdata[2].answers = answers;
   clickboxdata[2].startval = delay;
   clickboxdata[2].minval = 40;
   clickboxdata[2].maxval = 2000;
   clickboxdata[2].type = INTARRAY;
   clickboxdata[2].wantpreview = 0;
   clickboxdata[2].widget[0] = text;
   clickboxdata[2].widget[1] = slider;
   clickboxdata[2].form = form;  
   clickboxdata[2].path = NULL;  
   clickboxdata[2].decimalpoints = 0;  
   clickboxdata[2].k = 0;
   clickboxdata[2].f1 = null;
   clickboxdata[2].f2 = null;
   clickboxdata[2].f3 = null;
   XtAddCallback(delayslider, XmNdragCallback, (XtCBP)delaycb, (XtP)&clickboxdata[2]);
   XtAddCallback(delayslider, XmNvalueChangedCallback, (XtCBP)delaycb, (XtP)&clickboxdata[2]);

   w[wc++] = addlabel(form,"msec",LEFT,50,24,65,36);

   //--------Ok, Cancel, Help buttons & their callbacks---------------//

   addstandardbuttons(form, &w[wc], &helptopic);
   wc += 3;    // addstandardbuttons adds 3 widgets

   //--------Start/pause button---------------------------------------//

   n=0;
   XtSetArg(args[n], XmNleftPosition, 65); n++;    // % of width from left
   XtSetArg(args[n], XmNtopPosition, 14); n++;     // % of height from top
   XtSetArg(args[n], XmNbottomPosition, 28); n++;  // % of width from top
   XtSetArg(args[n], XmNrightPosition, 90); n++;   // % of height from left
   XtSetArg(args[n], XmNfractionBase, 100); n++;   // Use percentages
   XtSetArg(args[n], XmNtopAttachment, XmATTACH_POSITION); n++;
   XtSetArg(args[n], XmNleftAttachment, XmATTACH_POSITION); n++;
   XtSetArg(args[n], XmNbottomAttachment, XmATTACH_POSITION); n++;
   XtSetArg(args[n], XmNrightAttachment, XmATTACH_POSITION); n++;
   XtSetArg(args[n], XmNresizable, False); n++;
   startbutton = w[wc++] = XmCreatePushButton(form, "Start", args, n);
   XtManageChild(startbutton);
   XtAddCallback(startbutton, XmNactivateCallback, (XtCBP)startcb, (XtP)&clickboxdata[1]);

   ////  Movie callback
   XtAppAddTimeOut(XtWidgetToApplicationContext(form), delay, 
       moviecb, (XtP)&clickboxdata[1]);

   ////  Callbacks for x,y,z rotation sliders
   XtAddCallback(xrotslider, XmNvalueChangedCallback, (XtCBP)xrotcb, (XtP)&clickboxdata[1]);
   XtAddCallback(yrotslider, XmNvalueChangedCallback, (XtCBP)yrotcb, (XtP)&clickboxdata[1]);
   XtAddCallback(zrotslider, XmNvalueChangedCallback, (XtCBP)zrotcb, (XtP)&clickboxdata[1]);

   ////  Uncomment these if you have a really fast computer
   // XtAddCallback(xrotslider, XmNdragCallback,         (XtCBP)xrotcb, (XtP)&clickboxdata[1]);
   // XtAddCallback(yrotslider, XmNdragCallback,         (XtCBP)yrotcb, (XtP)&clickboxdata[1]);
   // XtAddCallback(zrotslider, XmNdragCallback,         (XtCBP)zrotcb, (XtP)&clickboxdata[1]);

   z[ci].animation = 1;
   XtManageChild(form);
   event_loop(form);

   done=1;
   clickboxdata[1].form = 0;
   XtUnmanageChild(form);
   XtVaGetValues(delayslider,XmNvalue,&delay,NULL);         
   if(delay) z[ci].fps = 1000.0/(double)delay;
   for(k=0;k<wc;k++) XtDestroyWidget(w[k]);
   delete[] w;
   delete[] answers;
   delete[] textlabel;
   return;
}

//--------------------------------------------------------------------// 
//  framenext                                                         //
//--------------------------------------------------------------------// 
void framenext(int answers[10])
{    
     int frame = answers[0];
     int ino = answers[1];
     if(ino>0 && ino<g.image_count)
     {   z[ino].cf = max(0,min(z[ino].frames-1, frame)); 
         frame = z[ino].cf;
         switchto(ino); 
         rebuild_display(ino);
         redraw(ino);
         ////  This is necessary in case image is on root window
         send_event(z[ino].win, Expose, 0, 0, z[ino].xsize, z[ino].ysize);
         XFlush(g.display);
     }
}



//--------------------------------------------------------------------//
// moviecb                                                            //
//--------------------------------------------------------------------//
void moviecb(XtP client_data, XtIntervalId *timer_id)
{  
    if(done) return;  // Stop it from coming here after Ok button clicked
    client_data=client_data; timer_id=timer_id;  // Keep compiler quiet
    char tempstring[100];
    XEvent event;
    XtAppContext xtapc; 
    xtapc = XtWidgetToApplicationContext(g.main_widget);
    clickboxinfo *c = (clickboxinfo *)client_data;
    if(c->form != 0 && c->answers[3])
    {    if(XCheckMaskEvent(g.display, g.main_mask | g.mouse_mask, &event))
              XtAppProcessEvent(xtapc, XtIMAll);
         XtAppAddTimeOut(XtWidgetToApplicationContext(g.main_widget), c->answers[2], 
             moviecb, (XtP)c);
         itoa(c->answers[0], tempstring, 10);   
         c->answers[0]++;   // frame no.  
         if(c->answers[0] > c->maxval) c->answers[0]=0;
         if(c->answers[4])  // if want refresh
         {   XmTextSetString(c->widget[0], tempstring);   
             XmScaleSetValue(c->widget[1], c->answers[0]);
             clickboxcb(c->widget[0], client_data, (XmACB*)NULL);
             slidercb(c->widget[1], client_data,(XmACB*)NULL);
         }else              // just call the callbax
         {   if(g.getout){ g.getout=0; g.dialogdone=c->form; }
             slider_now_cb((Widget)0, client_data,(XmACB*)NULL);
         }
    }   
}


//--------------------------------------------------------------------//
// delaycb                                                            //
//--------------------------------------------------------------------//
void delaycb(Widget w, XtP client_data, XmACB *call_data)
{
  if(done) return;      // Stop it from coming here after Ok button clicked
  call_data=call_data;  // Keep compiler quiet
  int answer=0;
  clickboxinfo *c = (clickboxinfo*)client_data;
  XmScaleGetValue(w, &answer);
  c->answers[2] = answer;
}


//--------------------------------------------------------------------//
// startcb                                                            //
//--------------------------------------------------------------------//
void startcb(Widget w, XtP client_data, XmACB *call_data)
{
   if(done) return;  // Stop it from coming here after Ok button clicked
   w=w; call_data=call_data;  // keep compiler quiet
   XmString xms;
   clickboxinfo *c = (clickboxinfo*)client_data;
   char tempstring[20];
   c->answers[3] = 1 - c->answers[3];
   if(c->answers[3])
   {   XtAppAddTimeOut(XtWidgetToApplicationContext(c->form), c->answers[2], 
              moviecb, (XtP)c);
       strcpy(tempstring,"Pause");   
       z[ci].animation = 1;
   }else
   {
       strcpy(tempstring,"Start");   
       z[ci].animation = 0;
   }
   XtVaSetValues(w, XmNlabelString, xms=XmStringCreateSimple(tempstring), NULL);
   XmStringFree(xms);   
}


//--------------------------------------------------------------------//
// xrotslidercb                                                       //
//--------------------------------------------------------------------//
void xrotcb(Widget w, XtP client_data, XmACB *call_data)
{
  int xangle, ino;
  call_data=call_data;  // Keep compiler quiet
  int answer=0;
  clickboxinfo *c = (clickboxinfo*)client_data;
  XmScaleGetValue(w, &answer);
  ino    = c->answers[1];
  xangle = answer;
  c->answers[4] = xangle;
  z[ino].xangle = xangle;
  rotate3d(ino, z[ino].xangle, z[ino].yangle, z[ino].zangle);  
}


//--------------------------------------------------------------------//
// yrotslidercb                                                       //
//--------------------------------------------------------------------//
void yrotcb(Widget w, XtP client_data, XmACB *call_data)
{
  int yangle, ino;
  call_data=call_data;  // Keep compiler quiet
  int answer=0;
  clickboxinfo *c = (clickboxinfo*)client_data;
  XmScaleGetValue(w, &answer);
  ino    = c->answers[1];
  yangle = answer;
  c->answers[5] = yangle;
  z[ino].yangle = yangle;
  rotate3d(ino, z[ino].xangle, z[ino].yangle, z[ino].zangle);  
}


//--------------------------------------------------------------------//
// zrotslidercb                                                       //
//--------------------------------------------------------------------//
void zrotcb(Widget w, XtP client_data, XmACB *call_data)
{
  int zangle, ino;
  call_data=call_data;  // Keep compiler quiet
  int answer=0;
  clickboxinfo *c = (clickboxinfo*)client_data;
  XmScaleGetValue(w, &answer);
  ino    = c->answers[1];
  zangle = answer;
  c->answers[6] = zangle;
  z[ino].zangle = zangle;
  rotate3d(ino, z[ino].xangle, z[ino].yangle, z[ino].zangle);  
}

 


//-------------------------------------------------------------------------//
// rotate3d - not finished                                                 //
//-------------------------------------------------------------------------//
void rotate3d(int ino, double xdegrees, double ydegrees, double zdegrees)
{
  xdegrees=xdegrees; ydegrees=ydegrees;
  const double DEGPERRAD = 57.2957795130823299701;
  ScanParams sp; 
  int bpp,iino,ibpp,j,k,oxsize,oysize,scancount=0,size,mode=0,
      ix1,ix2,iy1,iy2,j2,k2,xsize,ysize,oxpos,oypos,v;
  double xx[4], yy[4], zz[4];
  double degrees,a,b,c,d,e,f,h,q,s,dx,dy,r1,x1,x2,x3,x4,y1,y2,y3,y4;
  int xoffset, yoffset;

  drawselectbox(OFF);
  oxpos = g.selected_ulx;
  oypos = g.selected_uly;
  oxsize = g.selected_lrx-g.selected_ulx;
  oysize = g.selected_lry-g.selected_uly;
  ix1 = oxpos;
  iy1 = oypos;
  ix2 = ix1 + oxsize;
  iy2 = iy1 + oysize; 

  g.getout=0; 
  if(memorylessthan(16384)){  message(g.nomemory,ERROR); return; } 
  degrees=zdegrees;
  while(degrees>=360.0) degrees-=360.0;
  while(degrees<0.0) degrees+=360.0;
  
  r1 = degrees;
  while(r1>90.0) r1-=90.0;
  r1 = r1/DEGPERRAD;        // rotation angle in radians

  dx = sin(r1);  // increment in x direction (scan returns array spaced at 1 unit distances)
  dy = cos(r1);  // increment in y direction 

  a = (double)oysize * dx;
  b = a * dx;
  c = a * dy;
  d = (double)oxsize * dx;
  e = d * dy;
  f = d * dx;
  h = (double)oysize * dy * dy;   
  q = (double)oxsize * dy;
  s = (double)oysize * dy;

  xsize = (int)(a + q);
  ysize = (int)(d + s);
    
  if(between(degrees,90.001,180.001)) swap(xsize,ysize);
  if(between(degrees,270.001,359.999)) swap(xsize,ysize);

  bpp = z[ino].bpp;
  switchto(ino);

  size = 100 +(int)sqrt(oxsize*oxsize + oysize*oysize);
  sp.skip        = -1;
  sp.leavemarked = 0;
  sp.scanwidth   = 0;
  sp.invert      = 0;
  sp.od          = new int[256];
  sp.ino         = ci;
  sp.bpp         = z[ci].bpp;
  sp.wantcolor = 4;     // color, no antialiasing
  sp.diameter  = 12;
  
  sp.scan = new double[size];
  for(k=0;k<size;k++)sp.scan[k] = (double)k;
  
  for(k=0;k<256;k++) sp.od[k] = k;

  x1 = oxpos - c;  
  y1 = oypos + h;
  x2 = oxpos + oxsize - f;
  y2 = oypos + oysize + e;
  x3 = oxpos + oxsize + c;
  y3 = oypos + b;
  x4 = oxpos + f;
  y4 = oypos - e;

  if(between(degrees,0.0, 0.001)) mode=1;
  if(between(degrees,89.999, 90.001)) mode=2;
  if(between(degrees,179.999, 180.001)) mode=3;
  if(between(degrees,269.999, 270.001)) mode=4;
  if(between(degrees,359.999, 360.0)) mode=1; 
  if(between(degrees,0.001,89.999))   { xx[1]=x1; yy[1]=y1; xx[2]=x2; yy[2]=y2; dy*=-1; }
  if(between(degrees,90.001,179.999)) { xx[1]=x4; yy[1]=y4; xx[2]=x1; yy[2]=y1; fswap(dx,dy);}                    
  if(between(degrees,180.001,269.999)){ xx[1]=x3; yy[1]=y3; xx[2]=x4; yy[2]=y4; dx*=-1; }                    
  if(between(degrees,270.001,359.999)){ xx[1]=x2; yy[1]=y2; xx[2]=x3; yy[2]=y3; dx*=-1;
       dy*=-1; fswap(dx,dy);  }                    

  ////  Rotate the image
  printstatus(BUSY);
  xoffset = (xsize-oxsize)/2;
  yoffset = (ysize-oysize)/2;
  switch(mode)
  {   case 0:     // arbitrary angle
         for(j=0;j<ysize;j++) 
         {   
               scan_fixed_width_area3d(&sp, xx, yy, zz, scancount); 
               if(bpp!=g.bitsperpixel)
                   for(k=0;k<scancount;k++)
                        sp.scan[k] = (double)convertpixel((int)sp.scan[k], sp.bpp, g.bitsperpixel, 1);

               for(k=0;k<min(z[ino].xsize+xoffset,xsize);k++)          
               {    
                    if(between(ysize-j-yoffset-1, 0, z[ino].ysize-1) &&
                       between(k-xoffset, 0, z[ino].xsize-1))
                    {
                       putpixelbytes(z[ino].img[ysize-j-yoffset-1] + 
                        (k-xoffset)*g.off[g.bitsperpixel], (int)sp.scan[k], 1);
                    }                        
               }
               yy[1] += dy;
               yy[2] += dy;
               xx[1] += dx;
               xx[2] += dx;
         }
         break;
      case 1:     //  0 degrees
         for(j=iy1,j2=0;j<=iy2;j++,j2++) 
         for(k=ix1,k2=0;k<=ix2;k++,k2++)          
         {   v = readpixelonimage(k,j,ibpp,iino,-1);
             v = convertpixel((int)v, sp.bpp, g.bitsperpixel, 1);
             putpixelbytes(z[ino].img[j2]+k2*g.off[g.bitsperpixel], v, 1, g.bitsperpixel, 1);
         }
         break;
      case 2:    // 90 degrees
         for(j=iy1,j2=0;j<=iy2;j++,j2++) 
         for(k=ix1,k2=0;k<=ix2;k++,k2++)          
         {   v=readpixelonimage(k,j,bpp,iino,-1);
             v = convertpixel((int)v, sp.bpp, g.bitsperpixel, 1);
             putpixelbytes(z[ino].img[oxsize-k2]+j2*g.off[g.bitsperpixel],v,1,g.bitsperpixel,1);
         }
         break;
      case 3:     // 180 degrees
         for(j=iy1,j2=0;j<=iy2;j++,j2++) 
         for(k=ix1,k2=0;k<=ix2;k++,k2++)          
         {   v=readpixelonimage(k,j,ibpp,iino,-1);
             v = convertpixel((int)v, sp.bpp, g.bitsperpixel, 1);
             putpixelbytes(z[ino].img[oysize-j2]+(oxsize-k2)*g.off[g.bitsperpixel],v,1,g.bitsperpixel,1);
         }
         break;
      case 4:     // 270 degrees
         for(j=iy1,j2=0;j<=iy2;j++,j2++) 
         for(k=ix1,k2=0;k<=ix2;k++,k2++)          
         {   v=readpixelonimage(k,j,bpp,iino,-1);
             v = convertpixel((int)v, sp.bpp, g.bitsperpixel, 1);
             putpixelbytes(z[ino].img[k2]+(oysize-j2)*g.off[g.bitsperpixel],v,1,g.bitsperpixel,1);
         }
         break;
  } 
  delete[] sp.scan;
  delete[] sp.od;
  z[ino].touched = 1;
  switchto(ino);
  printstatus(NORMAL);
  redraw(ino);
  ////  This is necessary in case image is on root window
  send_event(z[ino].win,Expose,0,0,z[ino].xsize,z[ino].ysize);
  XFlush(g.display);
  return;
}


//-------------------------------------------------------------------------//
// scan_fixed_width_area3d - only works for z rotation so far              //
//-------------------------------------------------------------------------//
void scan_fixed_width_area3d(ScanParams *sp, double xx[], double yy[], double zz[], 
  int &scancount) 
{
  double a,m12,dx12;
  double d=0.0,dp,dx,dy,ddx,ddy,fx,fy,mp,xs,ys;
  int j,ix,iy,bpp,ino;
  zz=zz;
  ino=sp->ino;
  bpp=z[ino].bpp;
    //---Calculate line between the starting and ending points---//
  dx12 = (double)(xx[2]-xx[1]); if(dx12==0) dx12=1e-6;
  m12 = (yy[2] - yy[1])/dx12; if(m12==0) m12=1e-6;
    //---Length of line between x1,y1 and x2,y2------------------//
  a = (xx[2]-xx[1]) * (xx[2]-xx[1]) + (yy[2]-yy[1]) * (yy[2]-yy[1]);
  d = sqrt(a);
  scancount = (int)d;
    //---X & Y incremental distances along line parallel to 1--2 //
  ddx = sqrt(1.0/(1.0+m12*m12));
  if(xx[1]>xx[2]) ddx *= -1.0;
  ddy = ddx*m12;
    //---Calculate line perpendicular to 1--2, through x1,y1 ----//
  if(fabs(m12)>1e-10) mp = -1.0/m12;  else mp = -100000000.0;
  dp = - 1;
  dx = sqrt((dp*dp)/(1.0+mp*mp));  // Incremental distance along perp.
  dx *= sgn(dp);
  dy = mp * dx;       
  xs = xx[1] + dx;                 // Starting coordinates
  ys = yy[1] + dy;
  //---Calculate the line parallel to 1--2.--------------------//
  //---Calculate the coords. of each point on this line.-------//
  fx = xs - z[ino].xpos; 
  fy = ys - z[ino].ypos;    // floating-point real coordinates
  for(j=0;j<scancount;j++)
  {    ix = int(fx);
       iy = int(fy);
       if(between(ix,0,z[ino].xsize-1) && between(iy,0,z[ino].ysize-1))
             sp->scan[j]=pixelat(z[ino].image[0][iy]+ix*g.off[bpp], bpp);
       else sp->scan[j]=g.bcolor;
       fx+=ddx;
       fy+=ddy; 
  } 
}


//-------------------------------------------------------------------------//
//  add_slider                                                             //
//-------------------------------------------------------------------------//
Widget add_slider(Widget parent, char *name, int width, int left, int right, 
   int top, int bottom, int minval, int maxval, int startval, int increment)
{
   int n;
   Arg args[100];
   Widget w;
     
   n = 0;
   XtSetArg(args[n], XmNwidth, width); n++;      
   XtSetArg(args[n], XmNleftPosition, left); n++;      // % of width from left
   XtSetArg(args[n], XmNtopPosition, top); n++;        // % of height from top
   XtSetArg(args[n], XmNbottomPosition, bottom); n++;  // % of width from top
   XtSetArg(args[n], XmNrightPosition, right); n++;    // % of height from left
   XtSetArg(args[n], XmNfractionBase, 100); n++;       // Use percentages
   XtSetArg(args[n], XmNtopAttachment, XmATTACH_POSITION); n++;
   XtSetArg(args[n], XmNleftAttachment, XmATTACH_POSITION); n++;
   XtSetArg(args[n], XmNbottomAttachment, XmATTACH_POSITION); n++;
   XtSetArg(args[n], XmNrightAttachment, XmATTACH_POSITION); n++;
   XtSetArg(args[n], XmNminimum, minval); n++; 
   XtSetArg(args[n], XmNmaximum, maxval); n++; 
   XtSetArg(args[n], XmNprocessingDirection,XmMAX_ON_RIGHT); n++;      
   XtSetArg(args[n], XmNhighlightOnEnter, True); n++;      
   XtSetArg(args[n], XmNincrement, increment); n++; 
   XtSetArg(args[n], XmNvalue, startval); n++; 
   XtSetArg(args[n], XmNorientation, XmHORIZONTAL); n++;      
#ifdef MOTIF2
   XtSetArg(args[n], XmNshowValue, XmNEAR_BORDER); n++;      
   XtSetArg(args[n], XmNsliderMark, XmTHUMB_MARK); n++;      
   XtSetArg(args[n], XmNshowArrows, XmEACH_SIDE); n++;      
#else
   XtSetArg(args[n], XmNshowArrows, True); n++;      
#endif
   XtSetArg(args[n], XmNhighlightThickness, 1); n++;      
   ////  Stop Motif from trying to grab another color if none are available.
   if(g.want_colormaps)  
   {    XtSetArg(args[n], XmNbackground, g.main_bcolor); n++;
        XtSetArg(args[n], XmNforeground, g.main_fcolor); n++;
   }
   w = XmCreateScale(parent, name, args, n);
   XtManageChild(w);
   return w;
}
