//--------------------------------------------------------------------------//
// xmtnimage29.cc                                                           //
// fill                                                                     //
// Latest revision: 01-11-1999                                              //
// Copyright (C) 1999 by Thomas J. Nelson                                   //
// All rights reserved.                                                     //
//--------------------------------------------------------------------------//

#include "xmtnimage.h"

extern Globals     g;
extern Images     *z;
extern int         ci;
extern PrinterStruct printer;
int square=0;


//-------------------------------------------------------------------------//
//  fillregion - fill a region of the screen with a color                  //
//-------------------------------------------------------------------------//
void fillregion(void)
{
   static uint fillcolor=g.fcolor;
   static uint mingrad=0;
   static uint maxgrad=g.maxcolor;
   static int type=0;
   int bpp,oino,ino,j,k,x1,y1,x2,y2;   
  
   oino=g.selectedimage;
   g.region_ino = ci;
   x1 = g.selected_ulx;
   x2 = g.selected_lrx;
   y1 = g.selected_uly;
   y2 = g.selected_lry;
   if(x1==x2 || y1==y2)
   { message("Please select a region\nor image to fill",ERROR); return; }

   ////  Determine which bpp to use. This will determine whether to get 1 value
   ////  or 3 values for a rgb in multiclickbox.
   
   ////  bpp = whatbpp((x1+x2)/2,(y1+y2)/2);
   ino = whichimage((x1+x2)/2, (y1+y2)/2, bpp);
   if(bpp==8) 
   {   if(message("Recommend converting image to\n24 bits/pixel first\nProceed anyway?",
           YESNOQUESTION)!=YES) return;
   }
   if(z[ino].colortype==GRAY) bpp=8; else bpp=24;
      
   if(memorylessthan(16384)){  message(g.nomemory,ERROR); return; } 
   Dialog dialog;

   //// Radios
   
   dialog.needrepeat = 0;  
   strcpy(dialog.title,"Fill Region");
   strcpy(dialog.radio[0][0],"Fill type");             
   strcpy(dialog.radio[0][1],"Solid");           // wantgradient=0
   strcpy(dialog.radio[0][2],"Vert.Gradient");   // wantgradient=1
   strcpy(dialog.radio[0][3],"Horiz.Gradient");  // wantgradient=2
   dialog.radioset[0]=type+1;
   dialog.radiono[0]=4;
   dialog.radiono[1]=0;
   dialog.radiono[2]=0;
   dialog.radiono[3]=0;
   for(j=0;j<10;j++) for(k=0;k<20;k++) dialog.radiotype[j][k]=RADIO;

   //// Check boxes
 
   strcpy(dialog.boxes[0],"Fill Parameters");
   strcpy(dialog.boxes[1],"Solid fill color");
   strcpy(dialog.boxes[2],"Start gradient color");
   strcpy(dialog.boxes[3],"End gradient color");

   dialog.boxtype[0]=LABEL;
   dialog.boxtype[1]=MULTICLICKBOX;
   dialog.boxtype[2]=MULTICLICKBOX;
   dialog.boxtype[3]=MULTICLICKBOX;

   for(k=1;k<=3;k++){ dialog.boxmin[k]=0;  dialog.boxmax[k]=100; }
 
   sprintf(dialog.answer[1],"%d",fillcolor);
   sprintf(dialog.answer[2],"%d",mingrad);
   sprintf(dialog.answer[3],"%d",maxgrad);

   dialog.bpp = bpp;
   dialog.noofradios=1;
   dialog.noofboxes=4;
   dialog.helptopic=9;  
   dialog.f1 = fillcheck;
   dialog.want_changecicb = 0;
   dialog.keep=0;
   dialog.transient = 1;
   strcpy(dialog.path,".");
    
   ///////---///////
   dialogbox(dialog);
   ///////---///////

   if(g.getout)return;
   printstatus(FILL);
   type = dialog.radioset[0]-1;

   fillcolor = atoi(dialog.answer[1]);
   mingrad   = atoi(dialog.answer[2]);
   maxgrad   = atoi(dialog.answer[3]);

   g.getout=0; 
   drawselectbox(OFF);
   square = g.selected_is_square;
 
   if(!between(g.region_ino, 0, g.image_count-1)) { message("Please select a region first"); return; }
   x1 = y1 = 0;
   x2 = z[g.region_ino].xsize;
   y2 = z[g.region_ino].ysize;
   fill_gradient(x1,y1,x2,y2,fillcolor,type,bpp,mingrad,maxgrad);
   
   drawselectbox(ON);
   printstatus(NORMAL);
   if(oino<0 && g.bitsperpixel==8) repairimg(-1,x1,y1,x2,y2); 
   if(oino>=0 && (z[oino].bpp==8 || g.bitsperpixel==8)) repair(oino); 
   redrawscreen(); 
}


//-------------------------------------------------------------------------//
// fill_gradient                                                           //
//-------------------------------------------------------------------------//
void fill_gradient(int minx, int miny, int maxx, int maxy, int fc, 
     int type, int bpp, int mingrad, int maxgrad)
{
   int j,k;
   int rmin, gmin, bmin, rmax, gmax, bmax, grad1, grad2;
   int ulx = g.region_ulx;
   int uly = g.region_uly;
   int lrx = g.region_lrx;
   int lry = g.region_lry;
   if(lrx==ulx || lry==uly)
   {   ulx = g.ulx;
       uly = g.uly;
       lrx = g.lrx;
       lry = g.lry;
   }
   if(type==1){ grad1=minx; grad2=maxx; } else { grad1=miny; grad2=maxy; }
   if((type!=0)&&(grad1==grad2)){  message("Bad gradient parameters"); return; }
   valuetoRGB(mingrad,rmin,gmin,bmin,bpp);
   valuetoRGB(maxgrad,rmax,gmax,bmax,bpp);
   for(j=uly;j<lry;j++)   
   for(k=ulx;k<lrx;k++)
   {      if(j<0 || k<0) continue;
          if(!g.selected_is_square && !inside_irregular_region(k-ulx+g.region_ulx,
               j-uly+g.region_uly)) continue;
          fc = gradfillcolor(fc,j,k,minx,miny,maxx,maxy,rmin,rmax,gmin,gmax, 
               bmin,bmax,type,bpp); 
          setpixelonimage(k,j,fc,g.imode,bpp,-1,0,0,1);
   }
}


//-------------------------------------------------------------------------//
// fill - fills an area bounded by a range of designated colors            //
//       when a point within the area is specified.                        //
//  x,y = start coordinates                                                //
//  fc  = fill color (if solid fill)                                       //
//  minborder, maxborder = minimum and maximum colors for border           //
//  mingrad, maxgrad = minimum and maximum colors to fill with             //
//  type :  0 = solid fill                                                 //
//          1 = horizontal gradient                                        //
//          2 = vertical gradient                                          //
//-------------------------------------------------------------------------//
#if 0
void fill(int x, int y, int minx, int miny, int maxx, int maxy, int fc, int type, 
          int bpp, int minborder, int maxborder, int mingrad, int maxgrad)
{
   if(memorylessthan(32768)){  message(g.nomemory,3); return; } 
   static struct { int yy, xl, xr, dy; } buffer[5000];
   printstatus(FILL);
   int rmin, gmin, bmin, rmax, gmax, bmax, rr, gg, bb, grad1, grad2, 
       rminborder, gminborder, bminborder, rmaxborder, gmaxborder, bmaxborder,
       c, count=0, dy, ino, ibpp, sp=0, start, x1, x2, ok=1;

   ino = whichimage(x,y,bpp);
   if(type==1){ grad1=minx; grad2=maxx; } else { grad1=miny; grad2=maxy; }
   if(ino>-1 && z[ino].shell) switchto(ino);

   valuetoRGB(mingrad,rmin,gmin,bmin,bpp);
   valuetoRGB(maxgrad,rmax,gmax,bmax,bpp);
   valuetoRGB(minborder,rminborder,gminborder,bminborder,bpp);
   valuetoRGB(maxborder,rmaxborder,gmaxborder,bmaxborder,bpp);
   if((type!=0)&&(grad1==grad2)){  message("Bad gradient parameters"); return; }

   buffer[sp].yy   = y;
   buffer[sp].xl   = x; 
   buffer[sp].xr   = x;
   buffer[sp++].dy = 1;
   buffer[sp].yy   = y+1;
   buffer[sp].xl   = x;
   buffer[sp].xr   = x;
   buffer[sp++].dy = -1;
   while(sp>0 && !button_clicked())
   {      
       //// Check next lower item on stack

       dy = buffer[--sp].dy;
       if(sp<0 || sp>4999) break;
       y = buffer[sp].yy + dy;
       x1 = buffer[sp].xl;
       x2 = buffer[sp].xr;
       x = x1;
       //// Fill left until it hits a border color or y is off screen or it hits
       //// a color already filled
 
       c = (int)readpixelonimage(x,y,ibpp,ino);
       valuetoRGB(c,rr,gg,bb,bpp);
       fc = gradfillcolor(fc,x,y,minx,miny,maxx,maxy,rmin,rmax,gmin,gmax,
            bmin,bmax,type,bpp);      
       if(between(y, miny, maxy))
       while(between(x,minx,maxx) && 
            ( !between(rr, rminborder, rmaxborder) || 
              !between(gg, gminborder, gmaxborder) || 
              !between(bb, bminborder, bmaxborder)) && 
              c!=fc)
       {    
          ok = 0;
          if(square) ok=1;
          else if(inside_irregular_region(x,y)) ok=1;
          if(ok) 
          {   setpixelonimage(x--,y,fc,SET,bpp);
              c = (int)readpixelonimage(x,y,ibpp,ino);
          }else 
          {   c=fc; x--; break; }

          valuetoRGB(c,rr,gg,bb,bpp);
          fc = gradfillcolor(fc,x,y,minx,miny,maxx,maxy,rmin,rmax,gmin,gmax,
               bmin,bmax,type,bpp);
          check_event();
          if(g.getout) break;
       }

       //// Give user a chance to break out

       if(type==0) if(y<=miny)break;   // fix
       if(y<miny)break; 
       if(y>maxy)dy=-dy; 
       if(keyhit()) if(getcharacter()==27) break;
       if(++count==10)
       {   count=0;
           printcoordinates(x,y,0);    	            
       }

       if(x >= x1) goto enter;
       start = x + 1;

       //// Check next higher item on stack

       if(start < x1)
       {    buffer[sp].yy   = y;
            buffer[sp].xl   = start;
            buffer[sp].xr   = x1 - 1;
            buffer[sp++].dy = -dy;
            if(sp<0 || sp>4999) break;
       }
       x = x1 + 1;
       do        
       {  
           //// Fill right until it hits a border color or a color already filled

           c = (int)readpixelonimage(x,y,ibpp,ino);
           valuetoRGB(c,rr,gg,bb,bpp);
           fc =  gradfillcolor(fc,x,y,minx,miny,maxx,maxy,rmin,rmax,gmin,gmax,
                 bmin,bmax,type,bpp);
           if(between(y, miny, maxy))
           while(between(x,minx,maxx) && 
                ( !between(rr, rminborder, rmaxborder) || 
                  !between(gg, gminborder, gmaxborder) || 
                  !between(bb, bminborder, bmaxborder)) && 
                  c!=fc)
           {
                 ok = 0;
                 if(square) ok=1;
                 else if(inside_irregular_region(x,y)) ok=1;
                 if(ok) 
                 {   setpixelonimage(x++,y,fc,SET,bpp);
                     c = (int)readpixelonimage(x,y,ibpp,ino);
                 }else
                 {   c=fc; x++; break;
                 }

                 valuetoRGB(c,rr,gg,bb,bpp);
                 fc = gradfillcolor(fc,x,y,minx,miny,maxx,maxy,rmin,rmax,gmin,gmax,
                      bmin,bmax,type,bpp);
                 check_event();
                 if(g.getout) break;
           }
           buffer[sp].yy = y;
           buffer[sp].xl = start;
           buffer[sp].xr = x - 1;
           buffer[sp++].dy = dy;
           if(sp<0 || sp>4999) break;
           if (x > (x2 + 1))
           {   buffer[sp].yy = y;
               buffer[sp].xl = x2 + 1;
               buffer[sp].xr = x - 1;
               buffer[sp++].dy = -dy;
               if(sp<0 || sp>4999) break;
           }
enter:   
           //// Read right until it hits an non-border and non-filled space
           
           x++;
           c = (int)readpixelonimage(x,y,ibpp,ino);
           valuetoRGB(c,rr,gg,bb,bpp);
           fc =  gradfillcolor(fc,x,y,minx,miny,maxx,maxy,rmin,rmax,gmin,gmax,
                 bmin,bmax,type,bpp);
           if(between(y, miny, maxy))
           while( x <= x2 && 
                ( between(rr, rminborder, rmaxborder) && 
                  between(gg, gminborder, gmaxborder) && 
                  between(bb, bminborder, bmaxborder)) ||
                  c==fc )
           {   x++;
               c = (int)readpixelonimage(x,y,ibpp,ino);
               if(!square && inside_irregular_region(x,y)) c=fc; 
               valuetoRGB(c,rr,gg,bb,bpp);
               fc = gradfillcolor(fc,x,y,minx,miny,maxx,maxy,rmin,rmax,gmin,gmax,
                    bmin,bmax,type,bpp);
               if(g.getout) break;
           }
           start = x;
        }
        while(x <= x2 && !button_clicked());
        if(sp>=4999){ message("Area too complex",ERROR); break; }       
   }
}           
#endif



//-------------------------------------------------------------------------//
// fill - bpp-independent fill for densitometry                            //
// fc, maxc, and minc are {0..1}                                           //
// Solid fill only                                                         //
//-------------------------------------------------------------------------//
void fill(int x, int y, int &xmin, int &ymin, int &xmax, int &ymax,
       double fc, double maxfc, double minfc)
{
   if(memorylessthan(32768)){  message(g.nomemory,3); return; } 
   printstatus(FILL);
   double THRESH=0.02;
   int count=0, color, dy, ino, bpp, sp=0, start, x1, x2;
   double c;
   int minimumx, minimumy, maximumx, maximumy;

   if(minfc>maxfc) fswap(minfc,maxfc)
   static struct 
   {   int yy, xl, xr, dy;
   }buffer[5000];

   ino = whichimage(x,y,bpp);

   ////  Limits at which filling should stop.
   
   minimumx=g.selected_ulx;
   minimumy=g.selected_uly;
   maximumx=g.selected_lrx;
   maximumy=g.selected_lry;
   if(z[ino].shell)
   {    switchto(ino);
        minimumx = min(g.xres-g.main_xpos, max(minimumx,-g.main_xpos));
        maximumx = min(g.xres-g.main_xpos, max(maximumx,-g.main_xpos));
        minimumy = min(g.yres-g.main_ypos, max(minimumy,-g.main_ypos));
        maximumy = min(g.yres-g.main_ypos, max(maximumy,-g.main_ypos));
   }


   xmin = maximumx-1; xmax = minimumx;
   ymin = maximumy-1; ymax = minimumy;
   buffer[sp].yy = y;
   buffer[sp].xl = x; 
   buffer[sp].xr = x;
   buffer[sp++].dy = 1;
   buffer[sp].yy = y + 1;
   buffer[sp].xl = x;
   buffer[sp].xr = x;
   buffer[sp++].dy = -1;

   while (sp > 0)
   {      
       //// Check next lower item on stack

       dy = buffer[--sp].dy;
       if(sp<0 || sp>4999) break;
       y = buffer[sp].yy + dy;
       ymin = min(y,ymin);
       ymax = max(y,ymax);
       x1 = buffer[sp].xl;
       x2 = buffer[sp].xr;
       x = x1;

       //// Fill left until it hits a border color or y is off screen or it hits
       //// a color already filled
 
       c = (double)readpixelonimage(x,y,bpp,ino)/(double)g.maxvalue[bpp];
       if(between(y, minimumy, maximumy))
       while(x>=minimumx && between(c,minfc,maxfc)==0 && fabs(c-fc)>THRESH)
       {    
          color = (int)(fc*g.maxvalue[bpp]);
          setpixelonimage(x--,y,color,SET,bpp);
          c = (double)readpixelonimage(x,y,bpp,ino)/(double)g.maxvalue[bpp];
       }

       //// Give user a chance to break out

       if(y<=minimumy)break;   // fix
       if(keyhit()) if(getcharacter()==27) break;
       if(++count==10)
       {   count=0;
           printcoordinates(x,y,0);    	            
       }

       xmin = min(x,xmin);
       xmax = max(x,xmax);
       if (x >= x1) goto enter;
       start = x + 1;

       //// Check next higher item on stack

       if (start < x1)
       {    buffer[sp].yy = y;
            buffer[sp].xl = start;
            buffer[sp].xr = x1 - 1;
            buffer[sp++].dy = -dy;
            if(sp<0 || sp>4999) break;
       }
       x = x1 + 1;
       xmin = min(x,xmin);
       xmax = max(x,xmax);
       do        
       {  
           //// Fill right until it hits a border color or a color already filled

           c = (double)readpixelonimage(x,y,bpp,ino)/(double)g.maxvalue[bpp];
           if(between(y, minimumy, maximumy))
           while(x<maximumx && between(c,minfc,maxfc)==0 && fabs(c-fc)>THRESH)
           {
                 color = (int)(fc*g.maxvalue[bpp]);
                 setpixelonimage(x++,y,color,SET,bpp);
                 c = (double)readpixelonimage(x,y,bpp,ino)/(double)g.maxvalue[bpp];
           }
           xmin = min(x,xmin);
           xmax = max(x,xmax);  
           buffer[sp].yy = y;
           buffer[sp].xl = start;
           buffer[sp].xr = x - 1;
           buffer[sp++].dy = dy;
           if(sp<0 || sp>4999) break;
           if (x > (x2 + 1))
           {   buffer[sp].yy = y;
               buffer[sp].xl = x2 + 1;
               buffer[sp].xr = x - 1;
               buffer[sp++].dy = -dy;
               if(sp<0 || sp>4999) break;
           }
enter:   
           //// Read right until it hits an non-border and non-filled space
           
           x++;
           c = (double)readpixelonimage(x,y,bpp,ino)/(double)g.maxvalue[bpp];
           if(between(y, minimumy, maximumy))
           while( x <= x2 && ( between(c, minfc, maxfc)!=0 || fabs(c-fc)<=THRESH ))
           {   x++;
               c = (double)readpixelonimage(x,y,bpp,ino)/(double)g.maxvalue[bpp];
           }
           xmin = min(x,xmin);
           xmax = max(x,xmax);
           start = x;
        }while (x <= x2);

        if(sp>=4999){ message("Area too complex",ERROR); break; }       
   }
   if(xmin<minimumx) xmin=minimumx;
   if(xmax>maximumx) xmax=maximumx;
   if(ymin<minimumy) ymin=minimumy;
   if(ymax>maximumy) ymax=maximumy;    
   return;
}           



//-------------------------------------------------------------------------//
// gradfillcolor                                                           //
// Called by fill() during gradient fills to calculate the appropriate     //
// fill color.                                                             //
//-------------------------------------------------------------------------//
int gradfillcolor(int startcolor, int x, int y, 
                  int x1, int y1, int x2, int y2,
                  int rmin, int rmax, int gmin, 
                  int gmax, int bmin, int bmax, 
                  int type, int bpp)
{
  int f=startcolor;
  int dx=0,dy=0,fr,fg,fb;
  switch(type)
  { 
    case 0:        // no gradient
        break; 
    case 1:        // horizontal gradient
        dx = x2-x1;
        if(dx==0) return 0;
        fr = rmin + (x-x1)*(rmax - rmin)/dx;
        fg = gmin + (x-x1)*(gmax - gmin)/dx;
        fb = bmin + (x-x1)*(bmax - bmin)/dx;
        fr = max(0,min(fr,g.maxred[bpp]));
        fg = max(0,min(fg,g.maxgreen[bpp]));
        fb = max(0,min(fb,g.maxblue[bpp]));
        f = RGBvalue(fr,fg,fb,bpp);
        break;
    case 2:         // vertical gradient
        dy = y2-y1;
        fr = rmin + (y-y1)*(rmax - rmin)/dy;
        fg = gmin + (y-y1)*(gmax - gmin)/dy;
        fb = bmin + (y-y1)*(bmax - bmin)/dy;
        fr = max(0,min(fr,g.maxred[bpp]));
        fg = max(0,min(fg,g.maxgreen[bpp]));
        fb = max(0,min(fb,g.maxblue[bpp]));
        f = RGBvalue(fr,fg,fb,bpp);
        break;       
    default: break;
  }    
  return f;
}



//--------------------------------------------------------------------------//
//  fillcheck                                                               //
//--------------------------------------------------------------------------//
void fillcheck(dialoginfo *a, int radio, int box, int boxbutton)
{
    int j,k;box=box;boxbutton=boxbutton;
    if(radio==0) for(k=0;k<=3;k++) 
    if(a->radioset[0]==1)      // Solid
    {   if(a->boxwidget[1][k]) XtSetSensitive(a->boxwidget[1][k],True);
         for(j=2;j<=3;j++) 
              if(a->boxwidget[j][k]) XtSetSensitive(a->boxwidget[j][k],False);
    }else                      // Horiz or vertical gradient
    {  if(a->boxwidget[1][k]) XtSetSensitive(a->boxwidget[1][k],False);
       for(j=2;j<=3;j++) 
              if(a->boxwidget[j][k]) XtSetSensitive(a->boxwidget[j][k],True);
    }
}
