//--------------------------------------------------------------------------//
// xmtnimage3.cc                                                            //
// Image file reading, writing                                              //
// Latest revision: 05-18-1999                                              //
// Copyright (C) 1999 by Thomas J. Nelson                                   //
// All rights reserved.                                                     //
//--------------------------------------------------------------------------//
 
#include "xmtnimage.h"
extern Globals     g;
extern Images     *z;
extern int         ci;

int override=0;

// Variables for reading files
int raw=0;

int want_grayscale=0;
int want_convert=0;
int skipswitch=0;
int swap_bytes=0;
  
//--------------------------------------------------------------------------//
// setreadparameters                                                        //
// Selects custom parameters for reading an image, using dialog box.        //
// Needs to be rewritten.                                                   //
//--------------------------------------------------------------------------//
char **setreadparameters(int *status, int *count, int noofargs, char **arg)
{  
  if(memorylessthan(16384)){ message(g.nomemory,ERROR); *status=NOMEM; return NULL; }
  static char filename[FILENAMELENGTH]="Untitled";
  char **filelist=NULL;
  Dialog dialog;
  dialog.needrepeat=0;
  int j,k;
  char temp2[202];
  char *ptr; 
  g.getout=0;
  if(noofargs==0)
  {  strcpy(dialog.title,"Read Image");
     strcpy(dialog.radio[0][0],"File type");
     strcpy(dialog.radio[0][1],"Auto file type");
     strcpy(dialog.radio[0][2],"Raw bytes");
     strcpy(dialog.radio[0][3],"ASCII");
     strcpy(dialog.radio[0][4],"Raw 3-D");
     strcpy(dialog.radio[1][0],"Color reduction");
     strcpy(dialog.radio[1][1],"Quantization");
     strcpy(dialog.radio[1][2],"Fit current palette");
     strcpy(dialog.radio[1][3],"None");
  
     dialog.radioset[0]=raw+1;
     dialog.radioset[1]=g.want_quantize;
     dialog.radiono[0]=5;
     dialog.radiono[1]=4;
     dialog.radiono[2]=0;
     for(j=0;j<10;j++) for(k=0;k<20;k++) dialog.radiotype[j][k]=RADIO;

     strcpy(dialog.boxes[0],"File Parameters");
     strcpy(dialog.boxes[1],"Filename");
     strcpy(dialog.boxes[2],"X position");
     strcpy(dialog.boxes[3],"Y position");
     strcpy(dialog.boxes[4],"X size");
     strcpy(dialog.boxes[5],"Y size");
     strcpy(dialog.boxes[6],"CMYK->RGB");
     strcpy(dialog.boxes[7],"Convert->Gray scale");
     strcpy(dialog.boxes[8],"Convert->Screen depth");
     strcpy(dialog.boxes[9],"Negative image");
     strcpy(dialog.boxes[10],"Separate window");
     strcpy(dialog.boxes[11],"Swap bytes");
     strcpy(dialog.boxes[12] ,"Pre-processing");
     strcpy(dialog.boxes[13] ,"Command");
     strcpy(dialog.boxes[14] ,"Extension");

     dialog.boxtype[0]=LABEL;
     dialog.boxtype[1]=MULTIFILENAME;
     dialog.boxtype[2]=INTCLICKBOX; 
     dialog.boxtype[3]=INTCLICKBOX;
     dialog.boxtype[4]=INTCLICKBOX;
     dialog.boxtype[5]=INTCLICKBOX;
     dialog.boxtype[6]=TOGGLE;    
     dialog.boxtype[7]=TOGGLE;     
     dialog.boxtype[8]=TOGGLE;     
     dialog.boxtype[9]=TOGGLE;     
     dialog.boxtype[10]=TOGGLE;     
     dialog.boxtype[11]=TOGGLE;     
     dialog.boxtype[12]=LABEL;     
     dialog.boxtype[13]=STRING;     
     dialog.boxtype[14]=STRING;     
     dialog.boxmin[2]=0; dialog.boxmax[2]=g.xres;
     dialog.boxmin[3]=0; dialog.boxmax[3]=g.yres;
     dialog.boxmin[4]=0; dialog.boxmax[4]=100;
     dialog.boxmin[5]=0; dialog.boxmax[5]=100;

     strcpy(dialog.answer[1],basefilename(filename));
     itoa(g.tif_xoffset,temp2,10);
     strcpy(dialog.answer[2],temp2);
     itoa(g.tif_yoffset,temp2,10);
     strcpy(dialog.answer[3],temp2);
     gcvt(g.tif_xsize*100,5,temp2);       //  tif_xsize and tif_ysize are
                                          //  temporarily multiplied by 100
                                          //  for use in click box.
     strcpy(dialog.answer[4],temp2);
     gcvt(g.tif_ysize*100,5,temp2);
     strcpy(dialog.answer[5],temp2);
     if(g.read_cmyk)     dialog.boxset[6]=1; else dialog.boxset[6]=0;
     if(want_grayscale)  dialog.boxset[7]=1; else dialog.boxset[7]=0;
     if(want_convert)    dialog.boxset[8]=1; else dialog.boxset[8]=0;
     if(g.tif_positive)  dialog.boxset[9]=0; else dialog.boxset[9]=1;
     if(g.want_shell)    dialog.boxset[10]=1; else dialog.boxset[10]=0;
     if(swap_bytes)      dialog.boxset[11]=1; else dialog.boxset[11]=0;
     strcpy(dialog.answer[13], g.decompression);
     strcpy(dialog.answer[14], g.compression_ext);

     dialog.boxlist[1] = filelist;
     dialog.noofradios=2;
     dialog.noofboxes=15;
     dialog.helptopic=11;  
     dialog.keep=0;
     dialog.want_changecicb = 0;
     dialog.f1 = null;
     dialog.transient = 1;
     strcpy(dialog.path,".");

     /////////////////////////////

     dialogbox(dialog);

     /////////////////////////////

     if(g.getout){ *status=ABORT; return NULL;}
     raw = dialog.radioset[0]-1;
     g.want_quantize = dialog.radioset[1];

     strcpy(filename,dialog.answer[1]);
     *count = dialog.boxcount[1];
     g.tif_xoffset=atoi(dialog.answer[2]);
     g.tif_yoffset=atoi(dialog.answer[3]);
     g.tif_xsize  = strtod(dialog.answer[4],&ptr)/100.0;
     g.tif_ysize  = strtod(dialog.answer[5],&ptr)/100.0;
     if(dialog.boxset[6]) g.read_cmyk     =1; else g.read_cmyk     =0;
     if(dialog.boxset[7]) want_grayscale  =1; else want_grayscale  =0;
     if(dialog.boxset[8]) want_convert    =1; else want_convert    =0;
     if(dialog.boxset[9]) g.tif_positive  =0; else g.tif_positive  =1;
     if(dialog.boxset[10]) g.want_shell   =1; else g.want_shell    =0;
     if(dialog.boxset[11]) swap_bytes     =1; else swap_bytes      =0;
     strcpy(g.decompression, dialog.answer[13]);
     strcpy(g.compression_ext, dialog.answer[14]);
     filelist = dialog.boxlist[1];  
  }else
  {  if(noofargs>0)
     {   *count=1; 
         filelist = new char*[2];
         filelist[0] = (char*) XtMalloc(FILENAMELENGTH);
         strcpy(filename, arg[1]); 
         strcpy(filelist[0], arg[1]);        
     }
     if(noofargs>1) g.tif_xoffset = atoi(arg[2]);
     if(noofargs>2) g.tif_yoffset = atoi(arg[3]);
     if(noofargs>3) g.tif_xsize   = strtod(arg[4],&ptr);
     if(noofargs>4) g.tif_ysize   = strtod(arg[5],&ptr);

  }
    
  if(g.tif_xsize>1) g.tif_xsize=1;
  if(g.tif_ysize>1) g.tif_ysize=1;
  if(g.tif_xsize<0) g.tif_xsize=0;
  if(g.tif_ysize<0) g.tif_ysize=0;
  *status=OK; 
  return filelist;
}



//--------------------------------------------------------------------------//
// readfiles                                                                //
// Reads one or more image files. Accepts wildcards.                        //
//                                                                          //
// Use this function instead of readimage() for loading images when there   //
// is a chance the filename may contain wildcard characters.                //
// Returns the error status.                                                //
//--------------------------------------------------------------------------//
int readfiles(char* filename, int noofargs, char **arg)
{
     if(memorylessthan(4096)){  message(g.nomemory,ERROR); return(0); } 
     int status=OK;

    // In Unix, wildcard expansion is done by the shell. So we only 
    // have to read the specified file.

    if(filename!=NULL) 
    {  skipswitch=1;
       status=readimage(filename,noofargs,arg);
       skipswitch=0;
    }   
    return(status);
}


//--------------------------------------------------------------------------//
// readimage                                                                //
// Determines whether image is a TIF (=1), PCX (=2), IMA (3), IMG (4), etc. //
// Then automatically calls the appropriate file reading routine.           //
// This function only loads a single file.                                  //
// Use readfiles(), which checks for wildcards, to load an image with a     //
// user-specified filename which could have wildcards.                      //
//--------------------------------------------------------------------------//
int readimage(char* filename, int noofargs, char **arg)
{   
   if(g.diagnose){ printf("Reading image %s\n",filename);fflush(stdout); }
   int delay,f,i,i2,j,k,length,type,status=OK,oci=ci;
   uint color;
   char tempstring[FILENAMELENGTH];
   char program[64];
   char fname[1024];
   char identifier[64];
   int compress = 0;
 
   FILE *fp;
   ////  Test if file is readable by trying to open it - a more thorough 
   ////  test than access(). Also check if it's a directory.

   if(is_dir(filename)) { message("This is a directory",ERROR); return ERROR; }   
   if((fp=fopen(filename,"rb")) == NULL)
   {   error_message(filename, errno);
       return(ERROR);
   }
   fclose(fp);
   g.invertbytes=0;
   
   switch(raw)
   {   case 1:  type = RAW; break;
       case 2:  type = ASCII; break;
       case 3:  type = RAW3D; break;
       default: type = imagefiletype(filename, identifier, compress);
   }

   g.state=READING;
   printstatus(g.state);
   drawselectbox(OFF);
   setSVGApalette(1,0); // Switch to grayscale in case image has no palette

   //// This temporary file is the only way to decompress some image file formats.
   //// The limiting factor is TIFF which is impossible to read with out using
   //// fseek or lseek which can't be used in a pipe.
   //// No such limitation exists for writing image files, so writing can use a pipe.

   if(compress)
   {   strncpy(program, g.decompression, 64);
       for(k=0;k<(int)strlen(program);k++) if(program[k]==' ') program[k]=0;  
       if(access(program, X_OK)) 
       {    compress = 0;
            sprintf(tempstring, "Cannot execute %s", program);
            message(tempstring);
            return ABORT;
       }
       strcpy(fname, "/tmp/tni-temp");
       sprintf(tempstring, "%s %s %c %s", g.decompression, filename, '>', fname);
       system(tempstring);
       filename[strlen(filename) - strlen(g.compression_ext)] = 0;   
   }else
       strcpy(fname, filename);

   switch(type)       // status==OK means no errors
   {   case TIF:   status=readtiffile(fname);     break;
       case PCX:   status=readpcxfile(fname);     break;
       case IMA:   status=readimafile(fname);     break;
       case IMM:
       case IMG:
       case RAW:
       case ASCII: status=readimgfile(fname,type,noofargs,arg);break;
       case RAW3D: status=read3Dfile(fname);      break;
       case GIF:   status=readgiffile(fname);     break;
       case GEM:
       case IMDS:  status=readgemfile(fname,type);break;
       case JPG:   status=readjpgfile(fname);     break;
       case BMP:   status=readbmpfile(fname);     break;
       case TARGA: status=readtgafile(fname);     break;
       case PICT:  status=readjpgfile(fname);     break;
       case XWD:   status=readxwdfile(fname);     break;
       case FITS:  status=readfitsfile(fname);    break;
       case PDS:   status=readpdsfile(fname);     break;
       case PDS2:  status=readpds2file(fname);    break;
       case PBM:    
       case PGM:    
       case PPM:  
       case PBMRAW: 
       case PGMRAW: 
       case PPMRAW: status=readpbmfile(fname,0); break;
       case CUSTOM: status=readcustomfile(fname, identifier);break;  
   }   
   
   //// For image types whose bytes are not automatically swapped in Solaris
   if(g.bitsperpixel==8 && g.ximage_byte_order != LSBFirst)
   {  switch(type)
      {
           case JPG:
           case BMP:
           case CUSTOM:
           case TARGA:
              invertimagebytes(z[ci].bpp); 
              break;
      }
   }

   
   if(compress)
   {   unlink(fname);
       z[ci].was_compressed = 1;
   }

   printstatus(g.state);
 
   if(ci != oci)                    // If a new image was created 
   {       
      if(!g.tif_positive) invertimage(); 
      if(g.invertbytes) invertimagebytes(z[ci].bpp); 
      if(swap_bytes) 
      {      length = z[ci].xsize * g.off[z[ci].bpp];
             for(f=0;f<z[ci].frames;f++)
             for(j=0;j<z[ci].ysize;j++)
                swapbytes(z[ci].image[f][j],length,g.off[z[ci].bpp]);
             repair(ci);
      }
      if(ci>=0) 
         setimagetitle(ci, strip_relative_path(filename));
      if(g.want_shell)
      {   
         XtVaSetValues(z[ci].widget, XmNtitle,
              basefilename(filename),
              XmNiconName, basefilename(filename), 0);
         XtVaSetValues(XtParent(z[ci].widget), XmNtitle,
              basefilename(filename),
              XmNiconName, basefilename(filename), 0);
         XtVaSetValues(XtParent(XtParent(z[ci].widget)), XmNtitle,
              basefilename(filename),
              XmNiconName, basefilename(filename), 0);
      }
      strcpy(z[ci].format_name, identifier);

      if(status!=OK)
      {  sprintf(tempstring,"Error reading %s file",z[ci].format_name);
         message(tempstring,ERROR);
      }
      printstatus(g.state);
      if(want_grayscale) converttograyscale(ci);
                                    // Expand image if in 15-24 bpp modes
      if(want_convert) change_image_depth(ci,g.bitsperpixel,PERM);
      memcpy(z[ci].palette, g.palette, 768);
      if(z[ci].frames==1) sortpalette(ci);
      memcpy(z[ci].opalette, g.palette, 768);
      memcpy(z[ci].spalette, g.palette, 768);
                                    // Check if image is actually grayscale
      if(unmodified_grayscale(z[ci].palette) && z[ci].bpp==8) z[ci].colortype=GRAY;  
      if(g.autoundo) backupimage(ci,0); 
      if(skipswitch==0) switchto(ci);
      setpalette(z[ci].palette);
      rebuild_display(ci);
      repair(ci);
                                    // Different pixel interact modes
      if(g.imode!=SET)
      {  for(j=z[ci].ypos;j<z[ci].ypos+z[ci].ysize;j++)
         { for(i=z[ci].xpos,i2=0;i<z[ci].xpos+z[ci].xsize;i++,
                 i2+=g.off[z[ci].bpp])
           {  color = pixelat(z[ci].image[z[ci].cf][j-z[ci].ypos]+i2,z[ci].bpp);
                                    // Take color from the image
                                    // Interact it with topmost pixel from
                                    // another image or background but not
                                    // itself (skip ci).
              setpixelonimage(i,j,color,g.imode,z[ci].bpp,ci);
           }   
           if(keyhit())if(getcharacter()==27)break;
         }
         if(skipswitch==0) switchto(ci);          
         repairimg(ci,0,0,z[ci].xsize,z[ci].ysize);             // Fix up display
      }    

   }
   if(g.diagnose)
   { printf("done, ci %d x %d y %d bpp %d\n",ci,z[ci].xsize,z[ci].ysize,z[ci].bpp); }
   g.state=NORMAL;
   printstatus(g.state);

   //// Keep this at end 
   //// Control stays here until cancelled - ci can change in this loop

   if(z[ci].animation && z[ci].fps) 
   {  delay = (int)(1000/z[ci].fps);
      movie(delay);
   }
   raw = 0;  
   return(status);
}



//--------------------------------------------------------------------------//
// saveimage                                                                //
// save screen image on disk                                                //
//--------------------------------------------------------------------------//
int saveimage(int ino, int noofargs, char **arg)
{
   if(memorylessthan(16384)){ message(g.nomemory,ERROR); return(NOMEM); }
   Dialog dialog;
   dialog.needrepeat=0;
   static int write_all=1;
   static int file_format=TIF;
   static int owant_color_type=0;
   static int compress=0;

   int bpp, evenbits, gota0=0, customcount=0,
       hitnonstandard=0, j, k, kk, messagemode=ERROR, needrepeat=0, 
       noofcolors=0, type, savedxsize, savedysize, standard, 
       status=OK, tot_bpp, tot_colors=0; 
   uint size;
   char extension[FILENAMELENGTH]="X";
   char extension_upper[FILENAMELENGTH]="X";
   char *ptr;
   char *msg;
   char tempstring[FILENAMELENGTH];   
   char tempstring2[FILENAMELENGTH];   
   char filename[FILENAMELENGTH];   
   char actual_file[FILENAMELENGTH];   
   char **custom_format_list;
   char identifier[64];
   msg = new char[FILENAMELENGTH];
   msg[0]=0;

   ////  If a new format is added, increase this value

   const int STDFORMATS=12;
   int noofformats=STDFORMATS;  
   
   ////  If a new color type is added, add more entries to this table 
   ////  and inrease dimension of arrays if necessary   

   int w_bpp[10]       = { 1, 8, 8,15,16,24,32, 0, 8 };
   int w_noofcolors[10]= { 1, 1, 1, 3, 3, 3, 4, 0, 1 };
   int w_redbpp[10]    = { 0, 6, 6, 5, 5, 8, 8, 0, 6 };
   int w_greenbpp[10]  = { 0, 6, 6, 5, 6, 8, 8, 0, 6 };
   int w_bluebpp[10]   = { 0, 6, 6, 5, 5, 8, 8, 0, 6 };
   int w_blackbpp[10]  = { 0, 0, 0, 0, 0, 0, 8, 0, 6 };
   int w_savecmyk[10]  = { 0, 0, 0, 0, 0, 0, 1, 0, 0 };

   if(g.selectedimage>-1) 
        write_all=1; 
   else 
   {    write_all=0;
        if(g.selected_lrx-g.selected_ulx<=2 ||
           g.selected_lry-g.selected_uly<=2)
        {   message("Please select an area \nor image to save",ERROR); 
            delete[] msg;
            return BADPARAMETERS;
        }
    }

   if(write_all && ino>=0 && strlen(z[ino].name)>0) 
   {    if(strchr(z[ino].name, '/'))                // If name has path
            strcpy(filename,z[ino].name);
        else                                        // If no path, add cwd
            sprintf(filename,"%s/%s",g.currentdir,z[ino].name);
        bpp = z[ino].bpp;
        strcpy(identifier, z[ino].format_name);
   }else 
   {    sprintf(filename,"%s/Untitled",g.currentdir);
        bpp = g.bitsperpixel;
        strcpy(identifier, "TIF");
   }

   if(owant_color_type==7){ g.want_color_type=7; bpp=g.want_bpp; }

   if(g.want_color_type!=7)   // Set to default unless Custom previously set
   {   g.want_bpp       = w_bpp[g.want_color_type];
       g.want_noofcolors= w_noofcolors[g.want_color_type];
       g.want_redbpp    = w_redbpp[g.want_color_type];
       g.want_greenbpp  = w_greenbpp[g.want_color_type];
       g.want_bluebpp   = w_bluebpp[g.want_color_type];
       g.want_blackbpp  = w_blackbpp[g.want_color_type];
       g.save_cmyk      = w_savecmyk[g.want_color_type];
       switch(bpp)     
       {   case 8:  g.want_color_type=2; break;
           case 15: g.want_color_type=3; break;
           case 16: g.want_color_type=4; break;
           case 24: g.want_color_type=5; break;
           case 32: g.want_color_type=6; break;
       }
   }
   if(g.jpeg_qfac<1) g.jpeg_qfac=80;

   ////  Automatically select original file format if a good one
   ////  unless overridden by macro

   if(g.want_format>-1) 
       file_format=g.want_format;
   else if(ino>=0)
       file_format = z[ci].format;
   else file_format=TIF;

   ////  Get list of custom formats from disk

   customcount = count_custom_formats();
   custom_format_list = new char*[customcount];
   for(k=0;k<customcount;k++){ custom_format_list[k]=new char[64]; custom_format_list[k][0]=0;}
   read_custom_format_list(custom_format_list);
   noofformats += customcount;
   if(write_all) compress = z[ino].was_compressed;

startsaveimage:
   owant_color_type = g.want_color_type;
   needrepeat=0;
   if(noofargs)
   {   if(noofargs>=1) strcpy(filename, arg[1]);
       if(noofargs>=2) file_format = atoi(arg[2]);
       if(noofargs>=3) g.want_bpp = atoi(arg[3]);
   }else
   {   strcpy(dialog.title,"Save Image");
       strcpy(dialog.radio[0][0],"Save What");             
       strcpy(dialog.radio[0][1],"Entire image");
       strcpy(dialog.radio[0][2],"Selected region");

       strcpy(dialog.radio[1][0],"Image type");             
       strcpy(dialog.radio[1][1],"1 bpp Monochrome");    // want_color_type==0
       strcpy(dialog.radio[1][2],"8 bpp Gray Scale");    // want_color_type==1
       strcpy(dialog.radio[1][3],"8 bpp Indexed Color"); // want_color_type==2
       strcpy(dialog.radio[1][4],"15 bits/pixel");       // want_color_type==3
       strcpy(dialog.radio[1][5],"16 bits/pixel");       // want_color_type==4
       strcpy(dialog.radio[1][6],"24 bits/pixel");       // want_color_type==5
       strcpy(dialog.radio[1][7],"32 bits/pixel");       // want_color_type==6
       strcpy(dialog.radio[1][8],"Other");               // want_color_type==7

       strcpy(dialog.radio[2][0],"Treat data as");             
       strcpy(dialog.radio[2][1],"Color");
       strcpy(dialog.radio[2][2],"Gray scale");

       if(write_all) dialog.radioset[0]=1;
                else dialog.radioset[0]=2;

       if(z[ino].colortype==GRAY)
       {     dialog.radioset[2]=2;
             g.usegrayscale=1;
       }else
       {     dialog.radioset[2]=1;
             g.usegrayscale=0;
       }
  
       for(k=1;k<=8;k++) dialog.radioset[1]=k;
       dialog.radioset[1]=g.want_color_type+1;
 
       dialog.noofradios=3;
       dialog.radiono[0]=3;
       dialog.radiono[1]=9;
       dialog.radiono[2]=3;
       dialog.radiono[3]=0;
       for(j=0;j<10;j++) for(k=0;k<20;k++) dialog.radiotype[j][k]=RADIO;
   
       ////  Adjustable parameter in radio box 

       dialog.radiotype[1][8]=RADIOTEXT;
       dialog.radiomin[1][8]=1;
       dialog.radiomax[1][8]=32;
       itoa(g.want_bpp,dialog.radioanswer[1][8],10);
  
       ////  Boxes  

       strcpy(dialog.boxes[0],"File Parameters");
       strcpy(dialog.boxes[1],"Filename");
       strcpy(dialog.boxes[2],"Format");
       strcpy(dialog.boxes[3],"Image no.");

       strcpy(dialog.boxes[4],"Extra Parameters");
       strcpy(dialog.boxes[5],"Primary colors");
       strcpy(dialog.boxes[6],"Red bits/pixel");
       strcpy(dialog.boxes[7],"Green bits/pixel");
       strcpy(dialog.boxes[8],"Blue bits/pixel");
       strcpy(dialog.boxes[9],"Black bits/pixel");
       strcpy(dialog.boxes[10],"RGB->CMYK");
       strcpy(dialog.boxes[11],"JPEG quality");

       strcpy(dialog.boxes[12] ,"Post-processing");
       strcpy(dialog.boxes[13] ,"Process file");
       strcpy(dialog.boxes[14] ,"Command");
       strcpy(dialog.boxes[15] ,"Extension");

       strcpy(dialog.answer[1],filename);
       //// 2 is below
       sprintf(dialog.answer[3],"%d",ino);
       sprintf(dialog.answer[5],"%d",g.want_noofcolors);     
       sprintf(dialog.answer[6],"%d",g.want_redbpp);
       sprintf(dialog.answer[7],"%d",g.want_greenbpp);
       sprintf(dialog.answer[8],"%d",g.want_bluebpp);
       sprintf(dialog.answer[9],"%d",g.want_blackbpp);
       if(g.save_cmyk) dialog.boxset[10]=1; else dialog.boxset[10]=0;
       sprintf(dialog.answer[11],"%d",g.jpeg_qfac);
       if(compress) dialog.boxset[13]=1; else dialog.boxset[13]=0;
       strcpy(dialog.answer[14], g.compression);
       strcpy(dialog.answer[15], g.compression_ext);

       dialog.boxmenutitle[2] = new char[50];
       dialog.boxmenutitle[2][0] = 0;
       dialog.boxmenu[2] = new char*[noofformats+4];
       for(k=0;k<=noofformats+1;k++)
       {    dialog.boxmenu[2][k] = new char[50]; 
            dialog.boxmenu[2][k][0]=0;
       } 
       dialog.boxmenuselection[2]=0;
       if(file_format==TIF)   dialog.boxmenuselection[2]=0;
       if(file_format==PCX)   dialog.boxmenuselection[2]=1;
       if(file_format==IMG)   dialog.boxmenuselection[2]=2;
       if(file_format==JPG)   dialog.boxmenuselection[2]=3;
       if(file_format==TARGA) dialog.boxmenuselection[2]=4;
       if(file_format==BMP)   dialog.boxmenuselection[2]=5;
       if(file_format==GIF)   dialog.boxmenuselection[2]=6;
       if(file_format==GIF89) dialog.boxmenuselection[2]=7;
       if(file_format==ASCII) dialog.boxmenuselection[2]=8;
       if(file_format==RAW)   dialog.boxmenuselection[2]=9;
       if(file_format==RAW3D) dialog.boxmenuselection[2]=10;
       if(file_format==FITS)  dialog.boxmenuselection[2]=11;
       if(file_format==CUSTOM)dialog.boxmenuselection[2] = 
              min(noofformats, STDFORMATS + list_match(custom_format_list,
                                    identifier, noofformats));

       ////  Do not exceed 50 characters for the following menu items
       strcpy(dialog.boxmenutitle[2],"File Format");
       strcpy(dialog.boxmenu[2][0]," TIFF                ");
       strcpy(dialog.boxmenu[2][1]," PCX                 ");
       strcpy(dialog.boxmenu[2][2]," IMG (Frame grabber) ");
       strcpy(dialog.boxmenu[2][3]," JPG (Jpeg)          ");
       strcpy(dialog.boxmenu[2][4]," TGA (Targa RLE)     ");
       strcpy(dialog.boxmenu[2][5]," BMP (Windows bitmap)");
       strcpy(dialog.boxmenu[2][6]," GIF (GIF87a)        ");
       strcpy(dialog.boxmenu[2][7]," GIF (GIF89a)        ");
       strcpy(dialog.boxmenu[2][8]," ASCII               ");
       strcpy(dialog.boxmenu[2][9]," RAW                 ");
       strcpy(dialog.boxmenu[2][10]," RAW Multi-frame     ");
       strcpy(dialog.boxmenu[2][11]," FITS                ");

       for(k=STDFORMATS; k<noofformats; k++)
          sprintf(dialog.boxmenu[2][k]," %s", custom_format_list[k-STDFORMATS]);

       dialog.boxtype[0]=LABEL;        
       dialog.boxtype[1]=SCROLLEDSTRING;       
       dialog.boxtype[2]=NON_EDIT_LIST;
       dialog.boxtype[3]=INTCLICKBOX;

       dialog.boxtype[4]=LABEL;        
       dialog.boxtype[5]=INTCLICKBOX;
       dialog.boxtype[6]=INTCLICKBOX;
       dialog.boxtype[7]=INTCLICKBOX;
       dialog.boxtype[8]=INTCLICKBOX;  
       dialog.boxtype[9]=INTCLICKBOX;  
       dialog.boxtype[10]=TOGGLE;      
       dialog.boxtype[11]=INTCLICKBOX; 

       dialog.boxtype[12]=LABEL; 
       dialog.boxtype[13]=TOGGLE;      
       dialog.boxtype[14]=STRING;      
       dialog.boxtype[15]=STRING;

       dialog.boxmin[2]=0;  dialog.boxmax[2]=noofformats;
       dialog.boxmin[3]=0;  dialog.boxmax[3]=g.image_count-1;
       dialog.boxmin[5]=1;  dialog.boxmax[5]=4;
       dialog.boxmin[6]=0;  dialog.boxmax[6]=32;
       dialog.boxmin[7]=0;  dialog.boxmax[7]=32;
       dialog.boxmin[8]=0;  dialog.boxmax[8]=32;
       dialog.boxmin[9]=0;  dialog.boxmax[9]=32;
       dialog.boxmin[11]=1; dialog.boxmax[11]=99;

       dialog.noofboxes=16;
       dialog.helptopic=3;
       dialog.keep=0;
       dialog.want_changecicb = 0;
       dialog.f1 = savecheck;
       dialog.transient = 1;
       strcpy(dialog.path,".");

       //-------------------------//

       dialogbox(dialog);

       //-------------------------//

       kk = dialog.boxmenuselection[2];
       if(kk==0) file_format=TIF;
       if(kk==1) file_format=PCX;
       if(kk==2) file_format=IMG;
       if(kk==3) file_format=JPG;
       if(kk==4) file_format=TARGA;
       if(kk==5) file_format=BMP;
       if(kk==6) file_format=GIF;
       if(kk==7) file_format=GIF89;
       if(kk==8) file_format=ASCII;
       if(kk==9) file_format=RAW;
       if(kk==10) file_format=RAW3D;
       if(kk==11) file_format=FITS;
       if(kk>=STDFORMATS) 
       {    file_format = CUSTOM;
            strcpy(identifier, custom_format_list[kk-STDFORMATS]);
       }

       for(k=0;k<=noofformats+1;k++) delete[] dialog.boxmenu[2][k];
       delete[] dialog.boxmenu[2];
       delete[] dialog.boxmenutitle[2];
       if(g.getout)
       {   if(g.want_messages > 1) message("File transfer aborted",WARNING); 
           goto saveend; 
       }

       if(dialog.radioset[0]==1) write_all=1; else write_all=0;
       for(k=1;k<=8;k++) if(dialog.radioset[1]==k) g.want_color_type=k-1;

       ////  Check parameters 
       ////  If color type is changed, set new default parameters and 
       ////  show menu again               

       strcpy(filename,dialog.answer[1]);
       ino = atoi(dialog.answer[3]);
       ino = min(g.image_count-1,ino);
       if(dialog.radioset[2]==2) g.usegrayscale=1; else g.usegrayscale=0;

   }

   ////  If color type is not changed, take the user's parameters 

   if(g.want_color_type!=7)
   {  g.want_bpp       = w_bpp[g.want_color_type];
      g.want_noofcolors= w_noofcolors[g.want_color_type];
      if(g.usegrayscale) g.want_noofcolors = 1; 
      g.want_redbpp    = w_redbpp[g.want_color_type];
      g.want_greenbpp  = w_greenbpp[g.want_color_type];
      g.want_bluebpp   = w_bluebpp[g.want_color_type];
      g.want_blackbpp  = w_blackbpp[g.want_color_type];
      g.save_cmyk      = w_savecmyk[g.want_color_type];
   }else if(noofargs==0)
   {  g.want_bpp      = atoi(dialog.radioanswer[1][8]);
      g.want_noofcolors = atoi(dialog.answer[5]);
      g.want_redbpp   = atoi(dialog.answer[6]);
      g.want_greenbpp = atoi(dialog.answer[7]);
      g.want_bluebpp  = atoi(dialog.answer[8]);
      g.want_blackbpp = atoi(dialog.answer[9]);
      g.save_cmyk     = dialog.boxset[10];
   }
   if(noofargs==0)
   {  g.jpeg_qfac     = atoi(dialog.answer[11]);
      compress = dialog.boxset[13];
      strcpy(g.compression, dialog.answer[14]);
      strcpy(g.compression_ext, dialog.answer[15]);
   }
   if(write_all) z[ino].was_compressed = compress;

   tot_bpp=g.want_redbpp+g.want_greenbpp+g.want_bluebpp+g.want_blackbpp;

   ////  Check for consistency with specified file format

   messagemode = ERROR;
   strcpy(tempstring,filename);
   ptr = strchr(tempstring,'.');
   if(ptr!=NULL) strcpy(extension,ptr); 
   type = file_format;
   if(file_format>=100) type=CUSTOM;
   switch(type)
   {  
      case CUSTOM:
      case TIF:  
                 tot_colors=0;
                 {  if(g.want_blackbpp)tot_colors++;
                    if(g.want_bluebpp) tot_colors++; else if(tot_colors)gota0=1;
                    if(g.want_greenbpp)tot_colors++; else if(tot_colors)gota0=1;
                    if(g.want_redbpp)  tot_colors++; else if(tot_colors)gota0=1;
                 }
                    
                 if((g.want_noofcolors!=tot_colors)&&(g.want_color_type>2)&&
                    (g.want_noofcolors>1))
                 {  strcpy(msg,"Number of colors doesn't add up.\n");
                    strcat(msg,"Change the bits/pixel on a color\n");
                    strcat(msg,"or number of primary colors");
                    needrepeat=1;
                    break;
                 }
                 
                 if((g.want_noofcolors>1)&&(g.want_color_type==7))
                 { if(g.want_bpp!=tot_bpp)
                   {  strcpy(msg,"RGB bits/pixel don't add up to total.\n");
                      strcat(msg,"Change total bits/pixel or number of colors");
                      needrepeat=1;
                      break;
                   }
                 }

                 if((g.want_noofcolors>1)&&(g.usegrayscale))
                 {  if(g.want_color_type==7)
                    {  strcpy(msg,"You must have only 1 primary color\n");
                       strcat(msg,"to save data as grayscale");
                       needrepeat=1;
                       break;
                    }
                 }

                 if((g.want_noofcolors==1)&&(!g.usegrayscale))
                 {  if(g.want_color_type==7)
                    {  strcpy(msg,"You must have more than 1 primary color\n");
                       strcat(msg,"to save data as color");
                       needrepeat=1;
                       break;
                    }
                 }

                 if((g.save_cmyk) &&  
                     ((g.want_blackbpp==0)||(g.want_color_type<6)) &&
                     (g.want_color_type>2)  )
                 {  strcpy(msg,"Not enough bits for CMYK");
                    needrepeat=1;
                    break;
                 }

                 if((g.want_blackbpp)&&(!g.save_cmyk))
                 {  strcpy(msg,"You must select CMYK to use black bits");
                    needrepeat=1;
                    break;
                 }

                 if((g.want_noofcolors<4)&&(g.save_cmyk))
                 {  strcpy(msg,"Must have 4 colors for CMYK"); 
                    needrepeat=1;
                    break;
                 }

                                        // Warn if non-standard if done
                 if(dialog.needrepeat==0 && !hitnonstandard)
                 { standard=1;                
                   if(g.want_color_type==7)
                   {  if((g.want_redbpp%8)||(g.want_greenbpp%8))  standard=0;
                      if((g.want_bluebpp%8)||(g.want_blackbpp%8)) standard=0;
                      if((g.want_bpp>8  )&&(g.want_noofcolors<3)) standard=0;
                      if((g.want_bpp<=8 )&&(g.want_noofcolors>1 ))standard=0;
                      if((g.want_bpp<8  )&&(g.want_bpp>1)        )standard=0;
                      if((g.want_bpp>24 )&&(g.want_noofcolors<4 ))standard=0;
                      if((g.want_bpp<=24)&&(g.want_noofcolors==4))standard=0;
                      if((g.want_bpp==16)&&(g.want_redbpp==5)&&(g.want_greenbpp==6)&&
                         (g.want_bluebpp==5)) standard=1;
                      if((g.want_bpp==15)&&(g.want_redbpp==5)&&(g.want_greenbpp==5)&&
                         (g.want_bluebpp==5)) standard=1;
                      if(gota0) standard=0;                    
                   }
                   if(standard==0)   
                   {  strcpy(msg,"Non-standard image format\nIs this ok?");
                      if(message(msg,YESNOQUESTION)!=YES) needrepeat=1;
                        //// Suppress error message in dialogbox() because it
                        //// was handled here
                      messagemode=NONE;
                      hitnonstandard=1;
                      break;
                   }   
                 }
                 break;

      case GIF:  
      case GIF89:  
                 if(g.want_bpp!=8)
                 {  strcpy(msg,"GIF files must be 8 bits/pixel");
                    needrepeat=1;
                 }
                 break;
      case PCX:  if(g.want_bpp!=8)
                 {  strcpy(msg,"PCX files must be 8 bits/pixel");
                    needrepeat=1;
                 }
                 break;
      case IMG:  if((g.want_bpp!=1)&&(g.want_bpp!=8))
                 {  strcpy(msg,"IMG files must be 1 or 8 bits/pixel");
                    needrepeat=1;
                 }
                 break;
      case RAW:
      case RAW3D:
                 if(g.want_bpp!=8 && g.want_bpp!=15 && g.want_bpp!=16 && g.want_bpp!=24 && 
                    g.want_bpp!=32)
                 {  strcpy(msg,"Raw files must be 8,15,16,24,or 32 bits/pixel");
                    needrepeat=1;
                 }
                 break;
      case FITS:if(g.want_bpp!=8 && g.want_bpp!=16 && g.want_bpp!=32)
                 {  strcpy(msg,"FITS files must be 8,16, \nor 32 bits/pixel");
                    needrepeat=1;
                 }
                 break;
      case TARGA:if(g.want_bpp!=8 && g.want_bpp!=15 && g.want_bpp!=24 && g.want_bpp!=32)
                 {  strcpy(msg,"Targa files must be 8,15,24, \nor 32 bits/pixel");
                    needrepeat=1;
                 }
                 strcpy(extension_upper, extension);
                 strupr(extension_upper);
                 if(strcmp(extension_upper,".TGA")) //TGA can only be id'd by ext'n
                 {  strcpy(msg,"Extension must be TGA for Targa format");
                    needrepeat=1;
                 }
                 break;
      case BMP:  if((g.want_bpp!=4)&&(g.want_bpp!=8)&&(g.want_bpp!=24))
                 {  strcpy(msg,"BMP files must be 4,8,or 24 bits/pixel");
                    needrepeat=1;
                 }
                 if(g.want_color_type==1)
                 {  strcpy(msg,"8 bit BMP files must have a palette");
                    needrepeat=1;
                 }
                 break;
      case JPG:  if(g.want_bpp != 24)
                    strcpy(msg,"Selected bit/pixel values\nwill be ignored");
                 if(g.usegrayscale)
                 {  strcpy(msg,"Image must be converted to color first");
                    needrepeat=1;
                 }
                 break;
      default:   break;           
    }
 

    if(!needrepeat)
    {   if( (ino>=0 && write_all && g.want_color_type<=2 && z[ino].bpp>8) ||
            ((!write_all)&&(g.want_color_type<=2)&&(g.bitsperpixel>8)))
        {   strcpy(msg,"Color information will be lost!");
            if(!write_all) strcat(msg,"\nYou should create an 8 bit/pixel subimage first");
            else           strcat(msg,"\nYou should convert image to 8 bits/pixel first");
            strcat(msg,"\nOk to discard color information?");
            if(message(msg, YESNOQUESTION) != YES) needrepeat=1;
            messagemode = 0;
        }

        if(write_all && ino>=0 && z[ino].bpp==48)
        {   strcpy(msg,"Saving 48-bit images is not currently supported.");
            strcat(msg,"\nConvert image to 24 bits/pixel first.");
            needrepeat=1;
        }
        if(write_all && z[ino].frames>1) 
        {   switch(type)
            {   case GIF89:
                case CUSTOM:
                case RAW3D: break;
                default:
                   strcpy(msg,"Only current frame will be saved\nIs this ok?");
                   if(message(msg, YESNOQUESTION) != YES) needrepeat=1;
                   messagemode = 0;
            }
        }

    }
     
    
    if(filename[0]==0  && !needrepeat)
    {     strcpy(msg,"You must specify a filename");
          needrepeat=1;
    }

    if(dialog.needrepeat) 
    {     if(noofargs) status=BADPARAMETERS; 
          else goto startsaveimage;   
    }   

    if(needrepeat)
    {  if(noofargs) status=BADPARAMETERS; 
       else 
       {  dialog.needrepeat=1;
          dialog.message1 = msg;
          dialog.messagemode = messagemode;
          goto startsaveimage;
       }
    }
    g.want_color_type = g.want_color_type;

   ////-----End of input section-----------------------------------------////

   if(write_all && ino==-1) status=NOIMAGES;      // can't save, no images present
   if(g.getout){ g.getout=0; status=ABORT; }
   if(status==OK)
   {  if(write_all && ino>=0)
      {    if(z[ino].fftstate!=0)
           {    write_all=0;
                setSVGApalette(1,0);              // grayscale palette
           }
      }
      strcpy(actual_file,filename);
      if(compress) strcat(actual_file, g.compression_ext);         
      if(cant_overwrite_file(actual_file)) goto saveend;

      switchto(ino);      
      drawselectbox(OFF);

      ////  Writing routine is free to ignore 'compress' variable if
      ////  compression program is not found.

      if(file_format==TIF)   status=writetiffile(filename,write_all,compress);
      if(file_format==PCX)   status=writepcxfile(filename,write_all,compress);
      if(file_format==IMG)   status=writeimgfile(filename,write_all,compress);
      if(file_format==GIF)   status=writegiffile(filename,write_all,compress);
      if(file_format==GIF89) status=writegif89file(filename,write_all,compress);
      if(file_format==PNG) 
      {  message("Creating PNG files is not yet\nimplemented.");
         status=ABORT;
      }   
      if(file_format==JPG)   status=writejpeg(filename,write_all,compress);
      if(file_format==BMP)   status=writebmpfile(filename,write_all,BMP,compress);
      if(file_format==TARGA) status=writetgafile(filename,write_all,compress);
      if(file_format==ASCII) status=writeasciifile(filename,write_all,compress);
      if(file_format==RAW)   status=writerawfile(filename,write_all,compress);
      if(file_format==RAW3D) status=write3Dfile(filename,write_all,compress);
      if(file_format==FITS)  status=writefitsfile(filename,write_all,compress);
      if(file_format==CUSTOM)status=writecustomfile(filename,write_all,identifier,compress);
   }

   size = filesize(actual_file);                  // Check to ensure not an empty file
   if((size==0)&&(status==OK)) status=ZEROLENGTH; 
   
   if((status==OK)&&(!access(actual_file,F_OK)))  // access = 0 if file exists
   { 
      if(write_all && ino>=0)
      {  savedxsize = z[ino].xsize;
         savedysize = z[ino].ysize;
      }else
      {  savedxsize = 1+g.selected_lrx-g.selected_ulx;
         savedysize = 1+g.selected_lry-g.selected_uly;
      }   
      evenbits = ((savedxsize*g.want_bpp+7)/8)*8; 
      while(savedxsize*g.want_bpp < evenbits) savedxsize++;
      sprintf(tempstring,"%d x %d pixel region saved\nin %s\n(size=%d bytes)",
          savedxsize, savedysize, actual_file, size);
      message(tempstring);
      if(ino>=0) z[ino].touched=0;
   }   
   else 
   {  switch(status)
      {  case OK:        // OK = File saved ok but access() couldn't find it
            sprintf(tempstring2,"File error %d",errno);
            break;
         case ABORT:     // Non-file error (breakout due to bad parameters)
            strcpy(tempstring2,"File transfer aborted"); break;
         case ERROR:
         case UNKNOWN:   // Unknown file error
            strcpy(tempstring2,"File error"); break;
         case CANTCREATEFILE:         // File creation error
            strcpy(tempstring2, "Can't create file"); break;
         case CRITERR:   // Critical error
            strcpy(tempstring2,"An error occurred"); break;
         case NOIMAGES:
            strcpy(tempstring2,"No images to save.\nCreate an image or save a selected region.");
            break;
         case ZEROLENGTH:// File is length 0 bytes
            strcpy(tempstring2,"Unknown error - nothing was saved!"); break;
         case BADPARAMETERS:
            strcpy(tempstring2,"Bad parameters"); break;
         default:   
            strcpy(tempstring2,"Unknown error"); break;
      }          
      message(tempstring2,ERROR);
   }   
   
   ////  Update image statistics

   if(write_all && status==OK && ino>=0)
   {  if(g.usegrayscale)
         z[ino].colortype=GRAY;
      else
      {  noofcolors = 0;
         if(g.want_redbpp)   noofcolors++;                         
         if(g.want_greenbpp) noofcolors++;                         
         if(g.want_bluebpp)  noofcolors++;                         
         if(g.want_blackbpp) noofcolors++; 
      }
   
      if(ino>=0)setimagetitle(ino,filename);
      strcpy(z[ino].format_name, identifier);
      z[ino].format = file_format;
   }   

saveend:
   for(k=0;k<customcount;k++) delete[] custom_format_list[k];
   delete[] custom_format_list;
   delete[] msg;
   return(status);
}


//--------------------------------------------------------------------------//
//  savecheck                                                               //
//--------------------------------------------------------------------------//
void savecheck(dialoginfo *a, int radio, int box, int boxbutton)
{
    radio=radio; box=box; boxbutton=boxbutton;
    int j,k,tif=0,jpeg=0, compress=0;
    switch(a->boxmenuselection[2])
    {   case 0: tif=1; break;  // tif
        case 1: break;         // pcx
        case 2: break;         // img
        case 3: jpeg=1; break; // jpeg
        case 4: break;         // tga
        case 5: break;         // bmp
        case 6: break;         // gif
        case 7: break;         // gif89
        case 8: break;         // ascii
        case 9: break;         // raw
        case 10: break;        // raw3d
        case 11: break;        // fits
        default:tif=1;         // custom
    }

    for(k=0;k<3;k++)
    {  for(j=5;j<=10;j++)
       {  if(a->boxwidget[j][k])
          {   if(tif)  XtSetSensitive(a->boxwidget[j][k],True);
              else     XtSetSensitive(a->boxwidget[j][k],False);
       }  }
       if(a->boxwidget[11][k])
       {   if(jpeg)  XtSetSensitive(a->boxwidget[11][k],True);
           else      XtSetSensitive(a->boxwidget[11][k],False);
       }
    }

    if(a->boxset[13]) compress=1;    
    for(k=14;k<=15;k++)
       if(compress) XtSetSensitive(a->boxwidget[k][0],True);
       else XtSetSensitive(a->boxwidget[k][0],False);
}


//--------------------------------------------------------------------------//
// packbits                                                                 //
// Packs n bits into a block. Returns no.of bytes obtained.                 //
// Output block is the input bits packed into unsigned characters. This     //
//   means if n is a multiple of 8, the data are returned unchanged.        //
//   If not, the high-order bits from n to the next higher multiple of 8    //
//   are thrown away. The input data should                                 //
//   be right-shifted first if the high-order bits are to be saved.         //
//                                                                          //
// inpos     = Current position in array `inblock' (wraps to 0 if all the   //
//             bytes are used, i.e. if blockpos exceeds blocksize.          //
// outpos    = Current position in array `outblock'.                        //
// blocksize = Size of input array `inblock'                                //
// inblock   = char array of the data to be packed                          //
// outblock  = packed data which is returned                                //
//                                                                          //
// Bits are packed in the following format.                                 //
//                                                                          //
// Example for n=15:                                                        //
//     Input            7   6   5   4   3   2   1   0                       //
//     ------         --------------------------------                      //
//     Byte 1          a15 a14 a13 a12 a11 a10 a09 a08                      //
//     Byte 2          a07 a06 a05 a04 a03 a02 a01 a00                      //
//     Byte 3          b15 b14 b13 b12 b11 b10 b09 b08                      //
//     Byte 4          b07 b06 b05 b04 b03 b02 b01 b00                      //
//     ...                                                                  //
//     Output           7   6   5   4   3   2   1   0   Note: bit 15 is     //
//     ------         --------------------------------  thrown away.        //
//     Byte 1          a14 a13 a12 a11 a10 a09 a08 a07                      //
//     Byte 2          a06 a05 a04 a03 a02 a01 a00 b14                      //
//     Byte 3          b13 b12 b11 b10 b09 b08 b07 b06                      //
//     Byte 4          b05 b04 b03 b02 b01 b00 c14 c13                      //
//     ...                                                                  //
//                                                                          //
// Example for n=5:                                                         //
//     Input            7   6   5   4   3   2   1   0                       //
//     ------         --------------------------------                      //
//     Byte 1           a7  a6  a5  a4  a3  a2  a1  a0                      //
//     Byte 2           b7  b6  b5  b4  b3  b2  b1  b0                      //
//     Byte 3           c7  c6  c5  c4  c3  c2  c1  c0                      //
//     Byte 4           d7  d6  d5  d4  d3  d2  d1  d0                      //
//     ...                                                                  //
//     Output           7   6   5   4   3   2   1   0   Note: bits 7-4 are  //
//     ------         --------------------------------  thrown away. The    //
//     Byte 1           a4  a3  a2  a1  a0  b4  b3  b2  rest are packed     //
//     Byte 2           b1  b0  c4  c3  c2  c1  c0  d4  together.           //
//     Byte 3           d3  d2  d1  d0  e4  e3  e2  e1                      //
//     Byte 4           e0  f4  f3  f2  f1  f0  g4  g3                      //
//     ...                                                                  //
//--------------------------------------------------------------------------//
int packbits(int n,uchar* inblock,uchar* outblock, int blocksize)
{
   int k;
   int inpos = 0;   // input buffer byte position
   int outpos = 0;  // output buffer byte position
   int bitstoget=8; // no.of bits it is possible to get
   int need = 8;    // output bit position 8-0
   int total=0;     // input bit position 0-8
   int unusedbits;  // no.of bits to throw away
   int roundbytes;  // bytes in input for each n (n rounded up to next byte)
   int a;

   getbits(0,inblock,0,RESET);  //reset bits at each scan line

   roundbytes = (n+7) >> 3;
   for(k=0;k<blocksize;k++) outblock[k]=0;
   getbits(0,inblock,blocksize,RESET);
   unusedbits = (8 - (n%8))%8;  // 0,7,6,5,4,3,2,1,0,...
   getbits(unusedbits,inblock,blocksize,TIF);

   do
   {  bitstoget = min(need,n-total);
      a = getbits(bitstoget,inblock,blocksize,TIF) << (need-bitstoget);
      outblock[outpos] += a;
      total += bitstoget;
      need -= bitstoget;
      if(need==0) { outpos++; need=8; }
      if(total==n) 
      {  getbits(unusedbits,inblock,blocksize,TIF);
         total=0;
         inpos += roundbytes;
      }
   }while(inpos<blocksize);   
   return(outpos);
}




//--------------------------------------------------------------------------//
// imagefiletype                                                            //
// Returns integer TIF or whatever or 0 if unknown image file type.         //
// Returns string format identifier (must have enough for 64 bytes).        //
//--------------------------------------------------------------------------//
int imagefiletype(char *filename, char *identifier, int &compressed)
{  
   if(memorylessthan(16384)){ message(g.nomemory,ERROR); return(0); }

   uchar header[1034];  // Make static to avoid out-of-memory
   uchar oheader[1034];
   FILE *fp;
   int dot,k,h,ocompressed;
   short uint word1=0;
   short uint word2=0;
   short uint word3=0;
   short uint word4=0;
   short int pcx_id=0;
   char fitsheader[20];
   char tempstring[FILENAMELENGTH];
   char newfilename[FILENAMELENGTH];
   char gifid[50];
   char pbmid[5];
   char match[64] = "";
   char extension[FILENAMELENGTH]="X";
   char extension_upper[FILENAMELENGTH]="X";
   uchar pcx_version=0;
   short int xsize,ysize;
   long int fsize;
   int pos, elength;
   
   compressed = 0;
   elength = (int)strlen(g.compression_ext);
   if(elength) pos = (int)strlen(filename) - elength; else pos=0;
   if(pos>=0 && strcmp(filename + pos, g.compression_ext)==SAME) compressed = 1;

   //// This will change 'compressed' if g.decompression is not found

   ocompressed = compressed;
   if((fp=open_file(filename, compressed, READ, g.compression, g.decompression, 
       g.compression_ext))==NULL) 
       return 0;
   compressed = ocompressed;

   if(compressed){ strncpy(newfilename, filename, pos); newfilename[pos]=0; }
   else strcpy(newfilename, filename);
   
   fread(header,1024,1,fp);
   strncpy(identifier, (char*)header, 63);
   memcpy(oheader,header,128);
   close_file(fp, compressed);
   g.tif_skipbytes=0;

   //-------------Extract extension from filename------------//
   strcpy(tempstring, newfilename);
   dot = 0;
   for(k=0;k<(int)strlen(tempstring);k++) if(tempstring[k]=='.') dot=k;
   if(dot) strcpy(extension, tempstring+dot+1);

   //-------------Identify format----------------------------//
   for(h=0;h<=1;h++)
   { 
      word1 = header[0] + (header[1]<<8);
      word2 = header[2] + (header[3]<<8);
      word3 = header[4] + (header[5]<<8);
      word4 = header[6] + (header[7]<<8);
      pcx_id = word1 & 0xff;
      pcx_version = word1 & 0xff;
      word1 &= 0xffff;
      word2 &= 0xffff;
      gifid[0]=header[0]; gifid[1]=header[1]; gifid[2]=header[2]; gifid[3]=0;
      pbmid[0]=header[0]; pbmid[1]=header[1]; pbmid[2]=0;
      override = 0;

      strncpy(fitsheader, (char*)header, 6);
      strcpy(extension_upper, extension);
      strupr(extension_upper);
      fitsheader[6]=0;
      if((word2==42)&&(word1==0x4949))
      {    strcpy(identifier,"TIF");  return(TIF); }            // Intel TIF
      else if((word2==0x2A00)&&(word1==0x4d4d))
      {    strcpy(identifier,"TIF");  return(TIF); }            // Macintosh TIF
      else if(pcx_id==0x0A)
      {    strcpy(identifier,"PCX");  return(PCX); }
      else if(pcx_version==253)
      {    strcpy(identifier,"IMA");  return(IMA); }    
      else if(!strcmp(gifid,"GIF"))
      {    strcpy(identifier,"GIF");  return(GIF); }       
      else if((word1==0x0100)&&((word2==0x0800)||(word2==0x0900)))// Regular GEM IMG
      {    strcpy(identifier,"GEM");  return(GEM); }
      else if((word1==0x0070)&&(word2==0x0191))    // IMDS = MVS mainframe GEM
      {    strcpy(identifier,"IMDS"); return(IMDS); }
      else if(((word1)==0xD8FF)&&((word2&0xFF)==0xFF))
      {    strcpy(identifier,"JPEG"); return(JPG); }
      else if((gifid[0]=='B')&&(gifid[1]=='M'))
      {    strcpy(identifier,"BMP");  return(BMP); }
      else if(word1==0x0000 && word3==0x0000 && word4==0x0700)
      {    strcpy(identifier,"XWD screen dump"); return(XWD); }
      else if(!strcmp(extension_upper,"TGA"))   // TGA can only be ident'd by extension
      {    strcpy(identifier,"Targa"); return(TARGA); }
      else if(!strcmp(fitsheader,"SIMPLE"))  
      {    strcpy(identifier,"FITS"); return(FITS); }
      else if(strstr((char*)header,"FILE_TYPE"))  
      {    strcpy(identifier,"PDS");  return(PDS); }
      else if(strstr((char*)header,"SFDU_LABEL"))  
      {    strcpy(identifier,"PDS2"); return(PDS2); }
      else if(!strcmp(pbmid,"P1"))  
      {    strcpy(identifier,"PBM");  return(PBM); }
      else if(!strcmp(pbmid,"P2"))  
      {    strcpy(identifier,"PGM");  return(PGM); }
      else if(!strcmp(pbmid,"P3"))  
      {    strcpy(identifier,"PPM");  return(PPM); }
      else if(!strcmp(pbmid,"P4"))  
      {    strcpy(identifier,"PBMRAW");  return(PBMRAW); }
      else if(!strcmp(pbmid,"P5"))  
      {    strcpy(identifier,"PGMRAW");  return(PGMRAW); }
      else if(!strcmp(pbmid,"P6"))  
      {    strcpy(identifier,"PPMRAW");  return(PPMRAW); }
      else if(is_customfile(filename, identifier, extension, match))
      {    strcpy(identifier, match); return(CUSTOM);   }
      else if(!strcmp(extension,"ascii"))  
      {    strcpy(identifier,"ASCII");  return(ASCII); }
      else                    
      {                             // Check if an IMG by checking its size.
          xsize=word1;
          ysize=word2;
          fsize = filesize(newfilename);
          k = 2*sizeof(short int) + xsize*ysize;   // Expected file size
                                                   // Some valid files have a 
                                                   // header or tail at end 
                                                   // Assume>10 pixels in image
          if((fsize!=0 && k>10) || strcmp(extension,"img")==SAME)
          {
            if(((double)k/(double)fsize >=.95) && ((double)k/(double)fsize <=1.1))
            {    strcpy(identifier,"IMG"); return(IMG); }    // 8-bit bitmap
            else 
            if(((double)k/(double)(fsize*8)>=.95)&&((double)k/(double)(fsize*8)<=1.1))
            {    strcpy(identifier,"IMM"); return(IMM); }    // Monochrome bitmap
          }
      }
                                  // Check if there is an extra 128-byte
                                  // header added by Mac-TCP.                            
      for(k=0;k<128;k++) header[k]=header[k+128];
      g.tif_skipbytes+=128;
   }

   ////  Eliminating Mac header didn't help so reset tif_skipbytes to 0.
   g.tif_skipbytes=0;   
   sprintf(tempstring,"%s\nInvalid image file - try to read it anyway?",filename);
   if(message(tempstring,QUESTION)==YES)
   {     override=1; 
         strcpy(identifier,"RAW");  
         return(RAW); 
   }
   return(0);
}



//--------------------------------------------------------------------------//
// writeasciifile                                                           //
//--------------------------------------------------------------------------//
int writeasciifile(char *filename, int write_all, int compress)
{  
  int bpp,i,ino,j,v,xstart,ystart,xend,yend;
  int want_color = 1 - g.usegrayscale;
  FILE *fp;
  if(write_all==1)
  {   xstart = z[ci].xpos;
      ystart = z[ci].ypos;
      xend = xstart + z[ci].xsize - 1;
      yend = ystart + z[ci].ysize - 1;
  } else
  {   xstart=g.selected_ulx;
      xend=g.selected_lrx;
      ystart=g.selected_uly;
      yend=g.selected_lry;
  }
  if((fp=open_file(filename, compress, WRITE, g.compression, g.decompression, 
      g.compression_ext))==NULL) 
      return CANTCREATEFILE; 

  fprintf(fp,"%d ",z[ci].xsize);
  fprintf(fp,"%d ",z[ci].ysize);

  for(j=ystart;j<=yend;j++)
  { for(i=xstart;i<=xend;i++)
    {   v = readpixelonimage(i,j,bpp,ino);
        v = convertpixel(v, bpp, g.want_bpp, want_color);
        fprintf(fp,"%d ",v);
    }
    fprintf(fp,"\n");
  } 
  close_file(fp, compress);  
  return OK;
}



//--------------------------------------------------------------------------//
// writerawfile                                                             //
//--------------------------------------------------------------------------//
int writerawfile(char *filename, int write_all, int compress)
{
  int bpp,i,ino,j,off,xstart,ystart,xend,yend;
  int want_color = 1 - g.usegrayscale;
  uint v;
  FILE *fp;
  if(write_all==1)
  {   xstart = z[ci].xpos;
      ystart = z[ci].ypos;
      xend = xstart + z[ci].xsize - 1;
      yend = ystart + z[ci].ysize - 1;
  } else
  {   xstart=g.selected_ulx;
      xend=g.selected_lrx;
      ystart=g.selected_uly;
      yend=g.selected_lry;
  }
  if((fp=open_file(filename, compress, WRITE, g.compression, g.decompression, 
      g.compression_ext))==NULL) 
      return CANTCREATEFILE; 

  off = g.off[g.want_bpp];
  for(j=ystart;j<=yend;j++)
  {  for(i=xstart;i<=xend;i++)
     {   v = readpixelonimage(i,j,bpp,ino);
         v = convertpixel(v, bpp, g.want_bpp, want_color);
         putpixel(v,off,fp);
     } 
  }     
  close_file(fp, compress);  
  return OK;
}



//--------------------------------------------------------------------------//
// write3Dfile                                                              //
//--------------------------------------------------------------------------//
int write3Dfile(char *filename, int write_all, int compress)
{
  int bpp,f,i,i2,j,v;
  int want_color = 1 - g.usegrayscale;
  FILE *fp;
  if(write_all!=1 || ci<0)
  {   message("Must select an entire image to save as 3D");
      return BADPARAMETERS;
  }
  if((fp=open_file(filename, compress, WRITE, g.compression, g.decompression, 
      g.compression_ext))==NULL) 
      return CANTCREATEFILE; 

  bpp = z[ci].bpp;
  for(f=0;f<z[ci].frames;f++)
  for(j=0;j<z[ci].ysize;j++)
  {  
     for(i=0,i2=0; i<z[ci].xsize; i++,i2+=g.off[bpp])
     {   v = pixelat(z[ci].image[f][j]+i2, bpp);
         v = convertpixel(v, bpp, g.want_bpp, want_color);
         putpixel(v,g.off[g.want_bpp],fp);  
     }
  }     
  close_file(fp, compress);  
  return OK;
}


//--------------------------------------------------------------------------//
// readimafile                                                              //
// Transfer IMA file (from NPDATA) from disk to screen.                     //
// Returns error code (OK=no errors).                                       //
//--------------------------------------------------------------------------//
int readimafile(char *filename)
{  
   FILE *fp;
   uchar crudbuf[9];
   uchar *buffer;
   uchar value,color;


   int xsize = 640;
   int ysize = 480;
   uchar crud;
   char junk;
   int k,k1,k2,subfile,line;

   if ((fp=fopen(filename,"rb")) == NULL)
   {   error_message(filename, errno);
       return(NOTFOUND);
   }

   if(g.tif_skipbytes) fread(&junk,1,g.tif_skipbytes,fp);
   buffer = new uchar[g.off[g.bitsperpixel]*(xsize+4)]; 
   if(buffer==NULL) return(NOMEM);
   if(newimage(0,0,xsize,ysize,4,INDEXED,1,g.want_shell,PERM,1,g.window_border,0)!=OK) 
       { delete[] buffer; return(NOMEM); }

   for(k=0;k<5;k++) fread(&crud,1,1,fp);       /* 6 bytes at start of file  */

                                   /* 12 subfiles, 1 for each GET stmt.     */   
   for(subfile=0;subfile<12;subfile++) 
   {  for(k=0;k<4;k++)
        fread(&crud,1,1,fp);       /* 4 bytes at start of each subfile=junk */
     
      for(line=0;line<40;line++)   /* Each subfile has 40 lines             */
      {                            /* Each line has 4 bitmaps of 640 pixels */                                     
                                   /*  i.e., 80x4 bytes                     */
   
          fread(buffer,320,1,fp);    
          for(k1=0;k1<80;k1++)
          { for(k=0;k<8;k++) crudbuf[k]=0;                
            for(k2=0;k2<4;k2++)
            {   value=1<<k2;
                color=buffer[k1+k2*80];
                if(color&0x80) crudbuf[0]+=value;
                if(color&0x40) crudbuf[1]+=value;
                if(color&0x20) crudbuf[2]+=value;
                if(color&0x10) crudbuf[3]+=value; 
                if(color&0x08) crudbuf[4]+=value; 
                if(color&0x04) crudbuf[5]+=value; 
                if(color&0x02) crudbuf[6]+=value; 
                if(color&0x01) crudbuf[7]+=value;                 
            }
            for(k=0;k<8;k++)
                z[ci].image[z[ci].cf][subfile*40+line][k1*8+k] = crudbuf[k]<<4; 
          }          
      }   
      for(k=0;k<1171;k++)fread(&crud,1,1,fp);
   }
   fclose(fp);
   delete[] buffer;
   return(OK);
}



//--------------------------------------------------------------------------//
// readimgfile                                                              //
// Reads:   IMG files (8 bit from frame grabber)                            //
//          IMM files (1 bit)                                               //
//          RAW files (1-32 bit invalid or unknown file type)               //
//          ASCII files (1-32 bit invalid or unknown file type)             //
// Also can try to read any 1-32 bit image.                                 //
//--------------------------------------------------------------------------//
int readimgfile(char *filename, int type,int noofargs, char **arg)
{  
   static int xsize=0,ysize=0;
   static int platform=0;
   static int skip=0;
   static int rbpp=g.redbpp[g.bitsperpixel];
   static int gbpp=g.greenbpp[g.bitsperpixel];
   static int bbpp=g.bluebpp[g.bitsperpixel];
   static int kbpp=g.blackbpp[g.bitsperpixel];
   static short uint bpp=g.bitsperpixel;
   static int colortype=-1;
   static int packing=TIF;
   static int want_increment=0;
   static int want_color = 1;
   static int inc_inc=1;

   if(memorylessthan(16384)){ message(g.nomemory,ERROR); return(ABORT); }
   
   Dialog dialog;
   dialog.needrepeat=0;
   int done=0, i, i2, j, k, kk, mm, rr, gg ,bb, dbpp=0, ibpp=8,
       evenbits=0, increment=0, want_packing=2,
       fsize, bufsize, bytesperrow=0,
       size1, size2, noofcolors=1, ctype, crudint;
   short int short_xsize, short_ysize;
   uint value,vvv;
   FILE *fp;
   double pfac;
   uchar *bufr;
   uchar *bufr2;
   uchar *buffer;
   char temp[256];
   char crud[256];
   char junk; 
   
   //----------------------Open the file---------------------------------//

   fsize = filesize(filename);
  
   char option[4];
   if(type==ASCII) 
       strcpy(option,"rt");
   else strcpy(option,"rb");
   if ((fp=fopen(filename, option)) == NULL)
   {   error_message(filename, errno);
       return(NOTFOUND);
   }

   //---------------Try to determine file parameters---------------------//

   colortype=2;  // grayscale

   if(type!=ASCII && g.tif_skipbytes) fread(&junk,1,g.tif_skipbytes,fp);
   if(type==ASCII) 
   {  fscanf(fp,"%hd",&short_xsize);   // %hd = short int
      fscanf(fp,"%hd",&short_ysize);   // %hd = short int
      xsize = short_xsize;
      ysize = short_ysize;
      bpp=8;
   }
   if(type==IMG || type==IMM)
   {  
      xsize = getword(fp);
      ysize = getword(fp);
      want_color=0; packing=TIF; platform=0; colortype=2;
      bpp=8;
   }
   if(type==IMM)
   {   bpp=1; 
       evenbits = ((xsize*bpp+7)/8)*8; 
       while(xsize*bpp < evenbits) xsize++;
   }
   if(type==RAW && xsize<=0)   
   {   if(g.off[bpp]) xsize = (int)(sqrt(fsize/g.off[bpp]));
       else xsize = 128;
       ysize = xsize;
       bpp=8;
   }

   //---------------User Input-------------------------------------------//


inputstart:
  if(noofargs<=5)
   {
    if(override || raw)
    {     
      if(type==RAW)
         strcpy(dialog.title,"Read Raw Bytes");
      else if(type==ASCII)
         strcpy(dialog.title,"Read ASCII");
      else
         strcpy(dialog.title,"IMG File Parameters");
      strcpy(dialog.radio[0][0],"Image Source");              
      strcpy(dialog.radio[0][1],"PC");
      strcpy(dialog.radio[0][2],"Mac");
      strcpy(dialog.radio[0][3],"MVS Mainframe");
 
      strcpy(dialog.radio[1][0],"Color");
      strcpy(dialog.radio[1][1],"RGB Color");
      strcpy(dialog.radio[1][2],"Gray Scale/Indexed");
      strcpy(dialog.radio[1][3],"CMYK Color");
                      
      strcpy(dialog.radio[2][0],"Bit Packing");
      strcpy(dialog.radio[2][1],"TIF-like");
      strcpy(dialog.radio[2][2],"GIF-like");
      strcpy(dialog.radio[2][3],"None");
  
      dialog.radioset[0]=platform+1;  // PC Mac IBM = 1 2 3     
      dialog.radioset[1]=colortype;
      
      if(packing==TIF)  dialog.radioset[2]=1;
      if(packing==GIF)  dialog.radioset[2]=2;
      if(packing==NONE) dialog.radioset[2]=3;
   
      strcpy(dialog.boxes[0] ,"Image Parameters");
      strcpy(dialog.boxes[1] ,"X size (pixels)" );
      strcpy(dialog.boxes[2] ,"Y size (pixels)" );
      if(type==ASCII)
         strcpy(dialog.boxes[3] ,"No.of values to skip" );
      else
         strcpy(dialog.boxes[3] ,"No.of bytes to skip" );
      strcpy(dialog.boxes[4] ,"Total bits/pixel" );
      strcpy(dialog.boxes[5] ,"Color Depth");
      strcpy(dialog.boxes[6] ,"Red bits/pixel" );
      strcpy(dialog.boxes[7] ,"Green bits/pixel" );
      strcpy(dialog.boxes[8] ,"Blue bits/pixel " );
      strcpy(dialog.boxes[9] ,"Black bits/pixel" );
      strcpy(dialog.boxes[10] ,"Increment width" );
      strcpy(dialog.boxes[11] ,"Auto increment" );
      strcpy(dialog.boxes[12] ,"Increment" );

      itoa(xsize,temp,10); strcpy(dialog.answer[1],temp);
      itoa(ysize,temp,10); strcpy(dialog.answer[2],temp);
      itoa(skip ,temp,10); strcpy(dialog.answer[3],temp);
      itoa(bpp  ,temp,10); strcpy(dialog.answer[4],temp);
      itoa(rbpp ,temp,10); strcpy(dialog.answer[6],temp);
      itoa(gbpp ,temp,10); strcpy(dialog.answer[7],temp);
      itoa(bbpp ,temp,10); strcpy(dialog.answer[8],temp);
      itoa(kbpp ,temp,10); strcpy(dialog.answer[9],temp);
      if(want_increment) dialog.boxset[11]=1;    
      itoa(inc_inc,temp,10); strcpy(dialog.answer[12],temp);
   
      dialog.radiono[0]=4;
      dialog.radiono[1]=4;
      dialog.radiono[2]=4;
      dialog.radiono[3]=0;
      for(j=0;j<10;j++) for(k=0;k<20;k++) dialog.radiotype[j][k]=RADIO;
      dialog.boxtype[0]=LABEL; 
      dialog.boxtype[1]=STRING;
      dialog.boxtype[2]=STRING;
      dialog.boxtype[3]=STRING;
      dialog.boxtype[4]=INTCLICKBOX;
      dialog.boxtype[5]=LABEL;
      dialog.boxtype[6]=INTCLICKBOX;
      dialog.boxtype[7]=INTCLICKBOX;
      dialog.boxtype[8]=INTCLICKBOX;
      dialog.boxtype[9]=INTCLICKBOX;
      dialog.boxtype[10]=TOGGLE;
      dialog.boxtype[11]=TOGGLE;
      dialog.boxtype[12]=INTCLICKBOX;
    
      dialog.boxmin[4]=1; dialog.boxmax[4]=32;
      dialog.boxmin[6]=0; dialog.boxmax[6]=32;
      dialog.boxmin[7]=0; dialog.boxmax[7]=32;
      dialog.boxmin[8]=0; dialog.boxmax[8]=32;
      dialog.boxmin[9]=0; dialog.boxmax[9]=32;
      dialog.boxmin[12]=1; dialog.boxmax[12]=100;
     
      dialog.noofradios=3;
      dialog.noofboxes=13;
      dialog.helptopic=11;  
      dialog.keep=0;
      dialog.want_changecicb = 0;
      dialog.f1 = null;
      dialog.transient = 1;
      strcpy(dialog.path,".");
   
     //-------------------------//
      dialogbox(dialog);
     //-------------------------//
 
      if(g.getout) return(ABORT); 
      platform = dialog.radioset[0]-1;

      if(dialog.radioset[1]==1) { want_color=1; g.read_cmyk=0; colortype=1; }
      if(dialog.radioset[1]==2) { want_color=0; g.read_cmyk=0; colortype=2; }
      if(dialog.radioset[1]==3) { want_color=1; g.read_cmyk=1; colortype=3; }

      if(dialog.radioset[2]==1) packing=TIF;
      if(dialog.radioset[2]==2) packing=GIF;
      if(dialog.radioset[2]==3) packing=NONE;
      xsize = atoi(dialog.answer[1]);
      ysize = atoi(dialog.answer[2]);
      skip  = atoi(dialog.answer[3]);
      bpp   = atoi(dialog.answer[4]);
      rbpp  = atoi(dialog.answer[6]);
      gbpp  = atoi(dialog.answer[7]);
      bbpp  = atoi(dialog.answer[8]);
      kbpp  = atoi(dialog.answer[9]);
      if(dialog.boxset[11]) want_increment=1;else want_increment=0;
      inc_inc = atoi(dialog.answer[12]);

      if(want_color)
      {  if(rbpp+gbpp+bbpp+kbpp != bpp) 
         {  message("R,G,and B bits/pixel don't add up to total",ERROR);
            goto inputstart;
         }
      }      
    }
  }else
   { if(noofargs>5) platform = atoi(arg[6]);
     if(noofargs>6) 
     {    colortype   = atoi(arg[7]);
          if(colortype==1) { want_color=1; g.read_cmyk=0; }
          if(colortype==2) { want_color=0; g.read_cmyk=0; }
          if(colortype==3) { want_color=1; g.read_cmyk=1; }
     }
     packing=NONE;
     if(noofargs>7) 
     {    want_packing = atoi(arg[8]);
          if(want_packing ==0) packing=TIF;
          if(want_packing ==1) packing=GIF;
          if(want_packing ==2) packing=NONE;
     }
     if(noofargs>8) xsize = atoi(arg[9]);  if(xsize<1) return ERROR;
     if(noofargs>9) ysize = atoi(arg[10]); if(ysize<1) return ERROR;
     if(noofargs>10) skip = atoi(arg[11]);
     if(noofargs>11) bpp  = atoi(arg[12]); if(bpp>32 || bpp<=0) return ERROR;
     if(noofargs>12) rbpp = atoi(arg[13]);
     if(noofargs>13) gbpp = atoi(arg[14]);
     if(noofargs>14) bbpp = atoi(arg[15]);
     if(noofargs>15) kbpp = atoi(arg[16]);
   }
     
    //------------------------end of input section-------------------------//

   xsize=max(1,xsize);
   ysize=max(1,ysize);
   if(bpp==15)
     ibpp=15;
   else 
     ibpp = min(32,8*((bpp+7)/8)); // bpp increased to next multiple of 8.
                                       // Image is silently converted to ibpp. 
   if(packing==NONE) bpp=ibpp;
   
   pfac = 7.9999/(double)bpp;
   
   bytesperrow = (int)(xsize/pfac);

   //----------------------Allocate space--------------------------------//

   g.tif_xsize=1.0;
   g.tif_ysize=1.0;
   // kxfac=(int)g.tif_xsize*64; // integer to speed up multiplication
   //                          // so  tif_xsize*k  ==  ((kxfac*k)>>6).
   //
   // kyfac=(int)g.tif_ysize*64; // integer to speed up multiplication
   //                          // so  yfac*k  ==  ((kyfac*k)>>6).
 
   noofcolors = ((7+bpp)/8);
   size1         = noofcolors*xsize+10;
   size2         = g.off[max(g.bitsperpixel,ibpp)]*xsize+10;
   bufsize       = max(size1,size2);      
   bufr          = new uchar[bufsize];
   if(bufr==NULL){ message(g.nomemory,ERROR); fclose(fp); return(NOMEM); }
   bufr2         = new uchar[bufsize];
   if(bufr2==NULL){ delete[] bufr;fclose(fp);message(g.nomemory,ERROR);return(NOMEM);}
   bufr[bufsize-1]  = 99;
   bufr2[bufsize-1] = 99;

   buffer = new uchar[bufsize+10];
   if(buffer==NULL)
   {  message(g.nomemory,ERROR);  
      fclose(fp);
      delete[] bufr;
      delete[] bufr2;
      return(NOMEM); 
   }
   buffer[bufsize+9]=99;
   
   if(colortype==1 || colortype==3) ctype=COLOR;
   else if(want_color) ctype=INDEXED;
   else ctype=GRAY;

   if(newimage(g.tif_xoffset + 1, g.tif_yoffset,
        (int)(0.99999 + xsize*g.tif_xsize), 
        (int)(0.99999 + ysize*g.tif_ysize), 
        bpp, ctype, 1, g.want_shell,PERM,1,g.window_border,0)!=OK) 
   {  message(g.nomemory,ERROR);  
      fclose(fp);
      delete[] bufr;
      delete[] bufr2;
      delete[] buffer;
      return(NOMEM); 
   }

   if(!want_color) z[ci].colortype=GRAY;

   //----------------------Read image------------------------------------//

   if(skip)
   { if(type==ASCII)
     { for(k=0;k<skip;k++) fscanf(fp,"%d",&crudint);  } 
     else
     { for(k=0;k<skip;k++) fread(crud,noofcolors,1,fp);  } 
   }
   increment=0;
   if(platform==1) g.invertbytes=1; else g.invertbytes=0;

   if(type==ASCII)
   {   for(j=0;j<ysize;j++)   
       {  for(i=0,i2=0; i<xsize; i++,i2+=g.off[ibpp])   
          {   fscanf(fp,"%u",&vvv);
              if(vvv>(uint)g.maxvalue[ibpp]) vvv=(uint)g.maxvalue[ibpp];
              putpixelbytes(z[ci].image[z[ci].cf][j]+i2,vvv,1,ibpp,1);
              if(feof(fp)){ done=1; break; }
              if(done)break;
          }
          if(done)break;
       }
   }else   
   for(j=0;j<ysize;j++)   
   {
     if(want_increment) increment+=inc_inc;
     if(increment) for(k=0;k<increment;k++) fread(crud,noofcolors,1,fp);   
     fread(buffer,bytesperrow,1,fp);   

     if(feof(fp))break;
     getbits(0,buffer,0,RESET);     
     for(i=0,i2=0;i<xsize;i++,i2+=g.off[ibpp])   
     {  if(want_color==0)
        {  value = getbits(bpp,buffer,bytesperrow,packing);
           if(bpp<=8)                              // Filter thru current palette
           {  
              if(bpp==1) { if(value) value=g.maxcolor; }
              else
              {  dbpp = 8-bpp;                     //  if it is <= 8 bits/pixel
                 if(dbpp>0) value <<= ( dbpp); else value >>= (-dbpp);
                 if(ibpp>8)                        // Convert to grayscale 
                 {  valuetoRGB(value,rr,gg,bb,8);  // Use current palette           
                    value = RGBvalue(rr,gg,bb,ibpp);
                 }   
              }   
           }else
           {  
              dbpp = ibpp-bpp;                     // If >8 bits/pixel, don't use
              if(dbpp>0) value <<= ( dbpp);        //   palette. 
              if(dbpp<0) value >>= (-dbpp);
           }
        }else
        {  rr = getbits(rbpp,buffer,bytesperrow,packing);
           gg = getbits(gbpp,buffer,bytesperrow,packing);
           bb = getbits(bbpp,buffer,bytesperrow,packing);
           kk= getbits(kbpp,buffer,bytesperrow,packing);
           dbpp = g.redbpp[ibpp]  - rbpp;
           if(dbpp>0) rr <<= ( dbpp); else  rr >>= (-dbpp);
           dbpp = g.greenbpp[ibpp]- gbpp;    
           if(dbpp>0) gg <<= ( dbpp); else  gg >>= (-dbpp);
           dbpp = g.bluebpp[ibpp] - bbpp;  
           if(dbpp>0) bb <<= ( dbpp); else  bb >>= (-dbpp);
           dbpp = g.redbpp[ibpp]  - kbpp;  
           if(dbpp>0) kk <<=( dbpp); else kk >>= (-dbpp);
           rr = max(0,min(rr, g.maxred[ibpp]));
           gg = max(0,min(gg, g.maxred[ibpp]));
           bb = max(0,min(bb, g.maxred[ibpp]));
           kk= max(0,min(kk, g.maxred[ibpp]));

           if(g.read_cmyk)
           {  mm = g.maxred[ibpp]; 
              rr = max(0,min(mm,mm-rr-kk));
              mm = g.maxgreen[ibpp]; 
              gg = max(0,min(mm,mm-gg-kk));
              mm = g.maxblue[ibpp]; 
              bb = max(0,min(mm,mm-bb-kk));
           }
           value = RGBvalue(rr,gg,bb,ibpp);   
        }                                  
        putpixelbytes(z[ci].image[z[ci].cf][j]+i2,value,1,ibpp,1);
     }
   }

   if(want_color)
   {  noofcolors=0;
      if(rbpp) noofcolors++;                         
      if(gbpp) noofcolors++;                         
      if(bbpp) noofcolors++;                         
      if(kbpp) noofcolors++;  
      if(ibpp<=8) z[ci].colortype=INDEXED; else  z[ci].colortype=COLOR;
   }else
   {  
      z[ci].colortype=GRAY;
   }
   
   delete[] bufr;
   delete[] bufr2;
   delete[] buffer;
   fclose(fp);
   return(OK);
}


//--------------------------------------------------------------------------//
// read3Dfile                                                               //
//--------------------------------------------------------------------------//
int read3Dfile(char *filename)
{  

   static int bpp=8, frames=15, xsize=128, ysize=128, skipbytes=0;
   if(memorylessthan(16384)){ message(g.nomemory,ERROR); return(ABORT); }
   FILE *fp;
   Dialog dialog;
   dialog.needrepeat=0;
   int bytesperscanline,i,j,noofcolors,colortype;
   char tempstring[100];
   
   //----------------------Get parameters----------------------------------//

   itoa(frames,tempstring,10);
   strcpy(dialog.answer[0],tempstring);
   itoa(xsize,tempstring,10);
   strcpy(dialog.answer[1],tempstring);
   itoa(ysize,tempstring,10);
   strcpy(dialog.answer[2],tempstring);
   itoa(bpp,tempstring,10);
   strcpy(dialog.answer[3],tempstring);
   itoa(skipbytes,tempstring,10);
   strcpy(dialog.answer[4],tempstring);

   strcpy(dialog.title,"3D Parameters");
   strcpy(dialog.boxes[0],"No. of frames");
   strcpy(dialog.boxes[1],"Frame width (pixels)");
   strcpy(dialog.boxes[2],"Frame height (pixels)");
   strcpy(dialog.boxes[3],"Bits/pixel");
   strcpy(dialog.boxes[4],"Bytes to skip");
   dialog.boxtype[0]=STRING; 
   dialog.boxtype[1]=STRING; 
   dialog.boxtype[2]=STRING; 
   dialog.boxtype[3]=STRING; 
   dialog.boxtype[4]=STRING; 

   dialog.noofradios=0;
   dialog.radiono[0]=0;
   dialog.noofboxes=5;
   dialog.helptopic=37;
   dialog.keep=0;
   dialog.want_changecicb = 0;
   dialog.f1 = null;
   dialog.transient = 1;
   strcpy(dialog.path,".");

   ///////////////////
   dialogbox(dialog); 
   ///////////////////

   if(g.getout) return ABORT;
   frames = atoi(dialog.answer[0]);
   xsize = atoi(dialog.answer[1]);
   ysize = atoi(dialog.answer[2]);
   bpp = atoi(dialog.answer[3]);
   skipbytes = atoi(dialog.answer[4]);
   noofcolors = (7+bpp)/8;
   if(noofcolors>1) colortype=COLOR; else colortype=INDEXED;

   //----------------------Open the file----------------------------------//

   if(newimage(0,0,xsize,ysize,bpp,colortype,frames,g.want_shell,PERM,
       g.window_border,1,0)!=OK)  return NOMEM;

   if ((fp=fopen(filename,"rb")) == NULL)
   {   error_message(filename, errno);
       return(NOTFOUND);
   }
   if(skipbytes) fseek(fp, skipbytes, SEEK_SET);
   bytesperscanline = xsize*((bpp+7)/8);
   for(i=0;i<frames;i++)
   for(j=0;j<ysize;j++)
       fread(z[ci].image[i][j],bytesperscanline,1,fp);

   fclose(fp);
   return OK;
}


//--------------------------------------------------------------------------//
// swapbytes                                                                //
// reverses the order of bytes  n=no. of bytes in array,size=bytes at a time//
//--------------------------------------------------------------------------//
void swapbytes(uchar* a, int n, int size)
{
   int k;
   switch(size)
   {   case 1: return;           // Too small, throw it back
       case 2:
          for(k=0;k<n-1;k+=2)    // For 16 bit ints
             swap(a[k],a[k+1]);
          break;
       case 3: 
          for(k=0;k<n-2;k+=3)    // For 24 bit pixels
               swap(a[k], a[k+2]);
          break;
       case 4:
          for(k=0;k<=n-4;k+=4)    // For 32 bit ints
          {     
                swap(a[k],a[k+3]);
                swap(a[k+1],a[k+2]);
          }
          break;
       case 6:
          for(k=0;k<=n-6;k+=6)    // For 48 bit ints
          {     swap(a[k],a[k+5]);
                swap(a[k+1],a[k+4]);
                swap(a[k+2],a[k+3]);
          } 
          break;
       case 8:
          for(k=0;k<=n-8;k+=8)    // For 64 bit ints
          {     swap(a[k],a[k+7]);
                swap(a[k+1],a[k+6]);
                swap(a[k+2],a[k+5]);
                swap(a[k+3],a[k+4]);
          } 
          break;
       default:
          fprintf(stderr,"Error in swapbytes (size=%d)\n",size);
   }
}


//--------------------------------------------------------------------------//
// writeimgfile                                                             //
// Save screen image on disk.                                               //
// This format consists of 4 bytes that give x & y size, followed by the    //
// packed data in a raster sequence. Since there is no way to specify       //
// bits/pixel, only 1 and 8 are supported.                                  //
// (Frame grabber format - don't confuse with GEM)                          //
//--------------------------------------------------------------------------//
int writeimgfile(char *filename, int write_all, int compress)
{
  FILE *fp;
  if(memorylessthan(16384)){ message(g.nomemory,ERROR); return(NOMEM); }
  int ino,bpp,i,j,s,xsize,count;
  int x1,y1,x2,y2;
  
  
  if(write_all==1)
  {   x1 = z[ci].xpos;
      y1 = z[ci].ypos;
      x2 =  x1 + z[ci].xsize;
      y2 =  y1 + z[ci].ysize;
  }else
  {   x1 = g.selected_ulx;
      x2 = g.selected_lrx;
      y1 = g.selected_uly;
      y2 = g.selected_lry;
  }

  if((fp=open_file(filename, compress, WRITE, g.compression, g.decompression, 
      g.compression_ext))==NULL) 
      return CANTCREATEFILE;
  
  if(!g.want_color_type)
  {  message("Saving as monochrome!"); 
     xsize = ((x2-x1+7)>>3)<<3;
  }else 
     xsize = x2-x1;
 
  putword(xsize,fp); 
  s = y2-y1;
  putword(s,fp); 

  ////  Write image data    

  for(j=y1;j<y2;j++)
  {   if(!g.want_color_type)
      {   for(i=x1,count=0;count<(xsize>>3);i+=8)
          {  count++;
             s = readbyte(i,j); 
             putbyte(s,fp);
          }
      }else
      { if(write_all)
          fwrite(z[ci].image[z[ci].cf][j-y1],g.off[g.want_bpp]*xsize,1,fp);
        else
          for(i=x1;i<x2;i++)
          {  s = readpixelonimage(i,j,bpp,ino); 
             fwrite(&s,g.off[g.want_bpp],1,fp);
          }
      }
  }

  close_file(fp, compress);  
  return OK;
}


//--------------------------------------------------------------------------//
// writefft                                                                 //
// Save fft in ASCII format.                                                //
//--------------------------------------------------------------------------//
int writefft(int ino)
{
  FILE *fp;
  if(memorylessthan(16384)){ message(g.nomemory,ERROR); return(NOMEM); }
  int i,j;
  static char fftfile[FILENAMELENGTH]="fft.ascii";
  
  int status=OK;
  int size;

  if(!z[ino].floatexists)
  {   message("No FFT exists for this image",ERROR);
      return(BADPARAMETERS);
  }
  message("Filename:",fftfile,PROMPT,FILENAMELENGTH-1);
  if(cant_overwrite_file(fftfile)) return(ABORT);
  if ((fp=fopen(fftfile, "wt")) == NULL)
  {   error_message(fftfile, errno);
      return(CANTCREATEFILE);
  }

  fprintf(fp,"FFT of %s\n",z[ino].name);  
  fprintf(fp,"xsize %d\n", z[ino].xsize);  
  fprintf(fp,"ysize %d\n", z[ino].ysize);  
  fprintf(fp,"Real\n");  
  for(j=0;j<z[ino].fftysize;j++)
  {   for(i=0;i<z[ino].fftxsize;i++)
         fprintf(fp,"%g ",z[ino].fft[j][i].real());
      fprintf(fp,"\n");  
  }
  fprintf(fp,"\n\nImaginary\n");  
  for(j=0;j<z[ino].fftysize;j++)
  {   for(i=0;i<z[ino].fftxsize;i++)
         fprintf(fp,"%g ",z[ino].fft[j][i].imag());
      fprintf(fp,"\n");  
  }

  fclose(fp);
  size = filesize(fftfile);              // Check to ensure not an empty file
  if(size==0) status=ZEROLENGTH; 
  if(access(fftfile,F_OK)) status=ERROR; // access = 0 if file exists
  if(status==OK) message("FFT saved");
  else  message("Error saving FFT!",ERROR);
  return(status);
}


//--------------------------------------------------------------------------//
// readfft                                                                  //
// Read fft in ASCII format.                                                //
//--------------------------------------------------------------------------//
int readfft(int noofargs, char **arg)
{
   static char *filename=NULL;
   char temp1[256];
   char temp2[256];
   char temp3[256];
   FILE *fp;
   ////  Leave this allocated
   if(filename==NULL){ filename = new char[FILENAMELENGTH]; filename[0]=0; }
   char oldfilename[FILENAMELENGTH];
   if(strlen(filename)) strcpy(oldfilename, filename);
   int frame, i, j, status=OK, xsize, ysize;
   
   if(noofargs == 0)
      strcpy(filename, getfilename(oldfilename));
   else 
      strcpy(filename, arg[1]);
      
   if((fp=fopen(filename, "rt")) == NULL)
   {   error_message(filename, errno);
       return(ERROR);
   }
   
   // Always use field width when reading strings with fscanf to avoid
   // buffer overflow.
   
   fscanf(fp,"%3s %2s ",temp1, temp2);          // 'FFT of'
   if(strcmp(temp1,"FFT") != SAME){ message("Invalid FFT file",ERROR); return ERROR; }
   fscanf(fp,"%256s",temp3);                    // [filename]
   fscanf(fp,"%256s %d",temp1, &xsize);         // xsize 12345
   fscanf(fp,"%256s %d",temp1, &ysize);         // ysize 12345   
   fscanf(fp,"%256s",temp1);                    // Real
   
   if(newimage(0,0,xsize,ysize,g.bitsperpixel,GRAY,1,g.want_shell,PERM,1,
      g.window_border,0)!=OK) return(NOMEM); 
   if(setupfft(ci,xsize,ysize)!=OK)
   {  message("Unable to create FFT matrix!",ERROR); 
      return ERROR;
   }
   z[ci].fftstate=REAL;
   setimagetitle(ci, temp3);
   for(j=0;j<ysize;j++)
   for(i=0;i<xsize;i++)
      if(!fscanf(fp,"%lg",&z[ci].fft[j][i].real())){ status=ERROR; break; }

   fscanf(fp,"%256s",temp1);                    // Imaginary
   for(j=0;j<ysize;j++)
   for(i=0;i<xsize;i++)
      if(!fscanf(fp,"%lg",&z[ci].fft[j][i].imag())){ status=ERROR; break; }

   if(status==OK)
   {  z[ci].fftdisplay=REAL;                    // Wait here in case user aborts
      scalefft(ci);
      rebuild_display(ci);
                                                // Map fft gray values to image[]
      frame = z[ci].cf;
      for(j=0;j<z[ci].ysize;j++)
         memcpy(z[ci].image[frame][j], z[ci].img[j], 
            z[ci].xsize * g.off[z[ci].bpp]);

      switchto(ci);
      redrawscreen();
   }else message("Error reading FFT",ERROR);
   fclose(fp);
   return status;
}


//--------------------------------------------------------------------------//
// invertimagebytes                                                         //
// switches bytes of current image in case of Mac                           //
//--------------------------------------------------------------------------//
void invertimagebytes(int bpp)
{ 
    int j,k;
    for(j=0;j<z[ci].ysize;j++) 
    {  switch(bpp)
       {  case 15:
          case 16:
              for(k=0;k<z[ci].xsize*2-1;k+=2)
                  swap(z[ci].image[z[ci].cf][j][k], z[ci].image[z[ci].cf][j][k+1]);
              break;
          case 24:
              for(k=0;k<z[ci].xsize*3-1;k+=3)
                  swap(z[ci].image[z[ci].cf][j][k], z[ci].image[z[ci].cf][j][k+2]);
              break;
          case 32:
              for(k=0;k<z[ci].xsize*4-2;k+=4)
                  swap(z[ci].image[z[ci].cf][j][k], z[ci].image[z[ci].cf][j][k+2]);
              break;
          default: break;
       }
   }
}


//--------------------------------------------------------------------------//
// readgemfile                                                              //
// Transfer GEM IMG file from disk to screen.                               //
//--------------------------------------------------------------------------//
int readgemfile(char *filename,int subtype)
{  
   if(memorylessthan(16384)){ message(g.nomemory,ERROR); return(NOMEM); }
   short uint bpp;
   FILE *fp;
   short uint version,headerlength,patternlength,xmicrons,ymicrons,flag;
   int x,y,count=0;
   int c,c2,repeat;
   uchar *buffer;
   uchar *buf2;
   int mbpp;
   short int xsize=0,ysize=0;
   int col=1,color=1;;
   char junk; 
   int i,j,k,len;

   g.tif_xsize=1;    // Size reduction disabled 
   g.tif_ysize=1;   
   
   len = filesize(filename);
   if ((fp=fopen(filename, "rb")) == NULL)
   {   error_message(filename, errno);
       return(NOTFOUND);
   }

   /* Don't confuse tif_xsize, which is desired magnification (0-1), with */
   /* xsize, which is the no. of pixels across.                           */

   if(g.tif_skipbytes) fread(&junk,1,g.tif_skipbytes,fp);
   tif_fread(&version,      2,fp,1,2);
   tif_fread(&headerlength, 2,fp,1,2);
   tif_fread(&bpp,          2,fp,1,2);
   switch(bpp)                //This field is sometimes trashed
   { case 1: case 2: case 4: case 8: case 16: case 24: case 32:
             break;
     default: bpp=1; col=255; break;
   }   
   if(subtype==GEM) mbpp=8;
   mbpp = 8*((7+bpp)/8);
   tif_fread(&patternlength,2,fp,1,2);
   if(patternlength>32) patternlength=2;
   tif_fread(&xmicrons,     2,fp,1,2);
   tif_fread(&ymicrons,     2,fp,1,2);
   tif_fread(&xsize,        2,fp,1,2);
   tif_fread(&ysize,        2,fp,1,2);
   if(headerlength==9) tif_fread(&flag,2,fp,1,2);
   while(xsize%(8/bpp)) xsize++;
   buffer = new uchar[len+4];
   if(buffer==NULL){  fclose(fp); return(NOMEM);}
   buf2   = new uchar[xsize];
   if(buf2==NULL){ delete[] buffer; fclose(fp); return(NOMEM);}
   
     // Make an 8,16,24, or 32 bpp image buffer

   if(newimage(g.tif_xoffset+1, g.tif_yoffset, 
        (int)(0.99999 + (xsize)*g.tif_ysize), 
        (int)(0.99999 + (ysize)*g.tif_xsize), mbpp,INDEXED,1,g.want_shell,PERM,1,
        g.window_border,0)!=OK)
   {  fclose(fp); 
      delete[] buffer;
      delete[] buf2;
      return(NOMEM);
   }

   z[ci].originalbpp = bpp;
   for(i=0;i<ysize;i++)  
   for(j=0;j<xsize;j++)  
     z[ci].image[z[ci].cf][i][j]=0;

   y=0; x=0; count=0; repeat=0;

   int count2=5;
   int xlimit;
   if(subtype==IMDS)
   {                                  
     xsize--;
     xlimit = xsize*g.off[mbpp];
     fseek(fp,g.tif_skipbytes+32,SEEK_SET);
     fread(buffer,len,1,fp);        // read entire image
     while(count<len)
     {  c = buffer[count++]; 
        count2++;
        if(count2==4092){ count2=0; count+=4; }
        for(j=7;j>=0;j--)
        {  if(c & (1<<j)) putpixelbytes(z[ci].image[z[ci].cf][y]+x,g.maxcolor,1,mbpp);
           x+=g.off[mbpp];
        }   
        if(x>xlimit){ x=0;y++; }
        if(y>=ysize)break;
     }
  
   }else                            // subtype = GEM - must be 8bpp
   { 
     fread(buffer,len,1,fp);        // read entire image
     while(count<len)
     {  
      c = buffer[count++]; 
      switch(c)
      {  case 0:
            c = buffer[count++];
            if(c==0x00)
            {  if(buffer[count++]==0xff)     // vertical replication code
                 repeat = buffer[count++];   // no.times to repeat scan line
            }else                   // pattern code of length patternlength
            {                       // repeated c times 
               for(k=0;k<patternlength;k++)
                  buf2[k] = buffer[count++]; // get pattern                
               for(k=0;k<c;k++)         // repeat pattern
               {  for(i=0;i<patternlength;i++)  
                  { for(j=7;j>=0;j--) 
                    {  if(buf2[i] & (1<<j)) z[ci].image[z[ci].cf][y][x] += col;
                       x++;
                    }   
                  }  
               }         
            }        
            break;                      
         case 0x80:                        // literal run next c bytes 
            c = buffer[count++];           // no of bytes to take literally
            for(k=0;k<c;k++) 
            {  c2 = buffer[count++];       // get byte
               for(j=7;j>=0;j--)
               {  if(c2 & (1<<j)) z[ci].image[z[ci].cf][y][x] += col;
                  x++; 
                }   
            }       
            break;
         default:
            if(c & 0x80)                   // next 8*(c&0x7f)pixels are black
               x += 8*(c&0x7f);
            else                           // next 8*(c&0x7f)pixels are white
               for(k=0;k<8*(c&0x7f);k++) z[ci].image[z[ci].cf][y][x++] += (int)col; 
            break;
      }        

      if(x>=xsize)
      {     x=0; 
            color++; 
            if(bpp==1) col=255;
            else       col = (1<<(color-1)) * (256/(1<<bpp));      
            if(col>=256)col=255;
      }
      if(color>bpp)
      {    color=1;
           if(bpp==1) col=255;
           else       col = (1<<(color-1)) * (256/(1<<bpp));      
           if(col>=256)col=255;
           x=0; y++; 
           if(y<ysize)
           {  for(j=0;j<repeat;j++)
              {  
                for(k=0;k<=xsize;k++) 
                     z[ci].image[z[ci].cf][y][x++] = z[ci].image[z[ci].cf][y-1][x];
                y++;
                x=0;
                if(y>=ysize) break;
              }    
              repeat=0;
           } 
      }
      if(y>=ysize) break;
     }
   }  

   delete[] buf2;
   delete[] buffer;
   fclose(fp);
   return(OK);
}



//--------------------------------------------------------------------------//
// strupr                                                                   //
//--------------------------------------------------------------------------//
void strupr(char *s)
{
   int k;
   for(k=0;k<(int)strlen(s);k++) s[k]=toupper(s[k]);
}


//--------------------------------------------------------------------------//
// strlwr                                                                   //
//--------------------------------------------------------------------------//
void strlwr(char *s)
{
   int k;
   for(k=0;k<(int)strlen(s);k++) s[k]=tolower(s[k]);
}


//--------------------------------------------------------------------------//
//  remove_terminal_cr                                                      //
//--------------------------------------------------------------------------//
void remove_terminal_cr(char *s)
{
    int pos = max(0, (int)(strlen(s))-1);
    if(s[pos]=='\n') s[pos]=0;
}


//--------------------------------------------------------------------------//
//  filesize                                                                //
//--------------------------------------------------------------------------//
int filesize(char *filename)
{
     struct stat dstatus;
     stat(filename, &dstatus);
     return dstatus.st_size;
}  
 
//--------------------------------------------------------------------------//
//  is_dir                                                                  //
//--------------------------------------------------------------------------//
int is_dir(char *filename)
{
     struct stat dstatus;
     int mode;
     stat(filename, &dstatus);
     mode = dstatus.st_mode;
     if(S_ISDIR(mode)) return 1;
     return 0;
}  
