//--------------------------------------------------------------------------//
// xmtnimage33.cc                                                           //
// Latest revision: 01-23-1999                                              //
// Copyright (C) 1999 by Thomas J. Nelson                                   //
// All rights reserved.                                                     //
// move, copy, spray, math                                                  //
//--------------------------------------------------------------------------//

#include "xmtnimage.h"

extern Globals     g;
extern Images     *z;
extern int         ci;
extern PrinterStruct printer;

//-------------------------------------------------------------------------//
// move                                                                    //
// move or copy part of image from one area on the screen to another       //
//-------------------------------------------------------------------------//
int move(void)
{ 
  if(memorylessthan(16384)){  message(g.nomemory,ERROR); return ERROR; } 
  static int incopy=0;

  if(incopy) return BUSY;
  incopy=1;
  int bpp,cf,citoerase=0,done=0,frame=0,h,i,ii,ino,oino,j,jj,k,
      w,x1,x2,y1,y2,hitbkg=0,want_remap=1;
  uint value;
  RGB rgb;
  uchar *savebpp_1d;
  uchar **savebpp;
  uchar *alpha_1d;
  uchar **alpha;
  int *repairflags;
  g.getout = 0;
  if(g.getout){ g.getout=0; incopy=0; return ABORT; }
  for(k=0; k<g.image_count; k++) z[k].hit=0;
  hitbkg=0;
  citoerase=0;   
  printstatus(COPY);
  x1 = g.selected_ulx;
  x2 = g.selected_lrx;
  y1 = g.selected_uly;
  y2 = g.selected_lry;
  w = x2-x1;
  h = y2-y1;
  drawselectbox(OFF);
  ////  Make a temporary image at 24 bpp.
  if(newimage(x1,y1,w,h,24,COLOR,1,0,TEMP,0,g.window_border,0)!=OK)
  {  incopy=0; return(NOMEM); }
  
  savebpp_1d = new uchar[(h+1)*(w+1)];
  savebpp = make_2d_alias(savebpp_1d, w+1, h+1);
  alpha_1d = new uchar[(h+1)*(w+1)];
  alpha = make_2d_alias(alpha_1d, w+1, h+1);
  repairflags = new int[MAXIMAGES];

  ////  Make sure correct temporary image gets erased.
  citoerase = ci;

  ////  Get stuff to move, save it as pseudo-24 bpp, and record its original bpp. 
  ////  This causes pixel depths to be converted only if their bpp is different 
  ////  from the destination.
  ////  Make sure pixels aren't read from the temp. image (citoerase).

  cf = z[citoerase].cf;
  oino = ci;
  rgb.red = 0;
  rgb.green = 0;
  rgb.blue = 0;

  for(j=y1;j<y2;j++)
  for(i=x1;i<x2;i++)
  {    value = readpixelonimage(i,j,bpp,ino,citoerase);
       if(ino>=0) frame = z[ino].cf; else frame=0;
       if(ino!=oino)
       {   if(ino>=0)
           {   if(z[ino].bpp==8) switch_palette(ino); }
           else 
           {   if(g.bitsperpixel==8) memcpy(g.palette, g.b_palette, 768);}
       }oino=ino;

       ii = i-x1;
       jj = j-y1;
       putpixelbytes(z[citoerase].image[cf][jj]+g.off[24]*ii, value, 1, 24, 1);
       putpixelbytes(z[citoerase].img[jj] + g.off[g.bitsperpixel]*ii, 
            value, 1, g.bitsperpixel, 1);
       savebpp[jj][ii] = bpp;
       if(ino>=0)       
           alpha[jj][ii]=get_alpha_bit(ino,frame,i-z[ino].xpos,j-z[ino].ypos);
       else
           alpha[jj][ii]=get_alpha_bit(-1,0,i,j);
  }
  repairimg(citoerase,0,0,w,h);

  ////  Erase the old region if 'move' was selected.
  for(k=0;k<MAXIMAGES;k++) repairflags[k]=0;
  if(!g.copy)
  {  for(j=y1;j<y2;j++)
     {  for(i=x1;i<x2;i++)
        {   if(!g.selected_is_square && !inside_irregular_region(i,j)) continue;
            erase_pixel(i,j,repairflags);
            done = repairflags[0] & 4;
            if(done) break;
        }if(done) break;
     }
  }
  
  ////  Wait for user to figure out where to put it.     
  user_position_copy(citoerase,x1,y1,x2,y2,want_remap,CHROMAKEY_NONE,
      0,0,0,rgb,rgb,24,savebpp,alpha,hitbkg);
  eraseimage(citoerase,0,0,0);                    // Erase the temporary image bufr
  delete[](savebpp);
  free(savebpp_1d);
  delete[](alpha);
  free(alpha_1d);

  for(k=0; k<g.image_count; k++) if(z[k].hit){ rebuild_display(k); redraw(k); }
  incopy=0;
  drawselectbox(ON);
  delete[] repairflags;
  return OK;
}


//-------------------------------------------------------------------------//
//  user_position_copy                                                     //
//  want_remap should be 1 for images, 0 for text                          //
//  If chromakey_mode is 1, it only sets pixels if they are between rgb_min//
//     and rgb_max or gray_min & gray_max.                                 //
//  If force_alpha is set, alpha channel is set for all pixels, and **alpha//
//     can be NULL. Otherwise, alpha[][] is used to set the alpha channel  //
//     of the destination pixel.                                           //
//-------------------------------------------------------------------------//
void user_position_copy(int citoerase, int x1, int y1, int x2, int y2,
    int want_remap, int chromakey_mode, int force_alpha, 
    int gray_min, int gray_max,  RGB rgb_min, RGB rgb_max, 
    int bpp, uchar **savebpp, uchar **alpha, int &hitbkg)
{
   int ii,j,k,oino,x,y,ino,winx,winy,source_bpp,dest_bpp,
       rx,ry,hit=0,dx,dy,value,rr,gg,bb,wantcolor=1,ulx,uly,lrx,lry,
       remapped=0,want_alpha=0;
   Window win, rwin, cwin;
   uint keys;
   g.state = GETPOINT;
   oino = g.imageatcursor;
   dx = x2-x1;
   dy = y2-y1;
   int is_square = g.selected_is_square;
   int remap[256];
   while(g.state==GETPOINT)
   {
          XtAppProcessEvent(XtWidgetToApplicationContext(g.main_widget),XtIMAll);
          XQueryPointer(g.display,g.main_window,&rwin,&cwin,&rx,&ry,&x,&y,&keys);
          ino = g.imageatcursor;

          ////  Reparent to whatever window the user moves to.
          win = z[ino].win;
          winx = x - z[ino].xpos;
          winy = y - z[ino].ypos;
          if(ino != oino || !hit)
          { 
                switch_palette(ino);  
                XReparentWindow(g.display, z[citoerase].win, win, winx, winy);
                moveimage(citoerase,winx,winy,1);
                oino = ino;
                hit=1;
          }
          ////  Window coordinates are relative to parent
          moveimage(citoerase,winx,winy,0);
   }  
   ////  Put moving Widget back where it belongs so it doesn't interfere
   XReparentWindow(g.display, z[citoerase].win, g.main_window, 2*g.xres, 2*g.yres);
   moveimage(citoerase, 2*g.xres, 2*g.yres);

   ////  Switch to the new window to make sure it gets precedence for 
   ////  whichimage(), if in a separate window.  Set the palette to the
   ////  palette of the source image, so that pixels are converted using
   ////  their original color attributes.

   if(citoerase>=0) switch_palette(citoerase);
   oino = -2;
 
   ino = whichimage(x,y,dest_bpp,citoerase);
   ulx = x;
   uly = y;
   lrx = x+dx;
   lry = y+dy;

   printstatus(COPY);
   drawselectbox(OFF);

   for(j=uly;j<lry;j++)                             // Put stuff permanently
   for(k=ulx;k<lrx;k++)
   {      if(j-y<0 || k-x<0) continue;
          if(!force_alpha && !is_square && !inside_irregular_region(k-ulx+g.region_ulx,j-uly+g.region_uly)) continue;
          ino = whichimage(k,j,dest_bpp,citoerase);
          ////  Use array instead of normal alpha channel for speed
          if(force_alpha) want_alpha=1; else want_alpha = alpha[j-y][k-x];
          source_bpp = savebpp[j-y][k-x];            
          if(ino!=oino)
          {    
               if(ino>=0)
               {    if(g.bitsperpixel==8 && source_bpp!=8) z[ino].hit=1;
                    if(source_bpp != dest_bpp) z[ino].hit=1;
                    if(dest_bpp==8) z[ino].hit=1;
                    if(!g.wantr || !g.wantg || !g.wantb) z[ino].hit=1;
                    if(g.imode != SET) z[ino].hit=1;
                    if(z[ino].bpp==8) switch_palette(ino);
               }else 
               {    hitbkg=1;
                    if(g.bitsperpixel==8) memcpy(g.palette, g.b_palette, 768);
               }

               if(want_remap && citoerase>=0 && source_bpp==8 && dest_bpp==8 && ino>=0)
               {    remapped=1;
                    remap_palette(z[citoerase].palette,z[ino].palette,remap);
               }else remapped=0;
               oino=ino;
               if(dest_bpp!=8 && citoerase>=0) switch_palette(citoerase);
          }

          if(ino>=0)
               value = pixelat(z[citoerase].image[0][j-y] + g.off[bpp]*(k-x), bpp);
          else
               value = pixelat(z[citoerase].img[j-y]+g.off[g.bitsperpixel]*(k-x),g.bitsperpixel);
                                                    // Skip bufr when setting pixel
          if(chromakey_mode!=NONE)                  // Chromakey copy
          {    if(z[citoerase].colortype==GRAY)
               {     if(!is_opaque(value,gray_min,gray_max,chromakey_mode)) 
                         continue; 
               }else
               {     valuetoRGB(value,rr,gg,bb,bpp);
                     if(!is_opaque(rr,rgb_min.red,rgb_max.red,
                                   gg,rgb_min.green,rgb_max.green,
                                   bb,rgb_min.blue,rgb_max.blue, chromakey_mode)) 
                          continue; 
               }
          }
          if(source_bpp != dest_bpp)
                value = convertpixel(value,source_bpp,dest_bpp,wantcolor);  

          if(remapped)
                ii = setpixelonimage(k,j,remap[value],g.imode,dest_bpp,
                     citoerase,0,0,want_alpha);
          else
                ii = setpixelonimage(k,j,value,g.imode,dest_bpp,
                     citoerase,0,0,want_alpha);
          if(ii!=citoerase) ino=ii;
   }
   printstatus(NORMAL);
}



//-------------------------------------------------------------------------//
//  pasteimage                                                             //
//-------------------------------------------------------------------------//
int pasteimage(int noofargs, char **arg)
{
   static int set0 = 3;
   int j,k;
   if(memorylessthan(16384)){  message(g.nomemory,ERROR); return NOMEM; } 
   if(noofargs==0)
   {  Dialog dialog;
      dialog.needrepeat=0;
      dialog.helptopic=41;
      strcpy(dialog.title,"Paste Image");

      ////--Radio buttons--////

      strcpy(dialog.radio[0][0],"Paste mode");
      strcpy(dialog.radio[0][1],"Background -> transparent part of region");
      strcpy(dialog.radio[0][2],"Background -> visible part of region");
      strcpy(dialog.radio[0][3],"Visible part of region -> background");
      strcpy(dialog.radio[0][4],"Transparent part of region -> background");
      strcpy(dialog.radio[0][5],"Stencil transparent part of region -> background");
      strcpy(dialog.radio[0][6],"Entire region -> background");
      dialog.radioset[0] = set0;
      dialog.radiono[0]=7;
      dialog.radiono[1]=0;
      for(j=0;j<10;j++) for(k=0;k<20;k++) dialog.radiotype[j][k]=RADIO;
      dialog.noofradios=1;
      dialog.noofboxes=0;
      dialog.f1 = null;
      dialog.keep=0;
      dialog.want_changecicb = 0;
      dialog.transient = 1;
      strcpy(dialog.path,".");

      ///////---///////
      dialogbox(dialog);
      ///////---///////

      if(g.getout){ g.getout=0; return ABORT; }
      set0 = dialog.radioset[0];
   }else set0 = atoi(arg[1]);
   paste(set0);
   return OK;
}



//-------------------------------------------------------------------------//
//  paste                                                                  //
//  direction is:    1 = paste background to transparent part of image ci  // 
//                   2 = paste background to visible part of image ci      // 
//                   3 = paste visible pixels in ci onto background        // 
//                   4 = paste transparent pixels in ci onto background    // 
//                   5 = stencil transparent pixels in ci onto background  // 
//                   6 = paste all of ci onto background                   // 
//-------------------------------------------------------------------------//
void paste(int direction)
{
   if(ci<0){ message("No images selected",ERROR); return; }
   int bpp,ibpp,cf,ct,i,ino,j,v,v2,x,y,tmin,tmax,rmin,rmax,gmin,gmax,bmin,bmax,
       rr,gg,bb;
   cf = z[ci].cf;
   ibpp = z[ci].bpp;
   tmin = z[ci].ck_graymin;
   tmax = z[ci].ck_graymax;
   rmin = z[ci].ck_min.red;
   rmax = z[ci].ck_max.red;
   gmin = z[ci].ck_min.green;
   gmax = z[ci].ck_max.green;
   bmin = z[ci].ck_min.blue;
   bmax = z[ci].ck_max.blue;

   drawselectbox(OFF);
   switch(direction)
   { 
     case 1:         ////  Background to transparent part of image
          for(y=g.selected_uly;y<g.selected_lry;y++)
          {    j = y - z[ci].ypos;
               for(x=g.selected_ulx;x<g.selected_lrx;x++)
               {    if(!g.selected_is_square && !inside_irregular_region(x,y)) continue;
                    v = readpixelonimage(x,y,bpp,ino);
                    i = x - z[ci].xpos;
                    if(ino!=ci) putpixelbytes(z[ci].image[cf][j]+i*g.off[ibpp],v,1,ibpp);
               }
          }
          z[ci].touched = 1;
          rebuild_display(ci); 
          redraw(ci);
          break;
     case 2:         ////  Background to opaque part of image (not very useful)
          for(y=g.selected_uly;y<=g.selected_lry;y++)
          {    j = y - z[ci].ypos;
               for(x=g.selected_ulx;x<=g.selected_lrx;x++)
               {    if(!g.selected_is_square && !inside_irregular_region(x,y)) continue;
                    v = readpixelonimage(x,y,bpp,ino,ci);
                    i = x - z[ci].xpos;
                    v2 = pixelat(z[ci].image[cf][j] + i*g.off[ibpp], ibpp);
                    ct = COLOR;
                    if(ino>=0) {   if(z[ino].colortype==GRAY) ct=GRAY; }
                    else if(g.colortype==GRAY) ct=GRAY;
                    if(ct==GRAY)
                    {   if(is_opaque(v2,tmin,tmax,1)) 
                            putpixelbytes(z[ci].image[cf][j]+i*g.off[ibpp],v,1,ibpp);
                    }else
                    {
                        valuetoRGB(v,rr,gg,bb,ibpp);                    
                        if(is_opaque(rr,rmin,rmax,gg,gmin,gmax,bb,bmin,bmax,1)) 
                            putpixelbytes(z[ci].image[cf][j]+i*g.off[ibpp],v,1,ibpp);
                                      
                    }
               }
          }
          z[ci].touched = 1;
          rebuild_display(ci); 
          redraw(ci);
          break;
     case 3:         ////  Paste opaque pixels onto background
          for(y=g.selected_uly;y<g.selected_lry;y++)
          for(x=g.selected_ulx;x<g.selected_lrx;x++)
          {    
               if(!g.selected_is_square && !inside_irregular_region(x,y)) continue;
               ino = whichimage(x,y,bpp);
               if(ino==ci) 
               {     cf = z[ino].cf;
                     j = y - z[ino].ypos;
                     i = x - z[ino].xpos;
                     v = pixelat(z[ino].image[cf][j] + i*g.off[bpp], bpp);
                     z[ci].xpos += 2*g.xres;
                     setpixelonimage(x,y,v,g.imode);
                     z[ci].xpos -= 2*g.xres;
               }
          }
          redrawscreen();
          break;
     case 4:         ////  Paste transparent pixels onto background
          for(y=g.selected_uly;y<g.selected_lry;y++)
          for(x=g.selected_ulx;x<g.selected_lrx;x++)
          {    if(!g.selected_is_square && !inside_irregular_region(x,y)) continue;
               ino = whichimage(x,y,bpp);
               if(ino!=ci) 
               {     cf = z[ci].cf;
                     j = y - z[ci].ypos;
                     i = x - z[ci].xpos;
                     v = pixelat(z[ci].image[cf][j] + i*g.off[bpp], bpp);
                     setpixelonimage(x,y,v,g.imode);
               }
          }
          redrawscreen();
          break;
     case 5:         ////  Stencil transparent pixels onto background
          for(y=g.selected_uly;y<g.selected_lry;y++)
          for(x=g.selected_ulx;x<g.selected_lrx;x++)
          {    if(!g.selected_is_square && !inside_irregular_region(x,y)) continue;
               ino = whichimage(x,y,bpp);
               if(ino!=ci) setpixelonimage(x,y,g.fcolor,g.imode);
          }
          redrawscreen();
          break;
     case 6:         ////  Paste entire region onto background
          for(y=g.selected_uly;y<g.selected_lry;y++)
          for(x=g.selected_ulx;x<g.selected_lrx;x++)
          {      if(!g.selected_is_square && !inside_irregular_region(x,y)) continue;
                 j = y - z[ci].ypos;
                 i = x - z[ci].xpos;
                 v = pixelat(z[ci].image[cf][j] + i*g.off[ibpp], ibpp);
                 z[ci].xpos += 2*g.xres;
                 setpixelonimage(x,y,v,g.imode);
                 z[ci].xpos -= 2*g.xres;
          }
          redrawscreen();
          break;
   }         
}


//-------------------------------------------------------------------------//
// spray - sprays things                                                   //
//-------------------------------------------------------------------------//
int spray(int noofargs, char **arg)
{
  static char *mathtext;
  static int spraymode=FINESPRAY,filter_type=1,mathhit=0,ksize=3,
             range=7,kmult=1,max_bkg=0,sharpfac=50;
  int alloc1=0,bpp,bytesperline,clicked=0,done,f,i,ino=0,oino=0,hit=0,j,k,
      ox1=0,oy1=0,x1,y1,x2,y2,ok=1,
      rx,ry,sf,size=0,x,y;
  if(memorylessthan(16384)){  message(g.nomemory,ERROR); return NOMEM; } 
  int tempalloc[MAXIMAGES];             
  int changed[MAXIMAGES];
  int *repairflags;
  uchar **tempbackup[MAXIMAGES]; // Allocate maximum no. in case user creates a new one
  uchar *tempbackup_1d[MAXIMAGES]; 
  char **touched=NULL;
  char *touched_1d=NULL;
  Window rwin, cwin;
  uint mask;

  g.getout=0;

  if(noofargs==0)
  {   Dialog dialog;
      dialog.needrepeat=0;
      dialog.helptopic=44;
      strcpy(dialog.title,"Spray");

      ////--Radio buttons--////

      strcpy(dialog.radio[0][0],"Spray mode");
      strcpy(dialog.radio[0][1],"Fine spray");
      strcpy(dialog.radio[0][2],"Diffuse spray");
      strcpy(dialog.radio[0][3],"Math spray");
      strcpy(dialog.radio[0][4],"Filter spray");
      strcpy(dialog.radio[0][5],"Erase spray");
      dialog.radioset[0] = spraymode;
      dialog.radiono[0]=6;
      dialog.radiono[1]=0;
      for(j=0;j<10;j++) for(k=0;k<20;k++) dialog.radiotype[j][k]=RADIO;
      dialog.noofradios=1;

      ////-----Boxes-----////

      strcpy(dialog.boxes[0],"Spray parameters");             
      strcpy(dialog.boxes[1],"Spray factor");             
      dialog.boxtype[0]=LABEL;
      dialog.boxtype[1]=INTCLICKBOX;
      dialog.boxmin[1]=1; dialog.boxmax[1] = 200;
          sprintf(dialog.answer[1], "%d", g.sprayfac);
      dialog.noofboxes=2;
      dialog.keep=0;
      dialog.want_changecicb = 0;
      dialog.f1 = null;
      dialog.transient = 1;
      strcpy(dialog.path,".");

      ///////---///////
      dialogbox(dialog);
      ///////---///////

      if(g.getout){ g.getout=0; return ABORT; }
      spraymode = dialog.radioset[0];
      g.sprayfac = atoi(dialog.answer[1]);
  }else spraymode = atoi(arg[1]);

  ////----End of dialog section--------////

  g.state=SPRAY;
  if(spraymode==MATHSPRAY)
  {    if(!mathhit) 
       {   mathtext = new char[65536];
           memset(mathtext,0,65535);
       }
       mathhit=1;
       get_math_formulas(mathtext);
  }
  if(spraymode==FILTERSPRAY)
       get_filter_parameters(filter_type, ksize, range, kmult, max_bkg, sharpfac);

  if(g.getout){ g.getout=0; return ABORT; }


  //// Make a buffer to record which pixels have been touched already

  if(spraymode==MATHSPRAY ||  spraymode==FILTERSPRAY)
  {    size = g.xres*g.yres;
       touched_1d = new char[size+1];
       if(touched_1d==NULL){  message(g.nomemory,ERROR); return NOMEM; } 
       memset(touched_1d, 0, size*sizeof(char));
       touched = make_2d_alias(touched_1d, g.xres, g.yres);
       alloc1=1;
  }


  repairflags = new int[MAXIMAGES];
  for(k=0; k<MAXIMAGES; k++)
  {  tempalloc[k]=0; changed[k]=0; repairflags[k]=0; }
  for(k=0; k<g.image_count; k++) z[k].hit=0;

  ////  Start spraying

  g.getout=0;
  while(g.getout==0)
  {  
     check_event(); if(g.getout) break;
     XQueryPointer(g.display,z[0].win,&rwin,&cwin,&rx,&ry,&x,&y,&mask);
     check_event(); if(g.getout) break;
     if(mask && Button1Mask) 
     {   clicked = 1;
         switch(spraymode)
         {   case MATHSPRAY:
                 for(j=y-g.sprayfac; j<=y+g.sprayfac; j++)       
                 {   for(i=x-g.sprayfac; i<=x+g.sprayfac; i++)       
                     {   if(between(j,0,g.yres) && between(i,0,g.xres))
                         {   if(touched[j][i]) ok=0; else ok=1;
                             touched[j][i] = 1;
                         }else ok=1;
                         if(ok || !hit) 
                                  ino = do_math(i,j,i,j,mathtext,0);
                         if(g.getout) break;
                     }
                     if(g.getout) break;
                 }
                 check_event(); if(g.getout) break;
                 hit=1;
                 ox1 = x - g.sprayfac;
                 oy1 = y - g.sprayfac;
                 if(ino>=0) z[ino].hit=1;
                 break;
             case DIFFUSESPRAY:   
                 sf=g.sprayfac;
                 for(k=1;k<g.sprayfac*2;k++)
                 {  setpixelonimage(x+sprayrand(sf),y+sprayrand(sf),g.fcolor,g.imode,0,-1,0,0,1);
                    setpixelonimage(x+sprayrand(sf),y-sprayrand(sf),g.fcolor,g.imode,0,-1,0,0,1);
                    setpixelonimage(x-sprayrand(sf),y+sprayrand(sf),g.fcolor,g.imode,0,-1,0,0,1);
                    setpixelonimage(x-sprayrand(sf),y-sprayrand(sf),g.fcolor,g.imode,0,-1,0,0,1);
                 }
                 break; 
             case FINESPRAY:
                 for(i=x-g.sprayfac/2;i<=x+g.sprayfac/2;i++)
                 for(j=y-g.sprayfac/2;j<=y+g.sprayfac/2;j++)
                     setpixelonimage(i,j,g.fcolor,g.imode,0,-1,0,0,1); 
                 break;
             case FILTERSPRAY:
                 ino = whichimage(x,y,bpp);
                 
                  ////  Copy the backup, then convert indexed images to 24 bpp before
                  ////  filtering. Otherwise it will be done automatically in 
                  ////  filter_region() after every mouse click.

                 if(ino>=0 && z[ino].colortype==INDEXED && tempalloc[ino]==0) 
                 {    if(z[ino].backedup)   
                      {    bytesperline = z[ino].xsize*g.off[z[ino].bpp];
                           tempbackup_1d[ino] = new uchar[z[ino].ysize*bytesperline];
                           tempbackup[ino] = make_2d_alias(tempbackup_1d[ino], 
                                             bytesperline, z[ino].ysize);    
                           if(tempbackup[ino]==NULL)
                                {  message(g.nomemory, ERROR); break; } 
                           else tempalloc[ino]=1;
                           for(k=0;k<z[ino].ysize;k++)
                                memcpy(tempbackup[ino][k],z[ino].backup[z[ino].cf][k], 
                                      bytesperline);                               
                      }
                      change_image_depth(ino,24,0); 
                      changed[ino]=1;
                 }
                 if(ox1!=x || oy1!=y)
                     filter_region(x-g.sprayfac, y-g.sprayfac, x+g.sprayfac, 
                         y+g.sprayfac, filter_type, ksize, sharpfac, range, 
                         kmult, max_bkg,0,0); 
                 hit=1;
                 ox1 = x;
                 oy1 = y;
                 if(ino>=0) z[ino].hit=1;
                 break;
             case ERASESPRAY:
                 ino = whichimage(x,y,bpp);
                 oino=ino;
                 done=0;
                 x1 = x-g.sprayfac/2;
                 x2 = x+g.sprayfac/2;
                 y1 = y-g.sprayfac/2;
                 y2 = y+g.sprayfac/2;
                 for(k=0;k<g.image_count;k++) repairflags[k]=0;
                 for(i=x1;i<=x2;i++)
                 {   for(j=y1;j<=y2;j++)
                     {   ino=erase_pixel(i,j,repairflags);
                         if(ino!=oino){ switchto(ino); oino=ino; }
                         done = repairflags[0] & 4;
                         if(done) break;
                     }if(done) break;
                 }
                 break;
             default: message("",BUG);
         }
     }else if(clicked)   // mouse unclicked, reset touched buffer or whatever else is needed
     {   hit=0;
         clicked = 0;
  
         for(k=0; k<g.image_count; k++) 
         {   if(z[k].hit)
             {     switchto(k);
                   rebuild_display(k); 
                   redraw(k); 
             }
         }

         if(alloc1) memset(touched_1d, 0, size*sizeof(char));
     }
  }
  g.getout=0;
  for(k=0;k<g.image_count;k++) 
  {     
        if(changed[k])     // Convert image back to 8 bits/pixel
        {  
             change_image_depth(k,8,0);
             if(tempalloc[k]==1)
             {    bytesperline = z[k].xsize * g.off[z[k].bpp];
                  f = z[k].cf;
                  for(j=0;j<z[k].ysize;j++)
                       memcpy(z[k].backup[f][j], tempbackup[k][j], bytesperline);
                  free(tempbackup[k]);
                  delete[] tempbackup_1d[k];
                  z[k].backedup = 1;
             }
        }    
        if(z[k].hit) repair(k); 
  }
  g.state = NORMAL;
  delete[] repairflags;
  if(alloc1){ free(touched); delete[] touched_1d; }
  return OK;
}




//-------------------------------------------------------------------//
// sprayrand                                                         //
// return a random number for spray routine                          //
//-------------------------------------------------------------------//
int sprayrand(int sprayfac)
{  
   double ff;
   ff=(random_number()/32768.0)*(random_number()/32768.0)*(double)sprayfac;
   return (int)ff;
}



//-------------------------------------------------------------------------//
// get_math_formulas                                                       //
//-------------------------------------------------------------------------//
void get_math_formulas(char *text)
{
  const int helptopic=20;
  if(memorylessthan(16384)){ message(g.nomemory); return; }
  edit("Equation editor","Enter equations (Shift-Enter for single line equation)",
      text,256,80,256,helptopic);
}


//-------------------------------------------------------------------------//
// image_math                                                              //
//-------------------------------------------------------------------------//
void image_math(void)
{
  static int hit=0;
  static char *text;
  if(!hit){ text=new char[65536]; text[0]=0;}
  get_math_formulas(text);
  hit=1;
  if(g.getout==0) math(text);
  g.getout=0;
}


//-------------------------------------------------------------------------//
// math - mathematical function on pixel r,g,b                             //
//-------------------------------------------------------------------------//
int math(char *text)
{
  if(g.getout){ g.getout=0; return ABORT; }
  printstatus(BUSY);
  do_math(g.ulx, g.uly, g.lrx, g.lry, text, 1);
  printstatus(NORMAL);
  return OK;
}



//-------------------------------------------------------------------------//
//  do_math                                                                //
//-------------------------------------------------------------------------//
int do_math(int x1, int y1, int x2, int y2, char *text, int oktoconvert)
{
#ifdef HAVE_LEX
  Widget www, scrollbar;
  if(memorylessthan(16384)){ message(g.nomemory); return -1; }
  volatile int ii=ci, xx, yy;
  volatile double real=0.0,imag=0.0;
  int frame,i,ii2,j,k,rr,gg,bb,bpp,obpp=0,value,status=OK,ovalue;
  uchar *add;
  char tempstring[128];
  for(k=0; k<g.image_count; k++) z[k].hit=0;

  add_all_variables(ci);

  if(oktoconvert) progress_bar_open(www, scrollbar);
  for(j=y1; j<=y2; j++)
  {  if(keyhit())if(getcharacter()==27)break;  
     if(oktoconvert) 
     {    sprintf(tempstring,"Math..%d        ",j);
          printstatus(MESSAGE, tempstring);
          if(y1!=y2) progress_bar_update(scrollbar, (j-y1)*100/(y2-y1));
     }
     check_event();
     if(g.getout) break; 
     for(i=x1; i<=x2; i++)
     {   if(!g.selected_is_square && !inside_irregular_region(i,j)) continue;
         value = readpixelonimage(i,j,bpp,ii2);
         ii = ii2;
         if(bpp!=obpp && ii>=0 && bpp==8)
         {     obpp=bpp; 
               switch_palette(ii);
         }   

         ////  If 8-bit indexed color, convert to 24 bpp before doing math
       
         if(oktoconvert)
         {    if(z[ii].hit==0 && z[ii].colortype==INDEXED) 
              {                       // z[].hit must be set before change_image_depth
                    z[ii].hit=2;      // 2 = image was converted to 24 bpp
                    if(change_image_depth(ii,24,0)!=OK) 
                    {   message("Insufficient image buffers available,\naborting...");
                        g.getout=1; 
                        break;
                    }
                    value = readpixelonimage(i,j,bpp,ii2);
                    ii = ii2;
              }
         }
         if(z[ii].hit==0) z[ii].hit=1;   // 1 = image was hit
         valuetoRGB(value,rr,gg,bb,bpp);

         ////  Definition of variables x,y,i,r,g, and b for expression evaluator.
         ////  Change the source coordinates if you don't like the
         ////  behavior.

         if(g.selectedimage>=0)                       // Entire image selected
         {   xx = i-z[ii].xpos;                       // x coordinate
             yy = j-z[ii].ypos;                       // y coordinate                              
         }else if(ii>=0)                              // Part of image selected
         {   xx = i-z[ii].xpos;                       // x coordinate
             yy = j-z[ii].ypos;                       // y coordinate
         }else                                        // Non-image selected
         {   xx = i;                                  // x coordinate
             yy = j;                                  // y coordinate
         }
         if(z[ii].floatexists)
         {   real = z[ii].fft[yy][xx].real();
             imag = z[ii].fft[yy][xx].imag();
         }
         
         ovalue = value;
 
         add_variable("x",(double)xx);
         add_variable("y",(double)yy);
         add_variable("i",(double)value);
         add_variable("r",(double)rr);
         add_variable("g",(double)gg);
         add_variable("b",(double)bb);
         add_variable("v",(double)value/g.maxvalue[z[ii].bpp]);
         if(z[ii].floatexists)
         {  add_variable("re",real);
            add_variable("im",imag);
         }
         if(z[ii].waveletexists)
            add_variable("w",z[ii].wavelet[yy][xx]);
         
         ////  End of variable initialization

         if(strlen(text)) eval(text);

         value = cint(read_variable("i"));
         rr = cint(read_variable("r"));
         gg = cint(read_variable("g"));
         bb = cint(read_variable("b"));
         if(between(ii,0,g.image_count-1) && z[ii].floatexists)
         {   
             z[ii].fft[yy][xx].real() = read_variable("re");
             z[ii].fft[yy][xx].imag() = read_variable("im");
         }
         if(z[ii].waveletexists)
             z[ii].wavelet[yy][xx] = read_variable("w");

         if(value != ovalue)  
         {   value = max(0,min((int)g.maxvalue[bpp],value));
         }else
         {   rr = max(0,min(g.maxred[bpp],rr));
             gg = max(0,min(g.maxgreen[bpp],gg));
             bb = max(0,min(g.maxblue[bpp],bb));
             value = RGBvalue(rr,gg,bb,bpp);
         }
         frame = z[ii].cf;
         if(between(xx,0,z[ii].xsize-1) && between(yy,0,z[ii].ysize-1) && bpp==z[ii].bpp)
         {   add = z[ii].image[frame][yy] + xx*g.off[bpp];
             putpixelbytes(add, value, 1, bpp, 1);
             if(!oktoconvert) setpixel(xx,yy,value,SET);
         }
         z[ii].touched = 1;
         if(g.getout)break;
     }
     if(g.getout || status==ABORT)break;
  }      


  ////  Re-palettize any color images touched if in 8-bpp screen mode.
  ////  oktoconvert will be 0 if spraying (image bpp conversion will be 
  ////  done afterwards).

  if(z[ii].floatexists) scalefft(ii);
  if(oktoconvert)
  {  for(k=0; k<g.image_count; k++) 
     {   if(z[k].hit==2)
         {     z[k].hit=1;
               change_image_depth(k,8,0);
         }
     }
     for(k=0; k<g.image_count; k++) 
     {   if(z[k].hit)
         {     switchto(k);
               rebuild_display(k); 
               redraw(k); 
               z[k].hit = 0;
         }
     }
  }
  if(oktoconvert) progress_bar_close(www);
  check_event();
  return ii;
#else
  x1=x1; y1=y1; x2=x2; y2=y2; text=text; oktoconvert=oktoconvert;
  return NOTFOUND;
#endif
}


//-------------------------------------------------------------------------//
//  add_all_variables                                                      //
//-------------------------------------------------------------------------//
void add_all_variables(int ino)
{
  int k;
  char tempstring[128];
  add_variable("IMAGES",(double)g.image_count);
  add_variable("XRES",(double)g.xres);
  add_variable("YRES",(double)g.yres);
  add_variable("ULX",(double)g.ulx);
  add_variable("ULY",(double)g.uly);
  add_variable("LRX",(double)g.lrx);
  add_variable("LRY",(double)g.lry);
  add_variable("CI",(double)ino);
  if(ino>=0) 
  {   add_variable("BPP",(double)z[ino].bpp);
      add_variable("FRAMES",(double)z[ino].frames);
      add_variable("XSIZE",(double)z[ino].xsize);
      add_variable("YSIZE",(double)z[ino].ysize);
      add_variable("XPOS",(double)z[ino].xpos);
      add_variable("YPOS",(double)z[ino].ypos);
      add_variable("CF",(double)z[ino].cf);
      add_variable("CALLOG0",(double)z[ino].cal_log[0]);
      add_variable("CALLOG1",(double)z[ino].cal_log[1]);
      add_variable("CALDIMS",(double)z[ino].cal_dims);
      add_variable("FFTSTATE",z[ino].fftstate);
      add_variable("FMIN",z[ino].fmin);
      add_variable("FMAX",z[ino].fmax);
      add_variable("FFAC",z[ino].ffac);
      add_variable("WAVELETSTATE",z[ino].waveletstate);
      add_variable("WMIN",z[ino].wmin);
      add_variable("WMAX",z[ino].wmax);
      add_variable("WFAC",z[ino].wfac);
      for(k=0;k<10;k++)
      {   sprintf(tempstring, "Q0%d",k);
          add_variable(tempstring,(double)z[ino].cal_q[0][k]);
          sprintf(tempstring, "Q1%d",k);
          add_variable(tempstring,(double)z[ino].cal_q[1][k]);
      }
      
  }
}
