//--------------------------------------------------------------------------//
// xmtnimage5.cc                                                            //
// getcharacter, keyhit, configure, attributes                              //
// Latest revision: 04-14-1999                                              //
// Copyright (C) 1999 by Thomas J. Nelson                                   //
// All rights reserved.                                                     //
//--------------------------------------------------------------------------//

#include "xmtnimage.h"

extern Globals     g;
extern Images     *z;
extern int         ci;

int windowsareon=0;
uint keycode=0;


//--------------------------------------------------------------------------//
// getcharacter - return most recent keypress (different from DOS)          //
// key_ascii is set in keyhit().                                            //
//--------------------------------------------------------------------------//
int getcharacter(void)
{  
  return g.key_ascii;
}    

//--------------------------------------------------------------------------//
// keyhit                                                                   //
//--------------------------------------------------------------------------//
int keyhit(void)
{ 
   char buffer[20];
   KeySym key;
   XComposeStatus compose;
   XKeyEvent keyevent;
  
   int hit=0, bufsize=20;
   XEvent event;
   hit = XCheckMaskEvent(g.display, KeyPress, &event);
   if(hit) 
   {   keyevent = event.xkey;
       keycode = event.xkey.keycode;
       XLookupString(&keyevent,buffer,bufsize,&key,&compose);
       g.key_ascii= key & 0xff; 
   }
   return hit;
} 
   
//--------------------------------------------------------------------------//
//  configure                                                               //
//--------------------------------------------------------------------------//
void configure(void)
{
     int j,k,v,rr,gg,bb, old210;
     if(memorylessthan(16384)){ message(g.nomemory,ERROR); return; }

     const int NOOFCURSORS=11;
     static Cursor cursor = g.xlib_cursor;
     static Cursor old_cursor=cursor;

     Dialog dialog;
     dialog.needrepeat=0;
     char tempstring[128];
     strcpy(dialog.title,"Configuration");

     strcpy(dialog.radio[0][0],"Color reduction method");             
     strcpy(dialog.radio[0][1],"Quantization");
     strcpy(dialog.radio[0][2],"Fit current colormap");
     strcpy(dialog.radio[0][3],"None");

     strcpy(dialog.radio[1][0],"Update undo buffer");
     strcpy(dialog.radio[1][1],"Automatically");
     strcpy(dialog.radio[1][2],"Manually");
     strcpy(dialog.radio[1][3],"Never");

     strcpy(dialog.radio[2][0],"Colormap usage");
     strcpy(dialog.radio[2][1],"Allocate colors");
     strcpy(dialog.radio[2][2],"Install colormap");

     strcpy(dialog.radio[3][0],"Message boxes");
     strcpy(dialog.radio[3][1],"None");
     strcpy(dialog.radio[3][2],"Minimal");
     strcpy(dialog.radio[3][3],"Normal");

     strcpy(dialog.boxes[0],"Luminosity factor (0-1)");
     strcpy(dialog.boxes[1],"Red");
     strcpy(dialog.boxes[2],"Green");
     strcpy(dialog.boxes[3],"Blue");

     strcpy(dialog.boxes[4],"Significant digits"); 
     strcpy(dialog.boxes[5],"Cursor movement"); 
     strcpy(dialog.boxes[6],"Spray factor"); 

     strcpy(dialog.boxes[7],"Active Color Planes"); 
     strcpy(dialog.boxes[8],"Red"); 
     strcpy(dialog.boxes[9],"Green"); 
     strcpy(dialog.boxes[10],"Blue"); 
 
     strcpy(dialog.boxes[11],"Main cursor"); 
     dialog.boxmenutitle[11] = new char[50];
     dialog.boxmenu[11] = new char*[NOOFCURSORS+1];
     for(k=0;k<NOOFCURSORS+1;k++) dialog.boxmenu[11][k] = new char[50];
     switch(cursor)
     {  case XC_draft_large:    dialog.boxmenuselection[11]=0;break;
        case XC_draft_small:    dialog.boxmenuselection[11]=1;break;
        case XC_arrow:          dialog.boxmenuselection[11]=2;break;
        case XC_crosshair:      dialog.boxmenuselection[11]=3;break;
        case XC_cross:          dialog.boxmenuselection[11]=4;break;
        case XC_left_ptr:       dialog.boxmenuselection[11]=5;break;
        case XC_plus:           dialog.boxmenuselection[11]=6;break;
        case XC_top_left_arrow: dialog.boxmenuselection[11]=7;break;
        case XC_xterm:          dialog.boxmenuselection[11]=8;break;
        case XC_target:         dialog.boxmenuselection[11]=9;break;
        default:                dialog.boxmenuselection[11]=0;break;
     }
     if(g.want_crosshairs) dialog.boxmenuselection[11]=10;

     strcpy(dialog.boxmenutitle[11],"Cursor");
     strcpy(dialog.boxmenu[11][0]," draft large   ");                
     strcpy(dialog.boxmenu[11][1]," draft small   ");                 
     strcpy(dialog.boxmenu[11][2]," arrow         ");          
     strcpy(dialog.boxmenu[11][3]," crosshair     "); 
     strcpy(dialog.boxmenu[11][4]," cross         ");     
     strcpy(dialog.boxmenu[11][5]," left ptr      ");
     strcpy(dialog.boxmenu[11][6]," plus          ");
     strcpy(dialog.boxmenu[11][7]," top left arrow");
     strcpy(dialog.boxmenu[11][8]," xterm         ");
     strcpy(dialog.boxmenu[11][9]," target        ");
     strcpy(dialog.boxmenu[11][10]," full screen crosshairs");

     strcpy(dialog.boxes[12],"Raise image on focus"); 
     strcpy(dialog.boxes[13],"Separate windows"); 
     strcpy(dialog.boxes[14],"Window border"); 
     strcpy(dialog.boxes[15],"Text spacing"); 
     strcpy(dialog.boxes[16],"Object threshold"); 

     dialog.radioset[0] = g.want_quantize;
     dialog.radioset[1] = 3 - g.autoundo;
     dialog.radioset[2] = g.want_colormaps + 1;
     dialog.radioset[3] = g.want_messages + 1;
  
     gcvt(g.luminr,g.signif,tempstring);    
     strcpy(dialog.answer[1],tempstring);
     gcvt(g.luming,g.signif,tempstring);    
     strcpy(dialog.answer[2],tempstring);
     gcvt(g.luminb,g.signif,tempstring);    
     strcpy(dialog.answer[3],tempstring);
     itoa(g.signif,tempstring,10);
     strcpy(dialog.answer[4],tempstring);
     itoa(g.csize,tempstring,10);
     strcpy(dialog.answer[5],tempstring);
     itoa(g.sprayfac,tempstring,10);
     strcpy(dialog.answer[6],tempstring);

     if(g.wantr) dialog.boxset[8]=1; else dialog.boxset[8]=0;
     if(g.wantg) dialog.boxset[9]=1; else dialog.boxset[9]=0;
     if(g.wantb) dialog.boxset[10]=1; else dialog.boxset[10]=0;
     if(g.want_raise) dialog.boxset[12]=1; else dialog.boxset[12]=0;
     if(g.want_shell) dialog.boxset[13]=1; else dialog.boxset[13]=0;
     if(g.window_border) dialog.boxset[14]=1; else dialog.boxset[14]=0;
     sprintf(dialog.answer[15],"%d", g.text_spacing);
     sprintf(dialog.answer[16],"%d", 
        RGBvalue(g.object_threshold.red, 
                 g.object_threshold.green,
                 g.object_threshold.blue, 24));

     dialog.boxtype[0]=LABEL;
     dialog.boxtype[1]=STRING;
     dialog.boxtype[2]=STRING;
     dialog.boxtype[3]=STRING;
     dialog.boxtype[4]=INTCLICKBOX; dialog.boxmin[4]=0; dialog.boxmax[4]=10;
     dialog.boxtype[5]=INTCLICKBOX; dialog.boxmin[5]=1; dialog.boxmax[5]=200;
     dialog.boxtype[6]=INTCLICKBOX; dialog.boxmin[6]=1; dialog.boxmax[6]=200;
     dialog.boxtype[7]=LABEL; 
     dialog.boxtype[8]=TOGGLE;
     dialog.boxtype[9]=TOGGLE;
     dialog.boxtype[10]=TOGGLE;
     dialog.boxtype[11]=NON_EDIT_LIST; 
        dialog.boxmin[11]=0; dialog.boxmax[11]=NOOFCURSORS;
     dialog.boxtype[12]=TOGGLE;
     dialog.boxtype[13]=TOGGLE;
     dialog.boxtype[14]=TOGGLE;
     dialog.boxtype[15]=INTCLICKBOX; dialog.boxmin[15]=0; dialog.boxmax[15]=100;
     dialog.boxtype[16]=MULTICLICKBOX;dialog.boxmin[16]=1; dialog.boxmax[16]=100;

     dialog.bpp = 24;
     dialog.noofboxes=17;
     dialog.noofradios=4;
     dialog.radiono[0]=4;
     dialog.radiono[1]=4;
     dialog.radiono[2]=3;
     dialog.radiono[3]=4;
     dialog.helptopic=16;

     for(j=0;j<10;j++) for(k=0;k<20;k++) dialog.radiotype[j][k]=RADIO;
     old210 = dialog.radioset[2];
     dialog.keep=0;
     dialog.want_changecicb = 0;
     dialog.f1 = null;
     dialog.transient = 1;
     strcpy(dialog.path,".");

     ///////////////////
     dialogbox(dialog); 
     ///////////////////

     g.want_crosshairs = 0;
     switch(dialog.boxmenuselection[11])
     {    case 0: cursor=XC_draft_large;break;
          case 1: cursor=XC_draft_small;break;
          case 2: cursor=XC_arrow      ;break;
          case 3: cursor=XC_crosshair  ;break;
          case 4: cursor=XC_cross      ;break;
          case 5: cursor=XC_left_ptr   ;break;
          case 6: cursor=XC_plus       ;break;
          case 7: cursor=XC_top_left_arrow;break;
          case 8: cursor=XC_xterm         ;break;
          case 9: cursor=XC_target        ;break;
          case 10: g.want_crosshairs = 1  ;break;
          default: cursor=XC_draft_large  ;break;
     }
     if(cursor!=old_cursor)
     {    XFreeCursor(g.display, g.normal_cursor);
          g.normal_cursor = XCreateFontCursor(g.display, cursor);
          g.xlib_cursor = cursor;
          old_cursor = cursor;
          g.cursor = g.normal_cursor;
          XDefineCursor(g.display, g.main_window, g.cursor);
     }
     if(g.want_crosshairs)
     {    g.cursor = g.no_cursor;
          XDefineCursor(g.display, g.main_window, g.cursor);
     }
     for(k=0;k<NOOFCURSORS+1;k++) delete[] dialog.boxmenu[11][k];
     delete[] dialog.boxmenu[11];
     delete[] dialog.boxmenutitle[11];

     g.want_quantize = dialog.radioset[0];
     g.autoundo = 3 - dialog.radioset[1];
     g.want_messages = dialog.radioset[3] - 1;

     ////  If user switched to `allocate-colors', try to reinitialize colors.

     if(dialog.radioset[2]!=old210)
     { if( dialog.radioset[2]==1)
       {   message("Switching to allocated colors\nPlease exit and restart the program now");
           g.want_colormaps=0;
           setup_colors();
           g.main_fcolor=g.fcolor;
           g.main_bcolor=g.bcolor;
       }
       if(dialog.radioset[2]==2)
       {   message("Switching to colormaps\nPlease exit and restart the program now");
           g.fcolor=0;
           g.bcolor=1;
           g.main_fcolor=0;
           g.main_bcolor=1;
           g.want_colormaps=1;
       }
     }
     g.luminr = atof(dialog.answer[1]);
     g.luming = atof(dialog.answer[2]);
     g.luminb = atof(dialog.answer[3]);
     g.signif = atoi(dialog.answer[4]);
     g.csize = atoi(dialog.answer[5]);
     g.sprayfac = atoi(dialog.answer[6]);

     if(dialog.boxset[8]==1) g.wantr=1; else g.wantr=0;
     if(dialog.boxset[9]==1) g.wantg=1; else g.wantg=0;
     if(dialog.boxset[10]==1) g.wantb=1; else g.wantb=0;
     if(dialog.boxset[12]==1) g.want_raise=1; else g.want_raise=0;
     if(dialog.boxset[13]==1) g.want_shell=1; else g.want_shell=0;
     if(dialog.boxset[14]==1) g.window_border=1; else g.window_border=0;
     g.text_spacing = atoi(dialog.answer[15]);
     v = atoi(dialog.answer[16]);
     valuetoRGB(v,rr,gg,bb,24);
     g.object_threshold.red = rr;
     g.object_threshold.green = gg;
     g.object_threshold.blue = bb;
     if(g.diagnose) print_configuration();
     return;
}


//--------------------------------------------------------------------------//
// attributes                                                               //
//--------------------------------------------------------------------------//
void attributes(void)
{
   static int set0=1;
   static int isource = ci, idest = ci;
    if(memorylessthan(16384)){  message(g.nomemory,ERROR); return; } 
   Dialog dialog;
   char **arg;

   int j, k, delay, answer, bpp, test;
   char tempstring[1024] = "0";
   if(ci==-1)
   {     message("Set properties on which image?\n(Use 0 to change background)",tempstring,PROMPT,10); 
         ci = atoi(tempstring);
         if(ci>=g.image_count) return;
   }

   dialog.needrepeat=0;
   dialog.helptopic=48;  
   strcpy(dialog.title,"Image Properties");

   ////--Radio buttons--////

   strcpy(dialog.radio[0][0],"Copy tables");             
   strcpy(dialog.radio[0][1],"No change ");   
   strcpy(dialog.radio[0][2],"Copy colormap");   
   strcpy(dialog.radio[0][3],"Copy gamma table");   
   strcpy(dialog.radio[0][4],"Copy calibration");   

   strcpy(dialog.radio[1][0],"Color type");
   strcpy(dialog.radio[1][1],"Grayscale");   
   strcpy(dialog.radio[1][2],"Indexed");   
   strcpy(dialog.radio[1][3],"Color");   

   dialog.radioset[0] = set0;
   if(ci>=0)
       dialog.radioset[1] = z[ci].colortype+1;
   else
       dialog.radioset[1] = g.colortype+1;
   dialog.radiono[0]=5;
   dialog.radiono[1]=4;
   dialog.radiono[2]=0;
   for(j=0;j<10;j++) for(k=0;k<20;k++) dialog.radiotype[j][k]=RADIO;
   dialog.noofradios=2;

   ////-----Boxes-----////
   
   strcpy(dialog.boxes[0],"Image Number ");
   strcpy(dialog.boxes[1],"Image to change");
   strcpy(dialog.boxes[2],"Copy from");

   strcpy(dialog.boxes[3],"Image attributes");
   strcpy(dialog.boxes[4],"Title");
   strcpy(dialog.boxes[5],"Chromakeyed");             
   strcpy(dialog.boxes[6],"X position");
   strcpy(dialog.boxes[7],"Y position");
   strcpy(dialog.boxes[8],"Bits/pixel");
   strcpy(dialog.boxes[9],"Transparency");             
   strcpy(dialog.boxes[10],"Animation");             
   strcpy(dialog.boxes[11],"Frames/sec");             
   
   dialog.boxtype[0]=LABEL;
   dialog.boxtype[1]=INTCLICKBOX;
   dialog.boxtype[2]=INTCLICKBOX;
   dialog.boxtype[3]=LABEL;
   dialog.boxtype[4]=STRING;
   dialog.boxtype[5]=TOGGLE;
   dialog.boxtype[6]=INTCLICKBOX;
   dialog.boxtype[7]=INTCLICKBOX;
   dialog.boxtype[8]=INTCLICKBOX;
   dialog.boxtype[9]=INTCLICKBOX;
   dialog.boxtype[10]=TOGGLE;
   dialog.boxtype[11]=DOUBLECLICKBOX;
   
   dialog.boxmin[1]=0; dialog.boxmax[1]=g.image_count-1;
      sprintf(dialog.answer[1], "%d", ci);
   dialog.boxmin[2]=0; dialog.boxmax[2]=g.image_count-1;
      sprintf(dialog.answer[2], "%d", isource);
   strcpy(dialog.answer[4],z[ci].name);
   dialog.boxset[5] = (z[ci].chromakey!=0);
   dialog.boxmin[6]=-2*g.xres; dialog.boxmax[6]=2*g.xres;
      sprintf(dialog.answer[6], "%d", z[ci].xpos);
   dialog.boxmin[7]=-2*g.yres; dialog.boxmax[7]=2*g.yres;
      sprintf(dialog.answer[7], "%d", z[ci].ypos); 
   dialog.boxmin[8]=1; dialog.boxmax[8]=48;
      sprintf(dialog.answer[8], "%d", z[ci].bpp);
   dialog.boxmin[9]=0; dialog.boxmax[9]=100;
      sprintf(dialog.answer[9], "%d", z[ci].transparency);
   dialog.boxset[10] = (z[ci].animation!=0);
   dialog.boxmin[11]=0; dialog.boxmax[11]=200;
      sprintf(dialog.answer[11], "%f", z[ci].fps);
 
   dialog.noofboxes=12; 
   dialog.keep=0;
   dialog.want_changecicb = 0;
   dialog.f1 = null;
   dialog.transient = 1;
   strcpy(dialog.path,".");
   
   ///////---///////
   dialogbox(dialog);
   ///////---///////

   if(g.getout){ g.getout=0; return; }

   idest   = atoi(dialog.answer[1]);
   isource = atoi(dialog.answer[2]);

   set0 = dialog.radioset[0];
   switch(set0)
   {    case 1: break;
        case 2:
                memcpy(z[idest].palette,z[isource].palette, 768);
                break;
        case 3: memcpy(z[idest].gamma, z[isource].gamma, 256*sizeof(short));
                break;
        case 4: 
                strcpy(z[idest].cal_title[0], z[isource].cal_title[0]); 
                strcpy(z[idest].cal_title[1], z[isource].cal_title[1]); 
                z[idest].cal_slope[0] = z[isource].cal_slope[0];
                z[idest].cal_slope[1] = z[isource].cal_slope[1];
                z[idest].cal_int[0] = z[isource].cal_int[0];
                z[idest].cal_int[1] = z[isource].cal_int[1];
                z[idest].cal_log[0] = z[isource].cal_log[0];
                z[idest].cal_log[1] = z[isource].cal_log[1];
                z[idest].cal_xorigin[0] = z[isource].cal_xorigin[0];
                z[idest].cal_xorigin[1] = z[isource].cal_xorigin[1];
                z[idest].cal_yorigin[0] = z[isource].cal_yorigin[0];
                z[idest].cal_yorigin[1] = z[isource].cal_yorigin[1];
                z[idest].cal_dims = z[isource].cal_dims;
                for(k=0;k<10;k++) z[idest].cal_q[0][k] = z[isource].cal_q[0][k];                
                for(k=0;k<10;k++) z[idest].cal_q[1][k] = z[isource].cal_q[1][k];                
                break;
        default: break;
   }
   z[idest].colortype = dialog.radioset[1]-1;
   setimagetitle(idest, dialog.answer[4]);  
   test = dialog.boxset[5];
   if(test) set_chromakey(idest);
   else     z[idest].chromakey=0;
   if(z[idest].chromakey!=0 && z[idest].shell) 
       message("Warning: image in a floating window\nhas chromakey set",WARNING);
   answer = YES;
   if(!image_has_opaque_pixels(idest))
       answer = message("Warning: selected parameters will make \nimage completely invisible!\nProceed?",
            YESNOQUESTION);
   if(answer != YES) z[idest].chromakey=0;
   z[idest].xpos = atoi(dialog.answer[6]);
   z[idest].ypos = atoi(dialog.answer[7]);
   if(!z[idest].shell) moveimage(idest, z[idest].xpos, z[idest].ypos);

   z[idest].transparency = atoi(dialog.answer[9]);
   z[idest].fps = atof(dialog.answer[11]);
   if(z[idest].bpp != g.bitsperpixel && z[idest].transparency)
   {   sprintf(tempstring,"\
Warning: image should be converted to %d\n\
bits/pixel first. Transparency using images\n\
of different depths is not supported and may\n\
not work correctly. Continue?",g.bitsperpixel);
       answer = message(tempstring,YESNOQUESTION);
       if(answer!=YES) z[idest].transparency = 0;
   } 
   arg = new char*[3];
   arg[0] = new char[128];
   arg[1] = new char[128];
   arg[2] = new char[128];

   bpp=atoi(dialog.answer[8]);
   sprintf(arg[1],"%d",idest);
   sprintf(arg[2],"%d",bpp);
   changecolordepth(2,arg);
   rebuild_display(idest);
   if(z[idest].transparency) redraw_transparent_image(idest);
   else if(z[idest].chromakey) redraw_chromakey_image(idest);
   else redraw(idest);

   g.getout = 0;  // In case user clicked 'cancel'
   if(g.diagnose) print_image_info();
   delete[] arg[2];
   delete[] arg[1];
   delete[] arg[0];
   delete arg;

   //// Keep this at end 
   //// Control stays here until cancelled - idest and ci can change
   
   if(!dialog.boxset[10])
   {   g.getout=1; 
       check_event();
       z[idest].animation=0; 
   }else if(z[idest].fps) 
   {   delay = (int)(1000/z[idest].fps);
       z[idest].animation = 1;
       movie(delay);
   }
   return;
}


//--------------------------------------------------------------------------//
// set_chromakey                                                            //
//--------------------------------------------------------------------------//
void set_chromakey(int ino)
{
   if(memorylessthan(16384)){  message(g.nomemory,ERROR); return; } 
   int tmin,tmax;
   int cminr, cming, cminb, cmaxr, cmaxg, cmaxb;
   uint mincolor, maxcolor;
   char tempstring[20];
   Dialog dialog;
   if(ino==-1)
   {     message("Set chromakey on which image?",tempstring,PROMPT,10); 
         ino = atoi(tempstring);
         if(ino<0 || ino>=g.image_count) return;
   }

   dialog.needrepeat=0;
   dialog.helptopic=0;  
   strcpy(dialog.title,"Chromakey settings");

   strcpy(dialog.boxes[0],"Grayscale");
   strcpy(dialog.boxes[1],"Min opaque pixel");
   strcpy(dialog.boxes[2],"Max opaque pixel");
   strcpy(dialog.boxes[3],"Color");
   strcpy(dialog.boxes[4],"Min opaque color");
   strcpy(dialog.boxes[5],"Max opaque color");
   strcpy(dialog.boxes[6],"Invert chromakey");

   dialog.boxmin[1]=0; dialog.boxmax[1] = (int)g.maxvalue[24];
      sprintf(dialog.answer[1], "%d", z[ino].ck_graymin);
   dialog.boxmin[2]=0; dialog.boxmax[2] = (int)g.maxvalue[24];
      sprintf(dialog.answer[2], "%d", z[ino].ck_graymax);
      
   mincolor = RGBvalue((int)z[ino].ck_min.red, (int)z[ino].ck_min.green,
                       (int)z[ino].ck_min.blue, 24);
   dialog.boxmin[4]=0; 
   dialog.boxmax[4] = (int)g.maxvalue[24];
   sprintf(dialog.answer[4], "%d", mincolor);

   maxcolor = RGBvalue((int)z[ino].ck_max.red, (int)z[ino].ck_max.green,
              (int)z[ino].ck_max.blue, 24);
   dialog.boxmin[5]=0; 
   dialog.boxmax[5] = (int)g.maxvalue[24];
   sprintf(dialog.answer[5], "%d", maxcolor);
   if(z[ino].chromakey==-1) dialog.boxset[6]=1; else dialog.boxset[6]=0;

   dialog.boxtype[0]=LABEL;
   dialog.boxtype[1]=INTCLICKBOX;
   dialog.boxtype[2]=INTCLICKBOX;
   dialog.boxtype[3]=LABEL;
   dialog.boxtype[4]=MULTICLICKBOX;
   dialog.boxtype[5]=MULTICLICKBOX;
   dialog.boxtype[6]=TOGGLE;
 
   dialog.bpp = 24;
   dialog.noofboxes=7; 
   dialog.keep=0;
   dialog.want_changecicb = 0;
   dialog.f1 = chromakeycheck;
   dialog.transient = 1;
   strcpy(dialog.path,".");
  
   ///////---///////
   dialogbox(dialog);
   ///////---///////

   if(g.getout){ g.getout=0; return; }
   tmin = atoi(dialog.answer[1]); 
   tmax = atoi(dialog.answer[2]);
   if(tmin > tmax) swap(tmin,tmax);
   z[ino].ck_graymin = tmin; 
   z[ino].ck_graymax = tmax;

   mincolor = atoi(dialog.answer[4]); 
   maxcolor = atoi(dialog.answer[5]);   
   if(dialog.boxset[6]) z[ino].chromakey=-1; else z[ino].chromakey=1;
   valuetoRGB(mincolor, cminr, cming, cminb, 24);
   valuetoRGB(maxcolor, cmaxr, cmaxg, cmaxb, 24);
   if(cminr > cmaxr) swap(cminr, cmaxr);
   if(cming > cmaxg) swap(cming, cmaxg);
   if(cminb > cmaxb) swap(cminb, cmaxb);
   z[ino].ck_min.red = cminr;
   z[ino].ck_min.green = cming;
   z[ino].ck_min.blue = cminb;
   z[ino].ck_max.red = cmaxr;
   z[ino].ck_max.green = cmaxg;
   z[ino].ck_max.blue = cmaxb;
}


//--------------------------------------------------------------------------//
//  chromakeycheck                                                          //
//--------------------------------------------------------------------------//
void chromakeycheck(dialoginfo *a, int radio, int box, int boxbutton)
{
    radio=radio; box=box; boxbutton=boxbutton;
    int k;
    if(ci<0) return;
    if(z[ci].colortype==GRAY)
    {    for(k=0;k<=2;k++) 
         { 
              if(a->boxwidget[1][k]) XtSetSensitive(a->boxwidget[1][k],True);
              if(a->boxwidget[2][k]) XtSetSensitive(a->boxwidget[2][k],True);
              if(a->boxwidget[4][k]) XtSetSensitive(a->boxwidget[4][k],False);
              if(a->boxwidget[5][k]) XtSetSensitive(a->boxwidget[5][k],False);
         }
    }else
    {    for(k=0;k<=2;k++) 
         { 
              if(a->boxwidget[1][k]) XtSetSensitive(a->boxwidget[1][k],False);
              if(a->boxwidget[2][k]) XtSetSensitive(a->boxwidget[2][k],False);
              if(a->boxwidget[4][k]) XtSetSensitive(a->boxwidget[4][k],True);
              if(a->boxwidget[5][k]) XtSetSensitive(a->boxwidget[5][k],True);
         }
    }
}




//--------------------------------------------------------------------------//
// image_has_opaque_pixels                                                  //
//--------------------------------------------------------------------------//
int image_has_opaque_pixels(int ino)
{   
    int bpp,cf,i,j,tmin,tmax,rmin,rmax,gmin,gmax,bmin,bmax,rr,gg,bb,v;
    if(ino<0) return 1;
    if(!z[ino].chromakey) return 1;

    cf = z[ino].cf;
    bpp = z[ino].bpp;
    if(z[ino].colortype==GRAY)
    {    tmin = z[ino].ck_graymin;
         tmax = z[ino].ck_graymax;
         for(j=0;j<z[ino].ysize;j++)
         for(i=0;i<z[ino].xsize;i++)
         {    v = pixelat(z[ino].image[cf][j] + i*g.off[bpp], bpp);
              if(is_opaque(v,tmin,tmax,z[ino].chromakey)) return 1;
         }
    }else
    {    rmin = z[ino].ck_min.red;
         rmax = z[ino].ck_max.red;
         gmin = z[ino].ck_min.green;
         gmax = z[ino].ck_max.green;
         bmin = z[ino].ck_min.blue;
         bmax = z[ino].ck_max.blue;
         for(j=0;j<z[ino].ysize;j++)
         for(i=0;i<z[ino].xsize;i++)
         {    v = pixelat(z[ino].image[cf][j] + i*g.off[bpp], bpp);
              valuetoRGB(v,rr,gg,bb,bpp);
              convertRGBpixel(rr,gg,bb,bpp,24);
              if(is_opaque(rr,rmin,rmax,gg,gmin,gmax,bb,bmin,bmax,z[ino].chromakey))
                  return 1;
         }    
    }
    return 0;
}

