//--------------------------------------------------------------------------//
// xmtnimage6.cc                                                            //
// Help system                                                              //
// Latest revision: 03-05-1999                                              //
// Copyright (C) 1999 by Thomas J. Nelson                                   //
// All rights reserved.                                                     //
//--------------------------------------------------------------------------//
 
#include "xmtnimage.h"

extern Globals     g;
extern Images     *z;
extern int         ci;
extern PrinterStruct printer;
 
//--------------------------------------------------------------------------//
// sort                                                                     //
// Returns a sorted index of input array of strings with 'count'            //
// elements. Does not sort the input array itself. (Comb sort)              //
//--------------------------------------------------------------------------//
void sort(char *item[], int sorted[], int count)
{
    int k,gap,iswitch,ii,jj;
    gap = count;
    for(k=0;k<count;k++) sorted[k] = k;
    do
    {  gap = max((int)(gap/1.3), 1);
       iswitch = 0;
       for(ii=0;ii<count-gap;ii++)
       {  jj = ii + gap;
          if(strcmp(item[sorted[ii]], item[sorted[jj]]) > 0)
          {  swap(sorted[ii],sorted[jj]);
             iswitch++;
          }   
       }
    } while((iswitch!=0)||(gap!=1));   
}      


//--------------------------------------------------------------------------//
// sort                                                                     //
// Returns a sorted index of input array of ints with 'count'               //
// elements. Does not sort the input array itself. (Comb sort)              //
//--------------------------------------------------------------------------//
void sort(int item[], int sorted[], int count)
{
    int k,gap,iswitch,ii,jj;
    gap = count;
    for(k=0;k<count;k++) sorted[k] = k;
    do
    {  gap = max((int)(gap/1.3), 1);
       iswitch = 0;
       for(ii=0;ii<count-gap;ii++)
       {  jj = ii + gap;
          if(item[sorted[ii]] > item[sorted[jj]])
          {  swap(sorted[ii],sorted[jj]);
             iswitch++;
          }   
       }
    } while((iswitch!=0)||(gap!=1));   
}      



//--------------------------------------------------------------------------//
// sort (for doubles) - should replace with template                        //
//--------------------------------------------------------------------------//
void sort(double item[], int sorted[], int count)
{
    int k,gap,iswitch,ii,jj;
    gap = count;
    for(k=0;k<count;k++) sorted[k] = k;
    do
    {  gap = max((int)(gap/1.3), 1);
       iswitch = 0;
       for(ii=0;ii<count-gap;ii++)
       {  jj = ii + gap;
          if(item[sorted[ii]] > item[sorted[jj]])
          {  swap(sorted[ii], sorted[jj]);
             iswitch++;
          }   
       }
    } while((iswitch!=0)||(gap!=1));   
}      


//--------------------------------------------------------------------------//
// help                                                                     //
// Reads 'tnimage.hlp' and provides context-sensitive help.                 //
// Puts text in a list box.                                                 //
//--------------------------------------------------------------------------//
void help(int topic)
{
  if(memorylessthan(4096)){  message(g.nomemory,ERROR); return; } 
  int k;
  int tno;
  int intopic=0;
  FILE *fp;
  char tempstring[FILENAMELENGTH];

       // Variables for list box
  char listtitle[80]="";
  int size;
  int firstitem=0;
  int helptopic=34;
  char *info[4096];     // Maximum of 4096 lines of help

  if(topic<=0) topic=1;
  sprintf(tempstring, "%s/%s",g.helpdir,"tnimage.hlp");
  if ((fp=fopen(tempstring,"rt")) == NULL)
  {   sprintf(tempstring, "%s/%s",g.homedir,"tnimage.hlp");
      if ((fp=fopen(tempstring,"rt")) == NULL)
      {   if((fp=fopen("tnimage.hlp","rt")) == NULL)
          {   sprintf(tempstring, "Can't find help file\n(Should be: %s/tnimage.hlp)",g.helpdir);
              message (tempstring,3);
              return;
          }
      }
  }

  g.inmenu++;

  tno=0;
  intopic=0;
  while(!feof(fp))             // Count no. of lines in topic
  {
     fgets(tempstring,85,fp); 
     if(isdigit(tempstring[0])) tno = atoi(tempstring);
     if(tno==topic) intopic=1; 
     if((intopic) && (tno) && (tno!=topic)) break;
  }
  intopic=0;
  tno=0;

  fseek(fp,0,SEEK_SET);
  size=0;
  while(!feof(fp))
  {
     fgets(tempstring,85,fp); 
     if(isdigit(tempstring[0])) tno = atoi(tempstring);
     if(tno==topic) intopic=1;
     if((intopic) && (tno) && (tno!=topic)) break;
     if(intopic)
     {   tempstring[80]=0;
         remove_terminal_cr(tempstring);
         info[size] = new char[100];
         info[size][0]=0;
         if(strlen(tempstring)) strcpy(info[size], tempstring);
         else strcpy(info[size]," ");
         size++;
     }
     if(size>1023) break;
  }
  fclose(fp);
  
  if(size)
  {  strcpy(listtitle,info[0]);
   
     listinfo l;
     int crud=0;
     l.title = listtitle;
     l.info  = info;
     l.size  = size;
     l.itemstoshow = min(10, size);
     l.firstitem   = firstitem;
     l.wantsort    = 0;
     l.wantsave    = 0;
     l.helptopic   = helptopic;
     l.allowedit   = 0;
     l.selection   = &crud;
     l.width       = 0;
     l.transient   = 0;
     l.wantfunction = 0;
     l.autoupdate   = 0;
     list(&l);
  }
  g.inmenu--;
  for(k=0;k<size;k++) delete[] info[k];
  g.getout=0;   // In case user clicks 'cancel'
}









