//--------------------------------------------------------------------//
// xmtnimage.cc                                                       //
//                                                                    //
// Motif version of tnimage                                           //
// Latest revision: 05-17-1999                                        //
// Copyright (c) 1999 by Thomas J. Nelson                             //
// All rights reserved.                                               //
//--------------------------------------------------------------------//
 
#include "xmtnimage.h"
#include "xmtnimagec.h"

Images *z;
PrinterStruct printer;
Globals g;
int    ci=-1;                      // current image
Widget okbutton;
int mouse_near_selection=0;
int cancelled=0;
const int SLOW_DELAY=512;
int getpointstate = 0;
char lestif_filename[FILENAMELENGTH] = "nothing";

////  Don't set `transient' resource in fallbacks.
static String fallback_resources[] = 
{    
   "*.marginHeight: 0",
   "*.marginWidth: 0",
   "*.background: gray",
   "*.foreground: black",
   "*.shadowThickness: 2",
   "*.DialogForm*shadowThickness: 1",
   "*.Plot3DForm:shadowThickness: 1",

   "*.MenuBar*spacing: 3",
   "*.MenuBar*background: gray",
   "*.MenuBar*fontList: *helvetica-bold-r-normal--12*",
   "*.fontName: *times-bold-r-normal--12*",
   "*.Editor*fontList: *helvetica-bold-r-normal--12*",
   "*.Editor.background:gray",   
   "*.Editor.foreground:black",
   "*.EditForm*fontList: *helvetica-bold-r-normal--12*",
   "*.Ok*fontList: *helvetica-bold-r-normal--12*",
   "*.Cancel*fontList: *helvetica-bold-r-normal--12*",
   "*.Help*fontList: *helvetica-bold-r-normal--12*",
   "*.Save*fontList: *helvetica-bold-r-normal--12*",
   "*.Start*fontList: *helvetica-bold-r-normal--12*",
   "*.XmLabel*fontList: *helvetica-bold-r-normal--12*",
   "*.About the File*fontList: *helvetica-bold-r-normal--12*",
   "*.About the Image*fontList: *helvetica-bold-r-normal--12*",
   "*.Select Image*fontList: *helvetica-bold-r-normal--12*",
   "*.drawing_area2*XmPushButton*fontList: *helvetica-bold-r-normal--12*",
   "*.drawing_area2*XmToggleButton*fontList: *helvetica-bold-r-normal--12*",
   "*.Plot3DForm*XmToggleButton*fontList: *helvetica-bold-r-normal--12*",
   "*.XmText*background: #D0C5C2",
   "*.DialogForm*XmText*background: #D0C5C2",

   "*.info_area0.background:gray",   
   "*.info_area0.foreground:black",
   "*.info_area0*fontList: *helvetica-bold-r-normal--24*",
   "*.info_area1.background:gray",   
   "*.info_area1.foreground:black",
   "*.info_area1*fontList: *helvetica-bold-r-normal--24*",
   "*.info_area2.background:gray",   
   "*.info_area2.foreground:black",
   "*.info_area2*fontList: *helvetica-bold-r-normal--24*",
   "*.info_area3.background:gray",   
   "*.info_area3.foreground:black",
   "*.info_area3*fontList: *helvetica-bold-r-normal--24*",

   "*.DialogForm*background: gray",
   "*.DialogForm*foreground: black",
   "*.DialogForm*fontList:*helvetica-bold-r-normal--12*",                // labels
   "*.DialogForm.XmToggleButton.fontList:fixed", // toggle buttons
   "*.DialogForm.XmPushButton.fontList:fixed",   // push buttons
   "*.DialogForm*radiobox*fontList:fixed",       // radio boxes
   "*.DialogForm*Ok*fontList: *helvetica-bold-r-normal--12*",
   "*.DialogForm*Cancel*fontList: *helvetica-bold-r-normal--12*",
   "*.DialogForm*Help*fontList: *helvetica-bold-r-normal--12*",
   "*.DialogForm*START*fontList: *helvetica-bold-r-normal--12*",
   "*.DialogForm*transient: True",
   "*.label.fontList:*helvetica-bold-r-normal--12*",
   "*.image*background:black",

   "*XmMessageBox*marginHeight: 5",
   "*XmMessageBox*marginWidth: 5",
   "*XmMessageBox*background: gray",
   "*XmMessageBox*foreground: black",
   "*XmMessageBox*fontList: *helvetica-bold-r-normal--12*",

   "*.FileSelector*background: gray",
   "*.FileSelector*foreground: black",
   "*.FileSelector*fontList:*helvetica-bold-r-normal--12*",
   "*.FileSelector*marginWidth: 5",
   "*.FileSelector*marginHeight: 5",
   "*.FileSelector*listVisibleItemCount: 30",
   "*.FileSelector*borderWidth: 0",
   "*.FileSelector*doubleClickInterval: 500",

   "*.Prompt*marginHeight: 4",
   "*.Prompt*marginWidth: 6",
   "*.Prompt*fontList: *helvetica-bold-r-normal--12*",
   "*.ClickboxForm*fontList:*helvetica-bold-r-normal--12*",
   "*.MultiClickboxForm*fontList:*helvetica-bold-r-normal--12*",
   "*.List.XmLabel.fontList:*helvetica-bold-r-normal--12*",
   "*.Menu3DForm.XmLabel.fontList:*helvetica-bold-r-normal--12*",
   "*.drawing_area.background:gray",   
   "*.GraphForm*fontList:*helvetica-bold-r-normal--12*",
   "*.GetStrings*shadowThickness:1",

   "*.f101.acceleratorText: Ctrl+O",
   "*.f102.acceleratorText: Ctrl+S",
   "*.f103.acceleratorText: Ctrl+P",
   "*.f104.acceleratorText: Ctrl+A",
   "*.f106.acceleratorText: Ctrl+E",
   "*.f108.acceleratorText: Ctrl+N",
   "*.f110.acceleratorText: Ctrl+C",
   "*.f112.acceleratorText: Alt+X",
   "*.f203.acceleratorText: Alt+B",
   "*.f212.acceleratorText: Ctrl+B",
   "*.f213.acceleratorText: Ctrl+U",
   "*.f214.acceleratorText: Ctrl+R",
   "*.f301.acceleratorText: Ctrl+F",
   "*.f304.acceleratorText: Ctrl+D",
   "*.f305.acceleratorText: Ctrl+T",
   "*.f311.acceleratorText: Ctrl+I",
   "*.f314.acceleratorText: Shift+Enter",
   "*.f402.acceleratorText: Ctrl+M",
   "*.f405.acceleratorText: Ctrl+V",
   "*.f502.acceleratorText: Ctrl+L",
   "*.f507.acceleratorText: F2",
   "*.f508.acceleratorText: F3",

   "Interactionmode.labelString: Interaction Mode",
   "*XmArrowButton.background: gray",   
   NULL
};

//--------------------------------------------------------------------//

int main(int argc, char **argv)
{
   int i, argc2=argc;
   char **argv2 = new char*[argc2];
   check_diagnose(argc,argv);
   for(i=0;i<argc2;i++){ argv2[i]=new char[80]; strcpy(argv2[i],argv[i]); }

   XtAppContext app; 
   g.appname = argv[0];
   initialize_globals();
   readsettings();
   if(g.diagnose){ printf("Setting XtLanguageProc\n");fflush(stdout); }
   XtSetLanguageProc(NULL,NULL,NULL);
   if(g.diagnose){ printf("Initializing Xt resources...");fflush(stdout); }
   g.main_widget = XtVaAppInitialize(&app, "Tnimage", 
                        NULL, 0, &argc, argv, fallback_resources,  
                        XmNdeleteResponse, XmDO_NOTHING,
                        XmNwidth, g.total_xsize,
                        XmNheight, g.total_ysize,
                        NULL);
   init_xlib(); 
   resize_widget(g.main_widget, g.total_xsize, g.total_ysize);
   set_motif_colors();
   makewidgets(g.main_widget);
   create_drawing_area(g.main_widget);
   setup_display();
   setup_colors();
   xminitializemisc(g.main_widget);
   create_main_icon();
   init_data();
   handle_command_line(argc2,argv2);    // Take care of app-specific commands
   reset_user_buttons();
   XtAppAddTimeOut(app,1000,timer_callback,NULL);
   XtAppMainLoop(app);
}



//--------------------------------------------------------------------//
// create_main_icon                                                   //
// Set the icon in case user iconifies program. Need a bigger one.    //
//--------------------------------------------------------------------//
void create_main_icon(void)
{
   if(g.diagnose){ printf("Creating icons...");fflush(stdout); }
   Window win;
   XIconSize *size;
   int count, k, ok=0;
   int alloc1=0, n;
   Arg args[100];
   Pixmap icon;
   const uchar icon_data[] = {
   0x54, 0x01, 0xa8, 0x02, 0x50, 0x05, 0xa0, 0x0a, 
   0x50, 0x15, 0xa8, 0x2a, 0x14, 0x55, 0x0a, 0xaa, 
   0x05, 0x55, 0x82, 0x2a, 0x45, 0x15, 0xaa, 0x0a,
   0x54, 0x05, 0xa8, 0x02, 0x54, 0x01, 0xaa, 0x00,

   0x54, 0x01, 0xa8, 0x02, 0x50, 0x05, 0xa0, 0x0a, 
   0x50, 0x15, 0xa8, 0x2a, 0x14, 0x55, 0x0a, 0xaa, 
   0x05, 0x55, 0x82, 0x2a, 0x45, 0x15, 0xaa, 0x0a,
   0x54, 0x05, 0xa8, 0x02, 0x54, 0x01, 0xaa, 0x00,

   0x54, 0x01, 0xa8, 0x02, 0x50, 0x05, 0xa0, 0x0a, 
   0x50, 0x15, 0xa8, 0x2a, 0x14, 0x55, 0x0a, 0xaa, 
   0x05, 0x55, 0x82, 0x2a, 0x45, 0x15, 0xaa, 0x0a,
   0x54, 0x05, 0xa8, 0x02, 0x54, 0x01, 0xaa, 0x00,

   0x54, 0x01, 0xa8, 0x02, 0x50, 0x05, 0xa0, 0x0a, 
   0x50, 0x15, 0xa8, 0x2a, 0x14, 0x55, 0x0a, 0xaa, 
   0x05, 0x55, 0x82, 0x2a, 0x45, 0x15, 0xaa, 0x0a,
   0x54, 0x05, 0xa8, 0x02, 0x54, 0x01, 0xaa, 0x00,

   };

   win = RootWindow(g.display,DefaultScreen(g.display));

   ////  Make sure it is ok to create a 32x32 icon. XGetIconSizes returns 0
   ////  if preferred icon sizes are not set. Should ideally iterate through 
   ////  size[k].width_inc and size[k].height_inc.

   if(XGetIconSizes(g.display, win, &size, &count))
   {   alloc1=1;
       for(k=0;k<count;k++)  
       {    if(between(32, size[k].min_width, size[k].max_width) &&
               between(32, size[k].min_height, size[k].max_height)){ ok=1; break;}
       }
   }else ok=1;
   if(ok)
   {    icon = XCreateBitmapFromData(g.display, win, (char*)icon_data, 32, 32);
        n=0;
        if(icon != (Pixmap)None)
        {    XtSetArg(args[n], XmNiconic, False); n++;
             XtSetArg(args[n], XmNiconName, "TN-Image"); n++;
             XtSetArg(args[n], XmNiconPixmap, icon); n++;
        }else fprintf(stderr, "Can't create icon\n");
        XtSetValues(g.main_widget, args, n);
   }else fprintf(stderr, "Not allowed to create a 32x32 icon!\n");
   if(alloc1) XFree(size);
   if(g.diagnose){ printf("done\n");fflush(stdout); }
}



//--------------------------------------------------------------------//
// set_motif_colors                                                   //
// Call before makewidgets(), otherwise Motif can't allocate its own  //
// colors and retaliates by making everything black & white. After    //
// widgets are set up, then it is safe to allocate application colors.//                       //
// main_fcolor and main_bcolor are set here.                          //
//--------------------------------------------------------------------//
void set_motif_colors(void)
{ 
  if(g.diagnose){ printf("Setting Motif colors...");fflush(stdout); }
  long uint aa, main_top_shadow, main_bottom_shadow, main_select_color;

  ////  Find out what colors Motif will insist on using. Motif has to
  ////  grab its colors before you allocate any colors, otherwise it will
  ////  complain and set everything to black & white.

  ////  Read the foreground & background pixel values chosen by Motif.
  XtVaGetValues(g.main_widget, 
      XmNbackground, &g.main_bcolor,
      XmNforeground, &g.main_fcolor,  NULL);         

  ////  Let Motif calculate the other colors based on the background value.
  XmGetColors(XtScreen(g.main_widget), g.colormap, g.main_bcolor, &aa, 
      &main_top_shadow, &main_bottom_shadow, &main_select_color);
  g.main_fcolor = aa;

  ////  Set the colors accordingly.
  XtVaSetValues(g.main_widget,
      XmNtopShadowColor, main_top_shadow,
      XmNbottomShadowColor, main_bottom_shadow,
      XmNarmColor, main_select_color,
      XmNborderColor, g.main_fcolor,
      NULL);

  if(g.diagnose)
  { printf("done\n main fcolor %d\n main bcolor %d\n",g.main_fcolor,g.main_bcolor); }

}


//--------------------------------------------------------------------//
// Make widgets                                                       //
// Call after set_motif_colors and before setup_colors.               //
// Widgets that exist for the life of the application.                //
//--------------------------------------------------------------------//
void makewidgets(Widget parent)
{ 
  if(g.diagnose){ printf("Creating menu widgets\n");fflush(stdout); }
  int n;
  Arg args[100];
  Widget  menupane, main_window;

  n=0;
  XtSetArg(args[n], XmNmarginHeight, 0); n++;
  XtSetArg(args[n], XmNmarginWidth, 0); n++;

  main_window = XmCreateMainWindow(parent, "Main", args, n);

  n=0;
  XtSetArg(args[n], XmNmarginHeight, 0); n++;
  XtSetArg(args[n], XmNmarginWidth, 0); n++;
  g.menubar = XmCreateMenuBar(main_window, "MenuBar", args, n);

  //------Create 'File' pull-down menu---------------//

  menupane = createmenu(g.menubar, "fileMenu", " File ", 'f');
  createmenuitem(menupane, "f101",  "Open Image...", 'L', executecb, "load");
  createmenuitem(menupane, "f102",  "Save Image...", 'S', executecb, "save");
  createmenuitem(menupane, "f103",  "Print Image...", 'P', executecb, "print");
  createmenuseparator(menupane, "sep1");
  createmenuitem(menupane, "f104",  "Scanner...", 'S', executecb, "acquire");
  createmenuitem(menupane, "f105",  "Camera...", 'C', executecb, "camera");
  createmenuitem(menupane, "f106",  "Execute plugin...", 'A', executecb, "executeplugin");
  createmenuseparator(menupane, "sep3");
  createmenuitem(menupane, "f107",  "Change title", 'T', executecb, "changetitle");
  createmenuitem(menupane, "f108",  "New/Resize Image...", 'C', executecb, "createimage");
  createmenuitem(menupane, "f109",  "Create File Format...", 'F', executecb, "createfileformat");
  createmenuseparator(menupane, "sep4");
  createmenuitem(menupane, "f110", "Close Image", 'U', executecb, "unload");
  createmenuitem(menupane, "f111", "Close All Images", 'I', executecb, "unloadall");
  createmenuitem(menupane, "f112", "Quit", 'Q', quitcb, NULL);

  //------Create 'Image' pull-down menu--------------//

  menupane = createmenu(g.menubar, "imageMenu", " Image ", 'i');
  createmenuitem(menupane, "f201", "Delete region", 'D', executecb, "deleteregion");
  createmenuitem(menupane, "f202", "Crop", 'r', executecb, "crop");
  createmenuitem(menupane, "f203", "Erase background", 'E', executecb, "erasebackground");
  createmenuitem(menupane, "f204", "Paste...", 'a', executecb, "paste");
  createmenuseparator(menupane, "sep5");
  createmenuitem(menupane, "f205", "Change size", 'S', executecb, "changesize");
  createmenuitem(menupane, "f206","Zoom", 'Z', executecb, "zoom");
  createmenuitem(menupane, "f207", "Rotate...", 'o', executecb, "rotate");
  createmenuitem(menupane, "f208", "Warp", 'W', executecb, "warp");
  createmenuitem(menupane, "f209","Shift...", 'f', executecb, "shift");
  createmenuitem(menupane, "f210", "Flip horiz.", 'h', executecb, "fliphoriz");
  createmenuitem(menupane, "f211", "Flip vertically", 'v', executecb, "flipvertically");
  createmenuseparator(menupane, "sep6");
  createmenuitem(menupane, "f212", "Backup", 'B', executecb, "backup");
  createmenuitem(menupane, "f213", "Restore (Undo)", 'R', executecb, "restore");
  createmenuitem(menupane, "f214", "Repair/Zoom out", 'P', executecb, "repair");
  createmenuseparator(menupane, "sep6a");
  createmenuitem(menupane, "f216","Switch selected/unselected", 'c', executecb, "switchselected");
  createmenuitem(menupane, "f217","Clear alpha channel", 'C', executecb, "clearalpha");
  createmenuseparator(menupane, "sep6a");
  createmenuitem(menupane, "f218","Image properties...", 'P', executecb, "attributes");
  createmenuitem(menupane, "f219","Frame Controls...", '3', executecb, "3d");
#ifdef HAVE_XBAE
  createmenuitem(menupane, "f220","Spreadsheet...", 'p', executecb, "spreadsheet");
#endif
  //------Create 'Process' pull-down menu------------//

  menupane = createmenu(g.menubar, "processMenu", " Process ", 'p');
  createmenuitem(menupane, "f301", "Filter...", 'F', executecb, "filter");
  createmenuitem(menupane, "f313", "Mask...", 'a', executecb, "mask");
  createmenuitem(menupane, "f302", "Measure...", 'M', executecb, "measure");
  createmenuitem(menupane, "f303", "Calibration...", 'C', executecb, "calibration");
  createmenuitem(menupane, "f304", "Spot densitometry..", 'S', executecb, "spotdensitometry");
  createmenuitem(menupane, "f305", "Strip densitometry..", 't', executecb, "stripdensitometry");
  createmenuitem(menupane, "f306", "Trace curve...", 'T', executecb, "tracecurve");
  createmenuitem(menupane, "f307", "FFT/convolution...", 'c', executecb, "fft");
  createmenuitem(menupane, "f308","Wavelets...", 'c', executecb, "wavelets");
  createmenuseparator(menupane, "sep6b");
  createmenuitem(menupane, "f309","Partition", 't', executecb, "partition");
  createmenuitem(menupane, "f310","Grain/pattern counting...", 'G', executecb, "grains");
  createmenuseparator(menupane, "sep6b");
  createmenuitem(menupane, "f311", "Image math...", 'P', executecb, "imagemath");
  createmenuitem(menupane, "f312", "Command editor...", 'c', executecb, "macro");
  createmenuitem(menupane, "f314", "Repeat last command", 'r', executecb, "repeat");
  createmenuitem(menupane, "f315", "3D plot", '3', executecb, "3dplot");

  //------Create 'Color' pull-down menu--------------//

  menupane = createmenu(g.menubar, "colorMenu", " Color ", 'c');
  createmenuitem(menupane, "f400", "Color/contrast..", 'C', executecb, "contrast");
  createmenuitem(menupane, "f401", "Change RGB/HSV value..", 'C', executecb, "brightness");
  createmenuitem(menupane, "f402", "Intensity/HSV contrast..", 'M', executecb, "changecontrast");
  createmenuitem(menupane, "f403", "Colormap/False color...", 'P', executecb, "colormap");
  createmenuitem(menupane, "f404", "Remap colors...", 'R', executecb, "remapcolors");
  createmenuitem(menupane, "f405", "Invert colors", 'I',  executecb, "invertcolors");
  createmenuitem(menupane, "f406", "Separate RGB", 'S',  executecb, "separatergb");
  createmenuitem(menupane, "f407", "Composite RGB", 'c',  executecb, "compositergb");
  createmenuseparator(menupane, "sep6c");
  createmenuitem(menupane, "f408", "Change image depth", 'd',  executecb, "changecolordepth");
  createmenuseparator(menupane, "sep6c");
  createmenuitem(menupane, "f409", "Change pixel value..",'p',executecb, "changepixelvalues");
  createmenuitem(menupane, "f410","Maximize local contrast..", 'M', executecb, "localcontrast");
  createmenuitem(menupane, "f411", "Grayscale map...", 'M', executecb, "grayscalemap");
  createmenuitem(menupane, "f412", "Color->gray scale", 'g',  executecb, "color->grayscale");
  createmenuitem(menupane, "f413", "Gray scale->color", 'G',  executecb, "grayscale->color");
  createmenuseparator(menupane, "sep6d");
  createmenuitem(menupane, "f414", "Histogram", 'H',  executecb, "histogram");

  //------Create 'Draw' pull-down menu---------------//

  menupane = createmenu(g.menubar, "drawMenu", " Draw ", 'd');
  createmenuitem(menupane, "f500", "Foreground color", 'F', executecb, "foregroundcolor");
  createmenuitem(menupane, "f501", "Background color", 'B', executecb, "backgroundcolor");
  createmenuitem(menupane, "f502", "Label", 'e',  executecb, "label");
  createmenuitem(menupane, "f503", "Line/arrow...", 'L',  executecb, "line");
  createmenuitem(menupane, "f504", "Circle", 'C',  executecb, "circle");
  createmenuitem(menupane, "f505", "Box",'B',  executecb, "box");
  createmenuitem(menupane, "f506", "Curve", 'u',  executecb, "curve");
  createmenuitem(menupane, "f507", "Sketch", 'S',  executecb, "sketch");
  createmenuitem(menupane, "f508", "Scissors area selection", 'c', executecb, "selectarea");
  createmenuseparator(menupane, "sep7");
  createmenuitem(menupane, "f509", "Font...", 'F',  executecb, "font");
  createmenuitem(menupane, "f510", "Text direction", 'T',  executecb, "textdirection");
  createmenuseparator(menupane, "sep8");
  createmenuitem(menupane, "f511", "Fill region...", 'i',  executecb, "fill");
  createmenuitem(menupane, "f512", "Paint region", 'P',  executecb, "paint");
  createmenuitem(menupane, "f513", "Spray...", 'y',  executecb, "spray");
  createmenuitem(menupane, "f514", "Add border", 'b',  executecb, "border");

 //------Create 'About' pull-down menu---------------//

  menupane = createmenu(g.menubar, "aboutMenu", " About ", 'a');
  createmenuitem(menupane, "f601", "About the program", 'p', executecb, "abouttheprogram");
  createmenuitem(menupane, "f602", "About the file", 'f',  executecb, "aboutthefile");
  createmenuitem(menupane, "f603", "About the image",'i',  executecb, "abouttheimage");
  createmenuitem(menupane, "f604", "Select image",'i',  executecb, "selectimage");

  //----Create 'Config' pull-down menu---------------//

  menupane = createmenu(g.menubar, "configMenu", " Config ", 'o');
  createmenuitem(menupane, "f701", "Show colormap", 'p',  executecb, "showcolormap");
  createmenuitem(menupane, "f702", "Show O.D. table", 'O',  executecb, "showodtable");
  createmenuitem(menupane, "f703", "Pixel interact mode",'i',  executecb, "pixelinteractmode");
  createmenuitem(menupane, "f704", "Line style...", 'L',  executecb, "linestyle");
  createmenuitem(menupane, "f705", "Configure...", 'C',  executecb, "configure");
 
  //------Create 'Help' pull-down menu---------------//

  menupane = createmenu(g.menubar, "helpMenu", " Help ", 'h');
  createmenuitem(menupane, "f801", "Help", 'H',  executecb, "help");
  
  XtManageChild(g.menubar);
  XtManageChild(main_window);
  XtRealizeWidget(parent);
  XtMapWidget(parent);
  if(g.diagnose){ printf("done\n"); }
}


//--------------------------------------------------------------------//
// createmenu                                                         //
//--------------------------------------------------------------------//
Widget createmenu(Widget parent, char *name, char *label, char mnemonic)
{

    if(g.diagnose){ printf(" Creating menu %s\n",label); }
    int n;
    Arg args[100];
    Widget menu,w;
    XmString xmstring;
#ifdef MOTIF2
    XmString xms;
#endif
    char accelerator[256] = "Ctrl<Key>X";  // Substitute mnemonic for the 'X'
    accelerator[9] = mnemonic;

    menu = XmCreatePulldownMenu(parent, name, NULL, 0);
    XtVaSetValues(menu, 
        XmNtearOffModel, XmTEAR_OFF_ENABLED, 
        XmNmenuAccelerator, accelerator,            
        XmNaccelerator, accelerator,            
        XmNacceleratorText, "A",            
#ifdef MOTIF2
        XmNtearOffTitle, xms=XmStringCreateSimple(label),
#endif
        XmNmnemonic, mnemonic,            
        NULL);

#ifdef MOTIF2
    XmStringFree(xms);
#endif

    n = 0;
    XtSetArg(args[n], XmNsubMenuId, menu); n++;
    XtSetArg(args[n], XmNmnemonic, mnemonic); n++;
    XtSetArg(args[n], XmNtearOffModel, XmTEAR_OFF_ENABLED); n++;
    XtSetArg(args[n], XmNlabelString, xmstring=XmStringCreateSimple(label)); n++;
    w = XmCreateCascadeButton(parent,"cascadebutton",args,n);
    XtManageChild(w);
    XmStringFree(xmstring);
    return menu;
}


//--------------------------------------------------------------------//
// createmenuitem                                                     //
//--------------------------------------------------------------------//
Widget createmenuitem(Widget parent, char *name, char *label,
	char mnemonic, 
        void *callback,
        void *cbArg)
{
    Widget w;
    XmString xmstring;
    char accelerator[256] = "Ctrl<Key>X";  
    accelerator[9] = mnemonic;
    
    w = XtVaCreateManagedWidget(name, xmPushButtonWidgetClass, parent, 
    	    XmNlabelString, xmstring=XmStringCreateSimple(label),         
    	    XmNmnemonic, mnemonic, NULL);
    XtVaSetValues(w, XmNaccelerator, accelerator, NULL);

    XtAddCallback(w, XmNactivateCallback, (XtCBP)callback, cbArg);
    XmStringFree(xmstring);
    return w;
}


//--------------------------------------------------------------------//
// createmenuseparator                                                //
//--------------------------------------------------------------------//
Widget createmenuseparator(Widget parent, char *name)
{
    Widget button;
    int n;
    Arg args[100];
    n = 0;
    button = XmCreateSeparator(parent, name, args, n);
    XtManageChild(button);
    return button;
}


//--------------------------------------------------------------------//
// create drawing area                                                //
// Must be called after read_settings() and init_xlib()               //
// so it uses correct sizes.                                          //
//--------------------------------------------------------------------//
void create_drawing_area(Widget parent)
{ 
  if(g.diagnose){ printf("Creating drawing area...");fflush(stdout); }
  int k, n, x1, y1;
  Widget form, arrow_frame, separator;
  Widget button[4];                     // Arrow buttons on left
  Widget arrow_area;
  XGCValues xgcv;
  Arg args[100];
  int data[10];
  int x[4] = {-15,-15,-45,15};
  int y[4] = {2,32,17,17};

  int type[4] = {XmARROW_UP, XmARROW_DOWN, XmARROW_LEFT, XmARROW_RIGHT};
  void *cb[4] = {upcb, downcb, leftcb, rightcb};
  g.main_mask =  KeyPressMask |         // Keyboard
                StructureNotifyMask |
                SubstructureNotifyMask |
                ColormapChangeMask |
                EnterWindowMask |
                LeaveWindowMask ;   
  g.mouse_mask = Button1MotionMask |    // Click & Drag
                PointerMotionMask;      // Mouse movement  
 
  ////  Note - XmNheight puts data into a float on some platforms 
  ////  and an int on others.  No compiler warning occurs if you put 
  ////  the data into the wrong type. 'mainmenuheight' must be defined
  ////  as a Dimension and then type casted as needed.
     
  XtVaGetValues(g.menubar, XmNheight, &g.mainmenuheight, NULL);       
  y1 = (int)g.mainmenuheight;
  x1 = g.drawarea2width;

 //------------------- drawing area form------------------------------//

  n=0;
  XtSetArg(args[n], XmNwidth, g.total_xsize); n++;
  XtSetArg(args[n], XmNheight, g.total_ysize-y1+2); n++;
  XtSetArg(args[n], XmNx, 0); n++;
  XtSetArg(args[n], XmNy, y1-1); n++;
  XtSetArg(args[n], XmNresizePolicy, XmRESIZE_ANY); n++;
  XtSetArg(args[n], XmNtopAttachment, XmATTACH_WIDGET); n++;
  XtSetArg(args[n], XmNtopWidget, g.menubar); n++;
  form = XmCreateForm(parent, "drawing_area_form", args, n);
  XtManageChild(form);

  //-------------------separator--------------------------------------//

  n=0;
  XtSetArg(args[n], XmNx, x1); n++; 
  XtSetArg(args[n], XmNseparatorType, XmSHADOW_ETCHED_IN); n++;
  XtSetArg(args[n], XmNorientation, XmVERTICAL); n++;
  XtSetArg(args[n], XmNresizePolicy, XmRESIZE_NONE); n++;
  XtSetArg(args[n], XmNtopAttachment, XmATTACH_FORM); n++;
  XtSetArg(args[n], XmNbottomAttachment, XmATTACH_FORM); n++;
  separator = XmCreateSeparator(form,"separator",args,n);
  XtManageChild(separator);
  XtRealizeWidget(separator);

  //--------------drawing area 2 (at left)----------------------------//

  n=0;
  XtSetArg(args[n], XmNtitle, "Drawing Area"); n++;
  XtSetArg(args[n], XmNresizePolicy, XmRESIZE_NONE); n++;
  XtSetArg(args[n], XmNx, 0); n++;
  XtSetArg(args[n], XmNwidth, x1 - 5); n++;
  XtSetArg(args[n], XmNrightWidget, separator); n++;
  XtSetArg(args[n], XmNleftAttachment, XmATTACH_FORM); n++;
  XtSetArg(args[n], XmNrightAttachment, XmATTACH_WIDGET); n++;
  XtSetArg(args[n], XmNtopAttachment, XmATTACH_FORM); n++;
  XtSetArg(args[n], XmNbottomAttachment, XmATTACH_FORM); n++;
  g.drawing_area2 = XmCreateDrawingArea(form, "drawing_area2", args, n);
  XtRealizeWidget(g.drawing_area2);
  XtManageChild(g.drawing_area2);
  XtMapWidget(g.drawing_area2); 
 
  //--------------------add buttons at left----------------------------//

  for(k=0;k<g.nbuttons;k++) 
      g.button[k]->widget = add_mainbutton(g.button[k]->label, mainbuttoncb);

 //-------------------add information areas---------------------------//

  int ystart = y1 + 55 + 20*(g.nbuttons/2);
  g.info_area[0] = create_info_area(g.drawing_area2,"info_area0",ystart,182);
  ystart += 182;
  g.info_area[1] = create_info_area(g.drawing_area2,"info_area1",ystart,92);
  ystart += 92;
  g.info_area[2] = create_info_area(g.drawing_area2,"info_area2",ystart,56);
  ystart += 56;
  g.info_area[3] = create_info_area(g.drawing_area2,"info_area3",ystart,90);

 //--------------------drawing area (at right)------------------------//

  n=0;
  XtSetArg(args[n], XmNtitle, "Drawing Area"); n++;
  XtSetArg(args[n], XmNresizePolicy, XmRESIZE_NONE); n++;
           // Don't map window with call to XtRealizeWidget
  XtSetArg(args[n], XmNmappedWhenManaged, False); n++;
  XtSetArg(args[n], XmNx, x1 + 5); n++;
  XtSetArg(args[n], XmNwidth, g.main_xsize); n++;
           // Margin width must be 0, otherwise images will be moved by
           // Motif automatically at random times, causing pixels to be
           // drawn in the wrong location.
  XtSetArg(args[n], XmNleftAttachment, XmATTACH_WIDGET); n++;
  XtSetArg(args[n], XmNleftWidget, separator); n++;
  XtSetArg(args[n], XmNrightAttachment, XmATTACH_FORM); n++;
  XtSetArg(args[n], XmNtopAttachment, XmATTACH_FORM); n++;
  XtSetArg(args[n], XmNbottomAttachment, XmATTACH_FORM); n++;

  g.drawing_area = XmCreateDrawingArea(form, "drawing_area", args, n);
  XtManageChild(g.drawing_area);

  XtAddCallback(g.drawing_area, XmNexposeCallback, (XtCBP)drawcb, (XtP)&g.image_gc);
  XtAddCallback(g.drawing_area, XmNresizeCallback, (XtCBP)drawcb, (XtP)&g.image_gc);
  XtAddCallback(g.drawing_area, XmNinputCallback, (XtCBP)drawcb, (XtP)&g.image_gc);
  for(k=0;k<INFOWINDOWS;k++)
  XtAddCallback(g.info_area[k], XmNexposeCallback, (XtCBP)infocb, (XtP)&g.image_gc);

  ////  Need event handler to catch those wacky mouse movement events.
  ////  This is removed in quit().

  XtAddEventHandler(g.drawing_area,g.mouse_mask,False,(XtEH)mousecb, 
      (XtP)&g.image_gc);
  ////  Moving main window    
  XtAddEventHandler(g.main_widget, StructureNotifyMask, False, 
      (XtEH)configurecb, (XtP)NULL);

  ////  Stop information area from getting keyboard focus when clicked
  for(k=0;k<INFOWINDOWS;k++)
      XtSetKeyboardFocus(g.info_area[k], g.drawing_area);

 //-------------------------------------------------------------------//
 //--------------------arrow buttons (at left)------------------------//

  n=0;
  XtSetArg(args[n], XmNshadowType, XmSHADOW_ETCHED_IN); n++;
  XtSetArg(args[n], XmNx, 2); n++;
  XtSetArg(args[n], XmNy, 0); n++;
  XtSetArg(args[n], XmNresizePolicy, XmRESIZE_NONE); n++;
  XtSetArg(args[n], XmNwidth, x1-4); n++;
  XtSetArg(args[n], XmNheight, 65); n++;
  XtSetArg(args[n], XmNresizable, False); n++;
  arrow_frame = XmCreateFrame(g.drawing_area2, "arrowframe", args, n);
  XtManageChild(arrow_frame);

  n=0;
  XtSetArg(args[n], XmNtitle, "Arrow Area"); n++;
  XtSetArg(args[n], XmNresizePolicy, XmRESIZE_NONE); n++;
  XtSetArg(args[n], XmNx, 0); n++;
  XtSetArg(args[n], XmNwidth, x1 - 4); n++;
  XtSetArg(args[n], XmNheight, 65); n++;
  arrow_area = XmCreateDrawingArea(arrow_frame, "information_area", args, n);
  XtManageChild(arrow_area);

  for(k=0;k<4;k++)
  {  n=0;
     XtSetArg(args[n], XmNx, x1/2 + x[k] -2); n++;
     XtSetArg(args[n], XmNy, y[k]-2); n++;
     XtSetArg(args[n], XmNheight, 30); n++;
     XtSetArg(args[n], XmNwidth, 30); n++;
     XtSetArg(args[n], XmNarrowDirection, type[k]); n++;
     XtSetArg(args[n], XmNresizePolicy, XmRESIZE_NONE); n++;
     button[k] = XmCreateArrowButton(arrow_area, "Button", args, n);
     data[0] = k;
     XtAddCallback(button[k], XmNdisarmCallback, (XtCBP)disarmcb, (XtP)data);
     XtAddCallback(button[k], XmNarmCallback,(XtCBP)cb[k],(XtP)data);

     ////  Stop arrow buttons from getting keyboard focus when clicked
     XtSetKeyboardFocus(button[k], g.drawing_area);
     XtManageChild(button[k]);
  }

 //-------------------------------------------------------------------//

  ////  Must realize widgets before getting window ID
  XtRealizeWidget(g.drawing_area);
  XtRealizeWidget(arrow_frame);
  XtRealizeWidget(arrow_area);
  XtRealizeWidget(separator);

  for(k=0;k<INFOWINDOWS;k++)
  {   XtRealizeWidget(g.info_area[k]);
      g.info_window[k] = XtWindow(g.info_area[k]);
  }
  g.main_window = XtWindow(g.drawing_area);

  ////  Create a graphics context for images
  g.image_gc = XCreateGC(g.display, g.main_window, 0L,(XGCValues*)NULL);
  XSetFont(g.display, g.image_gc, g.image_font_struct->fid);
  XSetForeground(g.display, g.image_gc, BlackPixel(g.display, g.screen));
  XSetBackground(g.display, g.image_gc, WhitePixel(g.display, g.screen));
  g.main_window = XtWindow(g.drawing_area);

  ////  Create a graphics context for menus, graphs, etc
  g.gc = XCreateGC(g.display,g.info_window[0],0L,(XGCValues*)NULL);
  XSetFont(g.display, g.gc, g.fontstruct->fid);
  XSetForeground(g.display, g.gc, BlackPixel(g.display, g.screen));
  XSetBackground(g.display, g.gc, WhitePixel(g.display, g.screen));

  ////  Create a graphics context for XOR'ing in menus, graphs, etc
  xgcv.foreground = g.fcolor ^ g.bcolor;
  xgcv.background = g.bcolor;
  xgcv.function = GXxor;
  g.xor_gc = XCreateGC(g.display, g.info_window[0], 
      GCForeground|GCBackground|GCFunction, &xgcv);
  XSetForeground(g.display, g.xor_gc, BlackPixel(g.display, g.screen));
  XSetBackground(g.display, g.xor_gc, WhitePixel(g.display, g.screen));

  //----------Now map and manage all the Widgets----------------------//

  for(k=0;k<INFOWINDOWS;k++)
      XtManageChild(g.info_area[k]);
  XtMapWidget(parent);
  XtMapWidget(g.drawing_area); 
  XtMapWidget(separator); 
  XtMapWidget(arrow_frame); 
  XtMapWidget(arrow_area); 
  for(k=0;k<INFOWINDOWS;k++) XtMapWidget(g.info_area[k]); 
  if(g.diagnose){ printf("done\n"); }
}


//--------------------------------------------------------------------//
// create_info_area                                                   //
//--------------------------------------------------------------------//
Widget create_info_area(Widget parent, char *title, int ystart, int height)
{
  int n;
  Widget w,frame;
  n=0;
  Arg args[20];
  int x1 = g.drawarea2width - 4;

  XtSetArg(args[n], XmNshadowType, XmSHADOW_ETCHED_IN); n++;
  XtSetArg(args[n], XmNx, 2); n++;
  XtSetArg(args[n], XmNy, ystart); n++;
  XtSetArg(args[n], XmNwidth, x1); n++;
  XtSetArg(args[n], XmNheight, height); n++;
  frame = XmCreateFrame(parent, "frame", args, n);

  //// Info areas (inside frame)

  n=0;
  XtSetArg(args[n], XmNtitle, title); n++;
  XtSetArg(args[n], XmNresizePolicy, XmRESIZE_NONE); n++;
  XtSetArg(args[n], XmNx, 0); n++;
  XtSetArg(args[n], XmNwidth, x1); n++;
  XtSetArg(args[n], XmNheight, height); n++;
  w = XmCreateDrawingArea(frame, title, args, n);
  XtRealizeWidget(frame);
  XtManageChild(frame);
  XtMapWidget(frame); 
  return w;
}


//--------------------------------------------------------------------//
//  add_mainbutton                                                     //
//--------------------------------------------------------------------//
Widget add_mainbutton(char *name, void *cb)
{
  static int y=70;
  static int buttonno=0;
  Widget w;
  Arg args[100];
  int n,x;
  if(buttonno/2*2==buttonno) x=4; else x=60;
  n=0;
  XtSetArg(args[n], XmNx, x); n++;
  XtSetArg(args[n], XmNy, y); n++;
  XtSetArg(args[n], XmNheight, 20); n++;
  XtSetArg(args[n], XmNwidth, 55); n++;
  XtSetArg(args[n], XmNleftAttachment, XmATTACH_FORM); n++;
  XtSetArg(args[n], XmNtopAttachment, XmATTACH_FORM); n++;
  XtSetArg(args[n], XmNrecomputeSize, False); n++;
  XtSetArg(args[n], XmNtraversalOn, True); n++;
#ifdef MOTIF2
  XtSetArg(args[n], XmNindicatorOn, XmINDICATOR_NONE); n++;
#else
  XtSetArg(args[n], XmNindicatorOn, False); n++;
#endif
  w = XmCreateToggleButton(g.drawing_area2, name, args, n);
  g.button[buttonno]->button = buttonno;
  g.button[buttonno]->widget = w;
  g.button[buttonno]->state  = OFF;

  XtAddCallback(w, XmNvalueChangedCallback, (XtCBP)cb, (XtP)buttonno);
  XtManageChild(w);
  if(buttonno/2*2!=buttonno) y += 20;
  buttonno++;
  return w;
}


//--------------------------------------------------------------------//
//  add_togglebutton                                                  //
//--------------------------------------------------------------------//
Widget add_togglebutton(Widget parent, char *name, int x, int y, void *cb, void *ptr)
{
  Widget w;
  Arg args[100];
  int n;
  n=0;
  XtSetArg(args[n], XmNleftPosition, (Dimension)x); n++;      // % of width fromleft
  XtSetArg(args[n], XmNrightPosition, (Dimension)x+10); n++;  // % of width fromleft
  XtSetArg(args[n], XmNtopPosition, (Dimension)y); n++;       // % of height from top
  XtSetArg(args[n], XmNheight, 20); n++;
  XtSetArg(args[n], XmNtopAttachment, XmATTACH_POSITION); n++;
  XtSetArg(args[n], XmNleftAttachment, XmATTACH_POSITION); n++;
  XtSetArg(args[n], XmNrecomputeSize, False); n++;
  XtSetArg(args[n], XmNtraversalOn, True); n++;
#ifdef MOTIF2
  XtSetArg(args[n], XmNindicatorOn, XmINDICATOR_NONE); n++;
#else
  XtSetArg(args[n], XmNindicatorOn, False); n++;
#endif
  w = XmCreateToggleButton(parent, name, args, n);
  XtAddCallback(w, XmNvalueChangedCallback, (XtCBP)cb, ptr);
  XtManageChild(w);
  return w;
}


//--------------------------------------------------------------------//
//  add_pushbutton                                                    //
//--------------------------------------------------------------------//
Widget add_pushbutton(char *label, Widget parent, int x1, int y1, int x2, int y2,
    clickboxinfo *cb)
{
  Widget w;
  Arg args[100];
  int n;
  n=0;
  XtSetArg(args[n], XmNleftPosition, (Dimension)x1); n++;   // % of width fromleft
  XtSetArg(args[n], XmNrightPosition, (Dimension)x2); n++;  // % of width fromleft
  XtSetArg(args[n], XmNtopPosition, (Dimension)y1); n++;    // % of height from top
  XtSetArg(args[n], XmNbottomPosition, (Dimension)y2); n++; // % of width from top
  XtSetArg(args[n], XmNfractionBase, 100); n++;          // Use percentages
  XtSetArg(args[n], XmNtopAttachment, XmATTACH_POSITION); n++;
  XtSetArg(args[n], XmNleftAttachment, XmATTACH_POSITION); n++;
  XtSetArg(args[n], XmNbottomAttachment, XmATTACH_POSITION); n++;
  XtSetArg(args[n], XmNrightAttachment, XmATTACH_POSITION); n++;
   ////  Stop Motif from trying to grab another color if none are available.
  if(g.want_colormaps)  
  {    XtSetArg(args[n], XmNbackground, g.main_bcolor); n++;
       XtSetArg(args[n], XmNforeground, g.main_fcolor); n++;
  }
  w = XmCreatePushButton(parent, label, args, n);
  XtAddCallback(w, XmNactivateCallback, (XtCBP)buttoncb, (XtP)cb);
  XtManageChild(w);
  return w;
}


//--------------------------------------------------------------------//
// imagewidget                                                        //
// Create a drawing area widget for images. Later this can be extended//
// to add resizing and other features.                                //
//--------------------------------------------------------------------//
Widget imagewidget(int xpos, int ypos, int xsize, int ysize, ImageStruct *i)
{
   Arg args[100];
   int n;
   Widget w, parent;
   
   ////  Use `bitmap' to create icon
   const uchar icon_data[] = {
   0x54, 0x01, 0xa8, 0x02, 0x50, 0x05, 0xa0, 0x0a, 
   0x50, 0x15, 0xa8, 0x2a, 0x14, 0x55, 0x0a, 0xaa, 
   0x05, 0x55, 0x82, 0x2a, 0x45, 0x15, 0xaa, 0x0a,
   0x54, 0x05, 0xa8, 0x02, 0x54, 0x01, 0xaa, 0x00,
   };
    
           ////  Margin width must be 0, otherwise images will be moved by
           ////  Motif automatically at random times, causing pixels to be
           ////  drawn in the wrong location.

           ////  Create a Form Dialog Shell if user wants all images in 
           ////  separate windows

   n=0;
   XtSetArg(args[n], XmNtitle, "Image"); n++;
   XtSetArg(args[n], XmNwidth, xsize); n++;
   XtSetArg(args[n], XmNheight, ysize); n++;
   ////  Stop Motif from trying to grab another color if none are available.
   if(g.want_colormaps)  
   {    XtSetArg(args[n], XmNbackground, g.main_bcolor); n++;
        XtSetArg(args[n], XmNforeground, g.main_fcolor); n++;
   }
   if(i->shell)
   {  
        if(i->window_border)
        {   XtSetArg(args[n], XmNtransient, False); n++; } // Cant be set as resource
        else
        {   XtSetArg(args[n], XmNtransient, True); n++;  }
        XtSetArg(args[n], XmNresizable, False); n++;
        XtSetArg(args[n], XmNautoUnmanage, False); n++;
        XtSetArg(args[n], XmNtopAttachment, XmATTACH_SELF); n++;
        XtSetArg(args[n], XmNbottomAttachment, XmATTACH_NONE); n++;
        parent = XmCreateFormDialog(g.main_widget, "Image", args, n);
        XtRealizeWidget(parent);
        XtManageChild(parent);
        XtMapWidget(parent);        
   }else
   {    XtSetArg(args[n], XmNresizePolicy, XmRESIZE_ANY); n++;
        XtSetArg(args[n], XmNx, xpos); n++;
        XtSetArg(args[n], XmNy, ypos); n++;
        XtSetArg(args[n], XmNleftAttachment, XmATTACH_POSITION); n++;
        XtSetArg(args[n], XmNrightAttachment, XmATTACH_POSITION); n++;
        parent=g.drawing_area;
   }

   w = XmCreateDrawingArea(parent, "image", args, n);

           ////  If no window frame, move widget to the right place
           ////  and make sure the main window is on top.
   if(i->shell && !i->window_border)
   {    XtMoveWidget(XtParent(parent), xpos, ypos);
        XRaiseWindow(g.display,XtWindow(g.main_widget));
   }

           ////  Expose events = redraw part of the image
   XtAddCallback(w, XmNexposeCallback, (XtCBP)image_exposecb, (XtP)z);
           ////  Keypress or mouse click on the image
   XtAddCallback(w, XmNinputCallback, (XtCBP)drawcb, (XtP)z);
           ////  Mouse events    
   XtAddEventHandler(w, g.mouse_mask, False, (XtEH)mousecb, (XtP)z);
           ////  Moving window. Event handlers must be removed in eraseimage().
   XtAddEventHandler(XtParent(XtParent(w)), StructureNotifyMask, False, 
       (XtEH)configurecb, (XtP)z);
           ////  If user clicks on frame, event handler is needed to switch
           ////  to the image. Event handlers must be removed in eraseimage().
           ////  Clicking on window is handled by mousecb.
   XtAddEventHandler(XtParent(XtParent(w)), FocusChangeMask, False, 
       (XtEH)imagefocuscb, (XtP)z);

           ////  Map widget
   XtRealizeWidget(w);
   XtMapWidget(w); 
   XtManageChild(w);

           ////  Add icon
   i->icon = XCreateBitmapFromData(g.display, RootWindow(g.display, 
        DefaultScreen(g.display)), (char*)icon_data, 16, 16);
   if(i->icon != (Pixmap)None)
   {    n=0;
        XtSetArg(args[n], XmNiconic, False); n++;
        XtSetArg(args[n], XmNiconName, "Icon"); n++;
        XtSetArg(args[n], XmNiconPixmap, i->icon); n++;
        XtSetValues(XtParent(parent), args, n);
   }else fprintf(stderr, "Can't create icon\n");
   return w;
}


//--------------------------------------------------------------------//
// addstandardbuttons                                                 //
//--------------------------------------------------------------------//
void addstandardbuttons(Widget form, Widget *buttons, int *data) 
{
  addOkCancelHelpButtons(form, buttons,
         "Ok", 10, 
         "Cancel", 125, 
         "Help", 230, data);
}


//--------------------------------------------------------------------//
// addOkCancelHelpButtons                                             //
// Must use a ptr to put data in callback - a variable would go out   //
// of scope when this function returns.                               //
//--------------------------------------------------------------------//
void addOkCancelHelpButtons(Widget form, Widget *button, char *s1, int x1, 
   char *s2, int x2, char *s3, int x3, int *data)
{  
   Arg args[100];
   Cardinal n;
   const int bottom=6;

   n=0;
   XtSetArg(args[n],XmNresizable,       False); n++;
   XtSetArg(args[n],XmNtopAttachment,   XmATTACH_NONE); n++;
   XtSetArg(args[n],XmNbottomAttachment,XmATTACH_FORM); n++;
   XtSetArg(args[n],XmNleftAttachment,  XmATTACH_FORM); n++;
   XtSetArg(args[n],XmNrightAttachment, XmATTACH_NONE); n++;
   XtSetArg(args[n],XmNwidth,           100); n++;
   XtSetArg(args[n],XmNleftOffset,      x1); n++;
   XtSetArg(args[n],XmNbottomOffset,    bottom-5); n++;
   XtSetArg(args[n],XmNdefaultButton,   True); n++;
   XtSetArg(args[n],XmNshowAsDefault,   True); n++;
   XtSetArg(args[n],XmNsensitive,       True); n++;
   XtSetArg(args[n],XmNnavigationType,  XmEXCLUSIVE_TAB_GROUP); n++;
   XtSetArg(args[n],XmNinitialFocus,    True); n++;
   ////  Stop Motif from trying to grab another color if none are available.
   if(g.want_colormaps)  
   {    XtSetArg(args[n], XmNbackground, g.main_bcolor); n++;
        XtSetArg(args[n], XmNforeground, g.main_fcolor); n++;
   }
   button[0] = XmCreatePushButton(form,s1,args,n);  // OK button
   XtManageChild(button[0]);
   okbutton = button[0];

   n=0;
   XtSetArg(args[n],XmNresizable,       False); n++;
   XtSetArg(args[n],XmNtopAttachment,   XmATTACH_NONE); n++;
   XtSetArg(args[n],XmNbottomAttachment,XmATTACH_FORM); n++;
   XtSetArg(args[n],XmNleftAttachment,  XmATTACH_FORM); n++;
   XtSetArg(args[n],XmNrightAttachment, XmATTACH_NONE); n++;
   XtSetArg(args[n],XmNwidth,           100); n++;
   XtSetArg(args[n],XmNleftOffset,      x2); n++;
   XtSetArg(args[n],XmNbottomOffset,    bottom); n++;
   XtSetArg(args[n],XmNsensitive,       True); n++;
   XtSetArg(args[n],XmNdefaultButton,   False); n++;
   XtSetArg(args[n],XmNshowAsDefault,   False); n++;
   XtSetArg(args[n],XmNnavigationType,  XmEXCLUSIVE_TAB_GROUP); n++;
   ////  Stop Motif from trying to grab another color if none are available.
   if(g.want_colormaps)  
   {    XtSetArg(args[n], XmNbackground, g.main_bcolor); n++;
        XtSetArg(args[n], XmNforeground, g.main_fcolor); n++;
   }
   button[1] = XmCreatePushButton(form,s2,args,n);  // Cancel button
   XtManageChild(button[1]);

   n=0;
   XtSetArg(args[n],XmNresizable,       False); n++;
   XtSetArg(args[n],XmNtopAttachment,   XmATTACH_NONE); n++;
   XtSetArg(args[n],XmNbottomAttachment,XmATTACH_FORM); n++;
   XtSetArg(args[n],XmNleftAttachment,  XmATTACH_FORM); n++;
   XtSetArg(args[n],XmNrightAttachment, XmATTACH_NONE); n++;
   XtSetArg(args[n],XmNwidth,           100); n++;
   XtSetArg(args[n],XmNleftOffset,      x3); n++;
   XtSetArg(args[n],XmNbottomOffset,    bottom); n++;
   XtSetArg(args[n],XmNsensitive,       True); n++;
   XtSetArg(args[n],XmNdefaultButton,   False); n++;
   XtSetArg(args[n],XmNshowAsDefault,   False); n++;
   XtSetArg(args[n],XmNnavigationType,  XmEXCLUSIVE_TAB_GROUP); n++;
   ////  Stop Motif from trying to grab another color if none are available.
   if(g.want_colormaps)  
   {    XtSetArg(args[n], XmNbackground, g.main_bcolor); n++;
        XtSetArg(args[n], XmNforeground, g.main_fcolor); n++;
   }
   button[2] = XmCreatePushButton(form,s3,args,n);  // Help button
   XtManageChild(button[2]);

   XtAddCallback(button[0], XmNactivateCallback, (XtCBP)okcb, (XtP)form);
   XtAddCallback(button[1], XmNactivateCallback, (XtCBP)cancelcb, (XtP)form);
   XtAddCallback(button[2], XmNactivateCallback, (XtCBP)helpcb, (XtP)data);

   ////  Make Enter & Escape Keys the same as Mouse Click On The Buttons.
   
   XtAddEventHandler(button[0], KeyPressMask, FALSE, (XtEH)entercb, (XtP)form);
   XtAddEventHandler(button[1], KeyPressMask, FALSE, (XtEH)entercb, (XtP)form);
   XtAddEventHandler(button[2], KeyPressMask, FALSE, (XtEH)entercb, (XtP)form);
}



//--------------------------------------------------------------------//
// send_event                                                         //
// Artificially send an event (usually Expose) to a window.           //
//--------------------------------------------------------------------//
void send_event(Window w, int eventtype, int x, int y, int width, int height)
{
   XExposeEvent event;
   event.type = eventtype;
   event.send_event = True;
   event.display = g.display;
   event.window = w;
   event.x = x;  
   event.y = y;  
   event.width = width;  
   event.height = height;
   event.count = 0;
   XSendEvent(g.display, w, False, NoEventMask, (XEvent *)&event);
   
   XmDrawingAreaCallbackStruct xdacbs;
   XEvent ee;
   ////  In case rotating image is on root window
   if(w==g.root_window && eventtype == Expose)
   {   ee.xexpose = event;
       xdacbs.reason = XmCR_EXPOSE;
       xdacbs.event = &ee;
       image_exposecb(z[ci].widget, (XtP)NULL, (XtP*)(&xdacbs)); 
   }
}


//--------------------------------------------------------------------------//
// check_event  -  waits for events without blocking.                       //
//--------------------------------------------------------------------------//
void check_event(void)
{
   while(XtAppPending(XtWidgetToApplicationContext(g.main_widget)))    
       XtAppProcessEvent( XtWidgetToApplicationContext(g.drawing_area),XtIMAll);
   send_event(g.main_window, NoExpose, 0,0,1,1);
}



//--------------------------------------------------------------------//
// event_loop                                                         //
// Wait here until user clicks OK or Cancel, so that the variables    //
// being filled don't go out of scope. The only other way to avoid    //
// this is to make all the variables global, which would make the     //
// program incompatible with the DOS version.                         //
// Compare the widget ID of the form clicked in case 2 dialogs        //
// are active.                                                        //
//--------------------------------------------------------------------//
void event_loop(Widget w)
{
  g.dialogdone = 0;
  g.getout=0; 
  while(g.dialogdone != w)
    XtAppProcessEvent (XtWidgetToApplicationContext(g.main_widget), XtIMAll);
  g.dialogdone=0;
} 



//--------------------------------------------------------------------//
// redrawscreen - redraws main window including images on main window //
//--------------------------------------------------------------------//
void redrawscreen(void)
{
    copybackground(1,1,g.main_xsize-1,g.main_ysize-1,-1); 
}


//--------------------------------------------------------------------//
// redraw  - redraws an image if in separate window                   //
//--------------------------------------------------------------------//
void redraw(int ino)
{
    if(g.ignore || ino<0) return;
    if(!between(ino,0,g.image_count-1)) return;
    if(z[ino].chromakey)     
        redraw_chromakey_image(ino, 0);
    else if(z[ino].transparency)     
        redraw_transparent_image(ino, 0);
    else if(XtIsManaged(z[ino].widget))
        send_event(z[ino].win, Expose, 0, 0, z[ino].xsize, z[ino].ysize);
}


//--------------------------------------------------------------------//
// init_xlib                                                          //
// Initialize miscellaneous Xlib functions.                           //
// Call after read_settings so want_colormaps & colors are known.     //
//--------------------------------------------------------------------//
void init_xlib(void)
{
  XVisualInfo          vis_template;
  XVisualInfo         *vis_list;
  int                  num_visuals; 
  int                  win_depth;  // depth of visual
  Window               rwin;       // Window ID of root
  int                  depth;      // Bits/pixel of server
  uint uw,uh,ubw,udepth;           // width, height, bdr.width, & depth of root window
  int k,xroot,yroot;
  int bitmapunit;

  if(g.diagnose){ printf("done\nInitializing Xlib...");fflush(stdout); }

  if(setlocale(LC_ALL,"")==NULL)
       fprintf(stderr,"%s: cannot set locale\n",g.appname);
  if(XSetLocaleModifiers("")==NULL)
       fprintf(stderr, "Cant set locale modifiers\n");

  //-------Define the type of visual desired here---------------------//

  int depth_wanted;
  g.display = XtDisplay(g.main_widget);

  //------Set up fonts------------------------------------------------//

  if((g.fontstruct=XLoadQueryFont(g.display, g.font)) == NULL) 
  {   fprintf(stderr, "%s: display %s cannot load font %s\ntrying fixed font",
              g.appname, DisplayString(g.display), g.font);
      strcpy(g.font, "fixed");
      if((g.fontstruct=XLoadQueryFont(g.display, g.font)) == NULL) 
      {   fprintf(stderr, "%s: display %s cannot load fixed font\n",
              g.appname, DisplayString(g.display));
          exit(1);
      } 
  } 

  if((g.image_font_struct=XLoadQueryFont(g.display, g.imagefont)) == NULL) 
  {   fprintf(stderr, "%s: display %s cannot load font %s\n",
              g.appname, DisplayString(g.display), g.imagefont);
      exit(1);
  }  

  //------------------------------------------------------------------//

  g.screen = DefaultScreen(g.display); 
  g.root_window = RootWindow(g.display,g.screen);
  vis_template.screen = g.screen;

  //------Get a list of visuals for this screen-----------------------//

  depth_wanted = DefaultDepth(g.display, g.screen);
  depth = depth_wanted;

  vis_list = XGetVisualInfo(g.display, VisualScreenMask, &vis_template, &num_visuals);  
  if(g.visual_id_wanted==0 && g.visual_bpp_wanted==0)
      g.visual = DefaultVisual(g.display, g.screen);
  else if(g.visual_id_wanted)
  {   for(k=0;k<num_visuals;k++)
         if(vis_list[k].visualid == (uint)g.visual_id_wanted) g.visual=vis_list[k].visual;
  }
  else if(g.visual_bpp_wanted)
  {   for(k=0;k<num_visuals;k++)
         if(vis_list[k].depth == g.visual_bpp_wanted) g.visual=vis_list[k].visual;
  }

  //// There are several device dependencies that must be tested for:
  ////    byte_order in XImage
  ////    bitmap_bit_order in XImage
  ////    rgb vs. gbr order in Visual
  //// This gives 8 possible ways the bytes can be arranged in X windows.
  //// Moreover, you have to examine "opaque" structures to determine these
  ////    parameters. And it is not documented.
  //// This really really really really really really sucks!
  
  if(g.visual->red_mask < g.visual->blue_mask) g.swap_red_blue = 1;
  else g.swap_red_blue = 0;

  int vid = g.visual->visualid;
  if(num_visuals==0) { fprintf(stderr,"No visuals found\n"); exit(1); }
  if(g.diagnose)
  {  printf("\n%d Visuals found\n",num_visuals);
     printf("Display type: ");
     switch(g.visual->c_class)    // Use c_class in C++, class if using C
     {   case PseudoColor: printf("Pseudo color (0x%x)\n", vid); break;
         case GrayScale:   printf("Gray scale (0x%x)\n", vid);   break;
         case DirectColor: printf("Direct color (0x%x)\n", vid); break;
         case TrueColor:   printf("True color (0x%x)\n", vid);   break;
         default:          printf("Other (0x%x)\n", vid);        break;
      }
     printf("swap red/blue %d\n", g.swap_red_blue);
     printf("red %x grn %x blu %x\n",
             g.visual->red_mask, 
             g.visual->green_mask, 
             g.visual->blue_mask );
  }
  XFree(vis_list);      

  win_depth     = depth; 
  bitmapunit    = depth;
  if(win_depth>=24) bitmapunit=BitmapUnit(g.display);  // Actual depth for xserver

  //-------------------------------------------------------------------------//
  // New hack for X-Windows packed pixel 24-bpp mode                         //
  // Needed since BitmapUnit no longer gives accurate answer in Xfree86 3.3  //
  //-------------------------------------------------------------------------//
  if(g.diagnose)
      printf("bitmap_unit %d\ndepth %d %d \n",bitmapunit,depth,g.nosparse);

  //----Set the colormap to system default----------------------------//

  g.screen = DefaultScreen(g.display);
  g.colormap = DefaultColormap(g.display, g.screen);
  g.bitsperpixel  = depth;
  ////  Calculates bpp by creating an Ximage then examining its struct
  depth = bits_per_pixel();   
  g.bitsperpixel  = depth;
  if(g.bitsperpixel>=32 && win_depth==24) g.sparse_packing=1;
  if(g.bitsperpixel == 8 && 
    (g.visual->c_class == TrueColor || g.visual->c_class == DirectColor))
    {  g.bitsperpixel = 7; 
       g.want_colormaps = 0;
       printf("8-bit TrueColor mode, yuck!!!!!!!\n");
    }

  //// Allow user to override in case of server bug
  if(g.sparse){ g.sparse_packing=1; g.bitsperpixel=32; }
  if(g.nosparse){ g.sparse_packing=0; g.bitsperpixel=24; } 
  g.ximage_byte_order = ImageByteOrder(g.display);
  if(g.want_byte_order != -1) g.ximage_byte_order = g.want_byte_order;

  XGetGeometry(g.display,g.root_window,&rwin,&xroot,&yroot,&uw,&uh,&ubw,&udepth);
  g.xres = (int) uw;         // xres of root screen
  g.yres = (int) uh;         // yres of root screen

  g.main_xsize = min(g.main_xsize, g.xres-1);
  g.main_ysize = min(g.main_ysize, g.yres-1);
  g.total_xsize = min(g.total_xsize, g.xres-1);
  g.total_ysize = min(g.total_ysize, g.yres-1);

  if(g.diagnose)
  {   printf("done\n");
      printf(" xres        %d\n",g.xres);
      printf(" yres        %d\n",g.yres);
      printf(" main xsize  %d\n",g.main_xsize);
      printf(" main ysize  %d\n",g.main_ysize);
      printf(" total xsize %d\n",g.total_xsize);
      printf(" total ysize %d\n",g.total_ysize);
      printf(" depth       %d\n",depth);
      printf(" bitmapunit  %d\n",bitmapunit);
      printf(" sparse_pack %d\n",g.sparse_packing);
  }
}


//--------------------------------------------------------------------//
// bits_per_pixel                                                     //
//--------------------------------------------------------------------//
int bits_per_pixel(void)
{
/*   The correct way
  XPixmapFormatValues *xpfv;
  int count, k, bpp=0;
  if(g.bitsperpixel==15) return 15;
  xpfv = XListPixmapFormats(g.display, &count); 
  for(k=0;k<count;k++) bpp = max(bpp, xpfv[k].bits_per_pixel);
  XFree(xpfv);
  return bpp;
*/
  ////  This way seems safer
  int bitmap_pad = 8;   // Data is byte-organized
  int bytesperline=0;   // 0 means: scan lines are contiguous - X server
                        // calculates it for you 
  int xsize=10;
  int ysize=10;
  int bpp=g.bitsperpixel;
  char *buf;
  if(bpp==15) return 15;
  buf = (char*)malloc(1200);  // Must use malloc because XDestroyImage deallocates it "for" you.
  int offset = 0;
  XImage *ximage;
  ximage = XCreateImage(g.display, g.visual, (uint)bpp, ZPixmap, offset,
      buf, xsize, ysize, bitmap_pad, bytesperline);
  if(ximage==NULL){ printf("Cant create test image\n"); exit(1); }
  bpp = ximage->bits_per_pixel;
  XDestroyImage(ximage);
  return bpp;

}


//--------------------------------------------------------------------//
// xminitializemisc                                                   //
// Initialize miscellaneous Xm functions.                             //
// Must be called after create_drawing_area() so g.main_window &      //
//   g.display are defined.                                           //
// Must be called after init_xlib so g.fontstruct is defined.         //
//--------------------------------------------------------------------//
void xminitializemisc(Widget parent)
{
  Pixmap p, q;
  XColor fc, bc;
  char data[256];
  if(g.diagnose){ printf("Initializing Motif fonts...");fflush(stdout); }
  ////  This function is supposed to be obsolete in Motif 2.0 but Irix and
  ////  Solaris are still using 1.x 

  memset(data, 0, 256);
  g.fontlist = XmFontListCreate(g.fontstruct, XmSTRING_DEFAULT_CHARSET);
  g.normal_cursor = XCreateFontCursor(g.display, g.xlib_cursor);
  g.fleur_cursor = XCreateFontCursor(g.display, XC_fleur);
  g.busy_cursor = XCreateFontCursor(g.display, XC_watch);
  p = createxpixmap(g.main_window, 16, 16, 1);
  q = XCreatePixmapFromBitmapData(g.display, g.main_window, data, 16, 16, 1, 0, 1);
  g.no_cursor = XCreatePixmapCursor(g.display, p, q, &fc, &bc, 0, 0);
  XFreePixmap(g.display, p);
  XFreePixmap(g.display, q);
  if(g.want_crosshairs)
      g.cursor = g.no_cursor;
  else
      g.cursor = g.normal_cursor;

  XDefineCursor(g.display,g.main_window,g.cursor);

  ////  Try to determine window border
  XWindowAttributes xwa;
  XGetWindowAttributes(g.display, XtWindow(parent), &xwa);
  g.wm_leftborderwidth = xwa.x;
  g.wm_topborderwidth = xwa.y;

  ////  Get rid of those pesky error messages that spew out on the screen
  ////  all the time.
  if(!g.diagnose) 
     XtAppSetWarningHandler(XtWidgetToApplicationContext(parent), warningmessagecb);
  if(g.diagnose)
  {    printf("done\n");
       printf("left border width %d\n",g.wm_leftborderwidth);
       printf("top border width  %d\n",g.wm_topborderwidth);
  }
}



//--------------------------------------------------------------------//
// next_unused_color                                                  //
// Finds the lowest color that is not marked as being reserved, sets  //
// its r,g, and b values, returns pixel no.                           //
// Returns 0 if all colors are reserved.                              //
//--------------------------------------------------------------------//
int next_unused_color(int red, int grn, int blu)
{  
    int k, color=0;
    for(k=0;k<256;k++) if(g.reserved[k]==0){ color=k;break; }
    g.palette[color].red = red;
    g.palette[color].green = grn;
    g.palette[color].blue = blu;
    return color;
}


//--------------------------------------------------------------------//
// setup_colors - must be called after setup_display                  //
// Find out how many colors are already used by other apps.           //
// They are not necessarily continuous.                               //
//--------------------------------------------------------------------//
void setup_colors(void)
{    
  if(g.diagnose){ printf("Allocating colors...");fflush(stdout); }
  XColor color;
  int count=256, k, status=0;
  ulong plane_masks[256];
  ulong pixels[256];
  int menubarfcolor=0,menubarbcolor=0; // Motif colors for top menu bar
  int widgetfcolor=0, widgetbcolor=0;  // Motif colors for widgets
  int drawarea2fcolor=0, drawarea2bcolor=0;
  int main_bcolor=0, main_fcolor=0, main_top_shadow=0, main_bottom_shadow=0, 
      main_select_color=0, border_fcolor=0;

  if(g.bitsperpixel != 8 || g.visual->c_class!=PseudoColor)
  {   g.want_colormaps = 0;
      return;
  }

  //// Start with gray scale palette

  setSVGApalette(g.bkgpalette,0);

  //// Try to allocate all but 32 colors
  //// Main window's background & foreground colors
  //// Use white background in case of failure     
  
  if(g.fcolor==0 && g.bcolor==0)
  {   if(XParseColor(g.display, g.colormap,"gray", &color)==0 ||
               XAllocColor(g.display, g.colormap, &color)==0)
          g.bcolor = WhitePixel(g.display, g.screen);
      else
          g.bcolor = color.pixel;

      if(XParseColor(g.display, g.colormap, "black", &color)==0 ||
               XAllocColor(g.display, g.colormap, &color)==0)
          g.fcolor = BlackPixel(g.display, g.screen);
      else
          g.fcolor = color.pixel;
  }
  if(g.fcolor==0 && g.bcolor==0)
  {   g.want_colormaps=1;
      fprintf(stderr,"Using colormaps\n");
  }

  ////  Read the default colormap
  ////  Note: The rgb values range from 0 to 65535.
 
  for(k=0;k<256;k++)
  {   g.def_colors[k].pixel = k;
      g.def_colors[k].red   = 0;
      g.def_colors[k].green = 0;
      g.def_colors[k].blue  = 0;
      g.def_colors[k].flags = DoRed | DoGreen | DoBlue;
  } 
  XQueryColors(g.display, g.colormap, g.def_colors,256);

  status=0;
  count = 256;
  if(!g.want_colormaps)
  {                     ////  Find out how many colors can be allocated  
      while(status==0 && count>=32)
      {   status = XAllocColorCells(g.display,g.colormap,0,plane_masks,
               0,pixels,--count);
      }
      if(count<=32)    ////  Leave 32 colors for everyone else
      {    fprintf(stderr,"\nLess than 32 free color cells available\n");
           fprintf(stderr,"Using modifiable colormaps\n");
           g.want_colormaps=2;
      }else
      if(count<=128)   ////  Annoy them if less than 127 free
      {   fprintf(stderr,"\nWarning: only %d free color cells available\n",count);
          fprintf(stderr,"Recommend configuring tnimage to use colormaps\n");
      }
      if(status==0) count=0;  // Not able to allocate any colors
  }else count=0;

  ////  Array 'pixels' now contains a sorted list of available pixels.
  ////  Mark pixels allocated by other apps as reserved.
  ////  If unable to get any colors, or user wants to use colormaps,
  ////  set all the colors free.
  ////  After the last entry (i.e., the entry for which pixels[k] is
  ////  255), 'pixels[]' contains garbage.

  if(g.want_colormaps)
  {     if(count>0)
        {   fprintf(stderr,"Freeing %d colors \n",count); 
            XFreeColors(g.display, g.colormap, pixels, count, 0);
        }
        for(k=0;k<256;k++) g.reserved[k]=0;
        XtVaGetValues(g.menubar,
              XmNbackground, &menubarbcolor,
              XmNforeground, &menubarfcolor, NULL);

        ////  These two should be same as main_fcolor & main_bcolor unless 
        ////  user changed it.

        XtVaGetValues(g.info_area[0],   
              XmNbackground, &widgetbcolor,
              XmNforeground, &widgetfcolor, NULL); 
        if(g.fcolor==g.bcolor){ g.fcolor=0; g.bcolor=127; }
        g.reserved[0]=1;
        g.reserved[1]=1;
        g.reserved[menubarfcolor]=1;
        g.reserved[menubarbcolor]=1;
        g.reserved[widgetfcolor]=1;
        g.reserved[widgetbcolor]=1;
        XtVaGetValues(g.drawing_area2,   
              XmNbackground, &drawarea2bcolor,
              XmNforeground, &drawarea2fcolor, NULL); 
        g.reserved[drawarea2bcolor]=1;
        g.reserved[drawarea2fcolor]=1;

        XtVaGetValues(g.main_widget, 
              XmNbackground, &main_bcolor,
              XmNforeground, &main_fcolor, 
              XmNtopShadowColor, &main_top_shadow,
              XmNbottomShadowColor, &main_bottom_shadow,
              XmNarmColor, &main_select_color,
              XmNborderColor, &border_fcolor,
              NULL);         
        g.reserved[main_bcolor]=1;
        g.reserved[main_fcolor]=1;
        g.reserved[g.main_bcolor]=1;
        g.reserved[g.main_fcolor]=1;
        g.reserved[main_top_shadow]=1;
        g.reserved[main_bottom_shadow]=1;
        g.reserved[main_select_color]=1;
        g.reserved[border_fcolor]=1;

  }else
  {     XtVaGetValues(g.main_widget,
              XmNforeground, &g.main_fcolor,
              XmNbackground, &g.main_bcolor,
              NULL);       
        count = 0;
        for(k=0;k<256;k++) g.reserved[k]=1;
        for(k=0;k<256;k++)
        {   if(pixels[k]<256) 
            {     g.reserved[pixels[k]]=0;
                  count++;
            }
            if(pixels[k]>=255) break; 
        }
        if(g.bitsperpixel==8)
        {  if(g.reserved[g.fcolor])
           {   fprintf(stderr,"\nfcolor %d is already used by another application\n",
                   g.fcolor);
               if((g.fcolor = next_unused_color(g.fc.red, g.fc.green, g.fc.blue)))
                   fprintf(stderr,"fcolor is now set to %d \n",g.fcolor);
           }    

           if(g.reserved[g.bcolor])
           {   fprintf(stderr,"\nbcolor %d is already used by another application\n",g.bcolor);
               if((g.bcolor = next_unused_color(g.bc.red, g.bc.green, g.bc.blue)))
                   fprintf(stderr,"bcolor is now set to %d \n",g.bcolor);
           }    
        }
  }    
       
  //------------------------------------------------------------------//
  // Set the palette to use when user clicks on background area.      //
  //------------------------------------------------------------------//

  memcpy(g.b_palette,g.palette,768);
  if(g.diagnose)
  {   printf("done\n");
      printf("  colormaps %d\n",g.want_colormaps);
      printf("  colormaps %d\n",g.want_colormaps);
      printf("  count     %d\n",count);
      printf("  main fcolor   %d\n",g.main_fcolor);
      printf("  main bcolor   %d\n",g.main_bcolor);
      printf("  menubarfcolor %d\n",menubarfcolor);
      printf("  menubarbcolor %d\n",menubarbcolor);
      printf("  widgetfcolor  %d\n",widgetfcolor);
      printf("  widgetbcolor  %d\n",widgetbcolor);
      printf("  drawarea2fcolor %d\n",drawarea2fcolor);
      printf("  drawarea2bcolor %d\n",drawarea2bcolor);
      if(g.bitsperpixel==8)
      {   printf("  Reserved colors:\n");
          for(k=0;k<256;k++) if(g.reserved[k]) printf("%d ",k); 
          printf("\n");
      }
  }
  if(g.diagnose) printf("done\n");
}



//--------------------------------------------------------------------//
// string_width                                                       //
//--------------------------------------------------------------------//
int string_width(char *string, char *tag)
{
   int width=0;
   XmString xmstring;
   xmstring = XmStringCreateLtoR(string, tag);
   width = XmStringWidth(g.fontlist, xmstring);
   XmStringFree(xmstring);
   return width;
}


//--------------------------------------------------------------------//
// string_height                                                      //
//--------------------------------------------------------------------//
int string_height(char *string, char *tag)
{
   int height=0;
   XmString xmstring;
   xmstring = XmStringCreateLtoR(string, tag);
   height = XmStringHeight(g.fontlist, xmstring);
   XmStringFree(xmstring);
   return height;
}


//--------------------------------------------------------------------//
// addlabel                                                           //
// Print text on a Widget (used in dialog boxes)                      //
// Creates a Widget, don't forget to destroy it.                      //
// 'string' is the labelString resource specified in fallbacks        //
// 'position' can be LEFT, CENTER, or RIGHT.                          //
// Make boundaries as big as possible in case user changes string to  //
//  something wide. If x2-x1 is too small for the string, Motif will  //
//  enlarge the dialog box to gigantic size.                          //
//--------------------------------------------------------------------//
Widget addlabel(Widget parent, char *string, int position, double x1, double y1, 
   double x2, double y2) 
{
   Widget label;
   Arg args[100];
   int n=0;
   XtSetArg(args[n], XmNleftPosition, x1); n++;     // % of width from left
   XtSetArg(args[n], XmNtopPosition, y1); n++;      // % of height from top
   XtSetArg(args[n], XmNresizable, False); n++;
   XtSetArg(args[n], XmNtopAttachment, XmATTACH_POSITION); n++;
   XtSetArg(args[n], XmNleftAttachment, XmATTACH_POSITION); n++;
   XtSetArg(args[n], XmNrightPosition, x2); n++;  
   XtSetArg(args[n], XmNrightAttachment, XmATTACH_POSITION); n++;
   XtSetArg(args[n], XmNbottomPosition, y2); n++;  
   XtSetArg(args[n], XmNrightAttachment, XmATTACH_POSITION); n++;
   XtSetArg(args[n], XmNbottomAttachment, XmATTACH_POSITION); n++;
   ////  Stop Motif from trying to grab another color if none are available.
   if(g.want_colormaps)  
   {    XtSetArg(args[n], XmNbackground, g.main_bcolor); n++;
        XtSetArg(args[n], XmNforeground, g.main_fcolor); n++;
   }
   switch(position)
   {  case LEFT: XtSetArg(args[n], XmNalignment, XmALIGNMENT_BEGINNING); n++; break;
      case CENTER: XtSetArg(args[n], XmNalignment, XmALIGNMENT_CENTER); n++; break;
      case RIGHT: XtSetArg(args[n], XmNalignment, XmALIGNMENT_END); n++; break;
   }
   label = XmCreateLabel(parent, string, args, n);
   XtManageChild(label);   
   return label;
} 



//--------------------------------------------------------------------//
// check_diagnose                                                     //
// Read command line options that are needed to setup xlib            //
// Test if "-diag" is on command line. If so, set g.diagnose flag.    //
//--------------------------------------------------------------------//
void check_diagnose(int argc, char **argv)
{ 
   int k;
   char tempstring[1024];
   g.diagnose=0;
   g.nosparse=0;
   g.sparse=0;
   g.visual_id_wanted = 0;       // Command line specified visual id
   g.visual_bpp_wanted = 0;      // Command line specified bpp
   for(k=1;k<argc;k++)
   {  strcpy(tempstring,argv[k]);
      strupr(tempstring);
      if(strcmp(tempstring,"-DIAG")==SAME) g.diagnose=1;  
      if(strcmp(tempstring,"-DIAGNOSE")==SAME) g.diagnose=1;  
      if(strcmp(tempstring,"-NOSPARSE")==SAME) g.nosparse=1;
      if(strcmp(tempstring,"-SPARSE")==SAME)   g.sparse=1;
      if(strcmp(tempstring,"-VISUAL")==SAME)
      {    g.visual_id_wanted =  strtoul(argv[k+1], NULL, 16);
           strcpy(argv[k+1], "-");
      }
      if(strcmp(tempstring,"-BPP")==SAME)      g.visual_bpp_wanted = atoi(argv[k+1]);
   }
   if(g.diagnose) printf("\nStarting (diagnose mode)\n");
}


//--------------------------------------------------------------------//
// handle_command_line                                                //
// Take care of command-line options (except diagnose flag)           //
//--------------------------------------------------------------------//
int handle_command_line(int argc, char **argv)
{ 
   if(g.diagnose){ printf("Handling command line...");fflush(stdout); }
   int k;
   int status=OK;
   char *macrofile = NULL;
   char *listfilename = NULL;
   char *filename = NULL;
   char tempstring[1024];
   FILE *fp;

   filename = new char[FILENAMELENGTH];
   macrofile = new char[FILENAMELENGTH];
   listfilename = new char[FILENAMELENGTH];
   macrofile[0] = 0; listfilename[0] = 0; filename[0] = 0;
   for(k=1;k<argc;k++)
   {
      strcpy(tempstring,argv[k]);
      strupr(tempstring);
      if(strcmp(tempstring,      "?"       )==SAME) showoptions();  
      else if(strcmp(tempstring, "-?"      )==SAME) showoptions();  
      else if(strcmp(tempstring, "-OPTIONS")==SAME) showoptions();
      else if(strcmp(tempstring, "-FILES"  )==SAME) strcpy(listfilename,argv[++k]); 
      else if(strcmp(tempstring, "-MACRO"  )==SAME) strcpy(macrofile,argv[++k]);
      else if(argv[k][0]!='-')   
      {   strcpy(filename,argv[k]);
          readfiles(filename,0,NULL);         // Read file(s) 
      }
   }
   switch_palette(ci);
   if(status==OK && ci>=0) switchto(ci);

   // If a file list was specified, load all the filenames in the list.
   if(strlen(listfilename))
   {  if((fp=fopen(listfilename,"rt"))!=NULL)
      {  while(!feof(fp))
         {   fgets(tempstring,99,fp);
             for(k=0;k<(int)strlen(tempstring);k++) 
                 if((uchar)tempstring[k]<=13) tempstring[k]=0;
             if(strlen(tempstring)>0)
                 readfiles(tempstring,0,NULL);
             else
                 break;   
         }
	 fclose(fp);
      }else error_message(listfilename, errno);
   }
   if(strlen(macrofile)) 
   {   readmacrofile(macrofile, g.macrotext);
       macro(g.macrotext);
   }
   if(g.diagnose) printf("done\n");
   
   delete[] filename;
   delete[] listfilename;
   delete[] macrofile;
   return status;
}


                                                                           
//--------------------------------------------------------------------//
// list - display a single list (Motif)                               //
// Can only be called if parent is main widget.                       //
//--------------------------------------------------------------------//
void list(listinfo *l) 
{
    int wc = 0;
    Widget form, *widgetlist;
    widgetlist = new Widget[100];
    form = openwindow(l, widgetlist, &wc);   
    event_loop(form);
    closewindow(l, form, widgetlist, wc);
    XtUnmanageChild(form); 
    delete[] widgetlist;
}


//--------------------------------------------------------------------//
// additemtolist                                                      //
// 'w' is the list widget to add the item to.                         //
// 'l' is a ptr to the listinfo struct                                //
// 'form' is the form widget the list is displayed on.                //
// 'showpos' can be TOP or BOTTOM. If TOP it displays first item.     //
// 'wantraise' should be 1 unless adding a lot of items.              //
//--------------------------------------------------------------------//
void additemtolist(Widget w, Widget form, char *s, int showpos, int wantraise)
{
    XmString xms;
                 // Last param = position; 0 means append to list
     if(strlen(s))
     {    XmListAddItemUnselected(w, xms = XmStringCreateSimple(s), 0);
          if(showpos==BOTTOM) XmListSetBottomPos(w, 0);  // Last item is last visible item.
          XmStringFree(xms);      
     }
     if(XtIsManaged(form) && wantraise) 
          XRaiseWindow(g.display, XtWindow(XtParent(form)));
}

//--------------------------------------------------------------------//
// select_list_item                                                   //
//--------------------------------------------------------------------//
void select_list_item(Widget w, int pos)
{ 
 static int opos = pos;
 if(pos>=0)
 {   XmListSelectPos(w,pos,False);  
     if(pos!=opos)
     {  opos=pos;
        XmListSetBottomPos(w, pos+1);
     }
 }
}


//--------------------------------------------------------------------//
// update_list                                                        //
//--------------------------------------------------------------------//
void update_list(int listno)
{
  Widget w = g.openlist[listno]->form;
  g.openlist[listno]->f2(listno); 
  if(w) XRaiseWindow(g.display, XtWindow(XtParent(w)));
}


//--------------------------------------------------------------------//
// closewindow                                                        //
// Unmanages & destroys all Widgets on an opened window. The calling  //
//   routine must maintain a dynamic array w[] of Widgets and the     //
//   Widget count wc, which are filled when openwindow() is called.   //
//--------------------------------------------------------------------//
void closewindow(listinfo *l, Widget form, Widget *widgetlist, int wc)
{
    int j,k;
    if(l->wantsave)
    {   if(message("Save list contents?", YESNOQUESTION)==YES)
           savecb(l->form, l, NULL);
    }
    XtUnmanageChild(form);
    for(k=0;k<wc;k++) XtDestroyWidget(widgetlist[k]);
    if(l->autoupdate) 
    {   for(k=0;k<g.openlistcount;k++)
        {   if(g.openlist[k] == l)
            {   for(j=k;j<g.openlistcount-1;j++)
                    g.openlist[j] = g.openlist[j+1];
                g.openlistcount--;
                break;
            } 
        }
    }
}


//--------------------------------------------------------------------//
// openwindow  (Motif version)                                        //
// same as list except remains on screen permanently. Calling routine //
// calls closewindow() to get rid of it.                              //
// Pass the address of 'helptopic', not the helptopic no. itself,     //
// since the cb would go out of scope.                                //
// Returns the list Widget in 'listwidget' so caller can add to list. //
// 'listwidget' is needed for XmListAddItemUnselected.                //
// The return widget is needed as a parameter to closewindow().       //
// The calling routine must create and maintain a dynamic array w     //
//   of Widgets which is filled when openwindow() is called. This is  //
//   used to destroy the Widgets in closewindow().                    //
//--------------------------------------------------------------------//
Widget openwindow(listinfo *l, Widget *w, int *count)
{
   int k, width=0, xsize, ysize, showtop=TOP, wc=0;
   Widget list, form, label, savebutton;
   Arg args[100];
   XmString xms;
   Cardinal n;
   int LISTTOP = 8;
   if(l->itemstoshow<7) LISTTOP=16;
   
   xsize = 440;   // Minimum size
   ysize = l->itemstoshow*16 + 100;
   if(l->firstitem>1) showtop=BOTTOM;
   wc = *count;

   //------- Calculate width -----------------------------------------//

   for(k=0;k<l->size;k++) width=max(width,(int)strlen(l->info[k]));
   xsize = max(xsize,min(640,width*8));
   xsize = max(l->width, xsize);

   //------- Create a form dialog shell widget -----------------------//

   n=0;
   XtSetArg(args[n], XmNwidth, xsize); n++;
   XtSetArg(args[n], XmNheight, ysize); n++;
   if(l->transient)
   {  XtSetArg(args[n], XmNtransient, True); n++;}
   else
   {  XtSetArg(args[n], XmNtransient, False); n++;}
   XtSetArg(args[n], XmNresizable, False); n++;
   XtSetArg(args[n], XmNautoUnmanage, False); n++;
   XtSetArg(args[n], XmNkeyboardFocusPolicy, XmEXPLICIT); n++;
   XtSetArg(args[n], XmNnavigationType, XmEXCLUSIVE_TAB_GROUP); n++;
   XtSetArg(args[n], XmNdialogTitle, xms=XmStringCreateSimple(l->title)); n++;
   ////  Stop Motif from trying to grab another color if none are available.
   if(g.want_colormaps)  
   {    XtSetArg(args[n], XmNbackground, g.main_bcolor); n++;
        XtSetArg(args[n], XmNforeground, g.main_fcolor); n++;
   }
   form = w[wc++] = XmCreateFormDialog(g.main_widget, l->title, args, n);
   l->browser = form;
   XmStringFree(xms);
   label = w[wc++] = addlabel(form, l->title, CENTER, 20, 1, 80, LISTTOP); 

   //--------Title and 'save' button----------------------------------//

   addstandardbuttons(form, &w[wc], &l->helptopic);
   wc += 3;    // addstandardbuttons adds 3 widgets
   savebutton = w[wc++] = XtVaCreateManagedWidget("Save",
         xmPushButtonWidgetClass,    form,
         XmNtopAttachment,           XmATTACH_NONE,
         XmNbottomAttachment,        XmATTACH_FORM,
         XmNleftAttachment,          XmATTACH_FORM,
         XmNrightAttachment,         XmATTACH_NONE,
         XmNwidth,                   100,
         XmNleftOffset,              335,
         XmNbottomOffset,            5,
         XmNdefaultButton,           False,
         NULL);
   if(g.want_colormaps)  
       XtVaSetValues(savebutton, XmNbackground, g.main_bcolor,
               XmNforeground, g.main_fcolor,NULL); 
   

   //------- Put scrolled list on the form ---------------------------//

   XtSetArg(args[n], XmNbottomOffset, 34); n++;
   XtSetArg(args[n], XmNtopAttachment, XmATTACH_WIDGET); n++;
   XtSetArg(args[n], XmNtopWidget, label); n++;    
   XtSetArg(args[n], XmNfractionBase, 100); n++;   // Use percentages
   XtSetArg(args[n], XmNleftAttachment, XmATTACH_FORM); n++;
   XtSetArg(args[n], XmNbottomAttachment, XmATTACH_FORM); n++;
   XtSetArg(args[n], XmNrightAttachment, XmATTACH_FORM); n++;
   XtSetArg(args[n], XmNresizable, False); n++;
   XtSetArg(args[n], XmNlistSizePolicy, XmCONSTANT); n++;
   XtSetArg(args[n], XmNselectionPolicy, XmSINGLE_SELECT); n++;
   XtSetArg(args[n], XmNscrollBarDisplayPolicy, XmAS_NEEDED); n++; 
   XtSetArg(args[n], XmNorientation, XmVERTICAL); n++;
   XtSetArg(args[n], XmNvisibleItemCount, l->itemstoshow); n++;
   ////  Stop Motif from trying to grab another color if none are available.
   if(g.want_colormaps)  
   {    XtSetArg(args[n], XmNbackground, g.main_bcolor); n++;
        XtSetArg(args[n], XmNforeground, g.main_fcolor); n++;
   }
   list = w[wc++] = XmCreateScrolledList(form, "list", args, n);
   XtAddCallback(list, XmNsingleSelectionCallback, (XtCBP)listcb, (XtP*)l);
   l->widget = list;
   XtAddCallback(savebutton, XmNactivateCallback, (XtCBP)savecb, (XtP)l);
   XtAddEventHandler(list, KeyPressMask, FALSE, (XtEH)entercb, (XtP)form);

   for(k=0;k<l->size;k++) additemtolist(list, form, l->info[k], showtop,1);
   XtManageChild(list);
   XtManageChild(form);
   XtRealizeWidget(list);
   XtRealizeWidget(form);
   *count = wc;

   if(l->autoupdate)
   {    g.openlist[g.openlistcount] = l; 
        update_list(g.openlistcount);
        g.openlistcount = min(99, 1+g.openlistcount);
        l->form = form;  //// Setting form causes window to autoraise
   } else l->form=0;
   return form;
} 


//--------------------------------------------------------------------//
// message_window_open - opens a message window that stays up until a //
// task is finished.  Caller must periodically call check_event() and //  
// call message_window_close() to close the window.                   //
//--------------------------------------------------------------------//
Widget message_window_open(char *heading)
{
   int k,n;
   XmString xms=NULL;
   Arg args[100];
   Widget w,www=0;
   n = 0;
   XtSetArg(args[n], XmNtitle, "Information"); n++;
   XtSetArg(args[n], XmNmessageString, xms); n++;
   XtSetArg(args[n], XmNnoResize, False); n++;
   XtSetArg(args[n], XmNtransient, True); n++;
   xms = XmStringCreateLtoR(heading, XmFONTLIST_DEFAULT_TAG);
   XtSetArg(args[n], XmNmessageString, xms); n++;
   XtSetArg(args[n], XmNselectionLabelString, xms) ;n++;
   ////  Stop Motif from trying to grab another color if none are available.
   if(g.want_colormaps)  
   {    XtSetArg(args[n], XmNbackground, g.main_bcolor); n++;
        XtSetArg(args[n], XmNforeground, g.main_fcolor); n++;
   }
   www = XmCreateWorkingDialog(g.main_widget, "Wait", args, n);
   w = XmMessageBoxGetChild(www,XmDIALOG_OK_BUTTON);
   XtUnmanageChild(w);
   w = XmMessageBoxGetChild(www,XmDIALOG_HELP_BUTTON);
   XtUnmanageChild(w);
   XtManageChild(www);
   XmStringFree(xms);
   XFlush(g.display);
   
   ////  Flush events to make sure window gets drawn
   send_event(XtWindow(www),Expose,0,0,100,100);
   send_event(XtWindow(XtParent(www)),Expose,0,0,100,100);
   send_event(XtWindow(XtParent(XtParent(www))),Expose,0,0,100,100);
   for(k=0;k<100;k++) check_event();
   XFlush(g.display);
   return www;
}


//--------------------------------------------------------------------//
// message_window_close                                               //
//--------------------------------------------------------------------//
void message_window_close(Widget w)
{
   XtUnmanageChild(w);
   XtDestroyWidget(w);
   XFlush(g.display);
}


//--------------------------------------------------------------------//
// progress_bar_open                                                  //
//--------------------------------------------------------------------//
void progress_bar_open(Widget &www, Widget &scrollbar)
{
   int k,n;
   XmString xms=NULL;
   char heading[128] = "Processing";
   Arg args[100];
   Widget w;
   n = 0;
   XtSetArg(args[n], XmNtitle, heading); n++;
   XtSetArg(args[n], XmNmessageString, xms); n++;
   XtSetArg(args[n], XmNnoResize, True); n++;
   XtSetArg(args[n], XmNresizable, False); n++;
   XtSetArg(args[n], XmNtransient, True); n++;
   xms = XmStringCreateLtoR(heading, XmFONTLIST_DEFAULT_TAG);
   XtSetArg(args[n], XmNmessageString, xms); n++;
   XtSetArg(args[n], XmNselectionLabelString, xms) ;n++;
   ////  Stop Motif from trying to grab another color if none are available.
   if(g.want_colormaps)  
   {    XtSetArg(args[n], XmNbackground, g.main_bcolor); n++;
        XtSetArg(args[n], XmNforeground, g.main_fcolor); n++;
   }
   www = XmCreateWorkingDialog(g.main_widget, "Wait", args, n);
   w = XmMessageBoxGetChild(www,XmDIALOG_OK_BUTTON);
   XtUnmanageChild(w);
   w = XmMessageBoxGetChild(www,XmDIALOG_HELP_BUTTON);
   XtUnmanageChild(w);
   XtManageChild(www);

   n = 0;
   XtSetArg(args[n], XmNshowArrows, False); n++;
   XtSetArg(args[n], XmNminimum, 0); n++;
   XtSetArg(args[n], XmNmaximum, 100); n++;
   XtSetArg(args[n], XmNvalue, 0); n++;
   XtSetArg(args[n], XmNheight, 20); n++;
   XtSetArg(args[n], XmNorientation, XmHORIZONTAL); n++;
   XtSetArg(args[n], XmNeditable, False); n++;
   XtSetArg(args[n], XmNsliderSize, 1); n++;
   scrollbar = XmCreateScrollBar(www, "ProgressBar", args, n);
   XtManageChild(scrollbar);
   XtRealizeWidget(scrollbar);
   XtMapWidget(scrollbar);

   XmStringFree(xms);
   XFlush(g.display);
   
   ////  Flush events to make sure window gets drawn
   send_event(XtWindow(www),Expose,0,0,100,100);
   send_event(XtWindow(XtParent(www)),Expose,0,0,100,100);
   send_event(XtWindow(XtParent(XtParent(www))),Expose,0,0,100,100);
   send_event(XtWindow(scrollbar),Expose,0,0,100,100);
   for(k=0;k<100;k++) check_event();
   XFlush(g.display);
}


//--------------------------------------------------------------------//
// progress_bar_update                                                //
//--------------------------------------------------------------------//
void progress_bar_update(Widget scrollbar, int percent)
{
   static int opercent = 0;
   XmString xms=NULL;
   char heading[128];
   sprintf(heading,"%d%c",percent,'%');
   percent = max(1, min(percent,100));
   if(percent<opercent) opercent = 0;
   xms = XmStringCreateLtoR(heading, XmFONTLIST_DEFAULT_TAG);
   XtVaSetValues(scrollbar, XmNsliderSize, percent, NULL);
  
   //// This doesn't work in lesstif for some reason

#ifndef LESSTIF_VERSION
   if(abs(percent - opercent)>=5)
   {
       XtVaSetValues(XtParent(scrollbar), XmNmessageString, xms, NULL);
       opercent = percent;
       check_event();
   }
#endif
   XmStringFree(xms);
   XFlush(g.display);
}


//--------------------------------------------------------------------//
// progress_bar_close                                                 //
//--------------------------------------------------------------------//
void progress_bar_close(Widget w)
{
   XtUnmanageChild(w);
   XtDestroyWidget(w);
   XFlush(g.display);
}




//--------------------------------------------------------------------//
// message (Motif version)                                            //
// valid modes                                                        //
// -----------                                                        //
// NONE                                                               //
// INFO                                                               //
// PROMPT                                                             //
// QUESTION                                                           //
// YESNOQUESTION                                                      //
// WARNING                                                            //
// ERROR                                                              //
// BUG                                                                //
// Space for the returnstring must be already allocated.              //
// 'maxstringsize' must be set to the buffer size of `returnstring' if//
//    mode is PROMPT.  The string will be truncated to this size.     //
// Returns one of:                                                    //
//   OK                                                               //
//   INFO = a string was entered                                      //
//   YES = user clicked Yes to yes/no question or Ok                  //
//   NO  = user clicked No button                                     //
//   CANCEL = user clicked Cancel button                              // 
//--------------------------------------------------------------------//
int message(char *heading){  return message((char*)heading, (char*)NULL, (int)INFO, (int)0); }
int message(char *heading, int mode)
{   if(mode==PROMPT) fprintf(stderr,"Error in message, line %d\n",__LINE__);
    return message((char*)heading, (char*)NULL, (int)mode, (int)50); 
}
int message(char *heading, char *returnstring, int mode, int maxstringsize)
{ 
   int alloc1=0, alloc3=0, n, ostate;
   XmString xms, xms2, xms3=NULL;
   Arg args[100];
   Widget w2=0;
   Widget www, w;

   if(mode==NONE || !g.want_messages) return YES;
   ostate = g.state;
   g.state = MESSAGE;
   clickboxinfo c;
   c.title = new char[FILENAMELENGTH];
   c.helptopic   = 34;
   c.answer = 0;
   c.form = NULL;
   c.path = NULL;
   c.maxstringsize = maxstringsize;
   if(mode==PROMPT && returnstring!=NULL) strcpy(c.title, returnstring);
   n = 0; 

   if(mode==BUG)
       xms = XmStringCreateLtoR("Internal consistency check failed", XmFONTLIST_DEFAULT_TAG);
   else
       xms = XmStringCreateLtoR(heading, XmFONTLIST_DEFAULT_TAG);
   XtSetArg(args[n], XmNmessageString, xms); n++;
   XtSetArg(args[n], XmNnoResize, False); n++;
   XtSetArg(args[n], XmNselectionLabelString, xms) ;n++;
   ////  Stop Motif from trying to grab another color if none are available.
   if(g.want_colormaps)  
   {    XtSetArg(args[n], XmNbackground, g.main_bcolor); n++;
        XtSetArg(args[n], XmNforeground, g.main_fcolor); n++;
   }
   switch(mode)  
   {  case INFO:
         XtSetArg(args[n], XmNtitle, "Information"); n++;
         www = XmCreateInformationDialog(g.main_widget, "Information", args, n);
         break;
      case PROMPT:
         XtSetArg(args[n], XmNtitle, "Information needed"); n++;
         if(returnstring[0] && returnstring!=NULL)
         {   alloc3=1;
             XtSetArg(args[n], XmNtextString,xms3=XmStringCreateSimple(returnstring));n++;
         }

         www = XmCreatePromptDialog(g.main_widget, "Prompt", args, n);
         if(g.want_colormaps)
         {    w = XtNameToWidget(www, "Text");
              XtVaSetValues(w, XmNbackground, g.main_bcolor, XmNforeground, 
                   g.main_fcolor,NULL);
         }
         if(alloc3) XmStringFree(xms3); 
         break;
      case ERROR:
         XtSetArg(args[n], XmNtitle, "Error"); n++;
         www = XmCreateErrorDialog(g.main_widget, "Error", args, n);
         break;
      case BUG:
         XtSetArg(args[n], XmNtitle, "Error"); n++;
         www = XmCreateErrorDialog(g.main_widget, "Internal Error", args, n);
         break;
      case QUESTION:         // Ok, cancel, help
         XtSetArg(args[n], XmNtitle, "Question"); n++;
         www = XmCreateQuestionDialog(g.main_widget, "Question", args, n);
         break;
      case YESNOQUESTION:    // Yes, no, cancel, help
         XtSetArg(args[n], XmNtitle, "Question"); n++;
         XtSetArg(args[n], XmNokLabelString, xms2=XmStringCreateSimple("Yes")); n++;
         www = XmCreateQuestionDialog(g.main_widget, "YesNoQuestion", args, n);
         n = 0;
         ////  Stop Motif from trying to grab another color if none are available.
         if(g.want_colormaps)  
         {    XtSetArg(args[n], XmNbackground, g.main_bcolor); n++;
              XtSetArg(args[n], XmNforeground, g.main_fcolor); n++;
         }
         w2 = XmCreatePushButton(www, "No", args, n);
         XtManageChild(w2);
         alloc1 = 1;
         XtAddCallback(w2, XmNactivateCallback, (XtCBP)nomsgcb, (XtP)&c);
         XmStringFree(xms2);
        break;
      case WARNING:
      default:
         XtSetArg(args[n], XmNtitle, "Warning"); n++;
         www = XmCreateWarningDialog(g.main_widget, "Warning", args, n);
         break;
   }
   if(mode==PROMPT)
      XtAddCallback(www, XmNokCallback, (XtCBP)promptmsgcb, (XtP)&c);
   else
      XtAddCallback(www, XmNokCallback, (XtCBP)okmsgcb, (XtP)&c);
   XtAddCallback(www, XmNcancelCallback, (XtCBP)cancelmsgcb, (XtP)&c);
   XtManageChild(www);
   XmStringFree(xms);
   while(!c.answer)
        XtAppProcessEvent(XtWidgetToApplicationContext(www),XtIMAll);
   if(mode==PROMPT && c.title[0] && c.title!=NULL && returnstring!=NULL)
   {   c.title[FILENAMELENGTH-2] = 0;
       strcpy(returnstring, c.title); 
   }
   if(alloc1) XtDestroyWidget(w2);
   XtDestroyWidget(www);
   delete[] c.title;
   g.state = ostate;
   return c.answer;
}



//--------------------------------------------------------------------// 
//  clickbox                                                          //
//--------------------------------------------------------------------// 
int clickbox(char* title, int startval, int minval,
      int maxval, void f(int answer), int helptopic)
{
   return clickbox(title,startval,minval,maxval,f,null,0,INTEGER,helptopic);
}

double clickbox(char* title, double fstartval, double fminval,
      double fmaxval, void f(double answer), int helptopic)
{
   int startval, minval, maxval, answer;
   double fanswer;
   double factor = pow(10,g.signif);
 
   startval = (int)(fstartval * factor);
   minval = (int)(fminval * factor);
   maxval = (int)(fmaxval * factor);
   answer = clickbox(title, startval, minval, maxval, null, f, g.signif, 
       FLOAT, helptopic);
   fanswer = (double)answer / factor;
   return fanswer;
}


int clickbox(char* title, int startval, int minval, int maxval, void f1(int answer),
   void f2(double answer), int decimalpoints, int type, int helptopic)
{
   Widget form, slider, text, *w;
   clickboxinfo clickboxdata[2];
   int k, n, wc=0, xsize=340, ysize=200, answer, ostate;
   Arg args[100];
   w = new Widget[100];
   char *textlabel;

   startval = max(startval, min(startval,maxval));
   if(minval==maxval)
   {    message("Value cannot currently be changed"); 
        g.getout=0;
        return startval; 
   }

   ostate = g.state;
   g.state = MESSAGE;  // Prevent graph from obscuring it
   textlabel = new char[FILENAMELENGTH];
   if(type==INTEGER)
      itoa(startval, textlabel, 10);
   else
      gcvt(startval/pow(10, g.signif), g.signif, textlabel);
   
   //------- Create a form dialog shell widget -----------------------//

   n=0;
   XtSetArg(args[n], XmNwidth, xsize); n++;
   XtSetArg(args[n], XmNheight, ysize); n++;
   XtSetArg(args[n], XmNresizable, False); n++;
   XtSetArg(args[n], XmNautoUnmanage, False); n++;
   XtSetArg(args[n], XmNtopAttachment, XmATTACH_WIDGET); n++;
   XtSetArg(args[n], XmNbottomAttachment, XmATTACH_WIDGET); n++;
   XtSetArg(args[n], XmNtitle, title); n++;
   ////  Stop Motif from trying to grab another color if none are available.
   if(g.want_colormaps)  
   {    XtSetArg(args[n], XmNbackground, g.main_bcolor); n++;
        XtSetArg(args[n], XmNforeground, g.main_fcolor); n++;
   }
   form = w[wc++] = XmCreateFormDialog(g.main_widget, "ClickboxForm", args, n);

   //--------Title for dialog box-------------------------------------//

   w[wc++] = addlabel(form,title,CENTER,1,2,99,15);

   //--------Text area------------------------------------------------//

   n = 0;
   XtSetArg(args[n], XmNcolumns, 40); n++;
   XtSetArg(args[n], XmNrows, 1); n++;
   XtSetArg(args[n], XmNvalue, textlabel); n++;
   XtSetArg(args[n], XmNleftPosition, 5); n++;     // % of width from left
   XtSetArg(args[n], XmNrightPosition, 95); n++;   // % of height from left
   XtSetArg(args[n], XmNtopPosition, 20); n++;     // % of height from top
   XtSetArg(args[n], XmNbottomPosition, 40); n++;  // % of width from top
   XtSetArg(args[n], XmNfractionBase, 100); n++;   // Use percentages
   XtSetArg(args[n], XmNtopAttachment, XmATTACH_POSITION); n++;
   XtSetArg(args[n], XmNleftAttachment, XmATTACH_POSITION); n++;
   XtSetArg(args[n], XmNbottomAttachment, XmATTACH_POSITION); n++;
   XtSetArg(args[n], XmNrightAttachment, XmATTACH_POSITION); n++;
   XtSetArg(args[n], XmNmarginHeight, 2); n++;
   XtSetArg(args[n], XmNmarginWidth, 2); n++;
   ////  Stop Motif from trying to grab another color if none are available.
   if(g.want_colormaps)  
   {    XtSetArg(args[n], XmNbackground, g.main_bcolor); n++;
        XtSetArg(args[n], XmNforeground, g.main_fcolor); n++;
   }
   text = w[wc++] = XmCreateText(form, textlabel, args, n);
   XtManageChild(text);
   
   //--------Slider---------------------------------------------------//

   n = 0;
   XtSetArg(args[n], XmNwidth, max(200,xsize-20)); n++;      
   XtSetArg(args[n], XmNleftPosition, 5); n++;     // % of width from left
   XtSetArg(args[n], XmNrightPosition, 95); n++;   // % of height from left
   XtSetArg(args[n], XmNtopPosition, 50); n++;     // % of height from top
   XtSetArg(args[n], XmNbottomPosition, 75); n++;  // % of width from top
   XtSetArg(args[n], XmNfractionBase, 100); n++;   // Use percentages
   XtSetArg(args[n], XmNtopAttachment, XmATTACH_POSITION); n++;
   XtSetArg(args[n], XmNleftAttachment, XmATTACH_POSITION); n++;
   XtSetArg(args[n], XmNbottomAttachment, XmATTACH_POSITION); n++;
   XtSetArg(args[n], XmNrightAttachment, XmATTACH_POSITION); n++;
   XtSetArg(args[n], XmNminimum, minval); n++; 
   XtSetArg(args[n], XmNmaximum, maxval); n++; 
   XtSetArg(args[n], XmNprocessingDirection,XmMAX_ON_RIGHT); n++;      
   XtSetArg(args[n], XmNhighlightOnEnter, True); n++;      
   XtSetArg(args[n], XmNincrement, 1); n++; 
   XtSetArg(args[n], XmNvalue, startval); n++; 
   XtSetArg(args[n], XmNorientation, XmHORIZONTAL); n++;      
   XtSetArg(args[n], XmNscaleHeight, 25); n++;      
#ifdef MOTIF2
   XtSetArg(args[n], XmNshowValue, XmNEAR_BORDER); n++;      
   XtSetArg(args[n], XmNshowArrows,  XmEACH_SIDE); n++;      
#else
   XtSetArg(args[n], XmNshowArrows, True); n++;      
#endif
   XtSetArg(args[n], XmNdecimalPoints, decimalpoints); n++;      
   XtSetArg(args[n], XmNhighlightThickness, 1); n++;      
   ////  Stop Motif from trying to grab another color if none are available.
   if(g.want_colormaps)  
   {    XtSetArg(args[n], XmNbackground, g.main_bcolor); n++;
        XtSetArg(args[n], XmNforeground, g.main_fcolor); n++;
   }
   slider = w[wc++] = XmCreateScale(form, "Value", args, n);
   XtManageChild(slider);


   //--------Now add callbacks so slider can change text area---------//

   clickboxdata[0].title = textlabel;
   clickboxdata[0].answer = startval;
   clickboxdata[0].fanswer = startval;
   clickboxdata[0].startval = startval;
   clickboxdata[0].minval = minval;
   clickboxdata[0].maxval = maxval;
   clickboxdata[0].type = type;
   clickboxdata[0].wantpreview = 0;
   clickboxdata[0].decimalpoints = decimalpoints;
   clickboxdata[0].form = form;
   clickboxdata[0].widget[0] = slider;
   clickboxdata[0].f1 = null;
   clickboxdata[0].f2 = null;
   clickboxdata[0].f3 = null;
   clickboxdata[0].f4 = NULL;
   XtAddCallback(text, XmNvalueChangedCallback, (XtCBP)clickboxcb, 
       (XtP)&clickboxdata[0]);

   clickboxdata[1].title = textlabel;
   clickboxdata[1].answer = startval;
   clickboxdata[1].fanswer = startval;
   clickboxdata[1].startval = startval;
   clickboxdata[1].minval = minval;
   clickboxdata[1].maxval = maxval;
   clickboxdata[1].type = type;
   clickboxdata[1].wantpreview = 0;
   clickboxdata[1].form = form;
   clickboxdata[1].widget[0] = text;
   clickboxdata[1].decimalpoints = max(0,decimalpoints);
   clickboxdata[1].f1 = f1;
   clickboxdata[1].f2 = f2;
   clickboxdata[1].f3 = null;
   clickboxdata[1].f4 = NULL;
   XtAddCallback(slider, XmNdragCallback, (XtCBP)slidercb, (XtP)&clickboxdata[1]);
   XtAddCallback(slider, XmNvalueChangedCallback,(XtCBP)slidercb, 
       (XtP)&clickboxdata[1]);

   ////  Add callbacks so hitting Return activates Ok button
   for(k=0;k<wc;k++)
      XtAddEventHandler(w[k], KeyPressMask, FALSE, (XtEH)entercb, (XtP)form);
  
   //--------Ok, Cancel, Help buttons & their callbacks---------------//

   addstandardbuttons(form, &w[wc], &helptopic);
   wc += 3;    // addstandardbuttons adds 3 widgets
   XtManageChild(form);
   event_loop(form);
   XmScaleGetValue(slider, &answer);
   XtUnmanageChild(form);
   g.state = ostate;
   for(k=0;k<wc;k++) XtDestroyWidget(w[k]);
   delete[] w;
   delete[] textlabel;
   return answer;
}


//--------------------------------------------------------------------//
// multiclick- puts integers into clickboxinfo struct by click-and-   //
// box         dragging with the mouse.                               //
//            'getout' must be reset to 0 by the calling routine.     //
//             Returns error code (0=OK)                              //
//             Calls f(), which is a calling-routine-specific func-   //
//             tion, whenever a value is changed or mouse is          //
//             clicked. This allows passed function f() to add new    //
//             buttons.                                               //
//             'a.boxtype' is 0=COUNTER, 1=SLIDER, 2=VALSLIDER        //
//                            3=BUTTONBOXSLIDER                       //
//             If 'a[0].wantpreview'==1, it adds "preview" button and //
//             only calls f() when clicked; otherwise, it calls f()   //
//             continuously.                                          //
//--------------------------------------------------------------------//
int multiclickbox(char* title, int noofboxes, clickboxinfo* a,
      void f(int values[10]), int helptopic)
{
   Widget form, *slider, *text, *w;
   clickboxinfo *clickboxdata[2];
   int k, n, wc=0, xsize, y, ypct, ysize;
   int boxsize;
   Arg args[100];
   w = new Widget[100];
   slider = new Widget[noofboxes];
   text = new Widget[noofboxes];
   clickboxdata[0] = new clickboxinfo[noofboxes];
   clickboxdata[1] = new clickboxinfo[noofboxes];
   
   char *textlabel;
   textlabel = new char[FILENAMELENGTH];
   xsize = 425;
   ysize = 150+20*noofboxes;            // overall height in pixels

   int SCALESTART=3;
   int LABELSTART=64;
   int LABELEND=85; 
   for(k=0;k<noofboxes;k++) 
      if(a[k].type == BUTTONVALSLIDER)
         { SCALESTART=18; LABELSTART=77; LABELEND=86; break; }
   
   ypct = 100/(noofboxes+2);             // % of y height for each box
   boxsize = (int)(0.9*ypct);            // height of each box in %

   //------- Create a form dialog shell widget -----------------------//

   n=0;
   XtSetArg(args[n], XmNwidth, xsize); n++;
   XtSetArg(args[n], XmNheight, ysize); n++;
   XtSetArg(args[n], XmNresizable, False); n++;
   XtSetArg(args[n], XmNautoUnmanage, False); n++;
   XtSetArg(args[n], XmNtopAttachment, XmATTACH_WIDGET); n++;
   XtSetArg(args[n], XmNbottomAttachment, XmATTACH_WIDGET); n++;
   XtSetArg(args[n], XmNtitle, title); n++;
   ////  Stop Motif from trying to grab another color if none are available.
   if(g.want_colormaps)  
   {    XtSetArg(args[n], XmNbackground, g.main_bcolor); n++;
        XtSetArg(args[n], XmNforeground, g.main_fcolor); n++;
   }
   form = w[wc++] = XmCreateFormDialog(g.main_widget, "MultiClickboxForm", args, n);

   //--------Title for dialog box-------------------------------------//

   w[wc++] = addlabel(form,title,CENTER,1,1,99,15);

   //--------Slider---------------------------------------------------//

   y = 15;
   for(k=0;k<noofboxes;k++)
   {  
       a[0].answers[k] = a[k].startval;

       w[wc++] = addlabel(form,a[k].title,LEFT,LABELSTART,y+boxsize/4,
                 LABELEND,y+boxsize+boxsize/4);
       itoa(a[k].startval, textlabel, 10);

       n = 0;
       XtSetArg(args[n], XmNwidth, 150); n++;      
       XtSetArg(args[n], XmNleftPosition, SCALESTART); n++;   // % of width from left
       XtSetArg(args[n], XmNtopPosition, y); n++;             // % of height from top
       XtSetArg(args[n], XmNbottomPosition, y+boxsize); n++;  // % of width from top
       XtSetArg(args[n], XmNrightPosition, LABELSTART); n++;// % of height from left
       XtSetArg(args[n], XmNfractionBase, 100); n++;          // Use percentages
       XtSetArg(args[n], XmNtopAttachment, XmATTACH_POSITION); n++;
       XtSetArg(args[n], XmNleftAttachment, XmATTACH_POSITION); n++;
       XtSetArg(args[n], XmNbottomAttachment, XmATTACH_POSITION); n++;
       XtSetArg(args[n], XmNrightAttachment, XmATTACH_POSITION); n++;
       XtSetArg(args[n], XmNminimum, a[k].minval); n++; 
       XtSetArg(args[n], XmNmaximum, a[k].maxval); n++; 
       XtSetArg(args[n], XmNprocessingDirection,XmMAX_ON_RIGHT); n++;      
       XtSetArg(args[n], XmNhighlightOnEnter, True); n++;      
       XtSetArg(args[n], XmNincrement, 1); n++; 
       XtSetArg(args[n], XmNvalue, a[k].startval); n++; 
       XtSetArg(args[n], XmNorientation, XmHORIZONTAL); n++;      
       XtSetArg(args[n], XmNshowValue, XmNONE); n++;      
       XtSetArg(args[n], XmNdecimalPoints, 0); n++;      
#ifdef MOTIF2
       XtSetArg(args[n], XmNshowArrows, XmEACH_SIDE); n++;      
#else
       XtSetArg(args[n], XmNshowArrows, True); n++;      
#endif
       XtSetArg(args[n], XmNhighlightThickness, 1); n++;      
       ////  Stop Motif from trying to grab another color if none are available.
       if(g.want_colormaps)  
       {    XtSetArg(args[n], XmNbackground, g.main_bcolor); n++;
            XtSetArg(args[n], XmNforeground, g.main_fcolor); n++;
       }
       slider[k] = w[wc++] = XmCreateScale(form, "MultiClickBoxScale", args, n);
       XtManageChild(slider[k]);
 
       //--------Text area------------------------------------------------//
       
       n = 0;
       XtSetArg(args[n], XmNcolumns, 12); n++;
       XtSetArg(args[n], XmNrows, 1); n++;
       XtSetArg(args[n], XmNvalue, textlabel); n++;
       XtSetArg(args[n], XmNwidth, 50); n++;      
       XtSetArg(args[n], XmNleftPosition, LABELEND+1); n++;   // % of width from left
       XtSetArg(args[n], XmNtopPosition, y+boxsize/8); n++;   // % of height from top
       XtSetArg(args[n], XmNbottomPosition, y+boxsize); n++;  // % of width from top
       XtSetArg(args[n], XmNrightPosition, 98); n++;          // % of height from left
       XtSetArg(args[n], XmNfractionBase, 100); n++;          // Use percentages
       XtSetArg(args[n], XmNtopAttachment, XmATTACH_POSITION); n++;
       XtSetArg(args[n], XmNleftAttachment, XmATTACH_POSITION); n++;
       XtSetArg(args[n], XmNbottomAttachment, XmATTACH_POSITION); n++;
       XtSetArg(args[n], XmNrightAttachment, XmATTACH_POSITION); n++;
       XtSetArg(args[n], XmNmarginHeight, 1); n++;
       XtSetArg(args[n], XmNmarginWidth, 1); n++;
       ////  Stop Motif from trying to grab another color if none are available.
       if(g.want_colormaps)  
       {    XtSetArg(args[n], XmNbackground, g.main_bcolor); n++;
            XtSetArg(args[n], XmNforeground, g.main_fcolor); n++;
       }
       clickboxdata[0][k].title = textlabel;   // copy char pointer
       clickboxdata[0][k].answer = a[k].startval;
           // An answers[] array has been allocated only for the first one.
           // All the data are accessible to all the other sliders, and all
           // are aliased to the same original array.
       clickboxdata[0][k].answers = a[0].answers; 
       clickboxdata[0][k].k = k;
       clickboxdata[0][k].startval = a[k].startval;
       clickboxdata[0][k].minval = a[k].minval;
       clickboxdata[0][k].maxval = a[k].maxval;
       clickboxdata[0][k].type = INTEGER;
       clickboxdata[0][k].wantpreview = 0;
       clickboxdata[0][k].widget[0] = slider[k];
       clickboxdata[0][k].f1 = null;
       clickboxdata[0][k].f2 = null;
       clickboxdata[0][k].f3 = f;
       clickboxdata[0][k].f4 = NULL;
       text[k] = w[wc++] = XmCreateText(form, textlabel, args, n);
       XtAddCallback(text[k], XmNvalueChangedCallback,
          (XtCBP)clickboxcb, (XtP)&clickboxdata[0][k]);
       XtManageChild(text[k]);
 
       //--------Now add a callback so slider can change text area--------//
 
       clickboxdata[1][k].title = textlabel;
       clickboxdata[1][k].answer = a[k].startval;
       clickboxdata[1][k].answers = a[0].answers;
       clickboxdata[1][k].k = k;
       clickboxdata[1][k].startval = a[k].startval;
       clickboxdata[1][k].minval = a[k].minval;
       clickboxdata[1][k].maxval = a[k].maxval;
       clickboxdata[1][k].type = INTARRAY;
       clickboxdata[1][k].wantpreview = 0;
       clickboxdata[1][k].widget[0] = text[k];
       clickboxdata[1][k].decimalpoints = 0;
       clickboxdata[1][k].f1 = null;
       clickboxdata[1][k].f2 = null;
       clickboxdata[1][k].f3 = f;
       clickboxdata[1][k].f4 = NULL;
       XtAddCallback(slider[k], XmNvalueChangedCallback,
          (XtCBP)slidercb, (XtP)&clickboxdata[1][k]);
       if(a[k].wantdragcb)
           XtAddCallback(slider[k], XmNdragCallback,
               (XtCBP)slidercb, (XtP)&clickboxdata[1][k]);
       else    //// Change label only unless mouse released
       {
           XtAddCallback(slider[k], XmNdragCallback,
               (XtCBP)slider_nof_cb, (XtP)&clickboxdata[1][k]);
           XtAddCallback(slider[k], XmNvalueChangedCallback,
               (XtCBP)slider_now_cb, (XtP)&clickboxdata[1][k]);

       }       
               //// Put widget in original list for use by callback
       a[k].widget[0] = text[k];
       if(a[k].type == BUTTONVALSLIDER)
           w[wc++] = add_pushbutton(a[k].buttonlabel,form,1,y+4,SCALESTART-1,
               y+ypct-1,&a[k]);

       y+=ypct;
   }

   ////  Add callbacks so hitting Return activates Ok button
   for(k=0;k<wc;k++)
      XtAddEventHandler(w[k], KeyPressMask, FALSE, (XtEH)entercb, (XtP)form);

   //--------Ok, Cancel, Help buttons & their callbacks---------------//


   addstandardbuttons(form, &w[wc], &helptopic);
   wc += 3;    // addstandardbuttons adds 3 widgets

   XtManageChild(form);
   event_loop(form);
   for(k=0;k<noofboxes;k++) XmScaleGetValue(slider[k], &a[k].answer);
   XtUnmanageChild(form);
   for(k=0;k<wc;k++) XtDestroyWidget(w[k]);
   delete[] w;
   delete[] textlabel;
   delete[] slider;
   delete[] text;
   delete[] clickboxdata[0];
   delete[] clickboxdata[1];
   return 0;
}


//--------------------------------------------------------------------// 
//  getstrings - max of 2 dims                                        //
//--------------------------------------------------------------------// 
void getstrings(char *title, char **label, char **answer, int dims, 
     int nstrings, int maxlen)
{
   Widget form, *text, *w, dialogshell, scrolledwindow;
   int count, h, k, n,  wc=0, xsize, ostate, helptopic=0, 
       stringleft, stringright, winheight;
   double spacing, ybotpct, ytoppct, height, ystart, labelstartypos, 
       labelendypos;
   if(dims>2){ fprintf(stderr,"dims too big at %d %s\n",__LINE__,__FILE__); return; }
   Arg args[100];
   w = new Widget[100];
   text = new Widget[nstrings*dims];
   xsize = min(500,max(340, 200 + 7*strlen(label[0])));
   ystart = 30;     // y pixel for 1st text area
   height = 26.0;   // y pixels between text areas
   if(dims==1){ stringleft=3; stringright=50; }
   else       { stringleft=3; stringright=26; }

   ostate = g.state;
   g.state = MESSAGE;  // Prevent graph from obscuring it
   winheight = cint(height * nstrings + 60);
   spacing = height * 100.0 / ((double)winheight+20);  // y percentage between text areas
   ybotpct = 4 * 100.0 / ((double)winheight+20);       // y percentage for top of label
   ytoppct = ystart * 100.0 / ((double)winheight+20);  // y percentage for 1st text area

   //------- Create a dialog shell widget ----------------------------//

   dialogshell = w[wc++] = XtVaCreateManagedWidget("GetStrings",
                                xmDialogShellWidgetClass,  g.main_widget,
                                XmNx,                      g.main_xpos+100,
                                XmNy,                      g.main_ypos+100,
                                XmNwidth,                  xsize,
                                XmNheight,                 winheight,
                                XmNminWidth,               xsize+2,
                                XmNminHeight,              min(300,winheight+2),
                                XmNmaxHeight,              300,
                                XmNresizable,              False,
                                XmNtitle,                  "Enter Data",
                                NULL);

   //------- Create a scrolled window widget -------------------------//

   n=0;
   XtSetArg(args[n], XmNwidth, xsize); n++;
   XtSetArg(args[n], XmNheight, winheight); n++;
   XtSetArg(args[n], XmNscrollingPolicy, XmAUTOMATIC); n++;
   XtSetArg(args[n], XmNresizable, False); n++;
   scrolledwindow = w[wc++] = XmCreateScrolledWindow(dialogshell, "GetStrings", args, n);

   //------- Create a form widget ------------------------------------//

   n=0;
   XtSetArg(args[n], XmNwidth, xsize); n++;
   XtSetArg(args[n], XmNheight, winheight); n++;
   XtSetArg(args[n], XmNresizable, False); n++;
   XtSetArg(args[n], XmNautoUnmanage, False); n++;
   XtSetArg(args[n], XmNtopWidget, scrolledwindow); n++;
   XtSetArg(args[n], XmNleftWidget, scrolledwindow); n++;
   XtSetArg(args[n], XmNrightWidget, scrolledwindow); n++;
   XtSetArg(args[n], XmNbottomWidget, scrolledwindow); n++;
   XtSetArg(args[n], XmNtopAttachment, XmATTACH_WIDGET); n++;
   XtSetArg(args[n], XmNbottomAttachment, XmATTACH_WIDGET); n++;
   XtSetArg(args[n], XmNleftAttachment, XmATTACH_WIDGET); n++;
   XtSetArg(args[n], XmNrightAttachment, XmATTACH_WIDGET); n++;
   XtSetArg(args[n], XmNtopOffset, 20); n++;
   XtSetArg(args[n], XmNbottomOffset, 0); n++;
   XtSetArg(args[n], XmNtitle, title); n++;
   ////  Stop Motif from trying to grab another color if none are available.
   if(g.want_colormaps)  
   {    XtSetArg(args[n], XmNbackground, g.main_bcolor); n++;
        XtSetArg(args[n], XmNforeground, g.main_fcolor); n++;
   }
   form = w[wc++] = XmCreateForm(scrolledwindow, "GetStringsForm", args, n);

   //--------Title for dialog box-------------------------------------//

   w[wc++] = addlabel(form,title,CENTER,1,ybotpct,99,ytoppct);

   //--------Text area------------------------------------------------//

   count=0;
   for(h=0;h<dims;h++)
   for(k=0;k<nstrings;k++)
   {   if(h==1){ stringleft=28; stringright=51; }
       n = 0;
       XtSetArg(args[n], XmNresizable, False); n++;
       XtSetArg(args[n], XmNrows, 1); n++;
       XtSetArg(args[n], XmNcolumns, 10); n++;
       XtSetArg(args[n], XmNleftPosition, stringleft); n++;     // % of width from left
       XtSetArg(args[n], XmNrightPosition, stringright); n++;   // % of height from left
       XtSetArg(args[n], XmNtopPosition, ytoppct+(double)k*spacing); n++;     // % of height from top
       XtSetArg(args[n], XmNbottomPosition, ytoppct+((double)(k+1)*spacing)); n++;  // % of width from top
       XtSetArg(args[n], XmNfractionBase, 100); n++;   // Use percentages
       XtSetArg(args[n], XmNtopAttachment, XmATTACH_POSITION); n++;
       XtSetArg(args[n], XmNleftAttachment, XmATTACH_POSITION); n++;
       XtSetArg(args[n], XmNbottomAttachment, XmATTACH_POSITION); n++;
       XtSetArg(args[n], XmNrightAttachment, XmATTACH_POSITION); n++;
       XtSetArg(args[n], XmNmarginHeight, 0); n++;
       XtSetArg(args[n], XmNmarginWidth, 0); n++;
       XtSetArg(args[n], XmNmaxLength, maxlen); n++;
       XtSetArg(args[n], XmNvalue, answer[count]);n++; 
       XtSetArg(args[n], XmNautoShowCursorPosition, True); n++;
       XtSetArg(args[n], XmNcursorPositionVisible, True); n++;
         ////  Stop Motif from trying to grab another color if none are available.
       if(g.want_colormaps)  
       {    XtSetArg(args[n], XmNbackground, g.main_bcolor); n++;
            XtSetArg(args[n], XmNforeground, g.main_fcolor); n++;
       }
         ////  Motif ignores this for some reason
       XtSetArg(args[n], XmNcursorPosition,(int)strlen(answer[count])); n++;
       text[count] = w[wc++] = XmCreateText(form, label[k], args, n);
       XtManageChild(text[count]);
       XtAddCallback(text[count], XmNvalueChangedCallback, 
           (XtCBP)getstringcb, (XtP)answer[count]);
       count++;
   }
   for(k=0;k<nstrings;k++)
   {   labelstartypos = ytoppct + ((double)k+0.1)*spacing;
       labelendypos = ytoppct + ((double)k+1.1)*spacing;
       w[wc++] = addlabel(form,label[k],LEFT,stringright,labelstartypos,98,labelendypos);
   }
  
   //--------Ok, Cancel, Help buttons & their callbacks---------------//

   addstandardbuttons(form, &w[wc], &helptopic);
   wc += 3;    // addstandardbuttons adds 3 widgets
   ////  Add callbacks so hitting Return activates Ok button
   for(k=0;k<wc;k++)
      XtAddEventHandler(w[k], KeyPressMask, FALSE, (XtEH)entercb, (XtP)form);

   XtManageChild(dialogshell);
   XtManageChild(scrolledwindow);
   XtManageChild(form);
   event_loop(form);
   XtUnmanageChild(form);
   XtUnmanageChild(scrolledwindow);
   XtUnmanageChild(dialogshell);
   g.state = ostate;
   for(k=0;k<wc;k++)
       XtRemoveEventHandler(w[k], KeyPressMask, FALSE, (XtEH)entercb, (XtP)form);
   for(k=0;k<wc;k++) XtDestroyWidget(w[k]);   
   delete[] w;
   delete[] text;
   g.state = ostate;
}


//--------------------------------------------------------------------//
// getstringcb - callback for getting a string in getstring.          //
//--------------------------------------------------------------------//
void getstringcb(Widget w, XtP client_data, XmACB *call_data)
{
  w=w; call_data=call_data;  // Keep compiler quiet
  char *ptr;
  char *a = (char*)client_data;
  ptr = XmTextGetString(w);
  if(ptr != NULL){  strcpy(a, ptr); XtFree(ptr); }
  return;
}


//--------------------------------------------------------------------//
// createximage - set up an XImage structure for Xlib                 //
// buf_1d is an alias for a 2d image buffer.                          //
//--------------------------------------------------------------------//
XImage *createximage(int xsize, int ysize, int bpp, uchar *buf_1d)
{
  int bitmap_pad = 8;   // Data is byte-organized
  int bytesperline=0;   // 0 means: scan lines are contiguous - X server
                        // calculates it for you 
  int offset = 0;
  XImage *ximage;
  if(g.sparse_packing && bpp==32) bpp=24;
  if(bpp==7) bpp=8;
  ximage = XCreateImage(g.display, g.visual, (uint)bpp, ZPixmap, offset,
      (char*)(buf_1d), (uint)xsize, (uint)ysize, bitmap_pad, bytesperline);
  if(ximage==NULL) fprintf(stderr,"XCreateImage failed!\n");
  return ximage;  
}



//--------------------------------------------------------------------//
// createxpixmap - set up a Pixmap structure for Xlib                 //
//--------------------------------------------------------------------//
Pixmap createxpixmap(Window win, int xsize, int ysize, int bpp)
{
  Pixmap pmap;
  if(g.sparse_packing && bpp==32) bpp=24;
  if(bpp==7) bpp=8;
  pmap = XCreatePixmap(g.display, win, xsize, ysize, bpp);
  return pmap;
}


//-------------------------------------------------------------------// 
// copyimage  (Motif) - copy a rectangular region from the screen to //
//  a buffer or from a buffer to the screen.                         //
//                                                                   //
//  If mode = GET it copies from screen to the buffer.               //
//  If mode = PUT it copies from buffer to the screen.               //
//  Copyimage always copies the upper left of the image.             //
//                                                                   //
//  x1,y1     = screen starting coordinates                          //
//  x2,y2     = screen ending coordinates                            //
//  xoff,yoff = offset into buffer to get or put image (pixel units) //
//  mode      = GET or PUT                                           //
//  buf       = an array storing the image at same bpp as screen     //
//  The coordinates are clipped to fit within theWindow, to prevent  //
//    errors from Xlib.                                              //
//  For Xlib version, you have to pass an XImage* and Window.        //
//  In Xlib, this is the slowest routine.                            //
//  In Motif, subtract x and y upper left coordinates of image       //
//     because each image is on a separate window.                   // 
//-------------------------------------------------------------------//
void copyimage(int x1, int y1, int x2, int y2, int xoff, int yoff,
                int mode, XImage *ximage, Window win)
{
   uint uw, uh;
   x1 = max(0,x1);
   y1 = max(0,y1);
   x2 = min(g.main_xsize+xoff,x2);
   y2 = min(g.main_ysize+yoff,y2);
   uw = 1+x2-x1;
   uh = 1+y2-y1;
   if(mode==GET)
   {
      XGetSubImage(g.display, win, x1, y1, 
            uw, uh, XAllPlanes(), ZPixmap, ximage, xoff, yoff);
   }
   if(mode==PUT)
   {
      XPutImage(g.display, win, g.image_gc, ximage, x1, y1,
            xoff, yoff, uw, uh);
   }
}



//--------------------------------------------------------------------//
// blackbox (Xlib)                                                    //
// blank out an area of the screen to specified color.                //
// Not permanent.                                                     //
//--------------------------------------------------------------------//
void blackbox(int x1,int y1,int x2,int y2, unsigned int color, 
    Window win)
{
   uint uw,uh;
   XWindowAttributes xwa;
   int width,height;
     
   if(win==0) win=g.main_window;
   XGetWindowAttributes(g.display, win, &xwa);
   width = xwa.width;
   height = xwa.height;
   x1 = max(0, min(width-1,x1)); 
   y1 = max(0, min(height-1,y1)); 
   x2 = max(0, min(width-1,x2)); 
   y2 = max(0 ,min(height-1,y2)); 
   uw = 1+x2-x1;
   uh = 1+y2-y1;
   uw = max(1,min(width-1,(int)uw)); 
   uh = max(1,min(height-1,(int)uh)); 
   
   XSetForeground(g.display, g.image_gc, (ulong)color);
   XFillRectangle(g.display, win, g.image_gc, x1, y1, uw, uh);
   XSetForeground(g.display, g.image_gc, (ulong)g.fcolor);
}
 
 
//--------------------------------------------------------------------//
// gradientbox (Xlib)                                                 //
// blackbox  -  blank out an area of the screen to specified color    //
// Not permanent.                                                     //
// If last parameter !=0, it increments the color between minc and    //
// maxc every n lines, creating a gradient. The last 3 parameters are //
// optional. This version works for 8,15,16, and 24 bits/pixel.       //
//--------------------------------------------------------------------//
void gradientbox(int x1,int y1,int x2,int y2, uint color, 
    uint minc, uint maxc, int n, Window win)
{
   if(win==0) win=g.main_window;
   uint c=color;
   int y,count=0;
 
   for(y=y1;y<=y2;y++)
   {   if(n)
       {   count++;
           if(count>abs(n)){ count=0; c+=sgn(n); }        
           if(n>0) if(c==maxc) c=minc;
           if(n<0) if(c==minc) c=maxc;
       }    
       XSetForeground(g.display, g.image_gc, (ulong)c);
       XDrawLine(g.display,win,g.image_gc,x1,y,x2,y);
   }
   XSetForeground(g.display, g.image_gc, (ulong)g.fcolor);
}
  


//--------------------------------------------------------------------// 
// setup_display                                                      //
// Initializes data about video resolution                            //
// Uses the global variables: type  display_type                      //
// Call after init_xlib, so that bitsperpixel is defined.             //
//--------------------------------------------------------------------//
void setup_display()
{
    ////  Display formats: 8,15,16,24,32
    int k;
    if(g.diagnose){ printf("Setting up display...");fflush(stdout); }
    
    switch(g.bitsperpixel)
    {   case 7 :  g.maxcolor=255;
                  g.want_noofcolors=3;
                  g.colortype=COLOR;
                  break;
        case 8 :  g.maxcolor=255;
                  g.want_noofcolors=1;
                  g.colortype=GRAY;
                  break;
        case 15:  if(g.fcolor==g.bcolor)
                  {   g.fcolor=32767; 
                      g.line.color=32767;
                      g.bcolor=10570;
                  }
                  g.maxcolor=32767;
                  g.colortype=COLOR;
                  g.want_noofcolors=3;
                  break;
        case 16:  if(g.fcolor==g.bcolor)
                  {   g.fcolor=65535; 
                      g.line.color=65536;
                      g.bcolor=40147;
                  }
                  g.maxcolor=65535;
                  g.colortype=COLOR;
                  g.want_noofcolors=3;
                  break;
        case 24:  if(g.fcolor==g.bcolor)
                  {   g.fcolor=16777215;  
                      g.line.color=16777215;
                      g.bcolor=4605510;              
                  }
                  g.colortype=COLOR;
                  g.maxcolor=16777215;
                  g.want_noofcolors=3;
                  break;
        case 32:  if(g.fcolor==g.bcolor)
                  {   g.fcolor=16777215;  
                      g.line.color=16777215;
                      g.bcolor=4605510;              
                  }
                  g.colortype=COLOR;
                  g.maxcolor = 16777215;
                  g.want_noofcolors=3;
                  break;
    }

    //// Internal storage formats: 8,16,24,32,48
    
    //// Pseudo 32 bits/pixel is 8 bpp of r,g, and b & ignores alpha channel.
    //// Images with 9 to 16 bpp of r,g, or b should use 48 bpp.

    g.maxred[7] =  8; g.maxgreen[7] =  8; g.maxblue[7] =  8; g.maxvalue[7] =255.0;
    g.maxred[8] = 63; g.maxgreen[8] = 63; g.maxblue[8] = 63; g.maxvalue[8] =255.0;
    g.maxred[15]= 31; g.maxgreen[15]= 31; g.maxblue[15]= 31; g.maxvalue[15]=32767.0;
    g.maxred[16]= 31; g.maxgreen[16]= 63; g.maxblue[16]= 31; g.maxvalue[16]=65535.0;
    g.maxred[24]=255; g.maxgreen[24]=255; g.maxblue[24]=255; g.maxvalue[24]=16777215.0;
    g.maxred[32]=255;   g.maxgreen[32]=255; g.maxblue[32]=255; g.maxvalue[32]=16777215.0;
    g.maxred[48]=65535; g.maxgreen[48]=65535; g.maxblue[48]=65535; 
       g.maxvalue[48]=2.814749767e14;

    g.maxgray[7] =   8;
    g.maxgray[8] = 255;
    g.maxgray[15]=  31;
    g.maxgray[16]=  31;
    g.maxgray[24]= 255;    
    g.maxgray[32]= 255;
    g.maxgray[48]= 65536;

    ////  For 8bpp, set r,g & b bits/pixel to 6 for 0..63 palette
          
    g.redbpp[7] =3;  g.greenbpp[7] =3;  g.bluebpp[7] =3;  g.blackbpp[7]=0;
    g.redbpp[8] =6;  g.greenbpp[8] =6;  g.bluebpp[8] =6;  g.blackbpp[8]=0;
    g.redbpp[15]=5;  g.greenbpp[15]=5;  g.bluebpp[15]=5;  g.blackbpp[15]=0;
    g.redbpp[16]=5;  g.greenbpp[16]=6;  g.bluebpp[16]=5;  g.blackbpp[16]=0;
    g.redbpp[24]=8;  g.greenbpp[24]=8;  g.bluebpp[24]=8;  g.blackbpp[24]=0;
    g.redbpp[32]=8;  g.greenbpp[32]=8;  g.bluebpp[32]=8;  g.blackbpp[32]=8;
    g.redbpp[48]=16; g.greenbpp[48]=16; g.bluebpp[48]=16; g.blackbpp[48]=0;

    g.want_color_type = g.colortype;
    g.want_bpp        = g.bitsperpixel;
    g.want_redbpp     = g.redbpp[g.bitsperpixel];
    g.want_greenbpp   = g.greenbpp[g.bitsperpixel];
    g.want_bluebpp    = g.bluebpp[g.bitsperpixel];
    g.want_blackbpp   = g.blackbpp[g.bitsperpixel];

    for(k=0;k<64;k++) g.off[k]=0;
    g.off[7]=1;
    g.off[8]=1;
    g.off[15]=2;
    g.off[16]=2;
    g.off[24]=3;
    g.off[32]=4;   
    g.off[48]=6;   

    g.fcolor = min(g.fcolor, g.maxcolor);
    g.line.color = min(g.line.color, g.maxcolor);
    g.bcolor = min(g.bcolor, g.maxcolor);    
    if(g.diagnose)
    {   printf("done \n");
        printf("  color type %d \n",g.colortype);
        printf("  bits/pixel %d \n",g.bitsperpixel);
        printf("  fcolor     %d \n",g.fcolor);
        printf("  bcolor     %d \n",g.bcolor);
        printf("  line color %d \n",g.line.color);
    }
}       



//--------------------------------------------------------------------//
// savetouchedimages  - returns OK or ABORT                           //
//--------------------------------------------------------------------//
int savetouchedimages(void)
{  int k;
   int status=OK;
   for(k=0; k<g.image_count; k++) 
   {   if(z[k].touched) status = save_ok(k);
       if(status==ABORT) return ABORT;
   }
   return OK;
}



//--------------------------------------------------------------------//
// save_ok - returns YES if all images have been saved & ok to quit.  //
//           Returns NO if user clicks "no".                          //
//           Returns ABORT if user clicks "cancel"                    //
//--------------------------------------------------------------------//
int save_ok(int ino)
{  
    char name[FILENAMELENGTH];
    int answer=YES;
    if(memorylessthan(4096)){ message(g.nomemory,ERROR); return(ABORT); } 
    char tempstring[128];
    g.getout=0;
    if(ino<0) return(ERROR);                // should not happen
    if(strlen(z[ino].name) >0 )
       strcpy(name, z[ino].name);
    else
       strcpy(name, "[Untitled]");
    sprintf(tempstring,"Save image #%d? \n(%s)",ino,name);

    switch(message(tempstring,YESNOQUESTION))
    {  case YES: saveimage(ino,0,NULL); 
                 answer=YES; 
                 if(g.getout)answer=ABORT;  // Clicked Cancel in saveimage()
                 break;
       case NO:  answer=NO; break;          // No, dont save but ok to quit
       case CANCEL: answer=ABORT; break;    // Clicked Cancel in message box
    }
    return(answer);
}






//--------------------------------------------------------------------//
// cant_overwrite_file - returns 1 if file exists & dont want to      //
// erase it                                                           //
//--------------------------------------------------------------------//
int cant_overwrite_file(char* filename)
{
     if(memorylessthan(4096)){  message(g.nomemory,ERROR); return(ABORT); } 
     char temp[2048];
     if(!access(filename,F_OK))
     {  sprintf(temp,"Overwrite existing file\n%s (y/n)?",filename);
        if(message(temp,QUESTION)!=YES)
        {  message("File transfer aborted",WARNING); 
           return(ABORT);
        }
     }
     return(OK);
}


//--------------------------------------------------------------------//
// getbox                                                             //
// General routine for getting upper left and lower right coordinates //
// of a screen rectangle with the mouse.                              //
// The 4 parameters are passed by reference. They are automatically   //
// sorted before being returned. If user clicks right button, the     //
// parameters are left unchanged.                                     //
// Returns the mouse button clicked.                                  //
//--------------------------------------------------------------------//
int getbox(int &x1,int &y1,int &x2,int &y2)
{ 
   drawselectbox(OFF);
   g.state = GETBOX;
   g.selected_is_square=1;
   g.getout = 0;

   // This loop allows other events to happen without using up CPU time.
   // XtAppProcessEvent can't be in a separate subroutine or it will 
   // never return.
   
   while(g.state==GETBOX && g.getout==0)
        XtAppProcessEvent(XtWidgetToApplicationContext(g.drawing_area),XtIMAll);

   x1 = g.get_x1;  
   y1 = g.get_y1;
   x2 = g.get_x2;  
   y2 = g.get_y2;
   if(x1>x2) swap(x1,x2);
   if(y1>y2) swap(y1,y2);
   drawselectbox(OFF);
   return g.mouse_button;
}



//--------------------------------------------------------------------//
// getpoint                                                           //
// General routine for getting a x,y point with the mouse.            //
// Returns the mouse button clicked, so can also wait for a button.   //
//--------------------------------------------------------------------//
int getpoint(int &x,int &y)
{ 
   getpointstate = GETPOINT;

   // This loop allows other events to happen without using up CPU time.
   // XtAppProcessEvent can't be in a separate subroutine or it will 
   // never return.
   
   g.dialogdone = 0;
   while(getpointstate==GETPOINT && g.getout==0 && !g.dialogdone) 
        XtAppProcessEvent(XtWidgetToApplicationContext(g.drawing_area),XtIMAll);

   x = g.get_x1;  
   y = g.get_y1;
   return g.mouse_button;
}


//--------------------------------------------------------------------//
// getline                                                            //
//--------------------------------------------------------------------//
void getline(int &x1, int &y1, int &x2, int &y2)
{
   drawselectbox(OFF);
   g.state = GETLINE;
   
   // This loop allows other events to happen without using up CPU time.
   // XtAppProcessEvent can't be in a separate subroutine or it will 
   // never return.

   g.draw_figure = TEMPLINE;   
   g.dialogdone = 0;
   while(g.state==GETLINE && g.getout==0 && !g.dialogdone)
        XtAppProcessEvent(XtWidgetToApplicationContext(g.drawing_area),XtIMAll);

   g.draw_figure = NONE;   
   x1 = g.get_x1;  
   y1 = g.get_y1;
   x2 = g.get_x2;  
   y2 = g.get_y2;
   drawselectbox(OFF);
 }



//--------------------------------------------------------------------//
// drawselectbox                                                      //
// Put a dashed box around the selected area and background tasks     //
// such as drawing figures (called by timer_callback once/second and  //
// whenever mouse moves with left button pressed).                    //
// 'mode' can be ON or OFF.                                           //
//--------------------------------------------------------------------//
void drawselectbox(int mode)
{
   static int *save1=NULL, *save2=NULL, *save3=NULL, *save4=NULL;
   static int s=0,allocated=0;
   static int ox1=0, ox2=0, oy1=0, oy2=0, osquare=0;
   int color,count,i,j,x1,x2,y1,y2; 
   int black = BlackPixel(g.display, g.screen);
   int white = WhitePixel(g.display, g.screen);

   if(g.state==GETBOX)
   {    x1 = g.get_x1;
        x2 = g.get_x2;
        y1 = g.get_y1;
        y2 = g.get_y2;
   }else
   {    x1 = g.selected_ulx;
        x2 = g.selected_lrx;
        y1 = g.selected_uly;
        y2 = g.selected_lry;
   }
   if(x1>x2) swap(x1,x2);
   if(y1>y2) swap(y1,y2);
   if(x1==x2 && y1==y2) return;
   g.inmenu++;
   s++; 
   if(s>=2*g.spacing) s=0;
   crosshairs(0, 0);

   switch(mode)
   {   case ON:
           if(allocated && (x1!=ox1 || x2!=ox2 || y1!=oy1 || y2!=oy2 ))
           {  
               resetselectbox(ox1,oy1,ox2,oy2,save1,save2,save3,save4,osquare);
               allocated=0;  
           }
           if(!allocated) 
           {  
               if(g.selected_is_square)
               {   
                   save1 = new int[x2-x1+2];
                   save2 = new int[x2-x1+2];
                   save3 = new int[y2-y1+2];
                   save4 = new int[y2-y1+2];
                   allocated=1;
                   for(i=x1;i<=x2;i++)
                   {   save1[i-x1] = readpixel(i,y1);
                       save2[i-x1] = readpixel(i,y2);
                   }
                   for(j=y1;j<=y2;j++)
                   {   save3[j-y1] = readpixel(x1,j);
                       save4[j-y1] = readpixel(x2,j);
                   }
                   dashed_box(x1,y1,x2,y2,white,black,g.spacing,SET);
               }else
               {  
                   save1 = new int[(x2-x1+2)*(y2-y1+2)];
                   save2 = NULL;
                   save3 = NULL;
                   save4 = NULL;
                   allocated=1;
                   count=0;
                   for(j=y1;j<=y2;j++)
                   for(i=x1;i<=x2;i++)
                       save1[count++] = readpixel(i,j);
               }
               s=0;
           }else
           {  
              if(g.selected_is_square)
              {  
                 for(i=x1+s; i<x2; i+=2*g.spacing)
                 {   setpixel(i,y1,white,SET);
                     setpixel(i,y2,white,SET);
                     if(i+g.spacing>x2) continue;
                     setpixel(i+g.spacing,y1,black,SET);
                     setpixel(i+g.spacing,y2,black,SET);
                 }
                 for(j=y1+s;j<y2;j+=2*g.spacing)
                 {   setpixel(x1,j,white,SET);
                     setpixel(x2,j,white,SET);
                     if(j+g.spacing>y2) continue;
                     setpixel(x1,j+g.spacing,black,SET);
                     setpixel(x2,j+g.spacing,black,SET); 
                 }
              }else if(between(g.region_ino, 0, g.image_count-1))
              {  
                 for(j=y1;j<y2;j++)
                 for(i=x1;i<x2;i++)
                 {   
                     if((s+i>>2)&1)color=white; else color=black;
                     if(inside_irregular_region(i,j)==3) setpixel(i,j,color,SET);
                 }
              }  
           }
           break;
       default:
           if(allocated) 
              resetselectbox(ox1,oy1,ox2,oy2,save1,save2,save3,save4,osquare);
           allocated=0;
           break;
   }     
   osquare=g.selected_is_square;
   ox1=x1; ox2=x2; oy1=y1; oy2=y2;
   g.inmenu--;
}


//--------------------------------------------------------------------//
// resetselectbox                                                     //
//--------------------------------------------------------------------//
void resetselectbox(int x1, int y1, int x2, int y2, int *save1, int *save2,
                    int *save3, int *save4, int square)
{
    static int inreset=0;
    if(inreset) return;
    inreset=1;
    int i,j,count=0;
    if(square)
    {   
        g.inmenu++;
        for(i=x1;i<=x2;i++)
        {   setpixel(i,y1,save1[i-x1],SET);
            setpixel(i,y2,save2[i-x1],SET);
        }
        for(j=y1;j<=y2;j++)
        {   setpixel(x1,j,save3[j-y1],SET);
            setpixel(x2,j,save4[j-y1],SET);
        }
        if(save1!=NULL) delete[] save1; save1=NULL;
        if(save2!=NULL) delete[] save2; save2=NULL;
        if(save3!=NULL) delete[] save3; save3=NULL;
        if(save4!=NULL) delete[] save4; save4=NULL;
        g.inmenu--;
    }else
    {   
        if((y2-y1)*(x2-x1) < 16000)  // If small, just put the pixels back
        {  for(j=y1;j<=y2;j++)
           for(i=x1;i<=x2;i++)
                  setpixel(i,j,save1[count++],SET);
        }else if(between(g.region_ino, 0, g.image_count-1))
        {  rebuild_display(g.region_ino);
           redraw(g.region_ino);
        }
        if(save1!=NULL) delete[] save1; save1=NULL;
    }
    inreset=0;
}


//--------------------------------------------------------------------//
// draw - Figure drawing with unsorted coordinates                    //
//--------------------------------------------------------------------//
void draw(int mode)
{
   int dx,dy,ino,bpp,x,y,xx1,xx2,yy1,yy2,zoom;
   double angle;
   static int ox,oy,oxx1,oxx2,oyy1,oyy2,odiameter,ozoom;
   xx1 = g.get_x1;
   xx2 = g.get_x2;
   yy1 = g.get_y1;
   yy2 = g.get_y2;
   x = g.mouse_x;
   y = g.mouse_y;  
   int hitinmenu=0;

   ino = whichimage(x,y,bpp);
   if(ino>=0 && z[ino].is_zoomed) zoom=1; else zoom=0;
   if(mode!=END)
   {  switch(g.draw_figure)
      {            // For figures that only set pixels when mode==END:
                   // 'inmenu=1' prevents pixels from sticking on image.
         case LINE:
         case BOX:   
         case ARROW:  
         case CIRCLE: g.inmenu++; hitinmenu=1; break;
         default:     break;
      }
   }
   if(!g.inmenu)
   {
      x = zoom_x_coordinate(x,g.imageatcursor);
      y = zoom_y_coordinate(y,g.imageatcursor);
      xx1 = zoom_x_coordinate(xx1,g.imageatcursor);
      yy1 = zoom_y_coordinate(yy1,g.imageatcursor);
      xx2 = zoom_x_coordinate(xx2,g.imageatcursor);
      yy2 = zoom_y_coordinate(yy2,g.imageatcursor);
   }

   switch(g.draw_figure)
   {  case LINE:
         if(mode==START)
            line(xx1,yy1,xx2,yy2,g.maxcolor,XOR,&g.line);
         if(mode==CONTINUE)
         {  line(oxx1,oyy1,oxx2,oyy2,g.maxcolor,XOR,&g.line);
            line(xx1,yy1,xx2,yy2,g.maxcolor,XOR,&g.line);
         }
         if(mode==END)
         { 
            g.inmenu++;
            line(oxx1,oyy1,oxx2,oyy2,g.maxcolor,XOR,&g.line);
            g.inmenu--;
            line(xx1,yy1,xx2,yy2,g.fcolor,g.imode,&g.line);
         }
         break;
      case TEMPLINE:
         if(mode==START)
            line(xx1,yy1,xx2,yy2,g.maxcolor,XOR);
         if(mode==CONTINUE)
         {  line(oxx1,oyy1,oxx2,oyy2,g.maxcolor,XOR);
            line(xx1,yy1,xx2,yy2,g.maxcolor,XOR);
         }
         if(mode==END)
         {  line(oxx1,oyy1,oxx2,oyy2,g.maxcolor,XOR);
            if(g.draw_figure==LINE)  
                line(xx1,yy1,xx2,yy2,g.fcolor,g.imode);
         }
         break;
      case ARROW:
         if(mode==START)
            line(xx1,yy1,xx2,yy2,g.maxcolor,XOR,&g.line);
         if(mode==CONTINUE)
         {  line(oxx1,oyy1,oxx2,oyy2,g.maxcolor,XOR,&g.line);
            line(xx1,yy1,xx2,yy2,g.maxcolor,XOR,&g.line);
         }
         if(mode==END)
         { 
            g.inmenu++;
            line(oxx1,oyy1,oxx2,oyy2,g.maxcolor,XOR,&g.line);
            g.inmenu--;
            ////  Shorten the line so wide lines don't extend past arrow
            angle = atan2(yy2-yy1,xx2-xx1);
            dx = cint(g.line.arrow_inner_length * cos(angle));
            dy = cint(g.line.arrow_inner_length * sin(angle));
            x = xx1+dx;
            y = yy1+dy;
            line(x,y,xx2,yy2,g.fcolor,g.imode,&g.line);
            draw_arrow(xx1,yy1,xx2,yy2,&g.line);
         }
         break;
      case BOX:      
         if(mode==START)
            box(xx1,yy1,xx2,yy2,g.maxcolor,XOR,&g.line);
         if(mode==CONTINUE)
         { 
            box(oxx1,oyy1,oxx2,oyy2,g.maxcolor,XOR,&g.line);
            box(xx1,yy1,xx2,yy2,g.maxcolor,XOR,&g.line);
         }
         if(mode==END)
         {   
             g.inmenu++;
             box(oxx1,oyy1,oxx2,oyy2,g.maxcolor,XOR,&g.line);
             g.inmenu--;
             box(xx1,yy1,xx2,yy2,g.fcolor,g.imode,&g.line);
         }
         break;
      case SKETCH:  
         if(mode!=START && zoom==ozoom)
            sketch(ox,oy,x,y,g.fcolor,g.imode,&g.line);
         break;
      case CIRCLE:  
         if(mode==START)
            circle(x,y,g.diameter,g.maxcolor,XOR);
         if(mode==CONTINUE)
         {  circle(ox,oy,odiameter,g.maxcolor,XOR);
            circle(x,y,g.diameter,g.maxcolor,XOR);   
         }
         if(mode==END)
         {  circle(ox,oy,odiameter,g.maxcolor,XOR);
            circle(x,y,g.diameter,g.fcolor,g.imode);
         }
         odiameter=g.diameter;
         break;
      default: break; 
   }
   if(hitinmenu) g.inmenu--;
   ozoom=zoom;
   ox=x;oy=y;
   oxx1=xx1;
   oxx2=xx2;
   oyy1=yy1;
   oyy2=yy2;
}


    
//--------------------------------------------------------------------// 
// getcolor - enter a color value or RGB values if in color mode.     //
//           Returns answer in a ref so that starting value is shown. //
//           The optional parameter bpp is bits/pixel to use. If 0, i //
//             uses current screen bitsperpixel.                      //
//           The optional parameter cmyk changes the printed strings  //
//             only, for getting cmy values.                          //
//--------------------------------------------------------------------//
uint getcolor(char* title, uint color, int bpp, int cmyk)
{
   int c=0,rr,gg,bb;
   if(memorylessthan(16384)){ message(g.nomemory,ERROR); return color; }
   clickboxinfo* item;
   if(bpp==0) bpp=g.bitsperpixel;
   if(bpp==8)
       c = clickbox(title,color,0,g.maxcolor,samplecolor,0);
   else
   {   item = new clickboxinfo[3];
       item[0].title = new char[128];
       valuetoRGB(color,rr,gg,bb,bpp);
       if(cmyk)
          strcpy(item[0].title,"Cyan");
       else
          strcpy(item[0].title,"Red");
       item[0].startval = rr;
       item[0].minval = 0;
       item[0].maxval = g.maxred[bpp];
       item[0].type = 2;
       item[0].answers = new int[10]; // Must be 10 for multiclickbox cb
       item[0].wantdragcb = 1;
       item[0].wantpreview = 0;

       item[1].title = new char[128];
       if(cmyk)
          strcpy(item[1].title,"Magenta");
       else
          strcpy(item[1].title,"Green");
       item[1].startval = gg;
       item[1].minval = 0;
       item[1].maxval = g.maxgreen[bpp];
       item[1].type = 2;
       item[1].wantdragcb = 1;

       item[2].title = new char[128];
       if(cmyk)
          strcpy(item[2].title,"Yellow");
       else
          strcpy(item[2].title,"Blue");
       item[2].startval = bb;
       item[2].minval = 0;
       item[2].maxval = g.maxblue[bpp];
       item[2].type = 2;
       item[2].wantdragcb = 1;
       if(cmyk)
          multiclickbox(title, 3, item, null,0);
       else
          multiclickbox(title, 3, item, samplecolor,0);
       rr = item[0].answer;
       gg = item[1].answer;
       bb = item[2].answer;
       c = RGBvalue(rr,gg,bb,bpp);
       delete[] item[0].answers;
       delete[] item[0].title;
       delete[] item[1].title;
       delete[] item[2].title;
       delete[] item;                                   
   }       
   if(g.getout){ c=color; g.getout=0; }
   return c;
} 



//--------------------------------------------------------------------//
// Callbacks                                                          //
//--------------------------------------------------------------------//

//--------------------------------------------------------------------//
// clickboxcb - callback for getting a value in dialog box.  Called   //
// by a text widget. Reads the Widget's string, converts it to an     //
// integer, checks it against the values in the clickboxinfo struct,  //
// and sets the slider value in the 'c->widget' (which must be a      //
// XmScale).                                                          // 
//--------------------------------------------------------------------//
void clickboxcb(Widget w, XtP client_data, XmACB *call_data)
{
  call_data=call_data;  // Keep compiler quiet
  int answer=0;
  double fanswer=0;
  char *string = NULL;
  clickboxinfo *c = (clickboxinfo*)client_data;
  string = XmTextGetString(w);  // This allocates memory for string
  if(string != NULL) 
  {   if(c->type==INTEGER) 
      {    answer = atoi(string);
           answer=max(min(answer,c->maxval),c->minval);
           XmScaleSetValue(c->widget[0], answer);
      }
      if(c->type==FLOAT) 
      {    fanswer = atof(string) * 1.00000001 * pow(10, g.signif);
           c->fanswer = fanswer;
           fanswer=max(min(fanswer,c->maxval),c->minval);
           XmScaleSetValue(c->widget[0], (int)(fanswer));
      }
      XtFree(string);
  }
}




//--------------------------------------------------------------------//
// slidercb - Called by a slider widget, reads the slider's value,    //
// Widget's string, converts it to a string, and sets the text in the //
// 'c->widget' (which must be a XmText).                              //
//--------------------------------------------------------------------//
void slidercb(Widget w, XtP client_data, XmACB *call_data)
{
  call_data=call_data;  // Keep compiler quiet
  int answer=0;
  double fanswer=0.0;
  char *string = new char[256];
  strcpy(string," ");
  clickboxinfo *c = (clickboxinfo*)client_data;
  XmScaleGetValue(w, &answer);

  switch(c->type)
  {     case INTEGER: 
             c->f1(answer);  
             itoa(answer, string, 10); 
             break;
        case FLOAT:
             fanswer = ((double)answer)/pow(10, g.signif);  
             c->fanswer = fanswer;
             c->f2(fanswer); 
             gcvt(fanswer, g.signif, string); 
             break;
        case INTARRAY:
             c->answers[c->k] = answer;
             c->answer = answer;
             c->f3(c->answers);
             itoa(c->answers[c->k], string, 10); 
             break;
  }
  XmTextSetString(c->widget[0], string);
  delete[] string;
}


//--------------------------------------------------------------------//
// slider_nof_cb - Same as slidercb except doesn't call function.     //
//--------------------------------------------------------------------//
void slider_nof_cb(Widget w, XtP client_data, XmACB *call_data)
{
  call_data=call_data;  // Keep compiler quiet
  int answer=0;
  double fanswer=0.0;
  char *string = new char[256];
  strcpy(string," ");
  clickboxinfo *c = (clickboxinfo*)client_data;
  XmScaleGetValue(w, &answer);

  switch(c->type)
  {     case INTEGER: 
             itoa(answer, string, 10); 
             break;
        case FLOAT:
             fanswer = ((double)answer)/pow(10, g.signif);  
             c->fanswer = fanswer;
             gcvt(fanswer, g.signif, string); 
             break;
        case INTARRAY:
             c->answers[c->k] = answer;
             c->answer = answer;
             itoa(c->answers[c->k], string, 10); 
             break;
  }
  XmTextSetString(c->widget[0], string);
  delete[] string;
}


//--------------------------------------------------------------------//
// slider_now_cb - Same as slidercb except doesn't call widget.       //
//--------------------------------------------------------------------//
void slider_now_cb(Widget w, XtP client_data, XmACB *call_data)
{ 
  w=w;
  call_data=call_data;  // Keep compiler quiet
  int answer=0;
  double fanswer=0.0;
  clickboxinfo *c = (clickboxinfo*)client_data;
  switch(c->type)
  {     case INTEGER: c->f1(answer); break;
        case FLOAT:   c->f2(fanswer); break;
        case INTARRAY: c->f3(c->answers); break;
  }
}


//--------------------------------------------------------------------//
// timer_callback                                                     //
// Callback function for asynchronous or automatic events             //
//--------------------------------------------------------------------//
void timer_callback(XtP client_data, XtIntervalId *timer_id)
{  
    XEvent event;
    XtAppContext xtapc; 
    client_data=client_data; timer_id=timer_id;  // Keep compiler quiet
    // Restart timer once every 'DELAY' milliseconds
    int DELAY = 256;
    if(g.state==GETBOX) DELAY=128;
    if(g.moving) DELAY=64;
    if(!g.selected_is_square) DELAY=SLOW_DELAY;  // Remove if your computer is fast enough
    xtapc = XtWidgetToApplicationContext(g.main_widget);
    if(XCheckMaskEvent(g.display, g.main_mask | g.mouse_mask, &event))
       XtAppProcessEvent(xtapc, XtIMAll);
    XtAppAddTimeOut(xtapc, DELAY, timer_callback, NULL);
    if(g.selectedimage==-1 && g.state==NORMAL) drawselectbox(ON);
    if(g.state==GETBOX) drawselectbox(ON);
    if(g.want_slew && g.state!=BUSY) switch(g.moving)
    {  case 0: break;
       case 1: upcb((Widget)0, (XtP)0, (XtP)0); break;
       case 2: downcb((Widget)0, (XtP)0, (XtP)0); break;
       case 3: leftcb((Widget)0, (XtP)0, (XtP)0); break;
       case 4: rightcb((Widget)0, (XtP)0, (XtP)0); break;
    }
}
 

//--------------------------------------------------------------------//
// infocb  - handle expose events for information_area                //
//--------------------------------------------------------------------//
void infocb(Widget widget, XtP client_data, XtP *call_data)
{  
   widget=widget;client_data=client_data;call_data=call_data;
   printstatus(g.state);
   printcoordinates(g.mouse_x, g.mouse_y, 1); 
}

 
//--------------------------------------------------------------------//
// drawcb                                                             //
// This is the main callback for events in the main drawing area.     //
// Also handles input events for images.                              //
// Don't use 'widget' or call_data->window for anything, they don't   //
// always point to the correct window.                                //
//--------------------------------------------------------------------//
void drawcb(Widget widget, XtP client_data, XtP *call_data)
{ 
  widget=widget; client_data=client_data; // Keep compiler quiet
  XmDrawingAreaCallbackStruct *ptr;
  ptr = (XmDrawingAreaCallbackStruct*) call_data;
  int bufsize=20;
  int bpp, iii,key_x, key_y,rx,ry,wx,wy; 
  KeySym key;
  XComposeStatus compose;
  char buffer[20];
  char s[10]="";
  XEvent event;
  XKeyEvent keyevent;
  uint keys,keystate;
  Window rwin, cwin;
  if(g.main_window==0) return;

                       // Find current position of theWindow & image number
  XQueryPointer(g.display,g.main_window,&rwin,&cwin,&rx,&ry,&wx,&wy,&keys);
  g.main_xpos = rx-wx;
  g.main_ypos = ry-wy;

  if(ptr==NULL) return;
  switch(ptr->reason)
  {  
     case XmCR_RESIZE:
       break;
     case XmCR_EXPOSE:
       printstatus(REDRAW);
       event = *(ptr->event);
       printstatus(g.state);
       break;
     case XmCR_INPUT:
       if(ptr->event==NULL) break;
       event = *(ptr->event);

       ////  All X events except MotionNotify in the image window are handled
       ////  here.

       switch(ptr->event->type)
       {  case KeyPress: 
            keyevent = event.xkey;
            keystate = event.xkey.state;
            key_x    = event.xkey.x;
            key_y    = event.xkey.y;
            
            g.key_alt = 0;
            if(keystate & ControlMask) g.key_ctrl=1;
            if(keystate & Mod1Mask) g.key_alt=1;
            if(keystate & Mod3Mask) g.key_alt=1;
            if(keystate & ShiftMask) g.key_shift=1;

            iii = whichimage(g.mouse_x, g.mouse_y, bpp);
            if(iii<0 || z[iii].permanent) g.imageatcursor = iii;

            // Because each image has a separate window, add image position to
            // key coordinates to get screen coordinates.

            if(g.imageatcursor>=0)
            {   key_x += z[g.imageatcursor].xpos;
                key_y += z[g.imageatcursor].ypos;
            }

            XLookupString(&keyevent,buffer,bufsize,&key,&compose);
            g.key_ascii= key & 0xff; // A global, reset to 0 by getcharacter()
            s[0] = (uint)g.key_ascii;
            s[1] = ((uint)key)>>8;
            s[2] = 0;
            s[3] = 0;

            ////  If the key is a menu mnemonic, send the focus over to menu 
            ////  so alt-F pops up a menu.   

            if(g.key_alt && strchr("fipcdaoh", g.key_ascii))
                 XtSetKeyboardFocus(g.main_widget, g.menubar);
            else
                 print(s, g.mouse_x, g.mouse_y, g.fcolor, g.bcolor, &g.image_gc, 
                     g.main_window, 0, g.text_direction);
            break;
          case Expose: fprintf(stderr, "Expose event in wrong place\n"); break;
          case KeyRelease:   break;
          case MotionNotify: break;   //  MotionNotify is handled in 'mousecb'.
          case ButtonPress: 
              g.mouse_button = (int)event.xbutton.button;
              handle_button_press(); 
              break;
          case ButtonRelease: 
              handle_button_release(); break;
          default: break;
       }  
       break;
     default:
       fprintf(stderr,"Unknown event at %d\n",__LINE__);
       break;
  }
}



//--------------------------------------------------------------------//
// handle_button_press                                                //
//--------------------------------------------------------------------//
void handle_button_press(void)
{
   if(g.state==MESSAGE) return;  // Stop it from selecting if mouse clicked in message
   g.get_x1 = g.mouse_x;
   g.get_y1 = g.mouse_y;
   g.get_x2 = g.mouse_x;
   g.get_y2 = g.mouse_y;

   ////  If clicking on an image, bring it to the foreground. 
   ////  If clicking on bkgd, set bkgd palette & turn off selected area.                                          //
   ////  If image is already in foreground, switch to the image's  
   ////  palette and select it.                         
   ////  If clicking on selected area, copy it.
   ////  If double-clicking inside preselected rectangular area, identify
   ////  everything in the area as an object.

   
   if(g.imageatcursor==-1)        
   {  setSVGApalette(-4); 
      switchto(-1);
   }

   if(mouse_near_selection) 
      g.state=COPY;
   else if((g.imageatcursor >= 0) && (g.imageatcursor != ci)) // Switch images
   {  switchto(g.imageatcursor);
      if(ci>=0) setpalette(z[ci].palette);
   }else if(g.selectedimage>-1 || !insidebox(g.mouse_x, g.mouse_y,
      g.selected_ulx, g.selected_uly, g.selected_lrx, g.selected_lry))
   {  selectimage(g.imageatcursor);   
      if(g.imageatcursor>=0) setpalette(z[g.imageatcursor].palette);
   } 
   if(g.draw_figure) draw(START);
   printstatus(g.state);

#ifdef LINUX
   if(g.state == GETBOX || g.state == GETLINE) usleep(500);
#endif
   XtSetKeyboardFocus(g.main_widget, g.drawing_area);
}
 

//--------------------------------------------------------------------//
// handle_button_release                                              //
//--------------------------------------------------------------------//
void handle_button_release(void)
{
   static double oldtime=0.0;
   int msec;
   double newtime;

   g.mouse_button = 0;
   g.get_x2 = g.mouse_x;
   g.get_y2 = g.mouse_y;
   if(g.state==SELECT)   //// Selecting rectangular area
   {   g.selected_lrx = g.mouse_x;
       g.selected_lry = g.mouse_y;
       g.state = NORMAL;
       if(g.selected_ulx>g.selected_lrx) swap(g.selected_ulx,g.selected_lrx);
       if(g.selected_uly>g.selected_lry) swap(g.selected_uly,g.selected_lry);
       g.ulx = zoom_x_coordinate(g.selected_ulx, g.imageatcursor);
       g.uly = zoom_y_coordinate(g.selected_uly, g.imageatcursor);
       g.lrx = zoom_x_coordinate(g.selected_lrx, g.imageatcursor);
       g.lry = zoom_y_coordinate(g.selected_lry, g.imageatcursor);
   }else
   {   newtime = checktime(RESET);
       msec = int((newtime-oldtime)*1000); 
       if(msec<g.double_click_msec && oldtime!=0.0)
       {   if(!g.draw_figure && g.state==NORMAL)
               identify_object(g.mouse_x, g.mouse_y);
           g.state=NORMAL;
       }
       oldtime = newtime;
   }

       ////  If selected area is too small, throw it back
   if(abs(g.selected_ulx-g.selected_lrx)<2 || 
      abs(g.selected_uly-g.selected_lry)<2)
   {   selectimage(g.imageatcursor);
       g.ulx=0;g.lrx=0;g.uly=0;g.lry=0;
   }
   if(g.state==GETBOX && (g.get_x1!=g.get_x2 || g.get_y1!=g.get_y2))g.state = NORMAL;
   if(g.state==GETPOINT) g.state = NORMAL; 
   if(g.state==MOVEIMAGE) g.state = NORMAL;
   if(g.state==COPY) g.state = NORMAL;
   if(g.state==GETLINE && (g.get_x1!=g.get_x2 || g.get_y1!=g.get_y2)) g.state=NORMAL; 
   if(g.draw_figure) draw(END);
   printstatus(g.state);

   //// Release the mouse 
   for(int k=0;k<g.image_count;k++) if(z[k].s->visible) refreshspreadsheet(k);     
   getpointstate = 0;
}


//--------------------------------------------------------------------//
// eventcb - Handle other events in image window.                     //
// The corresponding mask must be set in main_mask to get events here.//
//--------------------------------------------------------------------//
void eventcb(Widget w, XtP client_data, XEvent *event)
{
   w=w; client_data=client_data;  // Keep compiler quiet
   whatevent(event->type);
}


//--------------------------------------------------------------------//
// whatevent - prints name of event for debugging.                    //
//--------------------------------------------------------------------//
void whatevent(int eventtype)
{
  switch(eventtype)
  { case KeyPress: printf("keypress ");fflush(stdout); break;
    case KeyRelease: printf("keyrelease ");fflush(stdout); break;
    case Expose: printf("expose ");fflush(stdout); break;
    case MotionNotify: printf("motionnotify ");fflush(stdout); break;
    case ButtonPress: printf("buttonpress ");fflush(stdout); break;
    case ButtonRelease: printf("buttonrelease ");fflush(stdout); break;
    case EnterNotify: printf("enternotify %d ",g.imageatcursor);fflush(stdout); break;
    case LeaveNotify: printf("leavenotify ");fflush(stdout); break;
    case FocusIn: printf("focusin ");fflush(stdout); break;
    case FocusOut: printf("focusout ");fflush(stdout); break;
    case KeymapNotify: printf("keymapnotify ");fflush(stdout); break;
    case GraphicsExpose: printf("graphicsexpose ");fflush(stdout); break;
    case NoExpose: printf("noexpose ");fflush(stdout); break;
    case CirculateNotify: printf("circulatenotify ");fflush(stdout); break;
    case ConfigureNotify : printf("configurenotify ");fflush(stdout); break;
    case MapNotify: printf("mapnotify ");fflush(stdout); break;
    case ResizeRequest: printf("resizerequest ");fflush(stdout); break;
    case MappingNotify: printf("mappingnotify ");fflush(stdout); break;
    case ColormapNotify: printf("colormapnotify ");fflush(stdout); break;
    case ReparentNotify: printf("reparentnotify ");fflush(stdout); break;
    default: printf("Unknown ");fflush(stdout); break;
  }
}


//--------------------------------------------------------------------//
// configurecb - Handle ConfigureNotify events to images              //
//--------------------------------------------------------------------//
void configurecb(Widget w, XtP client_data, XEvent *event)
{
  event=event;
  client_data=client_data;  w=w; // Keep compiler quiet
  int ino, oci=ci, k,rx,ry,wx,wy; 
  uint keys, uw, uh, ubw, ud;
  Window rwin, cwin;
  Widget widget;

  if(g.draw_figure) draw(END);
  drawselectbox(OFF);
                                // Find current position of main window & image number
  if(w==g.main_widget)
  {    XQueryPointer(g.display,g.main_window,&rwin,&cwin,&rx,&ry,&wx,&wy,&keys);
       g.main_xpos = rx-wx;
       g.main_ypos = ry-wy;
  }                             // Find position of all of them 
                                // If a shell widget, it can be resized so get its size too.
  for(ino=0; ino<g.image_count; ino++)
  {   if(z[ino].shell || ino==0)
      {    XQueryPointer(g.display, z[ino].win, &rwin, &cwin, &rx, &ry, &wx, &wy, &keys);
           z[ino].xpos = rx-wx-g.main_xpos;
           z[ino].ypos = ry-wy-g.main_ypos; 
           widget = XtParent(z[ino].widget);
           //// YAHFL 
#ifdef LESSTIF_VERSION
           if(ino==0)
	   {   widget = XtParent(XtParent(XtParent(z[0].widget)));
               uw -= 120;
	       uh -= 32;
	   }
#endif
           XGetGeometry(g.display, XtWindow(widget), &rwin, &rx, &ry, &uw, &uh, &ubw, &ud);            
           if(uw != (uint)z[ino].xsize || uh != (uint)z[ino].ysize)
           {   
              if(g.state != ACQUIRE)        // If filling camera bufr, don't resize.
              {   resize_image(ino,uw,uh);  // This changes ci
#ifdef LESSTIF_VERSION
                  resize_widget(XtParent(XtParent(z[0].widget)),uw,uh);
#endif
                  z[ino].xsize = uw;
                  z[ino].ysize = uh;
                  if(ino==0) 
                  {    g.main_xsize = uw; 
                       g.main_ysize = uh; 
                       g.total_xsize = uw + 2 + g.drawarea2width; 
                       g.total_ysize = uh - 2 + (int)g.mainmenuheight; 
                 }
	      }
           }
     }

  }

  ////  Deselect any non-rectangular region otherwise selection is in wrong place
  g.selected_is_square = 1;

  ////  Recalculate ulx, uly, etc
  switchto(oci);  //// Necessary if image is loaded on command line
  selectimage(ci);

  if(!g.moving) for(k=0;k<g.openlistcount;k++) update_list(k);
}


//--------------------------------------------------------------------//
// imagefocuscb - Handle FocusIn events to images. If image is in a   //
// separate frame, clicking on the frame generates a FocusIn.         //
// Only do this for images in separate windows. Focus for images on   //
// main window is handled in drawcb() and handle_button_press().      //
// Don't switch to the image if a non-rectangular region was selected.//
//--------------------------------------------------------------------//
void imagefocuscb(Widget w, XtP client_data, XEvent *event)
{
  client_data=client_data;  w=w; // Keep compiler quiet
  int k; 
  if(event->type==FocusIn && g.selected_is_square)
    for(k=0; k<g.image_count; k++) 
       if(z[k].shell && k!=ci && w==XtParent(XtParent(z[k].widget))) switchto(k);
  printstatus(g.state);
}


//--------------------------------------------------------------------//
// mousecb - Handle MotionNotify events in image window               //
//--------------------------------------------------------------------//
void mousecb(Widget w, XtP client_data, XEvent *event)
{
  w=w;client_data=client_data;  // Keep compiler quiet

  ////  If dragging the mouse, go into select mode. 'mouse_button' is set in 
  ////  drawcb(). Can't read mouse button here because this is not called in 
  ////  response to ButtonPress. Make sure mouse has moved before selecting 
  ////  an area.

  int bpp, iii, oiac, x1=0, x2=0, y1=0, y2=0, x, y;
  static int omouse_x=0, omouse_y=0;
  static Cursor ocursor = 0;
  Window window;
  int ostate=g.state;
  Cursor cursor = g.cursor;
  g.mouse_x = event->xmotion.x_root - g.main_xpos;
  g.mouse_y = event->xmotion.y_root - g.main_ypos;

  oiac = g.imageatcursor;
  iii = whichimage(g.mouse_x,g.mouse_y,bpp);
  if(iii>=0 &&z[iii].permanent) g.imageatcursor = iii;
  if(g.imageatcursor>=0) window = z[g.imageatcursor].win;
  else window = g.main_window;

  if(g.mouse_button)
  {   
       crosshairs(0, 0); 
       if(g.mouse_x != omouse_x || g.mouse_y != omouse_y)                        
       {    g.get_x2 = g.mouse_x;
            g.get_y2 = g.mouse_y;
            if(g.draw_figure)                     
                draw(CONTINUE);
            else if(g.state==MOVEIMAGE && ci>=0 && !z[ci].shell) 
            {  
                z[ci].xpos = g.mouse_x;
                z[ci].ypos = g.mouse_y;
                moveimage(ci, g.mouse_x, g.mouse_y);
            }
            else if(g.state==COPY)
            { 
                move();   
                mouse_near_selection=0;
                g.state=NORMAL;
            }
            else if(g.state==NORMAL) 
            {   g.selected_ulx = g.mouse_x;
                g.selected_uly = g.mouse_y;
                g.ulx = zoom_x_coordinate(g.selected_ulx, g.imageatcursor);
                g.uly = zoom_y_coordinate(g.selected_uly, g.imageatcursor);
                g.state = SELECT;
                g.selectedimage= -1;
                g.selected_is_square=1;
            }
            if(g.state==SELECT) 
            {   g.selected_lrx = g.mouse_x;
                g.selected_lry = g.mouse_y;
                g.lrx = zoom_x_coordinate(g.selected_lrx, g.imageatcursor);
                g.lry = zoom_y_coordinate(g.selected_lry, g.imageatcursor);
                drawselectbox(ON);           // Draw dashed outline box
            }
       }      
  }else
  {    
  
       if(between(g.imageatcursor,1,g.image_count-1) && !z[g.imageatcursor].shell)
       {    x1 = z[g.imageatcursor].xpos;
            y1 = z[g.imageatcursor].ypos;
            x2 = z[g.imageatcursor].xpos + z[g.imageatcursor].xsize;
            y2 = z[g.imageatcursor].ypos + z[g.imageatcursor].ysize;
            if(onedge(g.mouse_x,g.mouse_y,x1,y1,x2,y2))
            {   if(g.state==NORMAL) g.state = MOVEIMAGE; 
            }            
            else if(g.state==MOVEIMAGE) g.state=NORMAL; 
       }else if(g.state==MOVEIMAGE) g.state=NORMAL; 
       
       mouse_near_selection=0;
       if(g.selectedimage==-1 && g.state!=GETBOX && g.state!=GETPOINT)
       {   
            if(g.selected_is_square)
            {   if(onedge(g.mouse_x, g.mouse_y, g.selected_ulx, 
                           g.selected_uly, g.selected_lrx, g.selected_lry))
                {    mouse_near_selection=1;
                     g.state=NORMAL;
                }
            }else
            {   x1 = max(g.selected_ulx, g.mouse_x-2);
                y1 = max(g.selected_uly, g.mouse_y-2);
                x2 = min(g.selected_lrx, g.mouse_x+2);
                y2 = min(g.selected_lry, g.mouse_y+2);
                for(y=y1;y<=y2;y++)
                for(x=x1;x<=x2;x++)
                {   if(inside_irregular_region(x,y)==3)
                    {    mouse_near_selection=1;
                         g.state=NORMAL;
                         break; 
                    }
                }
            }
       }
  }

  if(mouse_near_selection || (g.state==MOVEIMAGE && g.imageatcursor>0)) 
       cursor = g.fleur_cursor;
  else cursor = g.cursor;

  ////   oiac may be different from g.imageatcursor if mouse moves fast
  if(cursor!=ocursor || oiac!=g.imageatcursor)
      XDefineCursor(g.display, window, cursor);
  
  crosshairs(g.mouse_x, g.mouse_y);
  if(g.state != ostate) printstatus(g.state);
  omouse_x = g.mouse_x;
  omouse_y = g.mouse_y;
  ocursor = cursor;
  printcoordinates(g.mouse_x, g.mouse_y, 0);    
  return;
}


//--------------------------------------------------------------------//
// crosshairs - call with x,y = 0,0 to erase                          //
//--------------------------------------------------------------------//
void crosshairs(int x, int y)
{
  static int hit, *xsave, *ysave, ox, oy;
  int i,j;
  if(!g.want_crosshairs) return;
  if(x<0 || y<0) return;
  if(!hit)
  {   xsave = new int[g.xres];
      ysave = new int[g.yres];
      if(ysave==NULL){ printf(g.nomemory); exit(1); }
  }
  g.inmenu++;
  if(hit)
  {   for(j=0;j<g.main_ysize;j++)
          setpixel(ox,j,ysave[j],SET);
      for(i=0;i<g.main_xsize;i++)
          setpixel(i,oy,xsave[i],SET);
  }
  for(j=0;j<g.main_ysize;j++)
      ysave[j] = readpixel(x,j);
  for(i=0;i<g.main_xsize;i++)
      xsave[i] = readpixel(i,y);
  if(x || y)
  {  for(j=0;j<g.main_ysize;j++)
         setpixel(x,j,g.fcolor,SET);
     for(i=0;i<g.main_xsize;i++)
         setpixel(i,y,g.fcolor,SET);
  }
  g.inmenu--;
  ox = x; oy = y;
  hit=1;
}


//--------------------------------------------------------------------//
// image_exposecb                                                     //
// Callback for image windows being exposed.                          //
//--------------------------------------------------------------------//
void image_exposecb(Widget widget, XtP client_data, XtP *call_data)
{
  client_data=client_data;  // Keep compiler quiet
  XmDrawingAreaCallbackStruct *ptr;
  int  bpp, ex, ey, ew, eh, ino;
  ptr = (XmDrawingAreaCallbackStruct*) call_data;
  if(ptr==NULL) return;
  ino = whichimage(widget,bpp);
  if(ino<0) return;
  switch(ptr->reason)
  {  
     case XmCR_EXPOSE:
       printstatus(REDRAW);
       ex = ptr->event->xexpose.x;
       ey = ptr->event->xexpose.y;
       ew = ptr->event->xexpose.width;
       eh = ptr->event->xexpose.height;
       XPutImage(g.display, z[ino].win, g.image_gc, z[ino].img_ximage,
            ex, ey, ex, ey, ew, eh);
       printstatus(g.state);
       XDefineCursor(g.display, z[ino].win, g.cursor);
       break;
     default:  
       fprintf(stderr,"Error in image_exposecb line %d\n",__LINE__);
       break;
  }
}



//--------------------------------------------------------------------//
// warningmessagecb - handle warning messages from Xt (mainly "unable //
// to allocate colormap entry for default background").               //
//--------------------------------------------------------------------//
void warningmessagecb(String aaa)
{ 
   aaa=aaa;
   printstatus(XTWARNING);
}


//--------------------------------------------------------------------//
// filenamecb                                                         //
// Called in response to mouse click on filename pushbutton.          //
// Calling routine must maintain a dynamic list of Widgets, then      //
//   destroy them when finished.                                      //
//--------------------------------------------------------------------//
void filenamecb(Widget widget, XtP client_data, XmACB *call_data)
{
   call_data=call_data;  // Keep compiler quiet
   Widget f,w,w3,dirmaskwidget;

   XmString title, dir_mask, pathxms=NULL;
   int n;
   Arg args[100];
   clickboxinfo *c = (clickboxinfo *)client_data;
   int wc = c->wc;
   Widget flist;

   int rx,ry,wx,wy; 
   uint keys;
   Window rwin, cwin; 

   ////  Find current position of main window & image number
   XQueryPointer(g.display,g.main_window,&rwin,&cwin,&rx,&ry,&wx,&wy,&keys);
   g.main_xpos = rx-wx;
   g.main_ypos = ry-wy;

   n = 0;
   XtSetArg(args[n], XmNdialogStyle, XmDIALOG_MODELESS); n++;
   XtSetArg(args[n], XmNdefaultPosition, False); n++;
   XtSetArg(args[n], XmNx, min(g.xres-380, g.main_xpos + 50)); n++;
   XtSetArg(args[n], XmNy, g.main_ypos - 50); n++;
   XtSetArg(args[n], XmNtitle, "File Selection"); n++;
   ////  Stop Motif from trying to grab another color if none are available.
   if(g.want_colormaps)  
   {    XtSetArg(args[n], XmNbackground, g.main_bcolor); n++;
        XtSetArg(args[n], XmNforeground, g.main_fcolor); n++;
   }
   w = c->w[wc++] = XmCreateBulletinBoardDialog(widget, "Select File", args, n);
   title = XmStringLtoRCreate("Filter",XmSTRING_DEFAULT_CHARSET);   
   if(c->dirmask)
        dir_mask = XmStringLtoRCreate(c->dirmask,XmSTRING_DEFAULT_CHARSET); 
   else
        dir_mask = XmStringLtoRCreate("*",XmSTRING_DEFAULT_CHARSET); 

   n = 0;
   XtSetArg(args[n], XmNdirMask, dir_mask); n++;  
   XtSetArg(args[n], XmNresizable, True); n++;  
   XtSetArg(args[n], XmNfilterLabelString, title); n++; 
   if(c->path != NULL)
   {   XtSetArg(args[n], XmNdirectory, pathxms = XmStringLtoRCreate(c->path,XmSTRING_DEFAULT_CHARSET)); n++;
   }

   ////  Stop Motif from trying to grab another color if none are available.
   if(g.want_colormaps)  
   {    XtSetArg(args[n], XmNbackground, g.main_bcolor); n++;
        XtSetArg(args[n], XmNforeground, g.main_fcolor); n++;
   }
   f = c->w[wc++] = XmCreateFileSelectionBox(w, "FileSelector", args, n);

   Widget child;
   if(c->type==MULTIPLE)
   {   child = c->listwidget = XmFileSelectionBoxGetChild(f, XmDIALOG_LIST);
       XtVaSetValues(child, XmNselectionPolicy, XmMULTIPLE_SELECT, NULL);
   }

   ////   The first pushbutton is automatically placed in the wrong
   ////   position, so an unused, unmanaged pushbutton must be added
   ////   to trick Motif.
   
   n = 0;
   ////  Stop Motif from trying to grab another color if none are available.
   if(g.want_colormaps)  
   {    XtSetArg(args[n], XmNbackground, g.main_bcolor); n++;
        XtSetArg(args[n], XmNforeground, g.main_fcolor); n++;
   }
   c->w[wc++] = XmCreatePushButton(f, "crudola", args, n);

   n = 0;
   XtSetArg(args[n], XmNchildPlacement, XmPLACE_BELOW_SELECTION); n++;
   ////  Stop Motif from trying to grab another color if none are available.
   if(g.want_colormaps)  
   {    XtSetArg(args[n], XmNbackground, g.main_bcolor); n++;
        XtSetArg(args[n], XmNforeground, g.main_fcolor); n++;
   }
   w3 = c->w[wc++] = XmCreatePushButton(f, "Chdir", args, n);
   XtManageChild(w3);

   ////  Set c->widget[0] to the fileselectionbox widget.
   ////  c->widget[1] is the 'filename' push button in dialog box.

   c->widget[0] = w; 
   XtAddCallback(f, XmNcancelCallback, (XtCBP)fscancelcb, (XtP)c);
   XtAddCallback(f, XmNokCallback, (XtCBP)fsokcb, (XtP)c); 

   flist =  XmFileSelectionBoxGetChild(f, XmDIALOG_LIST);
   XtAddCallback(flist, XmNsingleSelectionCallback, (XtCBP)fsscb, (XtP)flist);
   XtAddCallback(flist, XmNmultipleSelectionCallback, (XtCBP)fsscb, (XtP)flist);

   XtAddCallback(w3, XmNactivateCallback, (XtCBP)fscdcb, (XtP)f);
   dirmaskwidget = XmFileSelectionBoxGetChild(f, XmDIALOG_FILTER_TEXT);
   XtAddCallback(dirmaskwidget, XmNvalueChangedCallback, (XtCBP)fsdirmaskcb, (XtP)c); 

   if(c->path != NULL) XmStringFree(pathxms);
   XmStringFree(title);
   XmStringFree(dir_mask);
   XtManageChild(f);
   XtManageChild(w);

   //// It is necessary to manually set the colors in each subwindow.
           
   w = XmFileSelectionBoxGetChild(f, XmDIALOG_LIST);
   XtVaSetValues(w, 
#ifdef SOLARIS 
            XmNwidth, 400,
#endif
            XmNscrollBarDisplayPolicy, XmSTATIC,  // Essential for Solaris
            NULL);

   ////  Stop Motif from trying to grab another color if none are available.
   if(g.want_colormaps)  
   {   
       w = XmFileSelectionBoxGetChild(f, XmDIALOG_APPLY_BUTTON);
       XtVaSetValues(w, XmNbackground, g.main_bcolor, XmNforeground, g.main_fcolor,NULL);
       w = XmFileSelectionBoxGetChild(f, XmDIALOG_CANCEL_BUTTON);
       XtVaSetValues(w, XmNbackground, g.main_bcolor, XmNforeground, g.main_fcolor,NULL);
       w = XmFileSelectionBoxGetChild(f, XmDIALOG_DEFAULT_BUTTON);
       XtVaSetValues(w, XmNbackground, g.main_bcolor, XmNforeground, g.main_fcolor,NULL);
       w = XmFileSelectionBoxGetChild(f, XmDIALOG_DIR_LIST);
       XtVaSetValues(w, XmNbackground, g.main_bcolor, XmNforeground, g.main_fcolor,NULL);
       w = XmFileSelectionBoxGetChild(f, XmDIALOG_DIR_LIST_LABEL);
       XtVaSetValues(w, XmNbackground, g.main_bcolor, XmNforeground, g.main_fcolor,NULL);
       w = XmFileSelectionBoxGetChild(f, XmDIALOG_FILTER_LABEL);
       XtVaSetValues(w, XmNbackground, g.main_bcolor, XmNforeground, g.main_fcolor,NULL);
       w = XmFileSelectionBoxGetChild(f, XmDIALOG_FILTER_TEXT);
       XtVaSetValues(w, XmNbackground, g.main_bcolor, XmNforeground, g.main_fcolor,NULL);
       w = XmFileSelectionBoxGetChild(f, XmDIALOG_HELP_BUTTON);
       XtVaSetValues(w, XmNbackground, g.main_bcolor, XmNforeground, g.main_fcolor,NULL);
       w = XmFileSelectionBoxGetChild(f, XmDIALOG_LIST);
       XtVaSetValues(w, XmNbackground, g.main_bcolor, XmNforeground, g.main_fcolor,NULL);
       w = XmFileSelectionBoxGetChild(f, XmDIALOG_LIST_LABEL);
       XtVaSetValues(w, XmNbackground, g.main_bcolor, XmNforeground, g.main_fcolor,NULL);
       w = XmFileSelectionBoxGetChild(f, XmDIALOG_OK_BUTTON);
       XtVaSetValues(w, XmNbackground, g.main_bcolor, XmNforeground, g.main_fcolor,NULL);
       w = XmFileSelectionBoxGetChild(f, XmDIALOG_SELECTION_LABEL);
       XtVaSetValues(w, XmNbackground, g.main_bcolor, XmNforeground, g.main_fcolor,NULL);
       w = XmFileSelectionBoxGetChild(f, XmDIALOG_SEPARATOR);
       XtVaSetValues(w, XmNbackground, g.main_bcolor, XmNforeground, g.main_fcolor,NULL);
       w = XmFileSelectionBoxGetChild(f, XmDIALOG_TEXT);
       XtVaSetValues(w, XmNbackground, g.main_bcolor, XmNforeground, g.main_fcolor,NULL);
       w = XmFileSelectionBoxGetChild(f, XmDIALOG_WORK_AREA);
       XtVaSetValues(w, XmNbackground, g.main_bcolor, XmNforeground, g.main_fcolor,NULL);
   }
   c->wc = wc;
   //// Don't delete widgets here, delete at end of getfilename(s).
}


//--------------------------------------------------------------------//
//  fsscb                                                             //
//--------------------------------------------------------------------//
void fsscb(Widget w, XtP client_data, XmLCB *call_data)
{ 
   w=w; client_data=client_data;
   XmListCallbackStruct *ptr = call_data;
   int count = ptr->selected_item_count;
   char **tempstring=NULL;
   tempstring = new char *[count+1];
   XmStringGetLtoR(ptr->item, XmFONTLIST_DEFAULT_TAG, tempstring);
   if(strlen(tempstring[0])) strcpy(lestif_filename, tempstring[0]);
   delete[] tempstring;
}


//--------------------------------------------------------------------//
// fsokcb - callback for "ok" button in file selection box.           //
// Caller passes a clickboxinfo struct in client_data.                //
// Widget2 must be set to a pushbutton Widget or to NULL.             // 
// This is where memory is allocated for multifilename selector.      //
// The list array must be freed with delete[].                        //
// The filename strings must be freed with XtFree().                  //
//--------------------------------------------------------------------//
void fsokcb(Widget w, XtP client_data, XmFSBCB *call_data)
{
   call_data=call_data;
   Widget selectiontext;  // XmText for user to type in a filename 
   Arg args[100];
   XmString xms;
   XmStringTable xmstrings;
   int k,n = 0;
   clickboxinfo *c = (clickboxinfo *)client_data;
   char *filename; 
   char *fname;

   c->count=0;
   filename = new char[FILENAMELENGTH];
   filename[0]=0;
   
   if(c->type == MULTIPLE)
   {   XtVaGetValues(c->listwidget, XmNselectedItemCount, &c->count, NULL); 

       ////  This returns the XmList items themselves, not a copy. The 
       ////  XmStringTable is automatically created by FileSelectionBox.
       ////  The application must not free the XmStrings (see OSF p. 1-859).
       
       XtVaGetValues(c->listwidget, XmNselectedItems, &xmstrings, NULL);
       c->list = new char*[c->count+1];
       for(k=0;k<c->count;k++)
       {
            ////  This allocates memory for items in list, use XtFree to free it.
            XmStringGetLtoR(xmstrings[k], XmFONTLIST_DEFAULT_TAG, &c->list[k]);
       }
       if(c->count>0) 
       {    strcpy(c->title, c->list[0]);
            strcpy(filename, c->list[0]);
       }else 
       {       //// A single click selects the file, then a double click deselects
               //// it and then comes here with nothing in the list. So retaliate 
               //// by copying selected filename (set in fsscb) out of a global.
               //// Also, with lestif, the fileselector doesn't recognize the 'Enter" key.
            selectiontext = XmFileSelectionBoxGetChild(w, XmDIALOG_TEXT);
               //// First check if they typed something in the text widget.
            XtVaGetValues(selectiontext, XmNvalue, &fname, NULL);
            if(strlen(fname)) strcpy(filename, fname);
               //// If it got nothing or a directory, substitute previous selection.
               //// Lestif might have unselected it so copy from the global.
            if(!strlen(filename) || filename[(int)strlen(filename)-1]=='/') 
                  strcpy(filename, lestif_filename);
            c->list[0] = XtMalloc(FILENAMELENGTH);  // Free this with XtFree()
            if(strlen(filename)) strcpy(c->title, filename);
            if(strlen(filename)) strcpy(c->list[0], filename);

       }
   }

   ////  For single file mode, Motif puts filename in an editable text widget. 
   if(c->type == SINGLE)
   {    selectiontext = XmFileSelectionBoxGetChild(w, XmDIALOG_TEXT);
        XtVaGetValues(selectiontext, XmNvalue, &fname, NULL);
        if(strlen(fname)) strcpy(filename, fname);
        if(strlen(filename)) strcpy(c->title, filename);
        c->count=1;
   }
   XFlush(g.display);

   ////  Put the new filename on the pushbutton. 
   ////  The pushbutton's XmNresizable resource must be False, otherwise
   ////  Motif will use this as an excuse to resize the entire dialog box.
   ////  Unmanage c->calling widget, which is the bulletin board - not w,
   ////  which is the filenamewidget on top.

   ////  c->widget[1] is the 'filename' pushbutton in dialogbox.
   ////  If calling from somewhere else, this should be set to NULL.
     
   n = 0;
   XtSetArg(args[n], XmNwidth, 200); n++; 
   XtSetArg(args[n], XmNlabelString, xms=XmStringCreateSimple(filename)); n++;
   if(c->widget[1] != NULL)
       XtSetValues(c->widget[1], args, n); // Change label in boxbutton Widget
   XmStringFree(xms);
   c->done = 1;                            // Set flag indicating done
   delete[] filename;

   ////  Focus goes to OK button when file is selected, so pressing Enter
   ////  twice will load the image.
   
   if(c->form != NULL) XmProcessTraversal(c->form, XmTRAVERSE_NEXT_TAB_GROUP); 
}


//--------------------------------------------------------------------//
// fscancelcb - callback for "cancel" button in file selection box.   //
//--------------------------------------------------------------------//
void fscancelcb(Widget w, XtP client_data, XmFSBCB *call_data)
{
   w=w; call_data=call_data;  // Keep compiler quiet
   clickboxinfo *c = (clickboxinfo *)client_data;
   XtUnmanageChild(c->widget[0]);
   c->done = 1;                            // Set flag indicating done
   g.getout=1;
}


//--------------------------------------------------------------------//
// fscdcb - callback for "chdir" button in file selection box.        //
//--------------------------------------------------------------------//
void fscdcb(Widget w, XtP client_data, XmFSBCB *call_data)
{
   w=w; call_data=call_data;  // Keep compiler quiet
   Widget f = (Widget)client_data;
   char *dir;
   int len;
   dir = new char[1024];
   XmString xms = XmStringCreateLtoR(dir, XmSTRING_DEFAULT_CHARSET);
   XtVaGetValues(f, XmNdirectory,  &xms, NULL);       
   XmStringGetLtoR(xms, XmFONTLIST_DEFAULT_TAG, &dir);
   chdir(dir);
   len = strlen(dir)-1;            // eliminate trailing /
   if(dir[len]=='/') dir[len]=0;
   strcpy(g.currentdir,dir);
   XmStringFree(xms);
   delete[] dir;
}


//--------------------------------------------------------------------//
// fsdirmaskcb - callback for changing dir mask in file selection box.//
//--------------------------------------------------------------------//
void fsdirmaskcb(Widget w, XtP client_data, XmFSBCB *call_data)
{
   w=w; call_data=call_data;  // Keep compiler quiet
   clickboxinfo *c = (clickboxinfo *)client_data;  
   XmString xmstring;
   XtVaGetValues(XtParent(w), XmNdirMask,  &xmstring, NULL);       
   XmStringGetLtoR(xmstring, XmFONTLIST_DEFAULT_TAG, &c->dirmask);

   XtVaGetValues(XtParent(w), XmNdirectory,  &xmstring, NULL);       
   XmStringGetLtoR(xmstring, XmFONTLIST_DEFAULT_TAG, &c->path);
   XmStringFree(xmstring);
} 



//--------------------------------------------------------------------//
// listcb - callback for list box.                                    //
// Item text is placed in 'string', l->selection points to answer no. //
//--------------------------------------------------------------------//
void listcb(Widget w, XtP client_data, XmACB *call_data)
{
   int k;
   listinfo *l = (listinfo *)client_data;
   char *string;
   XmString xms;
   XmListCallbackStruct *ptr;
   ptr = (XmListCallbackStruct*) call_data;
   XmStringGetLtoR(ptr->item, XmFONTLIST_DEFAULT_TAG, &string);
 
   if(l->selection!=NULL) *l->selection = ptr->item_position;
 
   *l->selection = *l->selection - 1;
   k =  *l->selection;
   if(l->allowedit && k >= l->editrow)
   {     message(l->edittitle, l->info[k] + l->editcol, PROMPT, l->maxstringsize);
         xms = XmStringCreateSimple(l->info[k]);
         XmListReplaceItemsPosUnselected(w, &xms, 1, k+1);
         XmStringFree(xms);
   }
   if(l->wantfunction) l->f1(k - l->firstitem);
}



//--------------------------------------------------------------------//
//  moveimage                                                         //
//  want_redraw is optional (set to 0 to move without redrawing)      //
//    default=1                                                       //
//--------------------------------------------------------------------//
void moveimage(int ino, int xpos, int ypos, int want_redraw)
{
  int k, gotevent=0;
  XEvent event;
  gotevent = XCheckMaskEvent(g.display, g.main_mask | g.mouse_mask, &event);
  if(g.moving && gotevent) return;  // Don't return unless image is being moved
                                    // with arrow keys otherwise it will mess up
                                    // copy/paste
  if(ino>0)
  {   
      crosshairs(0, 0);
      if(z[ino].shell)
           XtMoveWidget(XtParent(XtParent(z[ino].widget)),xpos, ypos);
      else 
           XtMoveWidget(z[ino].widget, xpos, ypos);
      if(z[ino].chromakey)     
           redraw_chromakey_image(ino, want_redraw);
      if(z[ino].transparency)     
           redraw_transparent_image(ino, want_redraw);
      if(z[ino].shell)
      {     z[ino].xpos = xpos-g.main_xpos;
            z[ino].ypos = ypos-g.main_ypos; 
      }else
      {     z[ino].xpos = xpos;
            z[ino].ypos = ypos; 
      }

      ////  Dont update list after a move if image is in separate window,
      ////  because it gets a ConfigureNotify which updates list in configurecb().
      
      if(z[ino].permanent)
      {   if(!z[ino].shell) for(k=0;k<g.openlistcount;k++) update_list(k);
          switchto(ino);
      }
  }
}



//--------------------------------------------------------------------//
//  redraw_chromakey_image                                            //
//  want_redraw is optional, default=1. If 0 it speeds it up by only  //
//  redrawing the image every SPEED events (including timer or mouse  //
//  events). This is done by sending a flag to redraw().  If it is    //
//  still too slow, SPEED can be increased with no harmful effects.   //
//--------------------------------------------------------------------//
void redraw_chromakey_image(int ino, int want_redraw)
{
  const int SPEED=3;
  g.state = BUSY;
  printstatus(BUSY);
  int bpp,cf,i,j,junk,tmin,tmax,v,x,y,rr,gg,bb,rmin,rmax,gmin,gmax,bmin,bmax;
  if(ino<0 || !z[ino].chromakey) return;
  static int count=0;
  count++;
  if(!want_redraw && count!=SPEED) g.ignore=1; 
  if(count==SPEED)count=0;
  for(j=0;j<z[ino].ysize;j++)
  for(i=0;i<z[ino].xsize;i++)
  {    cf = z[ino].cf;
       bpp = z[ino].bpp;
       v = pixelat(z[ino].image[cf][j] + g.off[bpp]*i, bpp);       
       if(z[ino].colortype==GRAY)
       {    tmin = z[ino].ck_graymin;
            tmax = z[ino].ck_graymax;
            if(!is_opaque(v,tmin,tmax,z[ino].chromakey))
            {     x = i + z[ino].xpos;
                  y = j + z[ino].ypos;
                  v = readpixelonimage(x,y,bpp,junk,ino);
                  putpixelbytes(z[ino].img[j]+i*g.off[g.bitsperpixel], v);
            }
       }else
       {   
            rmin = z[ino].ck_min.red;
            rmax = z[ino].ck_max.red;
            gmin = z[ino].ck_min.green;
            gmax = z[ino].ck_max.green;
            bmin = z[ino].ck_min.blue;
            bmax = z[ino].ck_max.blue;
            valuetoRGB(v,rr,gg,bb,bpp);
            convertRGBpixel(rr,gg,bb,bpp,24);
            if(!is_opaque(rr,rmin,rmax,gg,gmin,gmax,bb,bmin,bmax,z[ino].chromakey)) 
            {     x = i + z[ino].xpos;
                  y = j + z[ino].ypos;
                  v = readpixelonimage(x,y,bpp,junk,ino);
                  putpixelbytes(z[ino].img[j]+i*g.off[g.bitsperpixel], v);
            }
       }
  }

  //// Skip redrawing if called from move() for speed
  if(g.ignore==0) 
        send_event(z[ino].win, Expose, 0, 0, z[ino].xsize, z[ino].ysize);
  g.state = NORMAL;
  printstatus(g.state);
  g.ignore=0; 
} 



//--------------------------------------------------------------------//
//  redraw_transparent_image                                          //
//  want_redraw is optional, default=1. If 0 it speeds it up by only  //
//  redrawing the image every SPEED events (including timer or mouse  //
//  events). This is done by sending a flag to redraw().  If it is    //
//  still too slow, SPEED can be increased with no harmful effects.   //
//--------------------------------------------------------------------//
void redraw_transparent_image(int ino, int want_redraw)
{
  static int count=0;
  const int SPEED=3;
  int bpp,bpp2,cf,i,ino2=0,j,v,v2,x,y,rr,gg,bb,rr2,gg2,bb2,value;
  printstatus(BUSY);
  double tr, tr2;
  if(ino<0 || !z[ino].transparency) return;
  count++;
  if(!want_redraw && count!=SPEED) g.ignore=1; 
  if(count==SPEED)count=0;
  bpp = z[ino].bpp;
  tr = (double)(z[ino].transparency)/100.00;
  tr2 = 1.00 - tr;
  cf = z[ino].cf;
  for(j=0;j<z[ino].ysize;j++)
  for(i=0;i<z[ino].xsize;i++)
  {  
       v = pixelat(z[ino].image[cf][j] + g.off[bpp]*i, bpp);
       x = i + z[ino].xpos;
       y = j + z[ino].ypos;
       v2 = readpixelonimage(x,y,bpp2,ino2,ino);
       if(z[ino].colortype==GRAY && bpp==8)
       {  
           value = (int)(v2*tr + v*tr2);
           putpixelbytes(z[ino].img[j]+i*g.off[g.bitsperpixel], value);
       }else
       {
           valuetoRGB(v,rr,gg,bb,bpp);   
           valuetoRGB(v2,rr2,gg2,bb2,bpp2);  
           rr = (int)(rr2*tr + rr*tr2);
           gg = (int)(gg2*tr + gg*tr2);
           bb = (int)(bb2*tr + bb*tr2);           
           value = RGBvalue(rr,gg,bb,bpp);          
           value=convertpixel(value,bpp,g.bitsperpixel,1);
           putpixelbytes(z[ino].img[j]+i*g.off[g.bitsperpixel], value);
       }
  }
 
  //// Skip redrawing if called from move() for speed
  if(g.ignore==0)
  {     repairimg(ino, 0, 0, z[ino].xsize, z[ino].ysize);
        send_event(z[ino].win, Expose, 0, 0, z[ino].xsize, z[ino].ysize);
  }
  printstatus(g.state);
  g.moving=0;
  XFlush(g.display);
  g.ignore=0; 
  return;
} 


//--------------------------------------------------------------------//
// upcb - callbacks for arrow button to move image.                   //
//--------------------------------------------------------------------//
void upcb(Widget w, XtP client_data, XtP call_data)
{  w=w; call_data=call_data; client_data=client_data;  // Keep compiler quiet
   Position xpos,ypos;
   if(ci>0)
   {  drawselectbox(OFF);
      g.moving=1;
      if(z[ci].shell)
      {   xpos = z[ci].xpos + g.main_xpos;
          ypos = z[ci].ypos + g.main_ypos - g.csize;
          xpos -= g.wm_leftborderwidth;
          ypos -= g.wm_topborderwidth;
          moveimage(ci,xpos,ypos);
      }else
      {   z[ci].ypos -= g.csize;
          moveimage(ci,z[ci].xpos,z[ci].ypos);
      }
      selectimage(ci);    
   }
}
void downcb(Widget w, XtP client_data, XtP call_data)
{  w=w; call_data=call_data; client_data=client_data;  // Keep compiler quiet
   Position xpos,ypos;
   if(ci>0)
   {  drawselectbox(OFF);
      g.moving=2;
      if(z[ci].shell)
      {   xpos = z[ci].xpos + g.main_xpos;
          ypos = z[ci].ypos + g.main_ypos + g.csize;
          xpos -= g.wm_leftborderwidth;
          ypos -= g.wm_topborderwidth;
          moveimage(ci,xpos,ypos);
      }else
      {   z[ci].ypos += g.csize;
          moveimage(ci, z[ci].xpos, z[ci].ypos);
      }
      selectimage(ci);    
   }
}
void leftcb(Widget w, XtP client_data, XtP call_data)
{  w=w; call_data=call_data; client_data=client_data;  // Keep compiler quiet
   Position xpos,ypos;
   if(ci>0)
   {  drawselectbox(OFF);
      g.moving=3;
      if(z[ci].shell)
      {   xpos = z[ci].xpos + g.main_xpos - g.csize;
          ypos = z[ci].ypos + g.main_ypos;
          xpos -= g.wm_leftborderwidth;
          ypos -= g.wm_topborderwidth;
          moveimage(ci,xpos,ypos);
      }else
      {   z[ci].xpos -= g.csize;
          moveimage(ci, z[ci].xpos, z[ci].ypos);
      }
      selectimage(ci);    
   }
}
void rightcb(Widget w, XtP client_data, XtP call_data)
{  w=w; call_data=call_data; client_data=client_data;  // Keep compiler quiet
   Position xpos,ypos;
   if(ci>0)
   {  drawselectbox(OFF);
      g.moving=4;
      if(z[ci].shell)
      {   xpos = z[ci].xpos + g.main_xpos + g.csize;
          ypos = z[ci].ypos + g.main_ypos;
          xpos -= g.wm_leftborderwidth;
          ypos -= g.wm_topborderwidth;
          moveimage(ci,xpos,ypos);
      }else
      {   z[ci].xpos += g.csize;
          moveimage(ci, z[ci].xpos, z[ci].ypos);
      }
      selectimage(ci);    
   }
}


//--------------------------------------------------------------------//
// disarmcb - callback for releasing a pushbutton.                    //
//--------------------------------------------------------------------//
void disarmcb(Widget w, XtP client_data, XmACB *call_data)
{  
    g.moving=0;
    w=w; call_data=call_data; client_data=client_data;  // Keep compiler quiet
    g.state=NORMAL;
    printstatus(g.state);
}


//--------------------------------------------------------------------//
// quitcb - callback for quitting.                                    //
//--------------------------------------------------------------------//
void quitcb(Widget w, XtP client_data, XmACB *call_data)
{
  if(g.diagnose){ printf("Quitting...");fflush(stdout); }
  w=w; call_data=call_data; client_data=client_data;  // Keep compiler quiet
  int status=OK;
  status = savetouchedimages();
  if(g.background_touched)
  {   status = message("Save background pixels?",YESNOQUESTION);
      if(status==NO) status=OK;
  }      
  if(status==OK)
  {   XtRemoveEventHandler(g.drawing_area, g.mouse_mask ,False, 
             (XtEH)mousecb, (XtP) &g.image_gc);
      savesettings();
      if(g.diagnose){ printf("done\n"); fflush(stdout); }
      exit(0);
  }
}


//--------------------------------------------------------------------//
// entercb - callback for pressing a key on a pushbutton              //
//--------------------------------------------------------------------//
void entercb(Widget w, XtP client_data, XEvent *event)
{
   w=w;   
   if(event->type!=KeyPress) return;
   char buffer[20];
   XComposeStatus compose;
   XKeyEvent keyevent = event->xkey;
   KeySym keysym;
   int key=0;
    
   Widget widget = *(Widget *)client_data;
 
   //// All this just to allow Enter key to activate a button
   int bufsize=20;
   XLookupString(&keyevent,buffer,bufsize,&keysym,&compose);
   key = keysym & 0xffff;
   if(key==XK_Return) g.dialogdone = widget;
   if(key==XK_Escape) 
   {    g.getout = 1;
        g.dialogdone = widget;
        g.state = NORMAL;
   }
}



//--------------------------------------------------------------------//
// okcb - callback                                                    //
//--------------------------------------------------------------------//
void okcb(Widget w, XtP client_data, XmACB *call_data)
{
   w=w; call_data=call_data; // keep compiler quiet
   Widget widget = *(Widget *)client_data;
   g.dialogdone = widget;
}



//--------------------------------------------------------------------//
// savecb - callback for saving list data                             //
//--------------------------------------------------------------------//
void savecb(Widget w, XtP client_data, XmACB *call_data)
{
   w=w; call_data=call_data; // keep compiler quiet
   static char filename[FILENAMELENGTH]="";
   listinfo *l = (listinfo *)client_data;
   if(memorylessthan(4096)){  message(g.nomemory,ERROR); return; } 
   char temp[FILENAMELENGTH] = "Data";
   int k, count;
   FILE *fp;

   count = l->size;
   if(count==0){ message("No data to save",ERROR); return; }
   message("New filename:",filename,PROMPT,FILENAMELENGTH-1);
   if(filename[0]==0 || filename==NULL) return;
   if(cant_overwrite_file(filename)) return;
   if ((fp=fopen(filename,"wt")) == NULL)
        error_message(filename, errno);
   else
   {    fprintf(fp,"%s\n",l->title);
        for(k=0;k<count;k++)
            fprintf(fp,"%s\n",l->info[k]);
        sprintf(temp,"%s saved in %s",l->title,filename);
        message(temp);
        fclose(fp);
   }
}


//--------------------------------------------------------------------//
// okmsgcb - callback for message box ok button                       //
//--------------------------------------------------------------------//
void okmsgcb(Widget w, XtP client_data, XmACB *call_data)
{
   call_data=call_data; // keep compiler quiet
   clickboxinfo *c = (clickboxinfo *)client_data;
   g.dialogdone=XtParent(w);
   c->answer = YES;
}


//--------------------------------------------------------------------//
// cancelmsgcb -  callback for message box cancel button              //
//--------------------------------------------------------------------//
void cancelmsgcb(Widget w, XtP client_data, XmACB *call_data)
{
   call_data=call_data; // keep compiler quiet
   clickboxinfo *c = (clickboxinfo *)client_data;
   c->answer = CANCEL;
   g.dialogdone=XtParent(w);
   g.getout = 1;
}


//--------------------------------------------------------------------//
// nomsgcb -  callback for message box 'no' button                    //
//--------------------------------------------------------------------//
void nomsgcb(Widget w, XtP client_data, XmACB *call_data)
{
   call_data=call_data;  // keep compiler quiet
   clickboxinfo *c = (clickboxinfo *)client_data;
   c->answer = NO;       // This is not zero!
   g.dialogdone=XtParent(w);
}


//--------------------------------------------------------------------//
// promptmsgcb - callback for message box ok button to get string     //
//--------------------------------------------------------------------//
void promptmsgcb(Widget w, XtP client_data, XmACB *call_data)
{
   clickboxinfo *c = (clickboxinfo *)client_data;
   char *string;         
   XmSelectionBoxCallbackStruct *ptr;
   ptr = (XmSelectionBoxCallbackStruct *)call_data;
    ////  This function allocates space so strcpy it then free it.
   XmStringGetLtoR(ptr->value, XmFONTLIST_DEFAULT_TAG, &string);
    ////  Make sure it is short enough
   if(string!=NULL && string[0])
   {   strcpy(c->title,string);
       c->title[c->maxstringsize-1] = 0;
       XtFree(string);
   }
   g.dialogdone=XtParent(w);
   c->answer = INFO;
}
 
 

//--------------------------------------------------------------------//
//  reset_user_buttons                                                //
//  Buttons at left whose state is read from tnimage.ini.             //
//--------------------------------------------------------------------//
void reset_user_buttons(void)
{
  int k;
  for(k=0;k<g.nbuttons;k++) 
  {  if(strcmp(g.button[k]->activate_cmd,"slew")==SAME)
     {   XmToggleButtonSetState(g.button[k]->widget, g.want_slew, False);
         g.button[k]->state = g.want_slew;
     }
     if(strcmp(g.button[k]->activate_cmd,"zoom")==SAME) g.zoom_button=k;
     if(strcmp(g.button[k]->activate_cmd,"move")==SAME)
     {   XmToggleButtonSetState(g.button[k]->widget, g.copy, False);
         g.button[k]->state = g.copy;
     }
     if(strcmp(g.button[k]->activate_cmd,"sketch")==SAME) 
         XmToggleButtonSetState(g.button[k]->widget, g.draw_figure==SKETCH, False);
  }
}


//--------------------------------------------------------------------//
//  unpush_null_buttons                                               //
//--------------------------------------------------------------------//
void unpush_null_buttons(void)
{
  int k;
  for(k=0;k<g.nbuttons;k++) 
     if(g.button[k]->state==ON &&
        strcmp(g.button[k]->deactivate_cmd,"null")==SAME)
        unpush_main_button(k);      
  g.getout=1;
}




//--------------------------------------------------------------------//
// unpush_main_button                                                 //
//--------------------------------------------------------------------//
void unpush_main_button(int k)
{
   XmToggleButtonSetState(g.button[k]->widget, False, False);
   g.button[k]->state = OFF;
}


//--------------------------------------------------------------------//
// push_main_button                                                   //
//--------------------------------------------------------------------//
void push_main_button(int k)
{
   XmToggleButtonSetState(g.button[k]->widget, True, False);
   g.button[k]->state = ON;
}


//--------------------------------------------------------------------//
// cancelcb - callback                                                //
//--------------------------------------------------------------------//
void cancelcb(Widget w, XtP client_data, XmACB *call_data)
{
   int k;
   client_data=client_data; call_data=call_data; // keep compiler quiet
   g.getout = 1;
   g.dialogdone=XtParent(w);
   g.state = NORMAL;
   printstatus(g.state);
   cancelled=1;
   if(ci>=0) for(k=0;k<20;k++) z[ci].gbutton[k]=0;
}


//--------------------------------------------------------------------//
// maincancelcb -  callback for cancel button on main screen          //
//--------------------------------------------------------------------//
void maincancelcb(Widget w, XtP client_data, XmACB *call_data)
{
   int k;
   w=w; call_data=call_data; client_data=client_data; // keep compiler quiet
   g.draw_figure = NONE;
   g.text_direction = HORIZONTAL;
   g.getout = 1;
   if(g.selectcurve) return;
   g.state = NORMAL;
   printstatus(g.state);
   if(!g.selected_is_square)
   {   selectimage(g.imageatcursor);
       g.selected_is_square=1;
   }
   for(k=0;k<g.nbuttons;k++) 
      if(strcmp(g.button[k]->deactivate_cmd, "cancel")==SAME)
          unpush_main_button(k);
   z[ci].animation = 0;
   reset_user_buttons();
}


//--------------------------------------------------------------------//
// mainbuttoncb                                                       //
//--------------------------------------------------------------------//
void mainbuttoncb(Widget w, XtP client_data, XmACB *call_data)
{
   w=w; call_data=call_data;  // keep compiler quiet
   int k,noofargs=0,button;
   char **arg;                // up to 20 arguments
   arg = new char*[20];
   for(k=0;k<20;k++){ arg[k] = new char[128]; arg[k][0]=0; }
   button = (int)client_data;
   if(g.button[button]->state==ON) g.button[button]->state=OFF; 
   else g.button[button]->state=ON;
   if(g.button[button]->state==ON)
      parsecommand(g.button[button]->activate_cmd, arg, noofargs, 128, 20);
   else if(strlen(g.button[button]->deactivate_cmd))
      parsecommand(g.button[button]->deactivate_cmd, arg, noofargs, 128, 20);
   if(strlen(arg[0])) execute(arg[0],noofargs,arg);
   for(k=0;k<20;k++) delete[] arg[k];
   
   ////  If no 'off' command, i.e. off command is "null", unpush button
   if(cancelled || strcmp(g.button[button]->deactivate_cmd,"null")==SAME) 
      unpush_main_button(button);
   delete arg;  
   cancelled=0;
}


//--------------------------------------------------------------------//
// buttoncb                                                           //
//--------------------------------------------------------------------//
void buttoncb(Widget w, XtP client_data, XmACB *call_data)
{
  w=w; call_data=call_data;  // keep compiler quiet
  clickboxinfo *c = (clickboxinfo*)client_data;
  if(c->f1 !=NULL) c->f1(c->k);
  if(c->f2 !=NULL) c->f2(c->fanswer);
  if(c->f3 !=NULL) c->f3(c->answers);
  if(c->f4 !=NULL) c->f4(c->k, c);
  c->answer = 100; // for buttons in multiclickbox BOTTONVALSLIDER
}


//--------------------------------------------------------------------//
// helpcb - callback for getting help                                 //
// The address of int helptopic is in client_data.                    //
//--------------------------------------------------------------------//
void helpcb(Widget w, XtP client_data, XmACB *call_data)
{
    w=w; call_data=call_data;  // keep compiler quiet
    int *h = (int *)client_data; 
    help(*h);
} 



//--------------------------------------------------------------------//
// executecb - callback for main menu items.                          //
//--------------------------------------------------------------------//
void executecb(Widget w, XtP client_data, XmACB *call_data)
{
   w=w; call_data=call_data;  // Keep compiler quiet
   int k,noofargs=0;
   char **arg;                // up to 20 arguments
   arg = new char*[20];
   for(k=0;k<20;k++) arg[k] = new char[128];
   parsecommand((char*)client_data, arg, noofargs, 128, 20);
   execute(arg[0],noofargs,arg);
   for(k=0;k<20;k++) delete[] arg[k];
   delete arg;  
}


